#line 1 "ad_riscv.cpp"
//
// Copyright (c) 2003, 2023, Oracle and/or its affiliates. All rights reserved.
// Copyright (c) 2014, 2020, Red Hat Inc. All rights reserved.
// Copyright (c) 2020, 2023, Huawei Technologies Co., Ltd. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/adGlobals_riscv.hpp"
#include "adfiles/ad_riscv.hpp"
#include "memory/allocation.inline.hpp"
#include "code/codeCache.hpp"
#include "code/compiledIC.hpp"
#include "code/nativeInst.hpp"
#include "code/vmreg.inline.hpp"
#include "gc/shared/collectedHeap.inline.hpp"
#include "oops/compiledICHolder.hpp"
#include "oops/compressedOops.hpp"
#include "oops/markWord.hpp"
#include "oops/method.hpp"
#include "oops/oop.inline.hpp"
#include "opto/c2_MacroAssembler.hpp"
#include "opto/cfgnode.hpp"
#include "opto/intrinsicnode.hpp"
#include "opto/locknode.hpp"
#include "opto/opcodes.hpp"
#include "opto/regalloc.hpp"
#include "opto/regmask.hpp"
#include "opto/runtime.hpp"
#include "runtime/safepointMechanism.hpp"
#include "runtime/sharedRuntime.hpp"
#include "runtime/stubRoutines.hpp"
#include "utilities/growableArray.hpp"
#include "utilities/powerOfTwo.hpp"

//SourceForm

#line 1091 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"


// Derived RegMask with conditionally allocatable registers

RegMask _ANY_REG32_mask;
RegMask _ANY_REG_mask;
RegMask _PTR_REG_mask;
RegMask _NO_SPECIAL_REG32_mask;
RegMask _NO_SPECIAL_REG_mask;
RegMask _NO_SPECIAL_PTR_REG_mask;

void reg_mask_init() {

  _ANY_REG32_mask = _ALL_REG32_mask;
  _ANY_REG32_mask.Remove(OptoReg::as_OptoReg(x0->as_VMReg()));

  _ANY_REG_mask = _ALL_REG_mask;
  _ANY_REG_mask.SUBTRACT(_ZR_REG_mask);

  _PTR_REG_mask = _ALL_REG_mask;
  _PTR_REG_mask.SUBTRACT(_ZR_REG_mask);

  _NO_SPECIAL_REG32_mask = _ALL_REG32_mask;
  _NO_SPECIAL_REG32_mask.SUBTRACT(_NON_ALLOCATABLE_REG32_mask);

  _NO_SPECIAL_REG_mask = _ALL_REG_mask;
  _NO_SPECIAL_REG_mask.SUBTRACT(_NON_ALLOCATABLE_REG_mask);

  _NO_SPECIAL_PTR_REG_mask = _ALL_REG_mask;
  _NO_SPECIAL_PTR_REG_mask.SUBTRACT(_NON_ALLOCATABLE_REG_mask);

  // x27 is not allocatable when compressed oops is on
  if (UseCompressedOops) {
    _NO_SPECIAL_REG32_mask.Remove(OptoReg::as_OptoReg(x27->as_VMReg()));
    _NO_SPECIAL_REG_mask.Remove(OptoReg::as_OptoReg(x27->as_VMReg()));
    _NO_SPECIAL_PTR_REG_mask.Remove(OptoReg::as_OptoReg(x27->as_VMReg()));
  }

  // x8 is not allocatable when PreserveFramePointer is on
  if (PreserveFramePointer) {
    _NO_SPECIAL_REG32_mask.Remove(OptoReg::as_OptoReg(x8->as_VMReg()));
    _NO_SPECIAL_REG_mask.Remove(OptoReg::as_OptoReg(x8->as_VMReg()));
    _NO_SPECIAL_PTR_REG_mask.Remove(OptoReg::as_OptoReg(x8->as_VMReg()));
  }
}

void PhaseOutput::pd_perform_mach_node_analysis() {
}

int MachNode::pd_alignment_required() const {
  return 1;
}

int MachNode::compute_padding(int current_offset) const {
  return 0;
}

// is_CAS(int opcode, bool maybe_volatile)
//
// return true if opcode is one of the possible CompareAndSwapX
// values otherwise false.
bool is_CAS(int opcode, bool maybe_volatile)
{
  switch (opcode) {
    // We handle these
    case Op_CompareAndSwapI:
    case Op_CompareAndSwapL:
    case Op_CompareAndSwapP:
    case Op_CompareAndSwapN:
    case Op_ShenandoahCompareAndSwapP:
    case Op_ShenandoahCompareAndSwapN:
    case Op_CompareAndSwapB:
    case Op_CompareAndSwapS:
    case Op_GetAndSetI:
    case Op_GetAndSetL:
    case Op_GetAndSetP:
    case Op_GetAndSetN:
    case Op_GetAndAddI:
    case Op_GetAndAddL:
      return true;
    case Op_CompareAndExchangeI:
    case Op_CompareAndExchangeN:
    case Op_CompareAndExchangeB:
    case Op_CompareAndExchangeS:
    case Op_CompareAndExchangeL:
    case Op_CompareAndExchangeP:
    case Op_WeakCompareAndSwapB:
    case Op_WeakCompareAndSwapS:
    case Op_WeakCompareAndSwapI:
    case Op_WeakCompareAndSwapL:
    case Op_WeakCompareAndSwapP:
    case Op_WeakCompareAndSwapN:
    case Op_ShenandoahWeakCompareAndSwapP:
    case Op_ShenandoahWeakCompareAndSwapN:
    case Op_ShenandoahCompareAndExchangeP:
    case Op_ShenandoahCompareAndExchangeN:
      return maybe_volatile;
    default:
      return false;
  }
}

// predicate controlling translation of CAS
//
// returns true if CAS needs to use an acquiring load otherwise false
bool needs_acquiring_load_reserved(const Node *n)
{
  assert(n != NULL && is_CAS(n->Opcode(), true), "expecting a compare and swap");

  LoadStoreNode* ldst = n->as_LoadStore();
  if (n != NULL && is_CAS(n->Opcode(), false)) {
    assert(ldst != NULL && ldst->trailing_membar() != NULL, "expected trailing membar");
  } else {
    return ldst != NULL && ldst->trailing_membar() != NULL;
  }
  // so we can just return true here
  return true;
}
#define __ _masm.

// advance declarations for helper functions to convert register
// indices to register objects

// the ad file has to provide implementations of certain methods
// expected by the generic code
//
// REQUIRED FUNCTIONALITY

//=============================================================================

// !!!!! Special hack to get all types of calls to specify the byte offset
//       from the start of the call to the point where the return address
//       will point.

int MachCallStaticJavaNode::ret_addr_offset()
{
  // jal
  return 1 * NativeInstruction::instruction_size;
}

int MachCallDynamicJavaNode::ret_addr_offset()
{
  return 7 * NativeInstruction::instruction_size; // movptr, jal
}

int MachCallRuntimeNode::ret_addr_offset() {
  // for generated stubs the call will be
  //   jal(addr)
  // or with far branches
  //   jal(trampoline_stub)
  // for real runtime callouts it will be 11 instructions
  // see riscv_enc_java_to_runtime
  //   la(t1, retaddr)                ->  auipc + addi
  //   la(t0, RuntimeAddress(addr))   ->  lui + addi + slli + addi + slli + addi
  //   addi(sp, sp, -2 * wordSize)    ->  addi
  //   sd(t1, Address(sp, wordSize))  ->  sd
  //   jalr(t0)                       ->  jalr
  CodeBlob *cb = CodeCache::find_blob(_entry_point);
  if (cb != NULL) {
    return 1 * NativeInstruction::instruction_size;
  } else {
    return 11 * NativeInstruction::instruction_size;
  }
}

//
// Compute padding required for nodes which need alignment
//

// With RVC a call instruction may get 2-byte aligned.
// The address of the call instruction needs to be 4-byte aligned to
// ensure that it does not span a cache line so that it can be patched.
int CallStaticJavaDirectNode::compute_padding(int current_offset) const
{
  // to make sure the address of jal 4-byte aligned.
  return align_up(current_offset, alignment_required()) - current_offset;
}

// With RVC a call instruction may get 2-byte aligned.
// The address of the call instruction needs to be 4-byte aligned to
// ensure that it does not span a cache line so that it can be patched.
int CallDynamicJavaDirectNode::compute_padding(int current_offset) const
{
  // skip the movptr in MacroAssembler::ic_call():
  // lui + addi + slli + addi + slli + addi
  // Though movptr() has already 4-byte aligned with or without RVC,
  // We need to prevent from further changes by explicitly calculating the size.
  const int movptr_size = 6 * NativeInstruction::instruction_size;
  current_offset += movptr_size;
  // to make sure the address of jal 4-byte aligned.
  return align_up(current_offset, alignment_required()) - current_offset;
}

//=============================================================================

#ifndef PRODUCT
void MachBreakpointNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  assert_cond(st != NULL);
  st->print("BREAKPOINT");
}
#endif

void MachBreakpointNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  C2_MacroAssembler _masm(&cbuf);
  __ ebreak();
}

uint MachBreakpointNode::size(PhaseRegAlloc *ra_) const {
  return MachNode::size(ra_);
}

//=============================================================================

#ifndef PRODUCT
  void MachNopNode::format(PhaseRegAlloc*, outputStream* st) const {
    st->print("nop \t# %d bytes pad for loops and calls", _count);
  }
#endif

  void MachNopNode::emit(CodeBuffer &cbuf, PhaseRegAlloc*) const {
    C2_MacroAssembler _masm(&cbuf);
    Assembler::CompressibleRegion cr(&_masm); // nops shall be 2-byte under RVC for alignment purposes.
    for (int i = 0; i < _count; i++) {
      __ nop();
    }
  }

  uint MachNopNode::size(PhaseRegAlloc*) const {
    return _count * (UseRVC ? NativeInstruction::compressed_instruction_size : NativeInstruction::instruction_size);
  }

//=============================================================================
const RegMask& MachConstantBaseNode::_out_RegMask = RegMask::Empty;

int ConstantTable::calculate_table_base_offset() const {
  return 0;  // absolute addressing, no offset
}

bool MachConstantBaseNode::requires_postalloc_expand() const { return false; }
void MachConstantBaseNode::postalloc_expand(GrowableArray <Node *> *nodes, PhaseRegAlloc *ra_) {
  ShouldNotReachHere();
}

void MachConstantBaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  // Empty encoding
}

uint MachConstantBaseNode::size(PhaseRegAlloc* ra_) const {
  return 0;
}

#ifndef PRODUCT
void MachConstantBaseNode::format(PhaseRegAlloc* ra_, outputStream* st) const {
  assert_cond(st != NULL);
  st->print("-- \t// MachConstantBaseNode (empty encoding)");
}
#endif

#ifndef PRODUCT
void MachPrologNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  assert_cond(st != NULL && ra_ != NULL);
  Compile* C = ra_->C;

  int framesize = C->output()->frame_slots() << LogBytesPerInt;

  if (C->output()->need_stack_bang(framesize)) {
    st->print("# stack bang size=%d\n\t", framesize);
  }

  st->print("sd  fp, [sp, #%d]\n\t", - 2 * wordSize);
  st->print("sd  ra, [sp, #%d]\n\t", - wordSize);
  if (PreserveFramePointer) { st->print("sub  fp, sp, #%d\n\t", 2 * wordSize); }
  st->print("sub sp, sp, #%d\n\t", framesize);

  if (C->stub_function() == NULL && BarrierSet::barrier_set()->barrier_set_nmethod() != NULL) {
    st->print("ld  t0, [guard]\n\t");
    st->print("membar LoadLoad\n\t");
    st->print("ld  t1, [xthread, #thread_disarmed_guard_value_offset]\n\t");
    st->print("beq t0, t1, skip\n\t");
    st->print("jalr #nmethod_entry_barrier_stub\n\t");
    st->print("j skip\n\t");
    st->print("guard: int\n\t");
    st->print("skip:\n\t");
  }
}
#endif

void MachPrologNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  assert_cond(ra_ != NULL);
  Compile* C = ra_->C;
  C2_MacroAssembler _masm(&cbuf);

  // n.b. frame size includes space for return pc and fp
  const int framesize = C->output()->frame_size_in_bytes();

  // insert a nop at the start of the prolog so we can patch in a
  // branch if we need to invalidate the method later
  {
    Assembler::IncompressibleRegion ir(&_masm);  // keep the nop as 4 bytes for patching.
    MacroAssembler::assert_alignment(__ pc());
    __ nop();  // 4 bytes
  }

  assert_cond(C != NULL);

  if (C->clinit_barrier_on_entry()) {
    assert(!C->method()->holder()->is_not_initialized(), "initialization should have been started");

    Label L_skip_barrier;

    __ mov_metadata(t1, C->method()->holder()->constant_encoding());
    __ clinit_barrier(t1, t0, &L_skip_barrier);
    __ far_jump(RuntimeAddress(SharedRuntime::get_handle_wrong_method_stub()));
    __ bind(L_skip_barrier);
  }

  int bangsize = C->output()->bang_size_in_bytes();
  if (C->output()->need_stack_bang(bangsize)) {
    __ generate_stack_overflow_check(bangsize);
  }

  __ build_frame(framesize);

  if (C->stub_function() == NULL) {
    BarrierSetAssembler* bs = BarrierSet::barrier_set()->barrier_set_assembler();
    if (BarrierSet::barrier_set()->barrier_set_nmethod() != NULL) {
      // Dummy labels for just measuring the code size
      Label dummy_slow_path;
      Label dummy_continuation;
      Label dummy_guard;
      Label* slow_path = &dummy_slow_path;
      Label* continuation = &dummy_continuation;
      Label* guard = &dummy_guard;
      if (!Compile::current()->output()->in_scratch_emit_size()) {
        // Use real labels from actual stub when not emitting code for purpose of measuring its size
        C2EntryBarrierStub* stub = new (Compile::current()->comp_arena()) C2EntryBarrierStub();
        Compile::current()->output()->add_stub(stub);
        slow_path = &stub->entry();
        continuation = &stub->continuation();
        guard = &stub->guard();
      }
      // In the C2 code, we move the non-hot part of nmethod entry barriers out-of-line to a stub.
      bs->nmethod_entry_barrier(&_masm, slow_path, continuation, guard);
    }
  }

  if (VerifyStackAtCalls) {
    Unimplemented();
  }

  C->output()->set_frame_complete(cbuf.insts_size());

  if (C->has_mach_constant_base_node()) {
    // NOTE: We set the table base offset here because users might be
    // emitted before MachConstantBaseNode.
    ConstantTable& constant_table = C->output()->constant_table();
    constant_table.set_table_base_offset(constant_table.calculate_table_base_offset());
  }
}

uint MachPrologNode::size(PhaseRegAlloc* ra_) const
{
  assert_cond(ra_ != NULL);
  return MachNode::size(ra_); // too many variables; just compute it
                              // the hard way
}

int MachPrologNode::reloc() const
{
  return 0;
}

//=============================================================================

#ifndef PRODUCT
void MachEpilogNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  assert_cond(st != NULL && ra_ != NULL);
  Compile* C = ra_->C;
  assert_cond(C != NULL);
  int framesize = C->output()->frame_size_in_bytes();

  st->print("# pop frame %d\n\t", framesize);

  if (framesize == 0) {
    st->print("ld  ra, [sp,#%d]\n\t", (2 * wordSize));
    st->print("ld  fp, [sp,#%d]\n\t", (3 * wordSize));
    st->print("add sp, sp, #%d\n\t", (2 * wordSize));
  } else {
    st->print("add  sp, sp, #%d\n\t", framesize);
    st->print("ld  ra, [sp,#%d]\n\t", - 2 * wordSize);
    st->print("ld  fp, [sp,#%d]\n\t", - wordSize);
  }

  if (do_polling() && C->is_method_compilation()) {
    st->print("# test polling word\n\t");
    st->print("ld t0, [xthread,#%d]\n\t", in_bytes(JavaThread::polling_word_offset()));
    st->print("bgtu sp, t0, #slow_path");
  }
}
#endif

void MachEpilogNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  assert_cond(ra_ != NULL);
  Compile* C = ra_->C;
  C2_MacroAssembler _masm(&cbuf);
  assert_cond(C != NULL);
  int framesize = C->output()->frame_size_in_bytes();

  __ remove_frame(framesize);

  if (StackReservedPages > 0 && C->has_reserved_stack_access()) {
    __ reserved_stack_check();
  }

  if (do_polling() && C->is_method_compilation()) {
    Label dummy_label;
    Label* code_stub = &dummy_label;
    if (!C->output()->in_scratch_emit_size()) {
      C2SafepointPollStub* stub = new (C->comp_arena()) C2SafepointPollStub(__ offset());
      C->output()->add_stub(stub);
      code_stub = &stub->entry();
    }
    __ relocate(relocInfo::poll_return_type);
    __ safepoint_poll(*code_stub, true /* at_return */, false /* acquire */, true /* in_nmethod */);
  }
}

uint MachEpilogNode::size(PhaseRegAlloc *ra_) const {
  assert_cond(ra_ != NULL);
  // Variable size. Determine dynamically.
  return MachNode::size(ra_);
}

int MachEpilogNode::reloc() const {
  // Return number of relocatable values contained in this instruction.
  return 1; // 1 for polling page.
}
const Pipeline * MachEpilogNode::pipeline() const {
  return MachNode::pipeline_class();
}

//=============================================================================

// Figure out which register class each belongs in: rc_int, rc_float or
// rc_stack.
enum RC { rc_bad, rc_int, rc_float, rc_vector, rc_stack };

static enum RC rc_class(OptoReg::Name reg) {

  if (reg == OptoReg::Bad) {
    return rc_bad;
  }

  // we have 30 int registers * 2 halves
  // (t0 and t1 are omitted)
  int slots_of_int_registers = Register::max_slots_per_register * (Register::number_of_registers - 2);
  if (reg < slots_of_int_registers) {
    return rc_int;
  }

  // we have 32 float register * 2 halves
  int slots_of_float_registers = FloatRegister::max_slots_per_register * FloatRegister::number_of_registers;
  if (reg < slots_of_int_registers + slots_of_float_registers) {
    return rc_float;
  }

  // we have 32 vector register * 4 halves
  int slots_of_vector_registers = VectorRegister::max_slots_per_register * VectorRegister::number_of_registers;
  if (reg < slots_of_int_registers + slots_of_float_registers + slots_of_vector_registers) {
    return rc_vector;
  }

  // Between vector regs & stack is the flags regs.
  assert(OptoReg::is_stack(reg), "blow up if spilling flags");

  return rc_stack;
}

uint MachSpillCopyNode::implementation(CodeBuffer *cbuf, PhaseRegAlloc *ra_, bool do_size, outputStream *st) const {
  assert_cond(ra_ != NULL);
  Compile* C = ra_->C;

  // Get registers to move.
  OptoReg::Name src_hi = ra_->get_reg_second(in(1));
  OptoReg::Name src_lo = ra_->get_reg_first(in(1));
  OptoReg::Name dst_hi = ra_->get_reg_second(this);
  OptoReg::Name dst_lo = ra_->get_reg_first(this);

  enum RC src_hi_rc = rc_class(src_hi);
  enum RC src_lo_rc = rc_class(src_lo);
  enum RC dst_hi_rc = rc_class(dst_hi);
  enum RC dst_lo_rc = rc_class(dst_lo);

  assert(src_lo != OptoReg::Bad && dst_lo != OptoReg::Bad, "must move at least 1 register");

  if (src_hi != OptoReg::Bad && !bottom_type()->isa_vectmask()) {
    assert((src_lo & 1) == 0 && src_lo + 1 == src_hi &&
           (dst_lo & 1) == 0 && dst_lo + 1 == dst_hi,
           "expected aligned-adjacent pairs");
  }

  if (src_lo == dst_lo && src_hi == dst_hi) {
    return 0;            // Self copy, no move.
  }

  bool is64 = (src_lo & 1) == 0 && src_lo + 1 == src_hi &&
              (dst_lo & 1) == 0 && dst_lo + 1 == dst_hi;
  int src_offset = ra_->reg2offset(src_lo);
  int dst_offset = ra_->reg2offset(dst_lo);

  if (bottom_type()->isa_vect() != NULL) {
    uint ireg = ideal_reg();
    if (ireg == Op_VecA && cbuf) {
      C2_MacroAssembler _masm(cbuf);
      int vector_reg_size_in_bytes = Matcher::scalable_vector_reg_size(T_BYTE);
      if (src_lo_rc == rc_stack && dst_lo_rc == rc_stack) {
        // stack to stack
        __ spill_copy_vector_stack_to_stack(src_offset, dst_offset,
                                            vector_reg_size_in_bytes);
      } else if (src_lo_rc == rc_vector && dst_lo_rc == rc_stack) {
        // vpr to stack
        __ spill(as_VectorRegister(Matcher::_regEncode[src_lo]), ra_->reg2offset(dst_lo));
      } else if (src_lo_rc == rc_stack && dst_lo_rc == rc_vector) {
        // stack to vpr
        __ unspill(as_VectorRegister(Matcher::_regEncode[dst_lo]), ra_->reg2offset(src_lo));
      } else if (src_lo_rc == rc_vector && dst_lo_rc == rc_vector) {
        // vpr to vpr
        __ vmv1r_v(as_VectorRegister(Matcher::_regEncode[dst_lo]), as_VectorRegister(Matcher::_regEncode[src_lo]));
      } else {
        ShouldNotReachHere();
      }
    } else if (bottom_type()->isa_vectmask() && cbuf) {
      C2_MacroAssembler _masm(cbuf);
      int vmask_size_in_bytes = Matcher::scalable_predicate_reg_slots() * 32 / 8;
      if (src_lo_rc == rc_stack && dst_lo_rc == rc_stack) {
        // stack to stack
        __ spill_copy_vmask_stack_to_stack(src_offset, dst_offset,
                                           vmask_size_in_bytes);
      } else if (src_lo_rc == rc_vector && dst_lo_rc == rc_stack) {
        // vmask to stack
        __ spill_vmask(as_VectorRegister(Matcher::_regEncode[src_lo]), ra_->reg2offset(dst_lo));
      } else if (src_lo_rc == rc_stack && dst_lo_rc == rc_vector) {
        // stack to vmask
        __ unspill_vmask(as_VectorRegister(Matcher::_regEncode[dst_lo]), ra_->reg2offset(src_lo));
      } else if (src_lo_rc == rc_vector && dst_lo_rc == rc_vector) {
        // vmask to vmask
        __ vmv1r_v(as_VectorRegister(Matcher::_regEncode[dst_lo]), as_VectorRegister(Matcher::_regEncode[src_lo]));
      } else {
        ShouldNotReachHere();
      }
    }
  } else if (cbuf != NULL) {
    C2_MacroAssembler _masm(cbuf);
    switch (src_lo_rc) {
      case rc_int:
        if (dst_lo_rc == rc_int) {  // gpr --> gpr copy
          if (!is64 && this->ideal_reg() != Op_RegI) { // zero extended for narrow oop or klass
            __ zero_extend(as_Register(Matcher::_regEncode[dst_lo]), as_Register(Matcher::_regEncode[src_lo]), 32);
          } else {
            __ mv(as_Register(Matcher::_regEncode[dst_lo]), as_Register(Matcher::_regEncode[src_lo]));
          }
        } else if (dst_lo_rc == rc_float) { // gpr --> fpr copy
          if (is64) {
            __ fmv_d_x(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                       as_Register(Matcher::_regEncode[src_lo]));
          } else {
            __ fmv_w_x(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                       as_Register(Matcher::_regEncode[src_lo]));
          }
        } else {                    // gpr --> stack spill
          assert(dst_lo_rc == rc_stack, "spill to bad register class");
          __ spill(as_Register(Matcher::_regEncode[src_lo]), is64, dst_offset);
        }
        break;
      case rc_float:
        if (dst_lo_rc == rc_int) {  // fpr --> gpr copy
          if (is64) {
            __ fmv_x_d(as_Register(Matcher::_regEncode[dst_lo]),
                       as_FloatRegister(Matcher::_regEncode[src_lo]));
          } else {
            __ fmv_x_w(as_Register(Matcher::_regEncode[dst_lo]),
                       as_FloatRegister(Matcher::_regEncode[src_lo]));
          }
        } else if (dst_lo_rc == rc_float) { // fpr --> fpr copy
          if (is64) {
            __ fmv_d(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                     as_FloatRegister(Matcher::_regEncode[src_lo]));
          } else {
            __ fmv_s(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                     as_FloatRegister(Matcher::_regEncode[src_lo]));
          }
        } else {                    // fpr --> stack spill
          assert(dst_lo_rc == rc_stack, "spill to bad register class");
          __ spill(as_FloatRegister(Matcher::_regEncode[src_lo]),
                   is64, dst_offset);
        }
        break;
      case rc_stack:
        if (dst_lo_rc == rc_int) {  // stack --> gpr load
          if (this->ideal_reg() == Op_RegI) {
            __ unspill(as_Register(Matcher::_regEncode[dst_lo]), is64, src_offset);
          } else { // // zero extended for narrow oop or klass
            __ unspillu(as_Register(Matcher::_regEncode[dst_lo]), is64, src_offset);
          }
        } else if (dst_lo_rc == rc_float) { // stack --> fpr load
          __ unspill(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                     is64, src_offset);
        } else {                    // stack --> stack copy
          assert(dst_lo_rc == rc_stack, "spill to bad register class");
          if (this->ideal_reg() == Op_RegI) {
            __ unspill(t0, is64, src_offset);
          } else { // zero extended for narrow oop or klass
            __ unspillu(t0, is64, src_offset);
          }
          __ spill(t0, is64, dst_offset);
        }
        break;
      default:
        ShouldNotReachHere();
    }
  }

  if (st != NULL) {
    st->print("spill ");
    if (src_lo_rc == rc_stack) {
      st->print("[sp, #%d] -> ", src_offset);
    } else {
      st->print("%s -> ", Matcher::regName[src_lo]);
    }
    if (dst_lo_rc == rc_stack) {
      st->print("[sp, #%d]", dst_offset);
    } else {
      st->print("%s", Matcher::regName[dst_lo]);
    }
    if (bottom_type()->isa_vect() && !bottom_type()->isa_vectmask()) {
      int vsize = 0;
      if (ideal_reg() == Op_VecA) {
        vsize = Matcher::scalable_vector_reg_size(T_BYTE) * 8;
      } else {
        ShouldNotReachHere();
      }
      st->print("\t# vector spill size = %d", vsize);
    } else if (ideal_reg() == Op_RegVectMask) {
      assert(Matcher::supports_scalable_vector(), "bad register type for spill");
      int vsize = Matcher::scalable_predicate_reg_slots() * 32;
      st->print("\t# vmask spill size = %d", vsize);
    } else {
      st->print("\t# spill size = %d", is64 ? 64 : 32);
    }
  }

  return 0;
}

#ifndef PRODUCT
void MachSpillCopyNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  if (ra_ == NULL) {
    st->print("N%d = SpillCopy(N%d)", _idx, in(1)->_idx);
  } else {
    implementation(NULL, ra_, false, st);
  }
}
#endif

void MachSpillCopyNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  implementation(&cbuf, ra_, false, NULL);
}

uint MachSpillCopyNode::size(PhaseRegAlloc *ra_) const {
  return MachNode::size(ra_);
}

//=============================================================================

#ifndef PRODUCT
void BoxLockNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  assert_cond(ra_ != NULL && st != NULL);
  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  int reg = ra_->get_reg_first(this);
  st->print("add %s, sp, #%d\t# box lock",
            Matcher::regName[reg], offset);
}
#endif

void BoxLockNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  C2_MacroAssembler _masm(&cbuf);
  Assembler::IncompressibleRegion ir(&_masm);  // Fixed length: see BoxLockNode::size()

  assert_cond(ra_ != NULL);
  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  int reg    = ra_->get_encode(this);

  if (Assembler::is_simm12(offset)) {
    __ addi(as_Register(reg), sp, offset);
  } else {
    __ li32(t0, offset);
    __ add(as_Register(reg), sp, t0);
  }
}

uint BoxLockNode::size(PhaseRegAlloc *ra_) const {
  // BoxLockNode is not a MachNode, so we can't just call MachNode::size(ra_).
  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());

  if (Assembler::is_simm12(offset)) {
    return NativeInstruction::instruction_size;
  } else {
    return 3 * NativeInstruction::instruction_size; // lui + addiw + add;
  }
}

//=============================================================================

#ifndef PRODUCT
void MachUEPNode::format(PhaseRegAlloc* ra_, outputStream* st) const
{
  assert_cond(st != NULL);
  st->print_cr("# MachUEPNode");
  if (UseCompressedClassPointers) {
    st->print_cr("\tlwu t0, [j_rarg0, oopDesc::klass_offset_in_bytes()]\t# compressed klass");
    if (CompressedKlassPointers::shift() != 0) {
      st->print_cr("\tdecode_klass_not_null t0, t0");
    }
  } else {
    st->print_cr("\tld t0, [j_rarg0, oopDesc::klass_offset_in_bytes()]\t# compressed klass");
  }
  st->print_cr("\tbeq t0, t1, ic_hit");
  st->print_cr("\tj, SharedRuntime::_ic_miss_stub\t # Inline cache check");
  st->print_cr("\tic_hit:");
}
#endif

void MachUEPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const
{
  // This is the unverified entry point.
  C2_MacroAssembler _masm(&cbuf);

  Label skip;
  __ cmp_klass(j_rarg0, t1, t0, t2 /* call-clobbered t2 as a tmp */, skip);
  __ far_jump(RuntimeAddress(SharedRuntime::get_ic_miss_stub()));
  __ bind(skip);

  // These NOPs are critical so that verified entry point is properly
  // 4 bytes aligned for patching by NativeJump::patch_verified_entry()
  __ align(NativeInstruction::instruction_size);
}

uint MachUEPNode::size(PhaseRegAlloc* ra_) const
{
  assert_cond(ra_ != NULL);
  return MachNode::size(ra_);
}

// REQUIRED EMIT CODE

//=============================================================================

// Emit exception handler code.
int HandlerImpl::emit_exception_handler(CodeBuffer& cbuf)
{
  // auipc t0, #exception_blob_entry_point
  // jr (offset)t0
  // Note that the code buffer's insts_mark is always relative to insts.
  // That's why we must use the macroassembler to generate a handler.
  C2_MacroAssembler _masm(&cbuf);
  address base = __ start_a_stub(size_exception_handler());
  if (base == NULL) {
    ciEnv::current()->record_failure("CodeCache is full");
    return 0;  // CodeBuffer::expand failed
  }
  int offset = __ offset();
  __ far_jump(RuntimeAddress(OptoRuntime::exception_blob()->entry_point()));
  assert(__ offset() - offset <= (int) size_exception_handler(), "overflow");
  __ end_a_stub();
  return offset;
}

// Emit deopt handler code.
int HandlerImpl::emit_deopt_handler(CodeBuffer& cbuf)
{
  // Note that the code buffer's insts_mark is always relative to insts.
  // That's why we must use the macroassembler to generate a handler.
  C2_MacroAssembler _masm(&cbuf);
  address base = __ start_a_stub(size_deopt_handler());
  if (base == NULL) {
    ciEnv::current()->record_failure("CodeCache is full");
    return 0;  // CodeBuffer::expand failed
  }
  int offset = __ offset();

  __ auipc(ra, 0);
  __ far_jump(RuntimeAddress(SharedRuntime::deopt_blob()->unpack()));

  assert(__ offset() - offset <= (int) size_deopt_handler(), "overflow");
  __ end_a_stub();
  return offset;

}
// REQUIRED MATCHER CODE

//=============================================================================

bool Matcher::match_rule_supported(int opcode) {
  if (!has_match_rule(opcode)) {
    return false;
  }

  switch (opcode) {
    case Op_OnSpinWait:
      return VM_Version::supports_on_spin_wait();
    case Op_CacheWB:           // fall through
    case Op_CacheWBPreSync:    // fall through
    case Op_CacheWBPostSync:
      if (!VM_Version::supports_data_cache_line_flush()) {
        return false;
      }
      break;

    case Op_ExpandBits:        // fall through
    case Op_CompressBits:      // fall through
      guarantee(UseRVV == (MaxVectorSize >= 16), "UseRVV and MaxVectorSize not matched");
    case Op_StrCompressedCopy: // fall through
    case Op_StrInflatedCopy:   // fall through
    case Op_CountPositives:    // fall through
    case Op_EncodeISOArray:
      return UseRVV;

    case Op_PopCountI:
    case Op_PopCountL:
      return UsePopCountInstruction;

    case Op_RotateRight:
    case Op_RotateLeft:
    case Op_CountLeadingZerosI:
    case Op_CountLeadingZerosL:
    case Op_CountTrailingZerosI:
    case Op_CountTrailingZerosL:
      return UseZbb;
    case Op_FmaF:
    case Op_FmaD:
    case Op_FmaVF:
    case Op_FmaVD:
      return UseFMA;
  }

  return true; // Per default match rules are supported.
}

const RegMask* Matcher::predicate_reg_mask(void) {
  return &_VMASK_REG_mask;
}

const TypeVectMask* Matcher::predicate_reg_type(const Type* elemTy, int length) {
  return new TypeVectMask(elemTy, length);
}

// Vector calling convention not yet implemented.
bool Matcher::supports_vector_calling_convention(void) {
  return false;
}

OptoRegPair Matcher::vector_return_value(uint ideal_reg) {
  Unimplemented();
  return OptoRegPair(0, 0);
}

// Is this branch offset short enough that a short branch can be used?
//
// NOTE: If the platform does not provide any short branch variants, then
//       this method should return false for offset 0.
// |---label(L1)-----|
// |-----------------|
// |-----------------|----------eq: float-------------------
// |-----------------| // far_cmpD_branch   |   cmpD_branch
// |------- ---------|    feq;              |      feq;
// |-far_cmpD_branch-|    beqz done;        |      bnez L;
// |-----------------|    j L;              |
// |-----------------|    bind(done);       |
// |-----------------|--------------------------------------
// |-----------------| // so shortBrSize = br_size - 4;
// |-----------------| // so offs = offset - shortBrSize + 4;
// |---label(L2)-----|
bool Matcher::is_short_branch_offset(int rule, int br_size, int offset) {
  // The passed offset is relative to address of the branch.
  int shortBrSize = br_size - 4;
  int offs = offset - shortBrSize + 4;
  return (-4096 <= offs && offs < 4096);
}

// Vector width in bytes.
int Matcher::vector_width_in_bytes(BasicType bt) {
  if (UseRVV) {
    // The MaxVectorSize should have been set by detecting RVV max vector register size when check UseRVV.
    // MaxVectorSize == VM_Version::_initial_vector_length
    int size = MaxVectorSize;
    // Minimum 2 values in vector
    if (size < 2 * type2aelembytes(bt)) size = 0;
    // But never < 4
    if (size < 4) size = 0;
    return size;
  }
  return 0;
}

// Limits on vector size (number of elements) loaded into vector.
int Matcher::max_vector_size(const BasicType bt) {
  return vector_width_in_bytes(bt) / type2aelembytes(bt);
}

int Matcher::min_vector_size(const BasicType bt) {
  int max_size = max_vector_size(bt);
  // Limit the min vector size to 8 bytes.
  int size = 8 / type2aelembytes(bt);
  if (bt == T_BYTE) {
    // To support vector api shuffle/rearrange.
    size = 4;
  } else if (bt == T_BOOLEAN) {
    // To support vector api load/store mask.
    size = 2;
  }
  if (size < 2) size = 2;
  return MIN2(size, max_size);
}

int Matcher::superword_max_vector_size(const BasicType bt) {
  return Matcher::max_vector_size(bt);
}

// Vector ideal reg.
uint Matcher::vector_ideal_reg(int len) {
  assert(MaxVectorSize >= len, "");
  if (UseRVV) {
    return Op_VecA;
  }

  ShouldNotReachHere();
  return 0;
}

int Matcher::scalable_vector_reg_size(const BasicType bt) {
  return Matcher::max_vector_size(bt);
}

MachOper* Matcher::pd_specialize_generic_vector_operand(MachOper* original_opnd, uint ideal_reg, bool is_temp) {
  ShouldNotReachHere(); // generic vector operands not supported
  return NULL;
}

bool Matcher::is_reg2reg_move(MachNode* m) {
  ShouldNotReachHere(); // generic vector operands not supported
  return false;
}

bool Matcher::is_generic_vector(MachOper* opnd) {
  ShouldNotReachHere(); // generic vector operands not supported
  return false;
}

// Return whether or not this register is ever used as an argument.
// This function is used on startup to build the trampoline stubs in
// generateOptoStub.  Registers not mentioned will be killed by the VM
// call in the trampoline, and arguments in those registers not be
// available to the callee.
bool Matcher::can_be_java_arg(int reg)
{
  return
    reg ==  R10_num || reg == R10_H_num ||
    reg ==  R11_num || reg == R11_H_num ||
    reg ==  R12_num || reg == R12_H_num ||
    reg ==  R13_num || reg == R13_H_num ||
    reg ==  R14_num || reg == R14_H_num ||
    reg ==  R15_num || reg == R15_H_num ||
    reg ==  R16_num || reg == R16_H_num ||
    reg ==  R17_num || reg == R17_H_num ||
    reg ==  F10_num || reg == F10_H_num ||
    reg ==  F11_num || reg == F11_H_num ||
    reg ==  F12_num || reg == F12_H_num ||
    reg ==  F13_num || reg == F13_H_num ||
    reg ==  F14_num || reg == F14_H_num ||
    reg ==  F15_num || reg == F15_H_num ||
    reg ==  F16_num || reg == F16_H_num ||
    reg ==  F17_num || reg == F17_H_num;
}

bool Matcher::is_spillable_arg(int reg)
{
  return can_be_java_arg(reg);
}

uint Matcher::int_pressure_limit()
{
  // A derived pointer is live at CallNode and then is flagged by RA
  // as a spilled LRG. Spilling heuristics(Spill-USE) explicitly skip
  // derived pointers and lastly fail to spill after reaching maximum
  // number of iterations. Lowering the default pressure threshold to
  // (_NO_SPECIAL_REG32_mask.Size() minus 1) forces CallNode to become
  // a high register pressure area of the code so that split_DEF can
  // generate DefinitionSpillCopy for the derived pointer.
  uint default_int_pressure_threshold = _NO_SPECIAL_REG32_mask.Size() - 1;
  if (!PreserveFramePointer) {
    // When PreserveFramePointer is off, frame pointer is allocatable,
    // but different from other SOC registers, it is excluded from
    // fatproj's mask because its save type is No-Save. Decrease 1 to
    // ensure high pressure at fatproj when PreserveFramePointer is off.
    // See check_pressure_at_fatproj().
    default_int_pressure_threshold--;
  }
  return (INTPRESSURE == -1) ? default_int_pressure_threshold : INTPRESSURE;
}

uint Matcher::float_pressure_limit()
{
  // _FLOAT_REG_mask is generated by adlc from the float_reg register class.
  return (FLOATPRESSURE == -1) ? _FLOAT_REG_mask.Size() : FLOATPRESSURE;
}

bool Matcher::use_asm_for_ldiv_by_con(jlong divisor) {
  return false;
}

RegMask Matcher::divI_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

// Register for MODI projection of divmodI.
RegMask Matcher::modI_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

// Register for DIVL projection of divmodL.
RegMask Matcher::divL_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

// Register for MODL projection of divmodL.
RegMask Matcher::modL_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

const RegMask Matcher::method_handle_invoke_SP_save_mask() {
  return FP_REG_mask();
}

bool size_fits_all_mem_uses(AddPNode* addp, int shift) {
  assert_cond(addp != NULL);
  for (DUIterator_Fast imax, i = addp->fast_outs(imax); i < imax; i++) {
    Node* u = addp->fast_out(i);
    if (u != NULL && u->is_Mem()) {
      int opsize = u->as_Mem()->memory_size();
      assert(opsize > 0, "unexpected memory operand size");
      if (u->as_Mem()->memory_size() != (1 << shift)) {
        return false;
      }
    }
  }
  return true;
}

// Should the Matcher clone input 'm' of node 'n'?
bool Matcher::pd_clone_node(Node* n, Node* m, Matcher::MStack& mstack) {
  assert_cond(m != NULL);
  if (is_vshift_con_pattern(n, m)) { // ShiftV src (ShiftCntV con)
    mstack.push(m, Visit);           // m = ShiftCntV
    return true;
  }
  return false;
}

// Should the Matcher clone shifts on addressing modes, expecting them
// to be subsumed into complex addressing expressions or compute them
// into registers?
bool Matcher::pd_clone_address_expressions(AddPNode* m, Matcher::MStack& mstack, VectorSet& address_visited) {
  return clone_base_plus_offset_address(m, mstack, address_visited);
}


#line 1141 "ad_riscv.cpp"


//SourceForm

#line 31 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"


  static void loadStore(C2_MacroAssembler masm, bool is_store,
                        VectorRegister reg, BasicType bt, Register base,
                        int vector_length, Assembler::VectorMask vm = Assembler::unmasked) {
    Assembler::SEW sew = Assembler::elemtype_to_sew(bt);
    masm.vsetvli_helper(bt, vector_length);

    if (is_store) {
      masm.vsex_v(reg, base, sew, vm);
    } else {
      if (vm == Assembler::v0_t) {
        masm.vxor_vv(reg, reg, reg);
      }
      masm.vlex_v(reg, base, sew, vm);
    }
  }

  bool Matcher::match_rule_supported_superword(int opcode, int vlen, BasicType bt) {
    return match_rule_supported_vector(opcode, vlen, bt);
  }

  // Identify extra cases that we might want to provide match rules for vector nodes
  // and other intrinsics guarded with vector length (vlen) and element type (bt).
  bool Matcher::match_rule_supported_vector(int opcode, int vlen, BasicType bt) {
    if (!UseRVV) {
      return false;
    }

    if (!match_rule_supported(opcode) || !vector_size_supported(bt, vlen)) {
      return false;
    }

    switch (opcode) {
      case Op_VectorMaskLastTrue:
        if (!UseZbb || vlen > XLEN) {
          return false;
        }
        break;
      case Op_VectorMaskToLong:
      case Op_VectorLongToMask:
        if (vlen > XLEN) {
          return false;
        }
        break;
      default:
        break;
    }
    return true;
  }

  bool Matcher::match_rule_supported_vector_masked(int opcode, int vlen, BasicType bt) {
    if (!UseRVV) {
      return false;
    }
    return match_rule_supported_vector(opcode, vlen, bt);
  }

  bool Matcher::vector_needs_partial_operations(Node* node, const TypeVect* vt) {
    return false;
  }


#line 1210 "ad_riscv.cpp"


//SourceForm

#line 33 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/x/x_riscv.ad"


static void x_load_barrier(MacroAssembler& _masm, const MachNode* node, Address ref_addr, Register ref, Register tmp, int barrier_data) {
  if (barrier_data == XLoadBarrierElided) {
    return;
  }
  XLoadBarrierStubC2* const stub = XLoadBarrierStubC2::create(node, ref_addr, ref, tmp, barrier_data);
  __ ld(tmp, Address(xthread, XThreadLocalData::address_bad_mask_offset()));
  __ andr(tmp, tmp, ref);
  __ bnez(tmp, *stub->entry(), true /* far */);
  __ bind(*stub->continuation());
}

static void x_load_barrier_slow_path(MacroAssembler& _masm, const MachNode* node, Address ref_addr, Register ref, Register tmp) {
  XLoadBarrierStubC2* const stub = XLoadBarrierStubC2::create(node, ref_addr, ref, tmp, XLoadBarrierStrong);
  __ j(*stub->entry());
  __ bind(*stub->continuation());
}


#line 1236 "ad_riscv.cpp"


//SourceForm

#line 33 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/z/z_riscv.ad"

#include "gc/z/zBarrierSetAssembler.hpp"

static void z_color(MacroAssembler& _masm, const MachNode* node, Register dst, Register src, Register tmp) {
  assert_different_registers(dst, tmp);

  __ relocate(barrier_Relocation::spec(), [&] {
    __ li16u(tmp, barrier_Relocation::unpatched);
  }, ZBarrierRelocationFormatStoreGoodBits);
  __ slli(dst, src, ZPointerLoadShift);
  __ orr(dst, dst, tmp);
}

static void z_uncolor(MacroAssembler& _masm, const MachNode* node, Register ref) {
  __ srli(ref, ref, ZPointerLoadShift);
}

static void check_color(MacroAssembler& _masm, Register ref, bool on_non_strong, Register result) {
  int format = on_non_strong ? ZBarrierRelocationFormatMarkBadMask
                             : ZBarrierRelocationFormatLoadBadMask;
  __ relocate(barrier_Relocation::spec(), [&] {
    __ li16u(result, barrier_Relocation::unpatched);
  }, format);
  __ andr(result, ref, result);
}

static void z_load_barrier(MacroAssembler& _masm, const MachNode* node, Address ref_addr, Register ref, Register tmp) {
  const bool on_non_strong =
      ((node->barrier_data() & ZBarrierWeak) != 0) ||
      ((node->barrier_data() & ZBarrierPhantom) != 0);

  if (node->barrier_data() == ZBarrierElided) {
    z_uncolor(_masm, node, ref);
    return;
  }

  ZLoadBarrierStubC2* const stub = ZLoadBarrierStubC2::create(node, ref_addr, ref);
  Label good;
  check_color(_masm, ref, on_non_strong, tmp);
  __ beqz(tmp, good);
  __ j(*stub->entry());

  __ bind(good);
  z_uncolor(_masm, node, ref);
  __ bind(*stub->continuation());
}

static void z_store_barrier(MacroAssembler& _masm, const MachNode* node, Address ref_addr, Register rnew_zaddress, Register rnew_zpointer, Register tmp, bool is_atomic) {
  if (node->barrier_data() == ZBarrierElided) {
    z_color(_masm, node, rnew_zpointer, rnew_zaddress, t0);
  } else {
    bool is_native = (node->barrier_data() & ZBarrierNative) != 0;
    ZStoreBarrierStubC2* const stub = ZStoreBarrierStubC2::create(node, ref_addr, rnew_zaddress, rnew_zpointer, is_native, is_atomic);
    ZBarrierSetAssembler* bs_asm = ZBarrierSet::assembler();
    bs_asm->store_barrier_fast(&_masm, ref_addr, rnew_zaddress, rnew_zpointer, tmp, true /* in_nmethod */, is_atomic, *stub->entry(), *stub->continuation());
  }
}

#line 1300 "ad_riscv.cpp"


#ifndef PRODUCT
void Compile::adlc_verification() {

  // Following assertions generated from definition section
  assert( DEFAULT_COST == 100, "Expect (100) to equal 100");
  assert( ALU_COST == 100, "Expect (1 * DEFAULT_COST) to equal 100");
  assert( LOAD_COST == 300, "Expect (3 * DEFAULT_COST) to equal 300");
  assert( STORE_COST == 100, "Expect (1 * DEFAULT_COST) to equal 100");
  assert( XFER_COST == 300, "Expect (3 * DEFAULT_COST) to equal 300");
  assert( BRANCH_COST == 200, "Expect (2 * DEFAULT_COST) to equal 200");
  assert( IMUL_COST == 1000, "Expect (10 * DEFAULT_COST) to equal 1000");
  assert( IDIVSI_COST == 3400, "Expect (34 * DEFAULT_COST) to equal 3400");
  assert( IDIVDI_COST == 6600, "Expect (66 * DEFAULT_COST) to equal 6600");
  assert( FMUL_SINGLE_COST == 500, "Expect (5 * DEFAULT_COST) to equal 500");
  assert( FMUL_DOUBLE_COST == 700, "Expect (7 * DEFAULT_COST) to equal 700");
  assert( FDIV_COST == 2000, "Expect (20 * DEFAULT_COST) to equal 2000");
  assert( FSQRT_COST == 2500, "Expect (25 * DEFAULT_COST) to equal 2500");
  assert( VOLATILE_REF_COST == 1000, "Expect (10 * DEFAULT_COST) to equal 1000");
  assert( CACHE_MISS_COST == 2000, "Expect (20 * DEFAULT_COST) to equal 2000");
  assert( VEC_COST == 200, "Expect (200) to equal 200");
}
#endif

// Map from machine-independent register number to register_save_policy
const        char register_save_policy[] = {
  'C', // R7
  'C', // R7_H
  'C', // R28
  'C', // R28_H
  'C', // R29
  'C', // R29_H
  'C', // R30
  'C', // R30_H
  'C', // R31
  'C', // R31_H
  'C', // R10
  'C', // R10_H
  'C', // R11
  'C', // R11_H
  'C', // R12
  'C', // R12_H
  'C', // R13
  'C', // R13_H
  'C', // R14
  'C', // R14_H
  'C', // R15
  'C', // R15_H
  'C', // R16
  'C', // R16_H
  'C', // R17
  'C', // R17_H
  'C', // R9
  'C', // R9_H
  'C', // R18
  'C', // R18_H
  'C', // R19
  'C', // R19_H
  'C', // R20
  'C', // R20_H
  'C', // R21
  'C', // R21_H
  'C', // R22
  'C', // R22_H
  'C', // R24
  'C', // R24_H
  'C', // R25
  'C', // R25_H
  'C', // R26
  'C', // R26_H
  'N', // R23
  'N', // R23_H
  'C', // R27
  'C', // R27_H
  'N', // R4
  'N', // R4_H
  'N', // R8
  'N', // R8_H
  'N', // R0
  'N', // R0_H
  'N', // R1
  'N', // R1_H
  'N', // R2
  'N', // R2_H
  'N', // R3
  'N', // R3_H
  'C', // F0
  'C', // F0_H
  'C', // F1
  'C', // F1_H
  'C', // F2
  'C', // F2_H
  'C', // F3
  'C', // F3_H
  'C', // F4
  'C', // F4_H
  'C', // F5
  'C', // F5_H
  'C', // F6
  'C', // F6_H
  'C', // F7
  'C', // F7_H
  'C', // F28
  'C', // F28_H
  'C', // F29
  'C', // F29_H
  'C', // F30
  'C', // F30_H
  'C', // F31
  'C', // F31_H
  'C', // F10
  'C', // F10_H
  'C', // F11
  'C', // F11_H
  'C', // F12
  'C', // F12_H
  'C', // F13
  'C', // F13_H
  'C', // F14
  'C', // F14_H
  'C', // F15
  'C', // F15_H
  'C', // F16
  'C', // F16_H
  'C', // F17
  'C', // F17_H
  'C', // F8
  'C', // F8_H
  'C', // F9
  'C', // F9_H
  'C', // F18
  'C', // F18_H
  'C', // F19
  'C', // F19_H
  'C', // F20
  'C', // F20_H
  'C', // F21
  'C', // F21_H
  'C', // F22
  'C', // F22_H
  'C', // F23
  'C', // F23_H
  'C', // F24
  'C', // F24_H
  'C', // F25
  'C', // F25_H
  'C', // F26
  'C', // F26_H
  'C', // F27
  'C', // F27_H
  'C', // V0
  'C', // V0_H
  'C', // V0_J
  'C', // V0_K
  'C', // V1
  'C', // V1_H
  'C', // V1_J
  'C', // V1_K
  'C', // V2
  'C', // V2_H
  'C', // V2_J
  'C', // V2_K
  'C', // V3
  'C', // V3_H
  'C', // V3_J
  'C', // V3_K
  'C', // V4
  'C', // V4_H
  'C', // V4_J
  'C', // V4_K
  'C', // V5
  'C', // V5_H
  'C', // V5_J
  'C', // V5_K
  'C', // V6
  'C', // V6_H
  'C', // V6_J
  'C', // V6_K
  'C', // V7
  'C', // V7_H
  'C', // V7_J
  'C', // V7_K
  'C', // V8
  'C', // V8_H
  'C', // V8_J
  'C', // V8_K
  'C', // V9
  'C', // V9_H
  'C', // V9_J
  'C', // V9_K
  'C', // V10
  'C', // V10_H
  'C', // V10_J
  'C', // V10_K
  'C', // V11
  'C', // V11_H
  'C', // V11_J
  'C', // V11_K
  'C', // V12
  'C', // V12_H
  'C', // V12_J
  'C', // V12_K
  'C', // V13
  'C', // V13_H
  'C', // V13_J
  'C', // V13_K
  'C', // V14
  'C', // V14_H
  'C', // V14_J
  'C', // V14_K
  'C', // V15
  'C', // V15_H
  'C', // V15_J
  'C', // V15_K
  'C', // V16
  'C', // V16_H
  'C', // V16_J
  'C', // V16_K
  'C', // V17
  'C', // V17_H
  'C', // V17_J
  'C', // V17_K
  'C', // V18
  'C', // V18_H
  'C', // V18_J
  'C', // V18_K
  'C', // V19
  'C', // V19_H
  'C', // V19_J
  'C', // V19_K
  'C', // V20
  'C', // V20_H
  'C', // V20_J
  'C', // V20_K
  'C', // V21
  'C', // V21_H
  'C', // V21_J
  'C', // V21_K
  'C', // V22
  'C', // V22_H
  'C', // V22_J
  'C', // V22_K
  'C', // V23
  'C', // V23_H
  'C', // V23_J
  'C', // V23_K
  'C', // V24
  'C', // V24_H
  'C', // V24_J
  'C', // V24_K
  'C', // V25
  'C', // V25_H
  'C', // V25_J
  'C', // V25_K
  'C', // V26
  'C', // V26_H
  'C', // V26_J
  'C', // V26_K
  'C', // V27
  'C', // V27_H
  'C', // V27_J
  'C', // V27_K
  'C', // V28
  'C', // V28_H
  'C', // V28_J
  'C', // V28_K
  'C', // V29
  'C', // V29_H
  'C', // V29_J
  'C', // V29_K
  'C', // V30
  'C', // V30_H
  'C', // V30_J
  'C', // V30_K
  'C', // V31
  'C', // V31_H
  'C', // V31_J
  'C', // V31_K
  'C' // no trailing comma // RFLAGS
};

// Map from machine-independent register number to c_reg_save_policy
const        char c_reg_save_policy[] = {
  'C', // R7
  'C', // R7_H
  'C', // R28
  'C', // R28_H
  'C', // R29
  'C', // R29_H
  'C', // R30
  'C', // R30_H
  'C', // R31
  'C', // R31_H
  'C', // R10
  'C', // R10_H
  'C', // R11
  'C', // R11_H
  'C', // R12
  'C', // R12_H
  'C', // R13
  'C', // R13_H
  'C', // R14
  'C', // R14_H
  'C', // R15
  'C', // R15_H
  'C', // R16
  'C', // R16_H
  'C', // R17
  'C', // R17_H
  'E', // R9
  'E', // R9_H
  'E', // R18
  'E', // R18_H
  'E', // R19
  'E', // R19_H
  'E', // R20
  'E', // R20_H
  'E', // R21
  'E', // R21_H
  'E', // R22
  'E', // R22_H
  'E', // R24
  'E', // R24_H
  'E', // R25
  'E', // R25_H
  'E', // R26
  'E', // R26_H
  'E', // R23
  'E', // R23_H
  'E', // R27
  'E', // R27_H
  'N', // R4
  'N', // R4_H
  'E', // R8
  'E', // R8_H
  'N', // R0
  'N', // R0_H
  'C', // R1
  'C', // R1_H
  'E', // R2
  'E', // R2_H
  'N', // R3
  'N', // R3_H
  'C', // F0
  'C', // F0_H
  'C', // F1
  'C', // F1_H
  'C', // F2
  'C', // F2_H
  'C', // F3
  'C', // F3_H
  'C', // F4
  'C', // F4_H
  'C', // F5
  'C', // F5_H
  'C', // F6
  'C', // F6_H
  'C', // F7
  'C', // F7_H
  'C', // F28
  'C', // F28_H
  'C', // F29
  'C', // F29_H
  'C', // F30
  'C', // F30_H
  'C', // F31
  'C', // F31_H
  'C', // F10
  'C', // F10_H
  'C', // F11
  'C', // F11_H
  'C', // F12
  'C', // F12_H
  'C', // F13
  'C', // F13_H
  'C', // F14
  'C', // F14_H
  'C', // F15
  'C', // F15_H
  'C', // F16
  'C', // F16_H
  'C', // F17
  'C', // F17_H
  'E', // F8
  'E', // F8_H
  'E', // F9
  'E', // F9_H
  'E', // F18
  'E', // F18_H
  'E', // F19
  'E', // F19_H
  'E', // F20
  'E', // F20_H
  'E', // F21
  'E', // F21_H
  'E', // F22
  'E', // F22_H
  'E', // F23
  'E', // F23_H
  'E', // F24
  'E', // F24_H
  'E', // F25
  'E', // F25_H
  'E', // F26
  'E', // F26_H
  'E', // F27
  'E', // F27_H
  'C', // V0
  'C', // V0_H
  'C', // V0_J
  'C', // V0_K
  'C', // V1
  'C', // V1_H
  'C', // V1_J
  'C', // V1_K
  'C', // V2
  'C', // V2_H
  'C', // V2_J
  'C', // V2_K
  'C', // V3
  'C', // V3_H
  'C', // V3_J
  'C', // V3_K
  'C', // V4
  'C', // V4_H
  'C', // V4_J
  'C', // V4_K
  'C', // V5
  'C', // V5_H
  'C', // V5_J
  'C', // V5_K
  'C', // V6
  'C', // V6_H
  'C', // V6_J
  'C', // V6_K
  'C', // V7
  'C', // V7_H
  'C', // V7_J
  'C', // V7_K
  'C', // V8
  'C', // V8_H
  'C', // V8_J
  'C', // V8_K
  'C', // V9
  'C', // V9_H
  'C', // V9_J
  'C', // V9_K
  'C', // V10
  'C', // V10_H
  'C', // V10_J
  'C', // V10_K
  'C', // V11
  'C', // V11_H
  'C', // V11_J
  'C', // V11_K
  'C', // V12
  'C', // V12_H
  'C', // V12_J
  'C', // V12_K
  'C', // V13
  'C', // V13_H
  'C', // V13_J
  'C', // V13_K
  'C', // V14
  'C', // V14_H
  'C', // V14_J
  'C', // V14_K
  'C', // V15
  'C', // V15_H
  'C', // V15_J
  'C', // V15_K
  'C', // V16
  'C', // V16_H
  'C', // V16_J
  'C', // V16_K
  'C', // V17
  'C', // V17_H
  'C', // V17_J
  'C', // V17_K
  'C', // V18
  'C', // V18_H
  'C', // V18_J
  'C', // V18_K
  'C', // V19
  'C', // V19_H
  'C', // V19_J
  'C', // V19_K
  'C', // V20
  'C', // V20_H
  'C', // V20_J
  'C', // V20_K
  'C', // V21
  'C', // V21_H
  'C', // V21_J
  'C', // V21_K
  'C', // V22
  'C', // V22_H
  'C', // V22_J
  'C', // V22_K
  'C', // V23
  'C', // V23_H
  'C', // V23_J
  'C', // V23_K
  'C', // V24
  'C', // V24_H
  'C', // V24_J
  'C', // V24_K
  'C', // V25
  'C', // V25_H
  'C', // V25_J
  'C', // V25_K
  'C', // V26
  'C', // V26_H
  'C', // V26_J
  'C', // V26_K
  'C', // V27
  'C', // V27_H
  'C', // V27_J
  'C', // V27_K
  'C', // V28
  'C', // V28_H
  'C', // V28_J
  'C', // V28_K
  'C', // V29
  'C', // V29_H
  'C', // V29_J
  'C', // V29_K
  'C', // V30
  'C', // V30_H
  'C', // V30_J
  'C', // V30_K
  'C', // V31
  'C', // V31_H
  'C', // V31_J
  'C', // V31_K
  'C' // no trailing comma // RFLAGS
};

// Map from machine-independent register number to register_save_type
const        int register_save_type[] = {
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_VecA,
  Op_RegFlags // no trailing comma
};


const        int   reduceOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  immI_rule,
  /*    9 */  immI0_rule,
  /*   10 */  immI_1_rule,
  /*   11 */  immI_M1_rule,
  /*   12 */  uimmI6_ge32_rule,
  /*   13 */  immI_le_4_rule,
  /*   14 */  immI_16_rule,
  /*   15 */  immI_24_rule,
  /*   16 */  immI_31_rule,
  /*   17 */  immI_63_rule,
  /*   18 */  immIAdd_rule,
  /*   19 */  immISub_rule,
  /*   20 */  immI5_rule,
  /*   21 */  immL5_rule,
  /*   22 */  immL_rule,
  /*   23 */  immL0_rule,
  /*   24 */  immP_rule,
  /*   25 */  immP0_rule,
  /*   26 */  immP_1_rule,
  /*   27 */  immByteMapBase_rule,
  /*   28 */  immI_16bits_rule,
  /*   29 */  immIpowerOf2_rule,
  /*   30 */  immL_32bits_rule,
  /*   31 */  immL_M1_rule,
  /*   32 */  immL_pc_off_rule,
  /*   33 */  immLAdd_rule,
  /*   34 */  immLSub_rule,
  /*   35 */  immN_rule,
  /*   36 */  immN0_rule,
  /*   37 */  immNKlass_rule,
  /*   38 */  immD_rule,
  /*   39 */  immD0_rule,
  /*   40 */  immF_rule,
  /*   41 */  immF0_rule,
  /*   42 */  immIOffset_rule,
  /*   43 */  immLOffset_rule,
  /*   44 */  immIScale_rule,
  /*   45 */  iRegI_rule,
  /*   46 */  iRegINoSp_rule,
  /*   47 */  iRegI_R10_rule,
  /*   48 */  iRegI_R12_rule,
  /*   49 */  iRegI_R13_rule,
  /*   50 */  iRegI_R14_rule,
  /*   51 */  iRegL_rule,
  /*   52 */  iRegLNoSp_rule,
  /*   53 */  iRegL_R28_rule,
  /*   54 */  iRegL_R29_rule,
  /*   55 */  iRegL_R30_rule,
  /*   56 */  iRegP_rule,
  /*   57 */  iRegPNoSp_rule,
  /*   58 */  iRegP_R10_rule,
  /*   59 */  iRegP_R11_rule,
  /*   60 */  iRegP_R12_rule,
  /*   61 */  iRegP_R13_rule,
  /*   62 */  iRegP_R14_rule,
  /*   63 */  iRegP_R15_rule,
  /*   64 */  iRegP_R16_rule,
  /*   65 */  iRegP_R28_rule,
  /*   66 */  iRegP_R30_rule,
  /*   67 */  iRegP_R31_rule,
  /*   68 */  iRegN_rule,
  /*   69 */  iRegNNoSp_rule,
  /*   70 */  iRegL_R10_rule,
  /*   71 */  fRegF_rule,
  /*   72 */  fRegD_rule,
  /*   73 */  vReg_rule,
  /*   74 */  vReg_V1_rule,
  /*   75 */  vReg_V2_rule,
  /*   76 */  vReg_V3_rule,
  /*   77 */  vReg_V4_rule,
  /*   78 */  vReg_V5_rule,
  /*   79 */  vReg_V6_rule,
  /*   80 */  vReg_V7_rule,
  /*   81 */  vReg_V8_rule,
  /*   82 */  vReg_V9_rule,
  /*   83 */  vReg_V10_rule,
  /*   84 */  vReg_V11_rule,
  /*   85 */  vReg_V12_rule,
  /*   86 */  vReg_V13_rule,
  /*   87 */  vReg_V14_rule,
  /*   88 */  vReg_V15_rule,
  /*   89 */  vRegMask_rule,
  /*   90 */  vRegMask_V0_rule,
  /*   91 */  javaThread_RegP_rule,
  /*   92 */  indirect_rule,
  /*   93 */  indOffI_rule,
  /*   94 */  indOffL_rule,
  /*   95 */  indirectN_rule,
  /*   96 */  indOffIN_rule,
  /*   97 */  indOffLN_rule,
  /*   98 */  thread_anchor_pc_rule,
  /*   99 */  stackSlotI_rule,
  /*  100 */  stackSlotF_rule,
  /*  101 */  stackSlotD_rule,
  /*  102 */  stackSlotL_rule,
  /*  103 */  iRegL2I_rule,
  /*  104 */  cmpOp_rule,
  /*  105 */  cmpOpU_rule,
  /*  106 */  cmpOpEqNe_rule,
  /*  107 */  cmpOpULtGe_rule,
  /*  108 */  cmpOpUEqNeLeGt_rule,
  /*  109 */  rFlagsReg_rule,
  /*  110 */  inline_cache_RegP_rule,
  // last operand
  /*  111 */  memory_rule,
  /*  112 */  iRegIorL2I_rule,
  /*  113 */  iRegIorL_rule,
  /*  114 */  iRegNorP_rule,
  /*  115 */  iRegILNP_rule,
  /*  116 */  iRegILNPNoSp_rule,
  /*  117 */  immIorL_rule,
  /*  118 */  vmemA_rule,
  // last operand class
  /*  119 */  _DecodeN_iRegN__rule,
  /*  120 */  _LoadB_memory__rule,
  /*  121 */  _LoadUB_memory__rule,
  /*  122 */  _LoadS_memory__rule,
  /*  123 */  _LoadUS_memory__rule,
  /*  124 */  _LoadI_memory__rule,
  /*  125 */  _ConvI2L__LoadI_memory___rule,
  /*  126 */  _Binary_iRegI_R12_iRegI_R13_rule,
  /*  127 */  _Binary_iRegI_iRegI_rule,
  /*  128 */  _Binary_iRegL_iRegL_rule,
  /*  129 */  _Binary_iRegP_iRegP_rule,
  /*  130 */  _Binary_iRegN_iRegN_rule,
  /*  131 */  _ConvL2I_iRegL__rule,
  /*  132 */  _ConvI2L_iRegI__rule,
  /*  133 */  _RShiftI_iRegIorL2I_immI_31_rule,
  /*  134 */  _RShiftL_iRegL_immI_63_rule,
  /*  135 */  _CastP2X_iRegP__rule,
  /*  136 */  _Binary_fRegF_fRegF_rule,
  /*  137 */  _Binary_fRegD_fRegD_rule,
  /*  138 */  _NegF_fRegF__rule,
  /*  139 */  _NegD_fRegD__rule,
  /*  140 */  _Binary_fRegF__NegF_fRegF__rule,
  /*  141 */  _Binary_fRegD__NegD_fRegD__rule,
  /*  142 */  _Binary_fRegD_immD_rule,
  /*  143 */  _Binary_immD_fRegD_rule,
  /*  144 */  _Binary_immF_fRegF_rule,
  /*  145 */  _ConvI2L_iRegIorL2I__rule,
  /*  146 */  _CastP2X__DecodeN_iRegN___rule,
  /*  147 */  _CmpI_iRegI_iRegI_rule,
  /*  148 */  _CmpU_iRegI_iRegI_rule,
  /*  149 */  _CmpL_iRegL_iRegL_rule,
  /*  150 */  _CmpUL_iRegL_iRegL_rule,
  /*  151 */  _CmpP_iRegP_iRegP_rule,
  /*  152 */  _CmpN_iRegN_iRegN_rule,
  /*  153 */  _CmpF_fRegF_fRegF_rule,
  /*  154 */  _CmpD_fRegD_fRegD_rule,
  /*  155 */  _CmpI_iRegI_immI0_rule,
  /*  156 */  _CmpU_iRegI_immI0_rule,
  /*  157 */  _CmpL_iRegL_immL0_rule,
  /*  158 */  _CmpUL_iRegL_immL0_rule,
  /*  159 */  _CmpP_iRegP_immP0_rule,
  /*  160 */  _CmpN_iRegN_immN0_rule,
  /*  161 */  _CmpP__DecodeN_iRegN__immP0_rule,
  /*  162 */  _Binary_cmpOp__CmpI_iRegI_iRegI_rule,
  /*  163 */  _Binary_iRegINoSp_iRegI_rule,
  /*  164 */  _Binary_cmpOpU__CmpU_iRegI_iRegI_rule,
  /*  165 */  _Binary_cmpOp__CmpL_iRegL_iRegL_rule,
  /*  166 */  _Binary_cmpOpU__CmpUL_iRegL_iRegL_rule,
  /*  167 */  _Binary_iRegLNoSp_iRegL_rule,
  /*  168 */  _PartialSubtypeCheck_iRegP_R14_iRegP_R10_rule,
  /*  169 */  _Binary_iRegP_R11_iRegI_R12_rule,
  /*  170 */  _Binary_iRegP_R13_iRegI_R14_rule,
  /*  171 */  _Binary_iRegP_R13_immI_le_4_rule,
  /*  172 */  _Binary_iRegP_R13_immI_1_rule,
  /*  173 */  _Binary_iRegP_R11_iRegP_R13_rule,
  /*  174 */  _Binary_vReg_vReg_rule,
  /*  175 */  _Binary_immI_vRegMask_V0_rule,
  /*  176 */  _Binary_vReg_vRegMask_V0_rule,
  /*  177 */  _NegVF_vReg__rule,
  /*  178 */  _Binary_vReg__NegVF_vReg__rule,
  /*  179 */  _NegVD_vReg__rule,
  /*  180 */  _Binary_vReg__NegVD_vReg__rule,
  /*  181 */  _Binary__NegVF_vReg__vRegMask_V0_rule,
  /*  182 */  _Binary__NegVD_vReg__vRegMask_V0_rule,
  /*  183 */  _MulVB_vReg_vReg_rule,
  /*  184 */  _MulVS_vReg_vReg_rule,
  /*  185 */  _MulVI_vReg_vReg_rule,
  /*  186 */  _MulVL_vReg_vReg_rule,
  /*  187 */  _Binary_vReg__MulVB_vReg_vReg_rule,
  /*  188 */  _Binary_vReg__MulVS_vReg_vReg_rule,
  /*  189 */  _Binary_vReg__MulVI_vReg_vReg_rule,
  /*  190 */  _Binary_vReg__MulVL_vReg_vReg_rule,
  /*  191 */  _Binary_iRegIorL2I_vReg_rule,
  /*  192 */  _Binary_iRegL_vReg_rule,
  /*  193 */  _Binary_fRegF_vReg_rule,
  /*  194 */  _Binary_fRegD_vReg_rule,
  /*  195 */  _RShiftCntV_immI__rule,
  /*  196 */  _Binary_vReg__RShiftCntV_immI__rule,
  /*  197 */  _LShiftCntV_immI__rule,
  /*  198 */  _Binary_vReg__LShiftCntV_immI__rule,
  /*  199 */  _Binary_iRegP_R11_iRegI_R13_rule,
  /*  200 */  _Binary_vReg__Binary_vReg_vRegMask_V0_rule,
  /*  201 */  _Binary_vReg_iRegIorL2I_rule,
  /*  202 */  _Binary_vReg_iRegL_rule,
  /*  203 */  _Binary_vReg_fRegF_rule,
  /*  204 */  _Binary_vReg_fRegD_rule,
  /*  205 */  _VectorTest_vRegMask_vRegMask_rule,
  /*  206 */  _Binary_cmpOp__VectorTest_vRegMask_vRegMask_rule,
  /*  207 */  _Binary_immI_1_immI0_rule,
  /*  208 */  _LShiftI_iRegIorL2I_immI_24_rule,
  /*  209 */  _LShiftI_iRegIorL2I_immI_16_rule,
  /*  210 */  _LShiftL_iRegL_immIScale_rule,
  /*  211 */  _LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  212 */  _XorI_iRegI_immI_M1_rule,
  /*  213 */  _XorL_iRegL_immL_M1_rule,
  /*  214 */  _AndI_iRegIorL2I_immIpowerOf2_rule,
  // last internally defined operand
  /*  215 */  iRegINoSp_rule,
  /*  216 */  iRegLNoSp_rule,
  /*  217 */  iRegPNoSp_rule,
  /*  218 */  iRegPNoSp_rule,
  /*  219 */  iRegPNoSp_rule,
  /*  220 */  iRegPNoSp_rule,
  /*  221 */  iRegNNoSp_rule,
  /*  222 */  iRegNNoSp_rule,
  /*  223 */  iRegNNoSp_rule,
  /*  224 */  fRegF_rule,
  /*  225 */  fRegF_rule,
  /*  226 */  fRegD_rule,
  /*  227 */  fRegD_rule,
  /*  228 */  iRegINoSp_rule,
  /*  229 */  iRegINoSp_rule,
  /*  230 */  iRegINoSp_rule,
  /*  231 */  iRegINoSp_rule,
  /*  232 */  fRegF_rule,
  /*  233 */  fRegD_rule,
  /*  234 */  iRegINoSp_rule,
  /*  235 */  iRegLNoSp_rule,
  /*  236 */  fRegF_rule,
  /*  237 */  fRegD_rule,
  /*  238 */  iRegPNoSp_rule,
  /*  239 */  iRegLNoSp_rule,
  /*  240 */  iRegPNoSp_rule,
  /*  241 */  iRegL_rule,
  /*  242 */  iRegI_rule,
  /*  243 */  iRegPNoSp_rule,
  /*  244 */  fRegF_rule,
  /*  245 */  fRegD_rule,
  /*  246 */  vReg_rule,
  /*  247 */  iRegINoSp_rule,
  /*  248 */  iRegINoSp_rule,
  /*  249 */  iRegINoSp_rule,
  /*  250 */  fRegF_rule,
  /*  251 */  iRegLNoSp_rule,
  /*  252 */  fRegD_rule,
  /*  253 */  iRegINoSp_rule,
  /*  254 */  fRegF_rule,
  /*  255 */  iRegLNoSp_rule,
  /*  256 */  fRegD_rule,
  /*  257 */  rFlagsReg_rule,
  /*  258 */  javaThread_RegP_rule,
  /*  259 */  rFlagsReg_rule,
  /*  260 */  rFlagsReg_rule,
  /*  261 */  vRegMask_rule,
  /*  262 */  vReg_rule,
  /*  263 */  vReg_rule,
  /*  264 */  vReg_rule,
  /*  265 */  vReg_rule,
  /*  266 */  vReg_rule,
  /*  267 */  vReg_rule,
  /*  268 */  vReg_rule,
  /*  269 */  vReg_rule,
  /*  270 */  vReg_rule,
  /*  271 */  vReg_rule,
  /*  272 */  vReg_rule,
  /*  273 */  vReg_rule,
  /*  274 */  vReg_rule,
  /*  275 */  vReg_rule,
  /*  276 */  vReg_rule,
  /*  277 */  vReg_rule,
  /*  278 */  vReg_rule,
  /*  279 */  vRegMask_rule,
  /*  280 */  vRegMask_rule,
  /*  281 */  vRegMask_rule,
  /*  282 */  vRegMask_rule,
  /*  283 */  vReg_rule,
  /*  284 */  vReg_rule,
  /*  285 */  vReg_rule,
  /*  286 */  vReg_rule,
  /*  287 */  vReg_rule,
  /*  288 */  vReg_rule,
  /*  289 */  vReg_rule,
  /*  290 */  vReg_rule,
  /*  291 */  vRegMask_rule,
  /*  292 */  iRegINoSp_rule,
  /*  293 */  iRegINoSp_rule,
  /*  294 */  iRegLNoSp_rule,
  /*  295 */  vRegMask_rule,
  /*  296 */  iRegINoSp_rule,
  /*  297 */  iRegINoSp_rule,
  /*  298 */  iRegINoSp_rule,
  /*  299 */  iRegINoSp_rule,
  /*  300 */  iRegINoSp_rule,
  /*  301 */  iRegINoSp_rule,
  /*  302 */  iRegINoSp_rule,
  /*  303 */  iRegLNoSp_rule,
  /*  304 */  iRegINoSp_rule,
  /*  305 */  iRegLNoSp_rule,
  /*  306 */  iRegINoSp_rule,
  /*  307 */  iRegLNoSp_rule,
  /*  308 */  iRegINoSp_rule,
  /*  309 */  iRegLNoSp_rule,
  /*  310 */  iRegINoSp_rule,
  /*  311 */  iRegLNoSp_rule,
  /*  312 */  iRegINoSp_rule,
  /*  313 */  iRegLNoSp_rule,
  /*  314 */  iRegLNoSp_rule,
  /*  315 */  iRegLNoSp_rule,
  /*  316 */  iRegINoSp_rule,
  /*  317 */  iRegPNoSp_rule,
  /*  318 */  iRegNNoSp_rule,
  /*  319 */  iRegPNoSp_rule,
  /*  320 */  iRegNNoSp_rule,
  /*  321 */  fRegF_rule,
  /*  322 */  fRegD_rule,
  /*  323 */  Universe_rule,
  /*  324 */  Universe_rule,
  /*  325 */  Universe_rule,
  /*  326 */  Universe_rule,
  /*  327 */  Universe_rule,
  /*  328 */  Universe_rule,
  /*  329 */  Universe_rule,
  /*  330 */  Universe_rule,
  /*  331 */  Universe_rule,
  /*  332 */  Universe_rule,
  /*  333 */  Universe_rule,
  /*  334 */  Universe_rule,
  /*  335 */  Universe_rule,
  /*  336 */  Universe_rule,
  /*  337 */  Universe_rule,
  /*  338 */  Universe_rule,
  /*  339 */  Universe_rule,
  /*  340 */  Universe_rule,
  /*  341 */  iRegINoSp_rule,
  /*  342 */  iRegINoSp_rule,
  /*  343 */  iRegINoSp_rule,
  /*  344 */  iRegINoSp_rule,
  /*  345 */  iRegINoSp_rule,
  /*  346 */  iRegINoSp_rule,
  /*  347 */  iRegINoSp_rule,
  /*  348 */  iRegINoSp_rule,
  /*  349 */  iRegINoSp_rule,
  /*  350 */  iRegINoSp_rule,
  /*  351 */  iRegINoSp_rule,
  /*  352 */  iRegINoSp_rule,
  /*  353 */  iRegINoSp_rule,
  /*  354 */  iRegINoSp_rule,
  /*  355 */  iRegINoSp_rule,
  /*  356 */  iRegLNoSp_rule,
  /*  357 */  iRegNNoSp_rule,
  /*  358 */  iRegPNoSp_rule,
  /*  359 */  iRegINoSp_rule,
  /*  360 */  iRegINoSp_rule,
  /*  361 */  iRegINoSp_rule,
  /*  362 */  iRegLNoSp_rule,
  /*  363 */  iRegNNoSp_rule,
  /*  364 */  iRegPNoSp_rule,
  /*  365 */  iRegINoSp_rule,
  /*  366 */  iRegINoSp_rule,
  /*  367 */  iRegINoSp_rule,
  /*  368 */  iRegINoSp_rule,
  /*  369 */  iRegINoSp_rule,
  /*  370 */  iRegINoSp_rule,
  /*  371 */  iRegINoSp_rule,
  /*  372 */  iRegINoSp_rule,
  /*  373 */  iRegINoSp_rule,
  /*  374 */  iRegINoSp_rule,
  /*  375 */  iRegINoSp_rule,
  /*  376 */  iRegINoSp_rule,
  /*  377 */  iRegINoSp_rule,
  /*  378 */  iRegLNoSp_rule,
  /*  379 */  iRegINoSp_rule,
  /*  380 */  iRegPNoSp_rule,
  /*  381 */  iRegINoSp_rule,
  /*  382 */  iRegLNoSp_rule,
  /*  383 */  iRegINoSp_rule,
  /*  384 */  iRegPNoSp_rule,
  /*  385 */  iRegLNoSp_rule,
  /*  386 */  Universe_rule,
  /*  387 */  iRegLNoSp_rule,
  /*  388 */  Universe_rule,
  /*  389 */  iRegINoSp_rule,
  /*  390 */  Universe_rule,
  /*  391 */  iRegINoSp_rule,
  /*  392 */  Universe_rule,
  /*  393 */  iRegLNoSp_rule,
  /*  394 */  Universe_rule,
  /*  395 */  iRegLNoSp_rule,
  /*  396 */  Universe_rule,
  /*  397 */  iRegINoSp_rule,
  /*  398 */  Universe_rule,
  /*  399 */  iRegINoSp_rule,
  /*  400 */  Universe_rule,
  /*  401 */  iRegINoSp_rule,
  /*  402 */  iRegINoSp_rule,
  /*  403 */  iRegINoSp_rule,
  /*  404 */  iRegPNoSp_rule,
  /*  405 */  iRegLNoSp_rule,
  /*  406 */  iRegPNoSp_rule,
  /*  407 */  iRegLNoSp_rule,
  /*  408 */  iRegLNoSp_rule,
  /*  409 */  iRegINoSp_rule,
  /*  410 */  iRegINoSp_rule,
  /*  411 */  iRegLNoSp_rule,
  /*  412 */  iRegLNoSp_rule,
  /*  413 */  iRegINoSp_rule,
  /*  414 */  iRegLNoSp_rule,
  /*  415 */  iRegINoSp_rule,
  /*  416 */  iRegLNoSp_rule,
  /*  417 */  iRegLNoSp_rule,
  /*  418 */  iRegLNoSp_rule,
  /*  419 */  iRegINoSp_rule,
  /*  420 */  iRegINoSp_rule,
  /*  421 */  iRegINoSp_rule,
  /*  422 */  iRegLNoSp_rule,
  /*  423 */  iRegLNoSp_rule,
  /*  424 */  iRegLNoSp_rule,
  /*  425 */  iRegINoSp_rule,
  /*  426 */  iRegINoSp_rule,
  /*  427 */  iRegLNoSp_rule,
  /*  428 */  iRegLNoSp_rule,
  /*  429 */  iRegINoSp_rule,
  /*  430 */  iRegINoSp_rule,
  /*  431 */  iRegINoSp_rule,
  /*  432 */  iRegINoSp_rule,
  /*  433 */  iRegINoSp_rule,
  /*  434 */  iRegINoSp_rule,
  /*  435 */  iRegLNoSp_rule,
  /*  436 */  iRegLNoSp_rule,
  /*  437 */  iRegLNoSp_rule,
  /*  438 */  iRegLNoSp_rule,
  /*  439 */  iRegLNoSp_rule,
  /*  440 */  iRegLNoSp_rule,
  /*  441 */  iRegLNoSp_rule,
  /*  442 */  iRegINoSp_rule,
  /*  443 */  iRegLNoSp_rule,
  /*  444 */  fRegF_rule,
  /*  445 */  fRegD_rule,
  /*  446 */  fRegF_rule,
  /*  447 */  fRegD_rule,
  /*  448 */  fRegF_rule,
  /*  449 */  fRegD_rule,
  /*  450 */  fRegF_rule,
  /*  451 */  fRegD_rule,
  /*  452 */  fRegF_rule,
  /*  453 */  fRegD_rule,
  /*  454 */  fRegF_rule,
  /*  455 */  fRegD_rule,
  /*  456 */  fRegF_rule,
  /*  457 */  fRegD_rule,
  /*  458 */  fRegF_rule,
  /*  459 */  fRegF_rule,
  /*  460 */  fRegD_rule,
  /*  461 */  fRegD_rule,
  /*  462 */  fRegF_rule,
  /*  463 */  fRegD_rule,
  /*  464 */  fRegF_rule,
  /*  465 */  fRegD_rule,
  /*  466 */  fRegD_rule,
  /*  467 */  fRegD_rule,
  /*  468 */  fRegF_rule,
  /*  469 */  fRegD_rule,
  /*  470 */  fRegF_rule,
  /*  471 */  iRegINoSp_rule,
  /*  472 */  iRegINoSp_rule,
  /*  473 */  iRegINoSp_rule,
  /*  474 */  iRegINoSp_rule,
  /*  475 */  iRegINoSp_rule,
  /*  476 */  iRegINoSp_rule,
  /*  477 */  iRegLNoSp_rule,
  /*  478 */  iRegLNoSp_rule,
  /*  479 */  iRegLNoSp_rule,
  /*  480 */  iRegLNoSp_rule,
  /*  481 */  iRegLNoSp_rule,
  /*  482 */  iRegLNoSp_rule,
  /*  483 */  iRegINoSp_rule,
  /*  484 */  iRegLNoSp_rule,
  /*  485 */  iRegINoSp_rule,
  /*  486 */  iRegINoSp_rule,
  /*  487 */  Universe_rule,
  /*  488 */  Universe_rule,
  /*  489 */  Universe_rule,
  /*  490 */  Universe_rule,
  /*  491 */  Universe_rule,
  /*  492 */  Universe_rule,
  /*  493 */  Universe_rule,
  /*  494 */  Universe_rule,
  /*  495 */  Universe_rule,
  /*  496 */  Universe_rule,
  /*  497 */  iRegLNoSp_rule,
  /*  498 */  iRegINoSp_rule,
  /*  499 */  iRegLNoSp_rule,
  /*  500 */  fRegD_rule,
  /*  501 */  fRegF_rule,
  /*  502 */  iRegINoSp_rule,
  /*  503 */  fRegF_rule,
  /*  504 */  iRegLNoSp_rule,
  /*  505 */  fRegF_rule,
  /*  506 */  iRegINoSp_rule,
  /*  507 */  fRegD_rule,
  /*  508 */  iRegLNoSp_rule,
  /*  509 */  fRegD_rule,
  /*  510 */  iRegINoSp_rule,
  /*  511 */  iRegINoSp_rule,
  /*  512 */  iRegNNoSp_rule,
  /*  513 */  iRegPNoSp_rule,
  /*  514 */  iRegPNoSp_rule,
  /*  515 */  iRegNNoSp_rule,
  /*  516 */  iRegPNoSp_rule,
  /*  517 */  stackSlotI_rule,
  /*  518 */  stackSlotF_rule,
  /*  519 */  stackSlotL_rule,
  /*  520 */  stackSlotD_rule,
  /*  521 */  iRegINoSp_rule,
  /*  522 */  iRegINoSp_rule,
  /*  523 */  iRegINoSp_rule,
  /*  524 */  iRegINoSp_rule,
  /*  525 */  iRegINoSp_rule,
  /*  526 */  iRegINoSp_rule,
  /*  527 */  iRegINoSp_rule,
  /*  528 */  iRegINoSp_rule,
  /*  529 */  iRegINoSp_rule,
  /*  530 */  iRegINoSp_rule,
  /*  531 */  iRegINoSp_rule,
  /*  532 */  iRegINoSp_rule,
  /*  533 */  iRegINoSp_rule,
  /*  534 */  iRegINoSp_rule,
  /*  535 */  iRegINoSp_rule,
  /*  536 */  Universe_rule,
  /*  537 */  Universe_rule,
  /*  538 */  Universe_rule,
  /*  539 */  Universe_rule,
  /*  540 */  Universe_rule,
  /*  541 */  Universe_rule,
  /*  542 */  Universe_rule,
  /*  543 */  Universe_rule,
  /*  544 */  Universe_rule,
  /*  545 */  Universe_rule,
  /*  546 */  Universe_rule,
  /*  547 */  Universe_rule,
  /*  548 */  Universe_rule,
  /*  549 */  Universe_rule,
  /*  550 */  Universe_rule,
  /*  551 */  Universe_rule,
  /*  552 */  Universe_rule,
  /*  553 */  Universe_rule,
  /*  554 */  Universe_rule,
  /*  555 */  Universe_rule,
  /*  556 */  Universe_rule,
  /*  557 */  Universe_rule,
  /*  558 */  Universe_rule,
  /*  559 */  Universe_rule,
  /*  560 */  Universe_rule,
  /*  561 */  Universe_rule,
  /*  562 */  Universe_rule,
  /*  563 */  Universe_rule,
  /*  564 */  Universe_rule,
  /*  565 */  Universe_rule,
  /*  566 */  Universe_rule,
  /*  567 */  Universe_rule,
  /*  568 */  Universe_rule,
  /*  569 */  Universe_rule,
  /*  570 */  Universe_rule,
  /*  571 */  Universe_rule,
  /*  572 */  Universe_rule,
  /*  573 */  Universe_rule,
  /*  574 */  Universe_rule,
  /*  575 */  Universe_rule,
  /*  576 */  Universe_rule,
  /*  577 */  Universe_rule,
  /*  578 */  Universe_rule,
  /*  579 */  iRegINoSp_rule,
  /*  580 */  iRegINoSp_rule,
  /*  581 */  iRegINoSp_rule,
  /*  582 */  iRegINoSp_rule,
  /*  583 */  iRegLNoSp_rule,
  /*  584 */  iRegLNoSp_rule,
  /*  585 */  iRegLNoSp_rule,
  /*  586 */  iRegLNoSp_rule,
  /*  587 */  Universe_rule,
  /*  588 */  Universe_rule,
  /*  589 */  Universe_rule,
  /*  590 */  Universe_rule,
  /*  591 */  Universe_rule,
  /*  592 */  iRegP_R15_rule,
  /*  593 */  iRegI_R10_rule,
  /*  594 */  iRegI_R10_rule,
  /*  595 */  iRegI_R10_rule,
  /*  596 */  iRegI_R10_rule,
  /*  597 */  iRegI_R10_rule,
  /*  598 */  iRegI_R10_rule,
  /*  599 */  iRegI_R10_rule,
  /*  600 */  iRegI_R10_rule,
  /*  601 */  iRegI_R10_rule,
  /*  602 */  iRegI_R10_rule,
  /*  603 */  iRegI_R10_rule,
  /*  604 */  iRegI_R10_rule,
  /*  605 */  Universe_rule,
  /*  606 */  Universe_rule,
  /*  607 */  iRegI_R10_rule,
  /*  608 */  iRegI_R10_rule,
  /*  609 */  iRegI_R10_rule,
  /*  610 */  iRegI_R10_rule,
  /*  611 */  Universe_rule,
  /*  612 */  Universe_rule,
  /*  613 */  Universe_rule,
  /*  614 */  iRegP_R10_rule,
  /*  615 */  Universe_rule,
  /*  616 */  Universe_rule,
  /*  617 */  Universe_rule,
  /*  618 */  vReg_rule,
  /*  619 */  Universe_rule,
  /*  620 */  vRegMask_rule,
  /*  621 */  vReg_rule,
  /*  622 */  vRegMask_rule,
  /*  623 */  vRegMask_rule,
  /*  624 */  vRegMask_rule,
  /*  625 */  vRegMask_rule,
  /*  626 */  vReg_rule,
  /*  627 */  vReg_rule,
  /*  628 */  vReg_rule,
  /*  629 */  vReg_rule,
  /*  630 */  vReg_rule,
  /*  631 */  vReg_rule,
  /*  632 */  vReg_rule,
  /*  633 */  vReg_rule,
  /*  634 */  vReg_rule,
  /*  635 */  vReg_rule,
  /*  636 */  vReg_rule,
  /*  637 */  vReg_rule,
  /*  638 */  vReg_rule,
  /*  639 */  vReg_rule,
  /*  640 */  vReg_rule,
  /*  641 */  vReg_rule,
  /*  642 */  vReg_rule,
  /*  643 */  vReg_rule,
  /*  644 */  vReg_rule,
  /*  645 */  vReg_rule,
  /*  646 */  vReg_rule,
  /*  647 */  vReg_rule,
  /*  648 */  vReg_rule,
  /*  649 */  vReg_rule,
  /*  650 */  vReg_rule,
  /*  651 */  vReg_rule,
  /*  652 */  vReg_rule,
  /*  653 */  vReg_rule,
  /*  654 */  vReg_rule,
  /*  655 */  vReg_rule,
  /*  656 */  vReg_rule,
  /*  657 */  vReg_rule,
  /*  658 */  vReg_rule,
  /*  659 */  vReg_rule,
  /*  660 */  vReg_rule,
  /*  661 */  vReg_rule,
  /*  662 */  vReg_rule,
  /*  663 */  vReg_rule,
  /*  664 */  vReg_rule,
  /*  665 */  vReg_rule,
  /*  666 */  vReg_rule,
  /*  667 */  vReg_rule,
  /*  668 */  vReg_rule,
  /*  669 */  vReg_rule,
  /*  670 */  vReg_rule,
  /*  671 */  vReg_rule,
  /*  672 */  vReg_rule,
  /*  673 */  vReg_rule,
  /*  674 */  vReg_rule,
  /*  675 */  vReg_rule,
  /*  676 */  vReg_rule,
  /*  677 */  vReg_rule,
  /*  678 */  vReg_rule,
  /*  679 */  vReg_rule,
  /*  680 */  vReg_rule,
  /*  681 */  vReg_rule,
  /*  682 */  vReg_rule,
  /*  683 */  vReg_rule,
  /*  684 */  vReg_rule,
  /*  685 */  vReg_rule,
  /*  686 */  vReg_rule,
  /*  687 */  vReg_rule,
  /*  688 */  vReg_rule,
  /*  689 */  vReg_rule,
  /*  690 */  vReg_rule,
  /*  691 */  vReg_rule,
  /*  692 */  vReg_rule,
  /*  693 */  vReg_rule,
  /*  694 */  vReg_rule,
  /*  695 */  vReg_rule,
  /*  696 */  vReg_rule,
  /*  697 */  vReg_rule,
  /*  698 */  vReg_rule,
  /*  699 */  vReg_rule,
  /*  700 */  vReg_rule,
  /*  701 */  vReg_rule,
  /*  702 */  vReg_rule,
  /*  703 */  vReg_rule,
  /*  704 */  vReg_rule,
  /*  705 */  vReg_rule,
  /*  706 */  vReg_rule,
  /*  707 */  vReg_rule,
  /*  708 */  vReg_rule,
  /*  709 */  vReg_rule,
  /*  710 */  vReg_rule,
  /*  711 */  vReg_rule,
  /*  712 */  vReg_rule,
  /*  713 */  vReg_rule,
  /*  714 */  vReg_rule,
  /*  715 */  vReg_rule,
  /*  716 */  vReg_rule,
  /*  717 */  vReg_rule,
  /*  718 */  vReg_rule,
  /*  719 */  vReg_rule,
  /*  720 */  vReg_rule,
  /*  721 */  vReg_rule,
  /*  722 */  vReg_rule,
  /*  723 */  vReg_rule,
  /*  724 */  vReg_rule,
  /*  725 */  vReg_rule,
  /*  726 */  vReg_rule,
  /*  727 */  vReg_rule,
  /*  728 */  vReg_rule,
  /*  729 */  vReg_rule,
  /*  730 */  iRegINoSp_rule,
  /*  731 */  iRegLNoSp_rule,
  /*  732 */  iRegINoSp_rule,
  /*  733 */  iRegLNoSp_rule,
  /*  734 */  iRegINoSp_rule,
  /*  735 */  iRegLNoSp_rule,
  /*  736 */  iRegINoSp_rule,
  /*  737 */  iRegLNoSp_rule,
  /*  738 */  iRegINoSp_rule,
  /*  739 */  iRegLNoSp_rule,
  /*  740 */  iRegINoSp_rule,
  /*  741 */  iRegLNoSp_rule,
  /*  742 */  iRegINoSp_rule,
  /*  743 */  iRegLNoSp_rule,
  /*  744 */  fRegF_rule,
  /*  745 */  fRegD_rule,
  /*  746 */  iRegINoSp_rule,
  /*  747 */  iRegLNoSp_rule,
  /*  748 */  fRegF_rule,
  /*  749 */  fRegD_rule,
  /*  750 */  iRegINoSp_rule,
  /*  751 */  iRegLNoSp_rule,
  /*  752 */  iRegINoSp_rule,
  /*  753 */  iRegLNoSp_rule,
  /*  754 */  iRegINoSp_rule,
  /*  755 */  iRegLNoSp_rule,
  /*  756 */  iRegINoSp_rule,
  /*  757 */  iRegLNoSp_rule,
  /*  758 */  fRegF_rule,
  /*  759 */  fRegD_rule,
  /*  760 */  fRegF_rule,
  /*  761 */  fRegD_rule,
  /*  762 */  fRegF_rule,
  /*  763 */  fRegD_rule,
  /*  764 */  fRegF_rule,
  /*  765 */  fRegD_rule,
  /*  766 */  vReg_rule,
  /*  767 */  vReg_rule,
  /*  768 */  vReg_rule,
  /*  769 */  vReg_rule,
  /*  770 */  vReg_rule,
  /*  771 */  vReg_rule,
  /*  772 */  vReg_rule,
  /*  773 */  vReg_rule,
  /*  774 */  vReg_rule,
  /*  775 */  vReg_rule,
  /*  776 */  vReg_rule,
  /*  777 */  vReg_rule,
  /*  778 */  vReg_rule,
  /*  779 */  vReg_rule,
  /*  780 */  vReg_rule,
  /*  781 */  vReg_rule,
  /*  782 */  vReg_rule,
  /*  783 */  vReg_rule,
  /*  784 */  vReg_rule,
  /*  785 */  vReg_rule,
  /*  786 */  vReg_rule,
  /*  787 */  vReg_rule,
  /*  788 */  vReg_rule,
  /*  789 */  vReg_rule,
  /*  790 */  vReg_rule,
  /*  791 */  vReg_rule,
  /*  792 */  vReg_rule,
  /*  793 */  vReg_rule,
  /*  794 */  vReg_rule,
  /*  795 */  vReg_rule,
  /*  796 */  vReg_rule,
  /*  797 */  vReg_rule,
  /*  798 */  vReg_rule,
  /*  799 */  vReg_rule,
  /*  800 */  vReg_rule,
  /*  801 */  vReg_rule,
  /*  802 */  vReg_rule,
  /*  803 */  vReg_rule,
  /*  804 */  vReg_rule,
  /*  805 */  vReg_rule,
  /*  806 */  vReg_rule,
  /*  807 */  vReg_rule,
  /*  808 */  vReg_rule,
  /*  809 */  vReg_rule,
  /*  810 */  vReg_rule,
  /*  811 */  vReg_rule,
  /*  812 */  vReg_rule,
  /*  813 */  vReg_rule,
  /*  814 */  vReg_rule,
  /*  815 */  vReg_rule,
  /*  816 */  iRegI_R10_rule,
  /*  817 */  iRegI_R10_rule,
  /*  818 */  iRegI_R10_rule,
  /*  819 */  iRegI_R10_rule,
  /*  820 */  iRegI_R10_rule,
  /*  821 */  iRegI_R10_rule,
  /*  822 */  iRegI_R10_rule,
  /*  823 */  iRegI_R10_rule,
  /*  824 */  Universe_rule,
  /*  825 */  iRegI_R10_rule,
  /*  826 */  iRegI_R10_rule,
  /*  827 */  iRegI_R10_rule,
  /*  828 */  iRegI_R10_rule,
  /*  829 */  iRegI_R10_rule,
  /*  830 */  iRegI_R10_rule,
  /*  831 */  Universe_rule,
  /*  832 */  iRegINoSp_rule,
  /*  833 */  iRegLNoSp_rule,
  /*  834 */  iRegINoSp_rule,
  /*  835 */  iRegLNoSp_rule,
  /*  836 */  vRegMask_rule,
  /*  837 */  vRegMask_rule,
  /*  838 */  vRegMask_rule,
  /*  839 */  vRegMask_rule,
  /*  840 */  vRegMask_rule,
  /*  841 */  vRegMask_rule,
  /*  842 */  vRegMask_rule,
  /*  843 */  vReg_rule,
  /*  844 */  Universe_rule,
  /*  845 */  vReg_rule,
  /*  846 */  vReg_rule,
  /*  847 */  vReg_rule,
  /*  848 */  vReg_rule,
  /*  849 */  vReg_rule,
  /*  850 */  vReg_rule,
  /*  851 */  vReg_rule,
  /*  852 */  vReg_rule,
  /*  853 */  vReg_rule,
  /*  854 */  vReg_rule,
  /*  855 */  vReg_rule,
  /*  856 */  vReg_rule,
  /*  857 */  vReg_rule,
  /*  858 */  vRegMask_rule,
  /*  859 */  vReg_rule,
  /*  860 */  vReg_rule,
  /*  861 */  iRegINoSp_rule,
  /*  862 */  iRegINoSp_rule,
  /*  863 */  iRegINoSp_rule,
  /*  864 */  iRegLNoSp_rule,
  /*  865 */  fRegF_rule,
  /*  866 */  fRegD_rule,
  /*  867 */  vRegMask_rule,
  /*  868 */  vReg_rule,
  /*  869 */  vReg_rule,
  /*  870 */  vReg_rule,
  /*  871 */  vReg_rule,
  /*  872 */  vReg_rule,
  /*  873 */  vReg_rule,
  /*  874 */  Universe_rule,
  /*  875 */  Universe_rule,
  /*  876 */  vReg_rule,
  /*  877 */  vReg_rule,
  /*  878 */  vReg_rule,
  /*  879 */  vReg_rule,
  /*  880 */  vReg_rule,
  /*  881 */  vReg_rule,
  /*  882 */  vReg_rule,
  /*  883 */  vReg_rule,
  /*  884 */  vReg_rule,
  /*  885 */  iRegINoSp_rule,
  /*  886 */  iRegINoSp_rule,
  /*  887 */  iRegINoSp_rule,
  /*  888 */  Universe_rule,
  /*  889 */  Universe_rule,
  /*  890 */  iRegINoSp_rule,
  /*  891 */  iRegLNoSp_rule,
  /*  892 */  iRegINoSp_rule,
  /*  893 */  iRegLNoSp_rule,
  /*  894 */  iRegINoSp_rule,
  /*  895 */  iRegLNoSp_rule,
  /*  896 */  iRegINoSp_rule,
  /*  897 */  iRegINoSp_rule,
  /*  898 */  iRegINoSp_rule,
  /*  899 */  iRegINoSp_rule,
  /*  900 */  iRegLNoSp_rule,
  /*  901 */  iRegINoSp_rule,
  /*  902 */  iRegLNoSp_rule,
  /*  903 */  iRegINoSp_rule,
  /*  904 */  iRegINoSp_rule,
  /*  905 */  iRegPNoSp_rule,
  /*  906 */  iRegPNoSp_rule,
  /*  907 */  iRegLNoSp_rule,
  /*  908 */  iRegLNoSp_rule,
  /*  909 */  iRegLNoSp_rule,
  /*  910 */  iRegLNoSp_rule,
  /*  911 */  iRegINoSp_rule,
  /*  912 */  iRegINoSp_rule,
  /*  913 */  iRegINoSp_rule,
  /*  914 */  iRegINoSp_rule,
  /*  915 */  iRegINoSp_rule,
  /*  916 */  iRegINoSp_rule,
  /*  917 */  iRegINoSp_rule,
  /*  918 */  iRegINoSp_rule,
  /*  919 */  iRegLNoSp_rule,
  /*  920 */  iRegLNoSp_rule,
  /*  921 */  iRegINoSp_rule,
  /*  922 */  iRegINoSp_rule,
  /*  923 */  iRegLNoSp_rule,
  /*  924 */  iRegLNoSp_rule,
  /*  925 */  iRegINoSp_rule,
  /*  926 */  iRegINoSp_rule,
  /*  927 */  iRegINoSp_rule,
  /*  928 */  iRegINoSp_rule,
  /*  929 */  iRegINoSp_rule,
  /*  930 */  iRegNNoSp_rule,
  /*  931 */  iRegPNoSp_rule,
  /*  932 */  iRegINoSp_rule,
  /*  933 */  iRegNNoSp_rule,
  /*  934 */  iRegPNoSp_rule,
  /*  935 */  iRegINoSp_rule,
  /*  936 */  iRegINoSp_rule,
  /*  937 */  iRegINoSp_rule,
  /*  938 */  iRegPNoSp_rule,
  /*  939 */  iRegINoSp_rule,
  /*  940 */  iRegINoSp_rule,
  /*  941 */  iRegINoSp_rule,
  /*  942 */  iRegINoSp_rule,
  /*  943 */  iRegPNoSp_rule,
  /*  944 */  iRegPNoSp_rule,
  /*  945 */  iRegPNoSp_rule,
  /*  946 */  iRegPNoSp_rule,
  /*  947 */  iRegPNoSp_rule,
  /*  948 */  Universe_rule,
  /*  949 */  iRegINoSp_rule,
  /*  950 */  iRegINoSp_rule,
  /*  951 */  iRegINoSp_rule,
  /*  952 */  iRegINoSp_rule,
  /*  953 */  iRegPNoSp_rule,
  /*  954 */  iRegPNoSp_rule,
  /*  955 */  iRegPNoSp_rule,
  /*  956 */  iRegPNoSp_rule,
  // last instruction
  0 // no trailing comma
};

const        int   leftOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  0,
  /*    9 */  0,
  /*   10 */  0,
  /*   11 */  0,
  /*   12 */  0,
  /*   13 */  0,
  /*   14 */  0,
  /*   15 */  0,
  /*   16 */  0,
  /*   17 */  0,
  /*   18 */  0,
  /*   19 */  0,
  /*   20 */  0,
  /*   21 */  0,
  /*   22 */  0,
  /*   23 */  0,
  /*   24 */  0,
  /*   25 */  0,
  /*   26 */  0,
  /*   27 */  0,
  /*   28 */  0,
  /*   29 */  0,
  /*   30 */  0,
  /*   31 */  0,
  /*   32 */  0,
  /*   33 */  0,
  /*   34 */  0,
  /*   35 */  0,
  /*   36 */  0,
  /*   37 */  0,
  /*   38 */  0,
  /*   39 */  0,
  /*   40 */  0,
  /*   41 */  0,
  /*   42 */  0,
  /*   43 */  0,
  /*   44 */  0,
  /*   45 */  0,
  /*   46 */  0,
  /*   47 */  0,
  /*   48 */  0,
  /*   49 */  0,
  /*   50 */  0,
  /*   51 */  0,
  /*   52 */  0,
  /*   53 */  0,
  /*   54 */  0,
  /*   55 */  0,
  /*   56 */  0,
  /*   57 */  0,
  /*   58 */  0,
  /*   59 */  0,
  /*   60 */  0,
  /*   61 */  0,
  /*   62 */  0,
  /*   63 */  0,
  /*   64 */  0,
  /*   65 */  0,
  /*   66 */  0,
  /*   67 */  0,
  /*   68 */  0,
  /*   69 */  0,
  /*   70 */  0,
  /*   71 */  0,
  /*   72 */  0,
  /*   73 */  0,
  /*   74 */  0,
  /*   75 */  0,
  /*   76 */  0,
  /*   77 */  0,
  /*   78 */  0,
  /*   79 */  0,
  /*   80 */  0,
  /*   81 */  0,
  /*   82 */  0,
  /*   83 */  0,
  /*   84 */  0,
  /*   85 */  0,
  /*   86 */  0,
  /*   87 */  0,
  /*   88 */  0,
  /*   89 */  0,
  /*   90 */  0,
  /*   91 */  0,
  /*   92 */  0,
  /*   93 */  iRegP_rule,
  /*   94 */  iRegP_rule,
  /*   95 */  iRegN_rule,
  /*   96 */  _DecodeN_iRegN__rule,
  /*   97 */  _DecodeN_iRegN__rule,
  /*   98 */  javaThread_RegP_rule,
  /*   99 */  0,
  /*  100 */  0,
  /*  101 */  0,
  /*  102 */  0,
  /*  103 */  iRegL_rule,
  /*  104 */  0,
  /*  105 */  0,
  /*  106 */  0,
  /*  107 */  0,
  /*  108 */  0,
  /*  109 */  0,
  /*  110 */  0,
  // last operand
  /*  111 */  0,
  /*  112 */  0,
  /*  113 */  0,
  /*  114 */  0,
  /*  115 */  0,
  /*  116 */  0,
  /*  117 */  0,
  /*  118 */  0,
  // last operand class
  /*  119 */  iRegN_rule,
  /*  120 */  memory_rule,
  /*  121 */  memory_rule,
  /*  122 */  memory_rule,
  /*  123 */  memory_rule,
  /*  124 */  memory_rule,
  /*  125 */  _LoadI_memory__rule,
  /*  126 */  iRegI_R12_rule,
  /*  127 */  iRegI_rule,
  /*  128 */  iRegL_rule,
  /*  129 */  iRegP_rule,
  /*  130 */  iRegN_rule,
  /*  131 */  iRegL_rule,
  /*  132 */  iRegI_rule,
  /*  133 */  iRegIorL2I_rule,
  /*  134 */  iRegL_rule,
  /*  135 */  iRegP_rule,
  /*  136 */  fRegF_rule,
  /*  137 */  fRegD_rule,
  /*  138 */  fRegF_rule,
  /*  139 */  fRegD_rule,
  /*  140 */  fRegF_rule,
  /*  141 */  fRegD_rule,
  /*  142 */  fRegD_rule,
  /*  143 */  immD_rule,
  /*  144 */  immF_rule,
  /*  145 */  iRegIorL2I_rule,
  /*  146 */  _DecodeN_iRegN__rule,
  /*  147 */  iRegI_rule,
  /*  148 */  iRegI_rule,
  /*  149 */  iRegL_rule,
  /*  150 */  iRegL_rule,
  /*  151 */  iRegP_rule,
  /*  152 */  iRegN_rule,
  /*  153 */  fRegF_rule,
  /*  154 */  fRegD_rule,
  /*  155 */  iRegI_rule,
  /*  156 */  iRegI_rule,
  /*  157 */  iRegL_rule,
  /*  158 */  iRegL_rule,
  /*  159 */  iRegP_rule,
  /*  160 */  iRegN_rule,
  /*  161 */  _DecodeN_iRegN__rule,
  /*  162 */  cmpOp_rule,
  /*  163 */  iRegINoSp_rule,
  /*  164 */  cmpOpU_rule,
  /*  165 */  cmpOp_rule,
  /*  166 */  cmpOpU_rule,
  /*  167 */  iRegLNoSp_rule,
  /*  168 */  iRegP_R14_rule,
  /*  169 */  iRegP_R11_rule,
  /*  170 */  iRegP_R13_rule,
  /*  171 */  iRegP_R13_rule,
  /*  172 */  iRegP_R13_rule,
  /*  173 */  iRegP_R11_rule,
  /*  174 */  vReg_rule,
  /*  175 */  immI_rule,
  /*  176 */  vReg_rule,
  /*  177 */  vReg_rule,
  /*  178 */  vReg_rule,
  /*  179 */  vReg_rule,
  /*  180 */  vReg_rule,
  /*  181 */  _NegVF_vReg__rule,
  /*  182 */  _NegVD_vReg__rule,
  /*  183 */  vReg_rule,
  /*  184 */  vReg_rule,
  /*  185 */  vReg_rule,
  /*  186 */  vReg_rule,
  /*  187 */  vReg_rule,
  /*  188 */  vReg_rule,
  /*  189 */  vReg_rule,
  /*  190 */  vReg_rule,
  /*  191 */  iRegIorL2I_rule,
  /*  192 */  iRegL_rule,
  /*  193 */  fRegF_rule,
  /*  194 */  fRegD_rule,
  /*  195 */  immI_rule,
  /*  196 */  vReg_rule,
  /*  197 */  immI_rule,
  /*  198 */  vReg_rule,
  /*  199 */  iRegP_R11_rule,
  /*  200 */  vReg_rule,
  /*  201 */  vReg_rule,
  /*  202 */  vReg_rule,
  /*  203 */  vReg_rule,
  /*  204 */  vReg_rule,
  /*  205 */  vRegMask_rule,
  /*  206 */  cmpOp_rule,
  /*  207 */  immI_1_rule,
  /*  208 */  iRegIorL2I_rule,
  /*  209 */  iRegIorL2I_rule,
  /*  210 */  iRegL_rule,
  /*  211 */  _ConvI2L_iRegI__rule,
  /*  212 */  iRegI_rule,
  /*  213 */  iRegL_rule,
  /*  214 */  iRegIorL2I_rule,
  // last internally defined operand
  /*  215 */  immI_rule,
  /*  216 */  immL_rule,
  /*  217 */  immP_rule,
  /*  218 */  immP0_rule,
  /*  219 */  immP_1_rule,
  /*  220 */  immByteMapBase_rule,
  /*  221 */  immN_rule,
  /*  222 */  immN0_rule,
  /*  223 */  immNKlass_rule,
  /*  224 */  immF_rule,
  /*  225 */  immF0_rule,
  /*  226 */  immD_rule,
  /*  227 */  immD0_rule,
  /*  228 */  fRegF_rule,
  /*  229 */  fRegD_rule,
  /*  230 */  fRegF_rule,
  /*  231 */  fRegD_rule,
  /*  232 */  fRegF_rule,
  /*  233 */  fRegD_rule,
  /*  234 */  iRegIorL2I_rule,
  /*  235 */  iRegL_rule,
  /*  236 */  fRegF_rule,
  /*  237 */  fRegD_rule,
  /*  238 */  iRegL_rule,
  /*  239 */  iRegP_rule,
  /*  240 */  iRegPNoSp_rule,
  /*  241 */  iRegL_rule,
  /*  242 */  iRegI_rule,
  /*  243 */  iRegPNoSp_rule,
  /*  244 */  fRegF_rule,
  /*  245 */  fRegD_rule,
  /*  246 */  vReg_rule,
  /*  247 */  iRegI_rule,
  /*  248 */  iRegP_rule,
  /*  249 */  stackSlotF_rule,
  /*  250 */  stackSlotI_rule,
  /*  251 */  stackSlotD_rule,
  /*  252 */  stackSlotL_rule,
  /*  253 */  fRegF_rule,
  /*  254 */  iRegI_rule,
  /*  255 */  fRegD_rule,
  /*  256 */  iRegL_rule,
  /*  257 */  _PartialSubtypeCheck_iRegP_R14_iRegP_R10_rule,
  /*  258 */  0,
  /*  259 */  iRegP_rule,
  /*  260 */  iRegP_rule,
  /*  261 */  vReg_rule,
  /*  262 */  vReg_rule,
  /*  263 */  vReg_rule,
  /*  264 */  vReg_rule,
  /*  265 */  vReg_rule,
  /*  266 */  vReg_rule,
  /*  267 */  vReg_rule,
  /*  268 */  iRegIorL2I_rule,
  /*  269 */  iRegL_rule,
  /*  270 */  immI5_rule,
  /*  271 */  immL5_rule,
  /*  272 */  fRegF_rule,
  /*  273 */  fRegD_rule,
  /*  274 */  iRegIorL2I_rule,
  /*  275 */  iRegIorL2I_rule,
  /*  276 */  vReg_rule,
  /*  277 */  vReg_rule,
  /*  278 */  immI0_rule,
  /*  279 */  _ConvI2L_iRegI__rule,
  /*  280 */  iRegL_rule,
  /*  281 */  immL_rule,
  /*  282 */  vRegMask_rule,
  /*  283 */  vReg_rule,
  /*  284 */  vReg_rule,
  /*  285 */  vReg_rule,
  /*  286 */  vReg_rule,
  /*  287 */  vReg_rule,
  /*  288 */  vReg_rule,
  /*  289 */  vReg_rule,
  /*  290 */  vReg_rule,
  /*  291 */  vRegMask_rule,
  /*  292 */  vRegMask_rule,
  /*  293 */  vRegMask_rule,
  /*  294 */  vRegMask_rule,
  /*  295 */  iRegL_rule,
  /*  296 */  iRegIorL2I_rule,
  /*  297 */  iRegL_rule,
  /*  298 */  iRegIorL2I_rule,
  /*  299 */  iRegL_rule,
  /*  300 */  iRegIorL2I_rule,
  /*  301 */  iRegL_rule,
  /*  302 */  iRegI_rule,
  /*  303 */  iRegL_rule,
  /*  304 */  memory_rule,
  /*  305 */  _LoadB_memory__rule,
  /*  306 */  memory_rule,
  /*  307 */  _LoadUB_memory__rule,
  /*  308 */  memory_rule,
  /*  309 */  _LoadS_memory__rule,
  /*  310 */  memory_rule,
  /*  311 */  _LoadUS_memory__rule,
  /*  312 */  memory_rule,
  /*  313 */  _LoadI_memory__rule,
  /*  314 */  _ConvI2L__LoadI_memory___rule,
  /*  315 */  memory_rule,
  /*  316 */  memory_rule,
  /*  317 */  memory_rule,
  /*  318 */  memory_rule,
  /*  319 */  memory_rule,
  /*  320 */  memory_rule,
  /*  321 */  memory_rule,
  /*  322 */  memory_rule,
  /*  323 */  memory_rule,
  /*  324 */  memory_rule,
  /*  325 */  memory_rule,
  /*  326 */  memory_rule,
  /*  327 */  memory_rule,
  /*  328 */  memory_rule,
  /*  329 */  memory_rule,
  /*  330 */  memory_rule,
  /*  331 */  memory_rule,
  /*  332 */  memory_rule,
  /*  333 */  memory_rule,
  /*  334 */  memory_rule,
  /*  335 */  memory_rule,
  /*  336 */  memory_rule,
  /*  337 */  memory_rule,
  /*  338 */  memory_rule,
  /*  339 */  memory_rule,
  /*  340 */  memory_rule,
  /*  341 */  indirect_rule,
  /*  342 */  indirect_rule,
  /*  343 */  indirect_rule,
  /*  344 */  indirect_rule,
  /*  345 */  indirect_rule,
  /*  346 */  indirect_rule,
  /*  347 */  indirect_rule,
  /*  348 */  indirect_rule,
  /*  349 */  indirect_rule,
  /*  350 */  indirect_rule,
  /*  351 */  indirect_rule,
  /*  352 */  indirect_rule,
  /*  353 */  indirect_rule,
  /*  354 */  indirect_rule,
  /*  355 */  indirect_rule,
  /*  356 */  indirect_rule,
  /*  357 */  indirect_rule,
  /*  358 */  indirect_rule,
  /*  359 */  indirect_rule,
  /*  360 */  indirect_rule,
  /*  361 */  indirect_rule,
  /*  362 */  indirect_rule,
  /*  363 */  indirect_rule,
  /*  364 */  indirect_rule,
  /*  365 */  indirect_rule,
  /*  366 */  indirect_rule,
  /*  367 */  indirect_rule,
  /*  368 */  indirect_rule,
  /*  369 */  indirect_rule,
  /*  370 */  indirect_rule,
  /*  371 */  indirect_rule,
  /*  372 */  indirect_rule,
  /*  373 */  indirect_rule,
  /*  374 */  indirect_rule,
  /*  375 */  indirect_rule,
  /*  376 */  indirect_rule,
  /*  377 */  indirect_rule,
  /*  378 */  indirect_rule,
  /*  379 */  indirect_rule,
  /*  380 */  indirect_rule,
  /*  381 */  indirect_rule,
  /*  382 */  indirect_rule,
  /*  383 */  indirect_rule,
  /*  384 */  indirect_rule,
  /*  385 */  indirect_rule,
  /*  386 */  indirect_rule,
  /*  387 */  indirect_rule,
  /*  388 */  indirect_rule,
  /*  389 */  indirect_rule,
  /*  390 */  indirect_rule,
  /*  391 */  indirect_rule,
  /*  392 */  indirect_rule,
  /*  393 */  indirect_rule,
  /*  394 */  indirect_rule,
  /*  395 */  indirect_rule,
  /*  396 */  indirect_rule,
  /*  397 */  indirect_rule,
  /*  398 */  indirect_rule,
  /*  399 */  indirect_rule,
  /*  400 */  indirect_rule,
  /*  401 */  iRegIorL2I_rule,
  /*  402 */  iRegIorL2I_rule,
  /*  403 */  _ConvL2I_iRegL__rule,
  /*  404 */  iRegP_rule,
  /*  405 */  _ConvI2L_iRegI__rule,
  /*  406 */  iRegP_rule,
  /*  407 */  iRegL_rule,
  /*  408 */  iRegL_rule,
  /*  409 */  iRegIorL2I_rule,
  /*  410 */  iRegIorL2I_rule,
  /*  411 */  iRegL_rule,
  /*  412 */  iRegL_rule,
  /*  413 */  immI0_rule,
  /*  414 */  immL0_rule,
  /*  415 */  iRegIorL2I_rule,
  /*  416 */  iRegL_rule,
  /*  417 */  iRegL_rule,
  /*  418 */  iRegL_rule,
  /*  419 */  iRegIorL2I_rule,
  /*  420 */  iRegIorL2I_rule,
  /*  421 */  _RShiftI_iRegIorL2I_immI_31_rule,
  /*  422 */  iRegL_rule,
  /*  423 */  iRegL_rule,
  /*  424 */  _RShiftL_iRegL_immI_63_rule,
  /*  425 */  iRegIorL2I_rule,
  /*  426 */  iRegIorL2I_rule,
  /*  427 */  iRegL_rule,
  /*  428 */  iRegL_rule,
  /*  429 */  iRegIorL2I_rule,
  /*  430 */  iRegIorL2I_rule,
  /*  431 */  iRegIorL2I_rule,
  /*  432 */  iRegIorL2I_rule,
  /*  433 */  iRegIorL2I_rule,
  /*  434 */  iRegIorL2I_rule,
  /*  435 */  iRegL_rule,
  /*  436 */  iRegL_rule,
  /*  437 */  iRegL_rule,
  /*  438 */  iRegL_rule,
  /*  439 */  _CastP2X_iRegP__rule,
  /*  440 */  iRegL_rule,
  /*  441 */  iRegL_rule,
  /*  442 */  iRegI_rule,
  /*  443 */  iRegL_rule,
  /*  444 */  fRegF_rule,
  /*  445 */  fRegD_rule,
  /*  446 */  fRegF_rule,
  /*  447 */  fRegD_rule,
  /*  448 */  fRegF_rule,
  /*  449 */  fRegD_rule,
  /*  450 */  fRegF_rule,
  /*  451 */  fRegD_rule,
  /*  452 */  _NegF_fRegF__rule,
  /*  453 */  _NegD_fRegD__rule,
  /*  454 */  fRegF_rule,
  /*  455 */  fRegD_rule,
  /*  456 */  _NegF_fRegF__rule,
  /*  457 */  _NegD_fRegD__rule,
  /*  458 */  fRegF_rule,
  /*  459 */  fRegF_rule,
  /*  460 */  fRegD_rule,
  /*  461 */  fRegD_rule,
  /*  462 */  fRegF_rule,
  /*  463 */  fRegD_rule,
  /*  464 */  fRegF_rule,
  /*  465 */  fRegD_rule,
  /*  466 */  fRegD_rule,
  /*  467 */  fRegD_rule,
  /*  468 */  fRegF_rule,
  /*  469 */  fRegD_rule,
  /*  470 */  fRegF_rule,
  /*  471 */  iRegI_rule,
  /*  472 */  iRegI_rule,
  /*  473 */  iRegI_rule,
  /*  474 */  iRegI_rule,
  /*  475 */  iRegI_rule,
  /*  476 */  iRegI_rule,
  /*  477 */  iRegL_rule,
  /*  478 */  iRegL_rule,
  /*  479 */  iRegL_rule,
  /*  480 */  iRegL_rule,
  /*  481 */  iRegL_rule,
  /*  482 */  iRegL_rule,
  /*  483 */  iRegIorL2I_rule,
  /*  484 */  iRegL_rule,
  /*  485 */  iRegIorL2I_rule,
  /*  486 */  iRegIorL2I_rule,
  /*  487 */  0,
  /*  488 */  0,
  /*  489 */  0,
  /*  490 */  0,
  /*  491 */  0,
  /*  492 */  0,
  /*  493 */  0,
  /*  494 */  0,
  /*  495 */  0,
  /*  496 */  0,
  /*  497 */  iRegIorL2I_rule,
  /*  498 */  iRegL_rule,
  /*  499 */  _ConvI2L_iRegIorL2I__rule,
  /*  500 */  fRegF_rule,
  /*  501 */  fRegD_rule,
  /*  502 */  fRegF_rule,
  /*  503 */  iRegIorL2I_rule,
  /*  504 */  fRegF_rule,
  /*  505 */  iRegL_rule,
  /*  506 */  fRegD_rule,
  /*  507 */  iRegIorL2I_rule,
  /*  508 */  fRegD_rule,
  /*  509 */  iRegL_rule,
  /*  510 */  _CastP2X_iRegP__rule,
  /*  511 */  _CastP2X__DecodeN_iRegN___rule,
  /*  512 */  iRegP_rule,
  /*  513 */  iRegN_rule,
  /*  514 */  iRegN_rule,
  /*  515 */  iRegP_rule,
  /*  516 */  iRegN_rule,
  /*  517 */  fRegF_rule,
  /*  518 */  iRegI_rule,
  /*  519 */  fRegD_rule,
  /*  520 */  iRegL_rule,
  /*  521 */  fRegF_rule,
  /*  522 */  fRegD_rule,
  /*  523 */  iRegL_rule,
  /*  524 */  iRegL_rule,
  /*  525 */  iRegI_rule,
  /*  526 */  iRegI_rule,
  /*  527 */  iRegIorL2I_rule,
  /*  528 */  iRegINoSp_rule,
  /*  529 */  iRegINoSp_rule,
  /*  530 */  iRegINoSp_rule,
  /*  531 */  immI0_rule,
  /*  532 */  iRegINoSp_rule,
  /*  533 */  immI0_rule,
  /*  534 */  iRegI_rule,
  /*  535 */  iRegI_rule,
  /*  536 */  0,
  /*  537 */  cmpOpEqNe_rule,
  /*  538 */  cmpOp_rule,
  /*  539 */  cmpOp_rule,
  /*  540 */  cmpOpU_rule,
  /*  541 */  cmpOp_rule,
  /*  542 */  cmpOp_rule,
  /*  543 */  cmpOpU_rule,
  /*  544 */  cmpOpU_rule,
  /*  545 */  cmpOpU_rule,
  /*  546 */  cmpOp_rule,
  /*  547 */  cmpOp_rule,
  /*  548 */  cmpOp_rule,
  /*  549 */  cmpOp_rule,
  /*  550 */  cmpOpUEqNeLeGt_rule,
  /*  551 */  cmpOp_rule,
  /*  552 */  cmpOp_rule,
  /*  553 */  cmpOpUEqNeLeGt_rule,
  /*  554 */  cmpOpEqNe_rule,
  /*  555 */  cmpOpEqNe_rule,
  /*  556 */  cmpOpEqNe_rule,
  /*  557 */  cmpOp_rule,
  /*  558 */  cmpOp_rule,
  /*  559 */  cmpOp_rule,
  /*  560 */  cmpOpU_rule,
  /*  561 */  cmpOp_rule,
  /*  562 */  cmpOp_rule,
  /*  563 */  cmpOpU_rule,
  /*  564 */  cmpOpU_rule,
  /*  565 */  cmpOpU_rule,
  /*  566 */  cmpOp_rule,
  /*  567 */  cmpOp_rule,
  /*  568 */  cmpOp_rule,
  /*  569 */  cmpOp_rule,
  /*  570 */  cmpOpUEqNeLeGt_rule,
  /*  571 */  cmpOpULtGe_rule,
  /*  572 */  cmpOp_rule,
  /*  573 */  cmpOp_rule,
  /*  574 */  cmpOpUEqNeLeGt_rule,
  /*  575 */  cmpOpULtGe_rule,
  /*  576 */  cmpOpEqNe_rule,
  /*  577 */  cmpOpEqNe_rule,
  /*  578 */  cmpOpEqNe_rule,
  /*  579 */  _Binary_cmpOp__CmpI_iRegI_iRegI_rule,
  /*  580 */  _Binary_cmpOpU__CmpU_iRegI_iRegI_rule,
  /*  581 */  _Binary_cmpOp__CmpL_iRegL_iRegL_rule,
  /*  582 */  _Binary_cmpOpU__CmpUL_iRegL_iRegL_rule,
  /*  583 */  _Binary_cmpOp__CmpL_iRegL_iRegL_rule,
  /*  584 */  _Binary_cmpOpU__CmpUL_iRegL_iRegL_rule,
  /*  585 */  _Binary_cmpOp__CmpI_iRegI_iRegI_rule,
  /*  586 */  _Binary_cmpOpU__CmpU_iRegI_iRegI_rule,
  /*  587 */  0,
  /*  588 */  0,
  /*  589 */  0,
  /*  590 */  0,
  /*  591 */  0,
  /*  592 */  iRegP_R14_rule,
  /*  593 */  _Binary_iRegP_R11_iRegI_R12_rule,
  /*  594 */  _Binary_iRegP_R11_iRegI_R12_rule,
  /*  595 */  _Binary_iRegP_R11_iRegI_R12_rule,
  /*  596 */  _Binary_iRegP_R11_iRegI_R12_rule,
  /*  597 */  _Binary_iRegP_R11_iRegI_R12_rule,
  /*  598 */  _Binary_iRegP_R11_iRegI_R12_rule,
  /*  599 */  _Binary_iRegP_R11_iRegI_R12_rule,
  /*  600 */  _Binary_iRegP_R11_iRegI_R12_rule,
  /*  601 */  _Binary_iRegP_R11_iRegI_R12_rule,
  /*  602 */  _Binary_iRegP_R11_iRegI_R12_rule,
  /*  603 */  _Binary_iRegP_R11_iRegI_R12_rule,
  /*  604 */  _Binary_iRegP_R11_iRegI_R12_rule,
  /*  605 */  iRegL_R29_rule,
  /*  606 */  immL_rule,
  /*  607 */  _Binary_iRegP_R11_iRegP_R13_rule,
  /*  608 */  _Binary_iRegP_R11_iRegP_R13_rule,
  /*  609 */  iRegP_R11_rule,
  /*  610 */  iRegP_R11_rule,
  /*  611 */  iRegP_rule,
  /*  612 */  iRegPNoSp_rule,
  /*  613 */  iRegPNoSp_rule,
  /*  614 */  0,
  /*  615 */  0,
  /*  616 */  0,
  /*  617 */  0,
  /*  618 */  vmemA_rule,
  /*  619 */  vmemA_rule,
  /*  620 */  vReg_rule,
  /*  621 */  vRegMask_V0_rule,
  /*  622 */  _Binary_vReg_vReg_rule,
  /*  623 */  _Binary_vReg_vReg_rule,
  /*  624 */  _Binary_vReg_vReg_rule,
  /*  625 */  _Binary_vReg_vReg_rule,
  /*  626 */  vReg_rule,
  /*  627 */  vReg_rule,
  /*  628 */  vReg_rule,
  /*  629 */  vReg_rule,
  /*  630 */  vReg_rule,
  /*  631 */  vReg_rule,
  /*  632 */  vReg_rule,
  /*  633 */  vReg_rule,
  /*  634 */  vReg_rule,
  /*  635 */  vReg_rule,
  /*  636 */  vReg_rule,
  /*  637 */  vReg_rule,
  /*  638 */  vReg_rule,
  /*  639 */  vReg_rule,
  /*  640 */  vReg_rule,
  /*  641 */  vReg_rule,
  /*  642 */  _Binary_vReg_vReg_rule,
  /*  643 */  _Binary_vReg_vReg_rule,
  /*  644 */  _Binary_vReg_vReg_rule,
  /*  645 */  _Binary_vReg_vReg_rule,
  /*  646 */  _Binary_vReg_vReg_rule,
  /*  647 */  _Binary_vReg_vReg_rule,
  /*  648 */  vReg_rule,
  /*  649 */  vReg_rule,
  /*  650 */  vReg_rule,
  /*  651 */  vReg_rule,
  /*  652 */  vReg_rule,
  /*  653 */  vReg_rule,
  /*  654 */  _Binary_vReg_vReg_rule,
  /*  655 */  _Binary_vReg_vReg_rule,
  /*  656 */  _Binary_vReg_vReg_rule,
  /*  657 */  _Binary_vReg_vReg_rule,
  /*  658 */  _Binary_vReg_vReg_rule,
  /*  659 */  _Binary_vReg_vReg_rule,
  /*  660 */  vReg_rule,
  /*  661 */  _Binary_vReg_vReg_rule,
  /*  662 */  vReg_rule,
  /*  663 */  _Binary_vReg_vReg_rule,
  /*  664 */  vReg_rule,
  /*  665 */  _Binary_vReg_vReg_rule,
  /*  666 */  vReg_rule,
  /*  667 */  vReg_rule,
  /*  668 */  _Binary_vReg_vReg_rule,
  /*  669 */  _Binary_vReg_vReg_rule,
  /*  670 */  vReg_rule,
  /*  671 */  vReg_rule,
  /*  672 */  _Binary_vReg_vReg_rule,
  /*  673 */  _Binary_vReg_vReg_rule,
  /*  674 */  vReg_rule,
  /*  675 */  vReg_rule,
  /*  676 */  _Binary_vReg_vReg_rule,
  /*  677 */  _Binary_vReg_vReg_rule,
  /*  678 */  vReg_rule,
  /*  679 */  vReg_rule,
  /*  680 */  _Binary_vReg_vReg_rule,
  /*  681 */  _Binary_vReg_vReg_rule,
  /*  682 */  vReg_rule,
  /*  683 */  vReg_rule,
  /*  684 */  _Binary_vReg__NegVF_vReg__rule,
  /*  685 */  _Binary_vReg__NegVD_vReg__rule,
  /*  686 */  _NegVF_vReg__rule,
  /*  687 */  _NegVD_vReg__rule,
  /*  688 */  _Binary_vReg__NegVF_vReg__rule,
  /*  689 */  _Binary_vReg__NegVD_vReg__rule,
  /*  690 */  _NegVF_vReg__rule,
  /*  691 */  _NegVD_vReg__rule,
  /*  692 */  _Binary_vReg_vReg_rule,
  /*  693 */  _Binary_vReg_vReg_rule,
  /*  694 */  vReg_rule,
  /*  695 */  _MulVB_vReg_vReg_rule,
  /*  696 */  vReg_rule,
  /*  697 */  _MulVS_vReg_vReg_rule,
  /*  698 */  vReg_rule,
  /*  699 */  _MulVI_vReg_vReg_rule,
  /*  700 */  vReg_rule,
  /*  701 */  _MulVL_vReg_vReg_rule,
  /*  702 */  _Binary_vReg__MulVB_vReg_vReg_rule,
  /*  703 */  _Binary_vReg__MulVS_vReg_vReg_rule,
  /*  704 */  _Binary_vReg__MulVI_vReg_vReg_rule,
  /*  705 */  _Binary_vReg__MulVL_vReg_vReg_rule,
  /*  706 */  vReg_rule,
  /*  707 */  vReg_rule,
  /*  708 */  vReg_rule,
  /*  709 */  vReg_rule,
  /*  710 */  _Binary_vReg__MulVB_vReg_vReg_rule,
  /*  711 */  _Binary_vReg__MulVS_vReg_vReg_rule,
  /*  712 */  _Binary_vReg__MulVI_vReg_vReg_rule,
  /*  713 */  _Binary_vReg__MulVL_vReg_vReg_rule,
  /*  714 */  vReg_rule,
  /*  715 */  vReg_rule,
  /*  716 */  vReg_rule,
  /*  717 */  vReg_rule,
  /*  718 */  vReg_rule,
  /*  719 */  vReg_rule,
  /*  720 */  _Binary_vReg_vReg_rule,
  /*  721 */  _Binary_vReg_vReg_rule,
  /*  722 */  _Binary_vReg_vReg_rule,
  /*  723 */  _Binary_vReg_vReg_rule,
  /*  724 */  _Binary_vReg_vReg_rule,
  /*  725 */  _Binary_vReg_vReg_rule,
  /*  726 */  vReg_rule,
  /*  727 */  vReg_rule,
  /*  728 */  vReg_rule,
  /*  729 */  vReg_rule,
  /*  730 */  iRegIorL2I_rule,
  /*  731 */  iRegL_rule,
  /*  732 */  _Binary_iRegIorL2I_vReg_rule,
  /*  733 */  _Binary_iRegL_vReg_rule,
  /*  734 */  iRegIorL2I_rule,
  /*  735 */  iRegL_rule,
  /*  736 */  _Binary_iRegIorL2I_vReg_rule,
  /*  737 */  _Binary_iRegL_vReg_rule,
  /*  738 */  iRegIorL2I_rule,
  /*  739 */  iRegL_rule,
  /*  740 */  _Binary_iRegIorL2I_vReg_rule,
  /*  741 */  _Binary_iRegL_vReg_rule,
  /*  742 */  iRegIorL2I_rule,
  /*  743 */  iRegL_rule,
  /*  744 */  fRegF_rule,
  /*  745 */  fRegD_rule,
  /*  746 */  _Binary_iRegIorL2I_vReg_rule,
  /*  747 */  _Binary_iRegL_vReg_rule,
  /*  748 */  _Binary_fRegF_vReg_rule,
  /*  749 */  _Binary_fRegD_vReg_rule,
  /*  750 */  iRegIorL2I_rule,
  /*  751 */  iRegL_rule,
  /*  752 */  _Binary_iRegIorL2I_vReg_rule,
  /*  753 */  _Binary_iRegL_vReg_rule,
  /*  754 */  iRegIorL2I_rule,
  /*  755 */  iRegL_rule,
  /*  756 */  _Binary_iRegIorL2I_vReg_rule,
  /*  757 */  _Binary_iRegL_vReg_rule,
  /*  758 */  fRegF_rule,
  /*  759 */  fRegD_rule,
  /*  760 */  _Binary_fRegF_vReg_rule,
  /*  761 */  _Binary_fRegD_vReg_rule,
  /*  762 */  fRegF_rule,
  /*  763 */  fRegD_rule,
  /*  764 */  _Binary_fRegF_vReg_rule,
  /*  765 */  _Binary_fRegD_vReg_rule,
  /*  766 */  vReg_rule,
  /*  767 */  vReg_rule,
  /*  768 */  vReg_rule,
  /*  769 */  vReg_rule,
  /*  770 */  _Binary_vReg_vReg_rule,
  /*  771 */  _Binary_vReg_vReg_rule,
  /*  772 */  _Binary_vReg_vReg_rule,
  /*  773 */  _Binary_vReg_vReg_rule,
  /*  774 */  vReg_rule,
  /*  775 */  vReg_rule,
  /*  776 */  vReg_rule,
  /*  777 */  vReg_rule,
  /*  778 */  _Binary_vReg_vReg_rule,
  /*  779 */  _Binary_vReg_vReg_rule,
  /*  780 */  _Binary_vReg_vReg_rule,
  /*  781 */  _Binary_vReg_vReg_rule,
  /*  782 */  vReg_rule,
  /*  783 */  vReg_rule,
  /*  784 */  vReg_rule,
  /*  785 */  vReg_rule,
  /*  786 */  _Binary_vReg_vReg_rule,
  /*  787 */  _Binary_vReg_vReg_rule,
  /*  788 */  _Binary_vReg_vReg_rule,
  /*  789 */  _Binary_vReg_vReg_rule,
  /*  790 */  vReg_rule,
  /*  791 */  vReg_rule,
  /*  792 */  vReg_rule,
  /*  793 */  vReg_rule,
  /*  794 */  _Binary_vReg__RShiftCntV_immI__rule,
  /*  795 */  _Binary_vReg__RShiftCntV_immI__rule,
  /*  796 */  _Binary_vReg__RShiftCntV_immI__rule,
  /*  797 */  _Binary_vReg__RShiftCntV_immI__rule,
  /*  798 */  vReg_rule,
  /*  799 */  vReg_rule,
  /*  800 */  vReg_rule,
  /*  801 */  vReg_rule,
  /*  802 */  _Binary_vReg__RShiftCntV_immI__rule,
  /*  803 */  _Binary_vReg__RShiftCntV_immI__rule,
  /*  804 */  _Binary_vReg__RShiftCntV_immI__rule,
  /*  805 */  _Binary_vReg__RShiftCntV_immI__rule,
  /*  806 */  vReg_rule,
  /*  807 */  vReg_rule,
  /*  808 */  vReg_rule,
  /*  809 */  vReg_rule,
  /*  810 */  _Binary_vReg__LShiftCntV_immI__rule,
  /*  811 */  _Binary_vReg__LShiftCntV_immI__rule,
  /*  812 */  _Binary_vReg__LShiftCntV_immI__rule,
  /*  813 */  _Binary_vReg__LShiftCntV_immI__rule,
  /*  814 */  vReg_rule,
  /*  815 */  vReg_rule,
  /*  816 */  _Binary_iRegP_R11_iRegP_R13_rule,
  /*  817 */  _Binary_iRegP_R11_iRegP_R13_rule,
  /*  818 */  iRegP_R11_rule,
  /*  819 */  iRegP_R11_rule,
  /*  820 */  _Binary_iRegP_R11_iRegI_R12_rule,
  /*  821 */  _Binary_iRegP_R11_iRegI_R12_rule,
  /*  822 */  _Binary_iRegP_R11_iRegI_R12_rule,
  /*  823 */  _Binary_iRegP_R11_iRegI_R12_rule,
  /*  824 */  iRegP_R10_rule,
  /*  825 */  iRegP_R12_rule,
  /*  826 */  iRegP_R12_rule,
  /*  827 */  iRegP_R12_rule,
  /*  828 */  iRegP_R11_rule,
  /*  829 */  _Binary_iRegP_R11_iRegI_R12_rule,
  /*  830 */  _Binary_iRegP_R11_iRegI_R12_rule,
  /*  831 */  iRegL_R29_rule,
  /*  832 */  iRegIorL2I_rule,
  /*  833 */  iRegL_rule,
  /*  834 */  iRegIorL2I_rule,
  /*  835 */  iRegL_rule,
  /*  836 */  immI_rule,
  /*  837 */  iRegIorL2I_rule,
  /*  838 */  immL_rule,
  /*  839 */  iRegL_rule,
  /*  840 */  vRegMask_rule,
  /*  841 */  vRegMask_rule,
  /*  842 */  vRegMask_rule,
  /*  843 */  vmemA_rule,
  /*  844 */  vmemA_rule,
  /*  845 */  _Binary_vReg_vReg_rule,
  /*  846 */  vReg_rule,
  /*  847 */  vReg_rule,
  /*  848 */  vReg_rule,
  /*  849 */  vReg_rule,
  /*  850 */  vReg_rule,
  /*  851 */  vReg_rule,
  /*  852 */  vReg_rule,
  /*  853 */  vReg_rule,
  /*  854 */  vReg_rule,
  /*  855 */  vReg_rule,
  /*  856 */  vReg_rule,
  /*  857 */  vReg_rule,
  /*  858 */  vRegMask_V0_rule,
  /*  859 */  vReg_rule,
  /*  860 */  _Binary_vReg_vReg_rule,
  /*  861 */  vReg_rule,
  /*  862 */  vReg_rule,
  /*  863 */  vReg_rule,
  /*  864 */  vReg_rule,
  /*  865 */  vReg_rule,
  /*  866 */  vReg_rule,
  /*  867 */  vRegMask_rule,
  /*  868 */  vReg_rule,
  /*  869 */  vReg_rule,
  /*  870 */  vReg_rule,
  /*  871 */  vReg_rule,
  /*  872 */  indirect_rule,
  /*  873 */  indirect_rule,
  /*  874 */  indirect_rule,
  /*  875 */  indirect_rule,
  /*  876 */  iRegIorL2I_rule,
  /*  877 */  _Binary_vReg_iRegIorL2I_rule,
  /*  878 */  _Binary_vReg_iRegIorL2I_rule,
  /*  879 */  _Binary_vReg_iRegL_rule,
  /*  880 */  _Binary_vReg_iRegL_rule,
  /*  881 */  _Binary_vReg_fRegF_rule,
  /*  882 */  _Binary_vReg_fRegF_rule,
  /*  883 */  _Binary_vReg_fRegD_rule,
  /*  884 */  _Binary_vReg_fRegD_rule,
  /*  885 */  vRegMask_rule,
  /*  886 */  _Binary_cmpOp__VectorTest_vRegMask_vRegMask_rule,
  /*  887 */  _Binary_cmpOp__VectorTest_vRegMask_vRegMask_rule,
  /*  888 */  cmpOpEqNe_rule,
  /*  889 */  cmpOpEqNe_rule,
  /*  890 */  iRegI_rule,
  /*  891 */  iRegL_rule,
  /*  892 */  iRegI_rule,
  /*  893 */  iRegL_rule,
  /*  894 */  iRegI_rule,
  /*  895 */  iRegL_rule,
  /*  896 */  _CastP2X_iRegP__rule,
  /*  897 */  _LShiftI_iRegIorL2I_immI_24_rule,
  /*  898 */  _LShiftI_iRegIorL2I_immI_16_rule,
  /*  899 */  iRegIorL2I_rule,
  /*  900 */  _ConvI2L_iRegIorL2I__rule,
  /*  901 */  iRegIorL2I_rule,
  /*  902 */  iRegL_rule,
  /*  903 */  iRegIorL2I_rule,
  /*  904 */  iRegIorL2I_rule,
  /*  905 */  iRegP_rule,
  /*  906 */  iRegP_rule,
  /*  907 */  iRegL_rule,
  /*  908 */  _LShiftL_iRegL_immIScale_rule,
  /*  909 */  iRegL_rule,
  /*  910 */  _LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  911 */  iRegI_rule,
  /*  912 */  iRegI_rule,
  /*  913 */  iRegI_rule,
  /*  914 */  immI0_rule,
  /*  915 */  iRegI_rule,
  /*  916 */  immI0_rule,
  /*  917 */  iRegI_rule,
  /*  918 */  _XorI_iRegI_immI_M1_rule,
  /*  919 */  iRegL_rule,
  /*  920 */  _XorL_iRegL_immL_M1_rule,
  /*  921 */  iRegI_rule,
  /*  922 */  _XorI_iRegI_immI_M1_rule,
  /*  923 */  iRegL_rule,
  /*  924 */  _XorL_iRegL_immL_M1_rule,
  /*  925 */  _AndI_iRegIorL2I_immIpowerOf2_rule,
  /*  926 */  indirect_rule,
  /*  927 */  indirect_rule,
  /*  928 */  indirect_rule,
  /*  929 */  indirect_rule,
  /*  930 */  indirect_rule,
  /*  931 */  indirect_rule,
  /*  932 */  indirect_rule,
  /*  933 */  indirect_rule,
  /*  934 */  indirect_rule,
  /*  935 */  indirect_rule,
  /*  936 */  indirect_rule,
  /*  937 */  indirect_rule,
  /*  938 */  memory_rule,
  /*  939 */  indirect_rule,
  /*  940 */  indirect_rule,
  /*  941 */  indirect_rule,
  /*  942 */  indirect_rule,
  /*  943 */  indirect_rule,
  /*  944 */  indirect_rule,
  /*  945 */  indirect_rule,
  /*  946 */  indirect_rule,
  /*  947 */  memory_rule,
  /*  948 */  memory_rule,
  /*  949 */  indirect_rule,
  /*  950 */  indirect_rule,
  /*  951 */  indirect_rule,
  /*  952 */  indirect_rule,
  /*  953 */  indirect_rule,
  /*  954 */  indirect_rule,
  /*  955 */  indirect_rule,
  /*  956 */  indirect_rule,
  // last instruction
  0 // no trailing comma
};

const        int   rightOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  0,
  /*    9 */  0,
  /*   10 */  0,
  /*   11 */  0,
  /*   12 */  0,
  /*   13 */  0,
  /*   14 */  0,
  /*   15 */  0,
  /*   16 */  0,
  /*   17 */  0,
  /*   18 */  0,
  /*   19 */  0,
  /*   20 */  0,
  /*   21 */  0,
  /*   22 */  0,
  /*   23 */  0,
  /*   24 */  0,
  /*   25 */  0,
  /*   26 */  0,
  /*   27 */  0,
  /*   28 */  0,
  /*   29 */  0,
  /*   30 */  0,
  /*   31 */  0,
  /*   32 */  0,
  /*   33 */  0,
  /*   34 */  0,
  /*   35 */  0,
  /*   36 */  0,
  /*   37 */  0,
  /*   38 */  0,
  /*   39 */  0,
  /*   40 */  0,
  /*   41 */  0,
  /*   42 */  0,
  /*   43 */  0,
  /*   44 */  0,
  /*   45 */  0,
  /*   46 */  0,
  /*   47 */  0,
  /*   48 */  0,
  /*   49 */  0,
  /*   50 */  0,
  /*   51 */  0,
  /*   52 */  0,
  /*   53 */  0,
  /*   54 */  0,
  /*   55 */  0,
  /*   56 */  0,
  /*   57 */  0,
  /*   58 */  0,
  /*   59 */  0,
  /*   60 */  0,
  /*   61 */  0,
  /*   62 */  0,
  /*   63 */  0,
  /*   64 */  0,
  /*   65 */  0,
  /*   66 */  0,
  /*   67 */  0,
  /*   68 */  0,
  /*   69 */  0,
  /*   70 */  0,
  /*   71 */  0,
  /*   72 */  0,
  /*   73 */  0,
  /*   74 */  0,
  /*   75 */  0,
  /*   76 */  0,
  /*   77 */  0,
  /*   78 */  0,
  /*   79 */  0,
  /*   80 */  0,
  /*   81 */  0,
  /*   82 */  0,
  /*   83 */  0,
  /*   84 */  0,
  /*   85 */  0,
  /*   86 */  0,
  /*   87 */  0,
  /*   88 */  0,
  /*   89 */  0,
  /*   90 */  0,
  /*   91 */  0,
  /*   92 */  0,
  /*   93 */  immIOffset_rule,
  /*   94 */  immLOffset_rule,
  /*   95 */  0,
  /*   96 */  immIOffset_rule,
  /*   97 */  immLOffset_rule,
  /*   98 */  immL_pc_off_rule,
  /*   99 */  0,
  /*  100 */  0,
  /*  101 */  0,
  /*  102 */  0,
  /*  103 */  0,
  /*  104 */  0,
  /*  105 */  0,
  /*  106 */  0,
  /*  107 */  0,
  /*  108 */  0,
  /*  109 */  0,
  /*  110 */  0,
  // last operand
  /*  111 */  0,
  /*  112 */  0,
  /*  113 */  0,
  /*  114 */  0,
  /*  115 */  0,
  /*  116 */  0,
  /*  117 */  0,
  /*  118 */  0,
  // last operand class
  /*  119 */  0,
  /*  120 */  0,
  /*  121 */  0,
  /*  122 */  0,
  /*  123 */  0,
  /*  124 */  0,
  /*  125 */  0,
  /*  126 */  iRegI_R13_rule,
  /*  127 */  iRegI_rule,
  /*  128 */  iRegL_rule,
  /*  129 */  iRegP_rule,
  /*  130 */  iRegN_rule,
  /*  131 */  0,
  /*  132 */  0,
  /*  133 */  immI_31_rule,
  /*  134 */  immI_63_rule,
  /*  135 */  0,
  /*  136 */  fRegF_rule,
  /*  137 */  fRegD_rule,
  /*  138 */  0,
  /*  139 */  0,
  /*  140 */  _NegF_fRegF__rule,
  /*  141 */  _NegD_fRegD__rule,
  /*  142 */  immD_rule,
  /*  143 */  fRegD_rule,
  /*  144 */  fRegF_rule,
  /*  145 */  0,
  /*  146 */  0,
  /*  147 */  iRegI_rule,
  /*  148 */  iRegI_rule,
  /*  149 */  iRegL_rule,
  /*  150 */  iRegL_rule,
  /*  151 */  iRegP_rule,
  /*  152 */  iRegN_rule,
  /*  153 */  fRegF_rule,
  /*  154 */  fRegD_rule,
  /*  155 */  immI0_rule,
  /*  156 */  immI0_rule,
  /*  157 */  immL0_rule,
  /*  158 */  immL0_rule,
  /*  159 */  immP0_rule,
  /*  160 */  immN0_rule,
  /*  161 */  immP0_rule,
  /*  162 */  _CmpI_iRegI_iRegI_rule,
  /*  163 */  iRegI_rule,
  /*  164 */  _CmpU_iRegI_iRegI_rule,
  /*  165 */  _CmpL_iRegL_iRegL_rule,
  /*  166 */  _CmpUL_iRegL_iRegL_rule,
  /*  167 */  iRegL_rule,
  /*  168 */  iRegP_R10_rule,
  /*  169 */  iRegI_R12_rule,
  /*  170 */  iRegI_R14_rule,
  /*  171 */  immI_le_4_rule,
  /*  172 */  immI_1_rule,
  /*  173 */  iRegP_R13_rule,
  /*  174 */  vReg_rule,
  /*  175 */  vRegMask_V0_rule,
  /*  176 */  vRegMask_V0_rule,
  /*  177 */  0,
  /*  178 */  _NegVF_vReg__rule,
  /*  179 */  0,
  /*  180 */  _NegVD_vReg__rule,
  /*  181 */  vRegMask_V0_rule,
  /*  182 */  vRegMask_V0_rule,
  /*  183 */  vReg_rule,
  /*  184 */  vReg_rule,
  /*  185 */  vReg_rule,
  /*  186 */  vReg_rule,
  /*  187 */  _MulVB_vReg_vReg_rule,
  /*  188 */  _MulVS_vReg_vReg_rule,
  /*  189 */  _MulVI_vReg_vReg_rule,
  /*  190 */  _MulVL_vReg_vReg_rule,
  /*  191 */  vReg_rule,
  /*  192 */  vReg_rule,
  /*  193 */  vReg_rule,
  /*  194 */  vReg_rule,
  /*  195 */  0,
  /*  196 */  _RShiftCntV_immI__rule,
  /*  197 */  0,
  /*  198 */  _LShiftCntV_immI__rule,
  /*  199 */  iRegI_R13_rule,
  /*  200 */  _Binary_vReg_vRegMask_V0_rule,
  /*  201 */  iRegIorL2I_rule,
  /*  202 */  iRegL_rule,
  /*  203 */  fRegF_rule,
  /*  204 */  fRegD_rule,
  /*  205 */  vRegMask_rule,
  /*  206 */  _VectorTest_vRegMask_vRegMask_rule,
  /*  207 */  immI0_rule,
  /*  208 */  immI_24_rule,
  /*  209 */  immI_16_rule,
  /*  210 */  immIScale_rule,
  /*  211 */  immIScale_rule,
  /*  212 */  immI_M1_rule,
  /*  213 */  immL_M1_rule,
  /*  214 */  immIpowerOf2_rule,
  // last internally defined operand
  /*  215 */  0,
  /*  216 */  0,
  /*  217 */  0,
  /*  218 */  0,
  /*  219 */  0,
  /*  220 */  0,
  /*  221 */  0,
  /*  222 */  0,
  /*  223 */  0,
  /*  224 */  0,
  /*  225 */  0,
  /*  226 */  0,
  /*  227 */  0,
  /*  228 */  0,
  /*  229 */  0,
  /*  230 */  0,
  /*  231 */  0,
  /*  232 */  0,
  /*  233 */  0,
  /*  234 */  0,
  /*  235 */  0,
  /*  236 */  0,
  /*  237 */  0,
  /*  238 */  0,
  /*  239 */  0,
  /*  240 */  0,
  /*  241 */  0,
  /*  242 */  0,
  /*  243 */  0,
  /*  244 */  0,
  /*  245 */  0,
  /*  246 */  0,
  /*  247 */  0,
  /*  248 */  0,
  /*  249 */  0,
  /*  250 */  0,
  /*  251 */  0,
  /*  252 */  0,
  /*  253 */  0,
  /*  254 */  0,
  /*  255 */  0,
  /*  256 */  0,
  /*  257 */  immP0_rule,
  /*  258 */  0,
  /*  259 */  iRegP_rule,
  /*  260 */  iRegP_rule,
  /*  261 */  0,
  /*  262 */  0,
  /*  263 */  0,
  /*  264 */  0,
  /*  265 */  0,
  /*  266 */  0,
  /*  267 */  0,
  /*  268 */  0,
  /*  269 */  0,
  /*  270 */  0,
  /*  271 */  0,
  /*  272 */  0,
  /*  273 */  0,
  /*  274 */  0,
  /*  275 */  0,
  /*  276 */  0,
  /*  277 */  0,
  /*  278 */  0,
  /*  279 */  0,
  /*  280 */  0,
  /*  281 */  0,
  /*  282 */  0,
  /*  283 */  0,
  /*  284 */  0,
  /*  285 */  0,
  /*  286 */  0,
  /*  287 */  0,
  /*  288 */  0,
  /*  289 */  0,
  /*  290 */  0,
  /*  291 */  0,
  /*  292 */  0,
  /*  293 */  0,
  /*  294 */  0,
  /*  295 */  0,
  /*  296 */  0,
  /*  297 */  0,
  /*  298 */  0,
  /*  299 */  0,
  /*  300 */  0,
  /*  301 */  0,
  /*  302 */  0,
  /*  303 */  0,
  /*  304 */  0,
  /*  305 */  0,
  /*  306 */  0,
  /*  307 */  0,
  /*  308 */  0,
  /*  309 */  0,
  /*  310 */  0,
  /*  311 */  0,
  /*  312 */  0,
  /*  313 */  0,
  /*  314 */  immL_32bits_rule,
  /*  315 */  0,
  /*  316 */  0,
  /*  317 */  0,
  /*  318 */  0,
  /*  319 */  0,
  /*  320 */  0,
  /*  321 */  0,
  /*  322 */  0,
  /*  323 */  immI0_rule,
  /*  324 */  immI0_rule,
  /*  325 */  iRegIorL2I_rule,
  /*  326 */  immI0_rule,
  /*  327 */  iRegIorL2I_rule,
  /*  328 */  immI0_rule,
  /*  329 */  iRegIorL2I_rule,
  /*  330 */  immI0_rule,
  /*  331 */  iRegL_rule,
  /*  332 */  immL0_rule,
  /*  333 */  iRegP_rule,
  /*  334 */  immP0_rule,
  /*  335 */  iRegN_rule,
  /*  336 */  immN0_rule,
  /*  337 */  fRegF_rule,
  /*  338 */  fRegD_rule,
  /*  339 */  iRegN_rule,
  /*  340 */  0,
  /*  341 */  _Binary_iRegI_R12_iRegI_R13_rule,
  /*  342 */  _Binary_iRegI_R12_iRegI_R13_rule,
  /*  343 */  _Binary_iRegI_iRegI_rule,
  /*  344 */  _Binary_iRegL_iRegL_rule,
  /*  345 */  _Binary_iRegP_iRegP_rule,
  /*  346 */  _Binary_iRegN_iRegN_rule,
  /*  347 */  _Binary_iRegI_R12_iRegI_R13_rule,
  /*  348 */  _Binary_iRegI_R12_iRegI_R13_rule,
  /*  349 */  _Binary_iRegI_iRegI_rule,
  /*  350 */  _Binary_iRegL_iRegL_rule,
  /*  351 */  _Binary_iRegP_iRegP_rule,
  /*  352 */  _Binary_iRegN_iRegN_rule,
  /*  353 */  _Binary_iRegI_R12_iRegI_R13_rule,
  /*  354 */  _Binary_iRegI_R12_iRegI_R13_rule,
  /*  355 */  _Binary_iRegI_iRegI_rule,
  /*  356 */  _Binary_iRegL_iRegL_rule,
  /*  357 */  _Binary_iRegN_iRegN_rule,
  /*  358 */  _Binary_iRegP_iRegP_rule,
  /*  359 */  _Binary_iRegI_R12_iRegI_R13_rule,
  /*  360 */  _Binary_iRegI_R12_iRegI_R13_rule,
  /*  361 */  _Binary_iRegI_iRegI_rule,
  /*  362 */  _Binary_iRegL_iRegL_rule,
  /*  363 */  _Binary_iRegN_iRegN_rule,
  /*  364 */  _Binary_iRegP_iRegP_rule,
  /*  365 */  _Binary_iRegI_R12_iRegI_R13_rule,
  /*  366 */  _Binary_iRegI_R12_iRegI_R13_rule,
  /*  367 */  _Binary_iRegI_iRegI_rule,
  /*  368 */  _Binary_iRegL_iRegL_rule,
  /*  369 */  _Binary_iRegN_iRegN_rule,
  /*  370 */  _Binary_iRegP_iRegP_rule,
  /*  371 */  _Binary_iRegI_R12_iRegI_R13_rule,
  /*  372 */  _Binary_iRegI_R12_iRegI_R13_rule,
  /*  373 */  _Binary_iRegI_iRegI_rule,
  /*  374 */  _Binary_iRegL_iRegL_rule,
  /*  375 */  _Binary_iRegN_iRegN_rule,
  /*  376 */  _Binary_iRegP_iRegP_rule,
  /*  377 */  iRegI_rule,
  /*  378 */  iRegL_rule,
  /*  379 */  iRegN_rule,
  /*  380 */  iRegP_rule,
  /*  381 */  iRegI_rule,
  /*  382 */  iRegL_rule,
  /*  383 */  iRegN_rule,
  /*  384 */  iRegP_rule,
  /*  385 */  iRegL_rule,
  /*  386 */  iRegL_rule,
  /*  387 */  immLAdd_rule,
  /*  388 */  immLAdd_rule,
  /*  389 */  iRegIorL2I_rule,
  /*  390 */  iRegIorL2I_rule,
  /*  391 */  immIAdd_rule,
  /*  392 */  immIAdd_rule,
  /*  393 */  iRegL_rule,
  /*  394 */  iRegL_rule,
  /*  395 */  immLAdd_rule,
  /*  396 */  immLAdd_rule,
  /*  397 */  iRegIorL2I_rule,
  /*  398 */  iRegIorL2I_rule,
  /*  399 */  immIAdd_rule,
  /*  400 */  immIAdd_rule,
  /*  401 */  iRegIorL2I_rule,
  /*  402 */  immIAdd_rule,
  /*  403 */  immIAdd_rule,
  /*  404 */  iRegL_rule,
  /*  405 */  uimmI6_ge32_rule,
  /*  406 */  immLAdd_rule,
  /*  407 */  iRegL_rule,
  /*  408 */  immLAdd_rule,
  /*  409 */  iRegIorL2I_rule,
  /*  410 */  immISub_rule,
  /*  411 */  iRegL_rule,
  /*  412 */  immLSub_rule,
  /*  413 */  iRegIorL2I_rule,
  /*  414 */  iRegL_rule,
  /*  415 */  iRegIorL2I_rule,
  /*  416 */  iRegL_rule,
  /*  417 */  iRegL_rule,
  /*  418 */  iRegL_rule,
  /*  419 */  iRegIorL2I_rule,
  /*  420 */  iRegIorL2I_rule,
  /*  421 */  immI_31_rule,
  /*  422 */  iRegL_rule,
  /*  423 */  iRegL_rule,
  /*  424 */  immI_63_rule,
  /*  425 */  iRegIorL2I_rule,
  /*  426 */  iRegIorL2I_rule,
  /*  427 */  iRegL_rule,
  /*  428 */  iRegL_rule,
  /*  429 */  iRegIorL2I_rule,
  /*  430 */  immI_rule,
  /*  431 */  iRegIorL2I_rule,
  /*  432 */  immI_rule,
  /*  433 */  iRegIorL2I_rule,
  /*  434 */  immI_rule,
  /*  435 */  iRegIorL2I_rule,
  /*  436 */  immI_rule,
  /*  437 */  iRegIorL2I_rule,
  /*  438 */  immI_rule,
  /*  439 */  immI_rule,
  /*  440 */  iRegIorL2I_rule,
  /*  441 */  immI_rule,
  /*  442 */  immI_M1_rule,
  /*  443 */  immL_M1_rule,
  /*  444 */  fRegF_rule,
  /*  445 */  fRegD_rule,
  /*  446 */  fRegF_rule,
  /*  447 */  fRegD_rule,
  /*  448 */  fRegF_rule,
  /*  449 */  fRegD_rule,
  /*  450 */  _Binary_fRegF_fRegF_rule,
  /*  451 */  _Binary_fRegD_fRegD_rule,
  /*  452 */  _Binary_fRegF_fRegF_rule,
  /*  453 */  _Binary_fRegD_fRegD_rule,
  /*  454 */  _Binary_fRegF__NegF_fRegF__rule,
  /*  455 */  _Binary_fRegD__NegD_fRegD__rule,
  /*  456 */  _Binary_fRegF__NegF_fRegF__rule,
  /*  457 */  _Binary_fRegD__NegD_fRegD__rule,
  /*  458 */  fRegF_rule,
  /*  459 */  fRegF_rule,
  /*  460 */  fRegD_rule,
  /*  461 */  fRegD_rule,
  /*  462 */  fRegF_rule,
  /*  463 */  fRegD_rule,
  /*  464 */  0,
  /*  465 */  0,
  /*  466 */  immI_rule,
  /*  467 */  _Binary_fRegD_immD_rule,
  /*  468 */  fRegF_rule,
  /*  469 */  _Binary_immD_fRegD_rule,
  /*  470 */  _Binary_immF_fRegF_rule,
  /*  471 */  iRegI_rule,
  /*  472 */  immIAdd_rule,
  /*  473 */  iRegI_rule,
  /*  474 */  immIAdd_rule,
  /*  475 */  iRegI_rule,
  /*  476 */  immIAdd_rule,
  /*  477 */  iRegL_rule,
  /*  478 */  immLAdd_rule,
  /*  479 */  iRegL_rule,
  /*  480 */  immLAdd_rule,
  /*  481 */  iRegL_rule,
  /*  482 */  immLAdd_rule,
  /*  483 */  0,
  /*  484 */  0,
  /*  485 */  0,
  /*  486 */  0,
  /*  487 */  0,
  /*  488 */  0,
  /*  489 */  0,
  /*  490 */  0,
  /*  491 */  0,
  /*  492 */  0,
  /*  493 */  0,
  /*  494 */  0,
  /*  495 */  0,
  /*  496 */  0,
  /*  497 */  0,
  /*  498 */  0,
  /*  499 */  immL_32bits_rule,
  /*  500 */  0,
  /*  501 */  0,
  /*  502 */  0,
  /*  503 */  0,
  /*  504 */  0,
  /*  505 */  0,
  /*  506 */  0,
  /*  507 */  0,
  /*  508 */  0,
  /*  509 */  0,
  /*  510 */  0,
  /*  511 */  0,
  /*  512 */  0,
  /*  513 */  0,
  /*  514 */  0,
  /*  515 */  0,
  /*  516 */  0,
  /*  517 */  0,
  /*  518 */  0,
  /*  519 */  0,
  /*  520 */  0,
  /*  521 */  fRegF_rule,
  /*  522 */  fRegD_rule,
  /*  523 */  iRegL_rule,
  /*  524 */  iRegL_rule,
  /*  525 */  iRegI_rule,
  /*  526 */  iRegI_rule,
  /*  527 */  immI0_rule,
  /*  528 */  iRegI_rule,
  /*  529 */  iRegI_rule,
  /*  530 */  immI0_rule,
  /*  531 */  iRegINoSp_rule,
  /*  532 */  immI0_rule,
  /*  533 */  iRegINoSp_rule,
  /*  534 */  iRegI_rule,
  /*  535 */  iRegI_rule,
  /*  536 */  0,
  /*  537 */  rFlagsReg_rule,
  /*  538 */  _CmpI_iRegI_iRegI_rule,
  /*  539 */  _CmpI_iRegI_iRegI_rule,
  /*  540 */  _CmpU_iRegI_iRegI_rule,
  /*  541 */  _CmpL_iRegL_iRegL_rule,
  /*  542 */  _CmpL_iRegL_iRegL_rule,
  /*  543 */  _CmpUL_iRegL_iRegL_rule,
  /*  544 */  _CmpP_iRegP_iRegP_rule,
  /*  545 */  _CmpN_iRegN_iRegN_rule,
  /*  546 */  _CmpF_fRegF_fRegF_rule,
  /*  547 */  _CmpD_fRegD_fRegD_rule,
  /*  548 */  _CmpI_iRegI_immI0_rule,
  /*  549 */  _CmpI_iRegI_immI0_rule,
  /*  550 */  _CmpU_iRegI_immI0_rule,
  /*  551 */  _CmpL_iRegL_immL0_rule,
  /*  552 */  _CmpL_iRegL_immL0_rule,
  /*  553 */  _CmpUL_iRegL_immL0_rule,
  /*  554 */  _CmpP_iRegP_immP0_rule,
  /*  555 */  _CmpN_iRegN_immN0_rule,
  /*  556 */  _CmpP__DecodeN_iRegN__immP0_rule,
  /*  557 */  rFlagsReg_rule,
  /*  558 */  _CmpI_iRegI_iRegI_rule,
  /*  559 */  _CmpI_iRegI_iRegI_rule,
  /*  560 */  _CmpU_iRegI_iRegI_rule,
  /*  561 */  _CmpL_iRegL_iRegL_rule,
  /*  562 */  _CmpL_iRegL_iRegL_rule,
  /*  563 */  _CmpUL_iRegL_iRegL_rule,
  /*  564 */  _CmpP_iRegP_iRegP_rule,
  /*  565 */  _CmpN_iRegN_iRegN_rule,
  /*  566 */  _CmpF_fRegF_fRegF_rule,
  /*  567 */  _CmpD_fRegD_fRegD_rule,
  /*  568 */  _CmpI_iRegI_immI0_rule,
  /*  569 */  _CmpI_iRegI_immI0_rule,
  /*  570 */  _CmpU_iRegI_immI0_rule,
  /*  571 */  _CmpU_iRegI_immI0_rule,
  /*  572 */  _CmpL_iRegL_immL0_rule,
  /*  573 */  _CmpL_iRegL_immL0_rule,
  /*  574 */  _CmpUL_iRegL_immL0_rule,
  /*  575 */  _CmpUL_iRegL_immL0_rule,
  /*  576 */  _CmpP_iRegP_immP0_rule,
  /*  577 */  _CmpN_iRegN_immN0_rule,
  /*  578 */  _CmpP__DecodeN_iRegN__immP0_rule,
  /*  579 */  _Binary_iRegINoSp_iRegI_rule,
  /*  580 */  _Binary_iRegINoSp_iRegI_rule,
  /*  581 */  _Binary_iRegINoSp_iRegI_rule,
  /*  582 */  _Binary_iRegINoSp_iRegI_rule,
  /*  583 */  _Binary_iRegLNoSp_iRegL_rule,
  /*  584 */  _Binary_iRegLNoSp_iRegL_rule,
  /*  585 */  _Binary_iRegLNoSp_iRegL_rule,
  /*  586 */  _Binary_iRegLNoSp_iRegL_rule,
  /*  587 */  0,
  /*  588 */  0,
  /*  589 */  0,
  /*  590 */  0,
  /*  591 */  0,
  /*  592 */  iRegP_R10_rule,
  /*  593 */  _Binary_iRegP_R13_iRegI_R14_rule,
  /*  594 */  _Binary_iRegP_R13_iRegI_R14_rule,
  /*  595 */  _Binary_iRegP_R13_iRegI_R14_rule,
  /*  596 */  _Binary_iRegP_R13_iRegI_R14_rule,
  /*  597 */  _Binary_iRegP_R13_iRegI_R14_rule,
  /*  598 */  _Binary_iRegP_R13_iRegI_R14_rule,
  /*  599 */  _Binary_iRegP_R13_iRegI_R14_rule,
  /*  600 */  _Binary_iRegP_R13_immI_le_4_rule,
  /*  601 */  _Binary_iRegP_R13_immI_le_4_rule,
  /*  602 */  _Binary_iRegP_R13_immI_1_rule,
  /*  603 */  iRegI_R13_rule,
  /*  604 */  iRegI_R13_rule,
  /*  605 */  iRegP_R28_rule,
  /*  606 */  iRegP_R28_rule,
  /*  607 */  iRegI_R14_rule,
  /*  608 */  iRegI_R14_rule,
  /*  609 */  iRegP_R12_rule,
  /*  610 */  iRegP_R12_rule,
  /*  611 */  0,
  /*  612 */  inline_cache_RegP_rule,
  /*  613 */  iRegP_R10_rule,
  /*  614 */  0,
  /*  615 */  0,
  /*  616 */  0,
  /*  617 */  0,
  /*  618 */  0,
  /*  619 */  vReg_rule,
  /*  620 */  vRegMask_V0_rule,
  /*  621 */  immI_rule,
  /*  622 */  immI_rule,
  /*  623 */  _Binary_immI_vRegMask_V0_rule,
  /*  624 */  immI_rule,
  /*  625 */  _Binary_immI_vRegMask_V0_rule,
  /*  626 */  0,
  /*  627 */  0,
  /*  628 */  0,
  /*  629 */  0,
  /*  630 */  vRegMask_V0_rule,
  /*  631 */  vRegMask_V0_rule,
  /*  632 */  vRegMask_V0_rule,
  /*  633 */  vRegMask_V0_rule,
  /*  634 */  vRegMask_V0_rule,
  /*  635 */  vRegMask_V0_rule,
  /*  636 */  vReg_rule,
  /*  637 */  vReg_rule,
  /*  638 */  vReg_rule,
  /*  639 */  vReg_rule,
  /*  640 */  vReg_rule,
  /*  641 */  vReg_rule,
  /*  642 */  vRegMask_V0_rule,
  /*  643 */  vRegMask_V0_rule,
  /*  644 */  vRegMask_V0_rule,
  /*  645 */  vRegMask_V0_rule,
  /*  646 */  vRegMask_V0_rule,
  /*  647 */  vRegMask_V0_rule,
  /*  648 */  vReg_rule,
  /*  649 */  vReg_rule,
  /*  650 */  vReg_rule,
  /*  651 */  vReg_rule,
  /*  652 */  vReg_rule,
  /*  653 */  vReg_rule,
  /*  654 */  vRegMask_V0_rule,
  /*  655 */  vRegMask_V0_rule,
  /*  656 */  vRegMask_V0_rule,
  /*  657 */  vRegMask_V0_rule,
  /*  658 */  vRegMask_V0_rule,
  /*  659 */  vRegMask_V0_rule,
  /*  660 */  vReg_rule,
  /*  661 */  vRegMask_V0_rule,
  /*  662 */  vReg_rule,
  /*  663 */  vRegMask_V0_rule,
  /*  664 */  vReg_rule,
  /*  665 */  vRegMask_V0_rule,
  /*  666 */  vReg_rule,
  /*  667 */  vReg_rule,
  /*  668 */  vRegMask_V0_rule,
  /*  669 */  vRegMask_V0_rule,
  /*  670 */  vReg_rule,
  /*  671 */  vReg_rule,
  /*  672 */  vRegMask_V0_rule,
  /*  673 */  vRegMask_V0_rule,
  /*  674 */  vReg_rule,
  /*  675 */  vReg_rule,
  /*  676 */  vRegMask_rule,
  /*  677 */  vRegMask_rule,
  /*  678 */  _Binary_vReg_vReg_rule,
  /*  679 */  _Binary_vReg_vReg_rule,
  /*  680 */  _Binary_vReg_vRegMask_V0_rule,
  /*  681 */  _Binary_vReg_vRegMask_V0_rule,
  /*  682 */  _Binary_vReg__NegVF_vReg__rule,
  /*  683 */  _Binary_vReg__NegVD_vReg__rule,
  /*  684 */  _Binary_vReg_vRegMask_V0_rule,
  /*  685 */  _Binary_vReg_vRegMask_V0_rule,
  /*  686 */  _Binary_vReg__NegVF_vReg__rule,
  /*  687 */  _Binary_vReg__NegVD_vReg__rule,
  /*  688 */  _Binary__NegVF_vReg__vRegMask_V0_rule,
  /*  689 */  _Binary__NegVD_vReg__vRegMask_V0_rule,
  /*  690 */  _Binary_vReg_vReg_rule,
  /*  691 */  _Binary_vReg_vReg_rule,
  /*  692 */  _Binary__NegVF_vReg__vRegMask_V0_rule,
  /*  693 */  _Binary__NegVD_vReg__vRegMask_V0_rule,
  /*  694 */  _MulVB_vReg_vReg_rule,
  /*  695 */  vReg_rule,
  /*  696 */  _MulVS_vReg_vReg_rule,
  /*  697 */  vReg_rule,
  /*  698 */  _MulVI_vReg_vReg_rule,
  /*  699 */  vReg_rule,
  /*  700 */  _MulVL_vReg_vReg_rule,
  /*  701 */  vReg_rule,
  /*  702 */  vRegMask_V0_rule,
  /*  703 */  vRegMask_V0_rule,
  /*  704 */  vRegMask_V0_rule,
  /*  705 */  vRegMask_V0_rule,
  /*  706 */  _MulVB_vReg_vReg_rule,
  /*  707 */  _MulVS_vReg_vReg_rule,
  /*  708 */  _MulVI_vReg_vReg_rule,
  /*  709 */  _MulVL_vReg_vReg_rule,
  /*  710 */  vRegMask_V0_rule,
  /*  711 */  vRegMask_V0_rule,
  /*  712 */  vRegMask_V0_rule,
  /*  713 */  vRegMask_V0_rule,
  /*  714 */  vReg_rule,
  /*  715 */  vReg_rule,
  /*  716 */  vReg_rule,
  /*  717 */  vReg_rule,
  /*  718 */  vReg_rule,
  /*  719 */  vReg_rule,
  /*  720 */  vRegMask_V0_rule,
  /*  721 */  vRegMask_V0_rule,
  /*  722 */  vRegMask_V0_rule,
  /*  723 */  vRegMask_V0_rule,
  /*  724 */  vRegMask_V0_rule,
  /*  725 */  vRegMask_V0_rule,
  /*  726 */  vRegMask_V0_rule,
  /*  727 */  vRegMask_V0_rule,
  /*  728 */  vRegMask_V0_rule,
  /*  729 */  vRegMask_V0_rule,
  /*  730 */  vReg_rule,
  /*  731 */  vReg_rule,
  /*  732 */  vRegMask_V0_rule,
  /*  733 */  vRegMask_V0_rule,
  /*  734 */  vReg_rule,
  /*  735 */  vReg_rule,
  /*  736 */  vRegMask_V0_rule,
  /*  737 */  vRegMask_V0_rule,
  /*  738 */  vReg_rule,
  /*  739 */  vReg_rule,
  /*  740 */  vRegMask_V0_rule,
  /*  741 */  vRegMask_V0_rule,
  /*  742 */  vReg_rule,
  /*  743 */  vReg_rule,
  /*  744 */  vReg_rule,
  /*  745 */  vReg_rule,
  /*  746 */  vRegMask_V0_rule,
  /*  747 */  vRegMask_V0_rule,
  /*  748 */  vRegMask_V0_rule,
  /*  749 */  vRegMask_V0_rule,
  /*  750 */  vReg_rule,
  /*  751 */  vReg_rule,
  /*  752 */  vRegMask_V0_rule,
  /*  753 */  vRegMask_V0_rule,
  /*  754 */  vReg_rule,
  /*  755 */  vReg_rule,
  /*  756 */  vRegMask_V0_rule,
  /*  757 */  vRegMask_V0_rule,
  /*  758 */  vReg_rule,
  /*  759 */  vReg_rule,
  /*  760 */  vRegMask_V0_rule,
  /*  761 */  vRegMask_V0_rule,
  /*  762 */  vReg_rule,
  /*  763 */  vReg_rule,
  /*  764 */  vRegMask_V0_rule,
  /*  765 */  vRegMask_V0_rule,
  /*  766 */  vReg_rule,
  /*  767 */  vReg_rule,
  /*  768 */  vReg_rule,
  /*  769 */  vReg_rule,
  /*  770 */  vRegMask_rule,
  /*  771 */  vRegMask_rule,
  /*  772 */  vRegMask_V0_rule,
  /*  773 */  vRegMask_V0_rule,
  /*  774 */  vReg_rule,
  /*  775 */  vReg_rule,
  /*  776 */  vReg_rule,
  /*  777 */  vReg_rule,
  /*  778 */  vRegMask_rule,
  /*  779 */  vRegMask_rule,
  /*  780 */  vRegMask_V0_rule,
  /*  781 */  vRegMask_V0_rule,
  /*  782 */  vReg_rule,
  /*  783 */  vReg_rule,
  /*  784 */  vReg_rule,
  /*  785 */  vReg_rule,
  /*  786 */  vRegMask_rule,
  /*  787 */  vRegMask_rule,
  /*  788 */  vRegMask_V0_rule,
  /*  789 */  vRegMask_V0_rule,
  /*  790 */  _RShiftCntV_immI__rule,
  /*  791 */  _RShiftCntV_immI__rule,
  /*  792 */  _RShiftCntV_immI__rule,
  /*  793 */  _RShiftCntV_immI__rule,
  /*  794 */  vRegMask_V0_rule,
  /*  795 */  vRegMask_V0_rule,
  /*  796 */  vRegMask_V0_rule,
  /*  797 */  vRegMask_V0_rule,
  /*  798 */  _RShiftCntV_immI__rule,
  /*  799 */  _RShiftCntV_immI__rule,
  /*  800 */  _RShiftCntV_immI__rule,
  /*  801 */  _RShiftCntV_immI__rule,
  /*  802 */  vRegMask_V0_rule,
  /*  803 */  vRegMask_V0_rule,
  /*  804 */  vRegMask_V0_rule,
  /*  805 */  vRegMask_V0_rule,
  /*  806 */  _LShiftCntV_immI__rule,
  /*  807 */  _LShiftCntV_immI__rule,
  /*  808 */  _LShiftCntV_immI__rule,
  /*  809 */  _LShiftCntV_immI__rule,
  /*  810 */  vRegMask_V0_rule,
  /*  811 */  vRegMask_V0_rule,
  /*  812 */  vRegMask_V0_rule,
  /*  813 */  vRegMask_V0_rule,
  /*  814 */  vRegMask_V0_rule,
  /*  815 */  vRegMask_V0_rule,
  /*  816 */  iRegI_R14_rule,
  /*  817 */  iRegI_R14_rule,
  /*  818 */  iRegP_R12_rule,
  /*  819 */  iRegP_R12_rule,
  /*  820 */  _Binary_iRegP_R13_iRegI_R14_rule,
  /*  821 */  _Binary_iRegP_R13_iRegI_R14_rule,
  /*  822 */  _Binary_iRegP_R13_iRegI_R14_rule,
  /*  823 */  _Binary_iRegP_R13_iRegI_R14_rule,
  /*  824 */  _Binary_iRegP_R11_iRegI_R12_rule,
  /*  825 */  _Binary_iRegP_R11_iRegI_R13_rule,
  /*  826 */  _Binary_iRegP_R11_iRegI_R13_rule,
  /*  827 */  _Binary_iRegP_R11_iRegI_R13_rule,
  /*  828 */  iRegI_R12_rule,
  /*  829 */  iRegI_R13_rule,
  /*  830 */  iRegI_R13_rule,
  /*  831 */  iRegP_R28_rule,
  /*  832 */  iRegIorL2I_rule,
  /*  833 */  iRegL_rule,
  /*  834 */  iRegIorL2I_rule,
  /*  835 */  iRegL_rule,
  /*  836 */  0,
  /*  837 */  0,
  /*  838 */  0,
  /*  839 */  0,
  /*  840 */  vRegMask_rule,
  /*  841 */  vRegMask_rule,
  /*  842 */  vRegMask_rule,
  /*  843 */  vRegMask_V0_rule,
  /*  844 */  _Binary_vReg_vRegMask_V0_rule,
  /*  845 */  vRegMask_V0_rule,
  /*  846 */  0,
  /*  847 */  0,
  /*  848 */  0,
  /*  849 */  0,
  /*  850 */  0,
  /*  851 */  0,
  /*  852 */  0,
  /*  853 */  0,
  /*  854 */  0,
  /*  855 */  0,
  /*  856 */  0,
  /*  857 */  0,
  /*  858 */  0,
  /*  859 */  vReg_rule,
  /*  860 */  vRegMask_V0_rule,
  /*  861 */  immI_rule,
  /*  862 */  immI_rule,
  /*  863 */  immI_rule,
  /*  864 */  immI_rule,
  /*  865 */  immI_rule,
  /*  866 */  immI_rule,
  /*  867 */  0,
  /*  868 */  vRegMask_V0_rule,
  /*  869 */  vRegMask_V0_rule,
  /*  870 */  _Binary_vReg_vReg_rule,
  /*  871 */  _Binary_vReg_vReg_rule,
  /*  872 */  vReg_rule,
  /*  873 */  _Binary_vReg_vRegMask_V0_rule,
  /*  874 */  _Binary_vReg_vReg_rule,
  /*  875 */  _Binary_vReg__Binary_vReg_vRegMask_V0_rule,
  /*  876 */  iRegIorL2I_rule,
  /*  877 */  immI_rule,
  /*  878 */  iRegIorL2I_rule,
  /*  879 */  immI_rule,
  /*  880 */  iRegIorL2I_rule,
  /*  881 */  immI_rule,
  /*  882 */  iRegIorL2I_rule,
  /*  883 */  immI_rule,
  /*  884 */  iRegIorL2I_rule,
  /*  885 */  0,
  /*  886 */  _Binary_immI_1_immI0_rule,
  /*  887 */  _Binary_immI_1_immI0_rule,
  /*  888 */  _VectorTest_vRegMask_vRegMask_rule,
  /*  889 */  _VectorTest_vRegMask_vRegMask_rule,
  /*  890 */  immI_rule,
  /*  891 */  immI_rule,
  /*  892 */  iRegI_rule,
  /*  893 */  iRegI_rule,
  /*  894 */  iRegI_rule,
  /*  895 */  iRegI_rule,
  /*  896 */  0,
  /*  897 */  immI_24_rule,
  /*  898 */  immI_16_rule,
  /*  899 */  immI_16bits_rule,
  /*  900 */  immL_32bits_rule,
  /*  901 */  0,
  /*  902 */  0,
  /*  903 */  0,
  /*  904 */  0,
  /*  905 */  _LShiftL_iRegL_immIScale_rule,
  /*  906 */  _LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  907 */  _LShiftL_iRegL_immIScale_rule,
  /*  908 */  iRegL_rule,
  /*  909 */  _LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  910 */  iRegL_rule,
  /*  911 */  iRegI_rule,
  /*  912 */  iRegI_rule,
  /*  913 */  immI0_rule,
  /*  914 */  iRegI_rule,
  /*  915 */  immI0_rule,
  /*  916 */  iRegI_rule,
  /*  917 */  _XorI_iRegI_immI_M1_rule,
  /*  918 */  iRegI_rule,
  /*  919 */  _XorL_iRegL_immL_M1_rule,
  /*  920 */  iRegL_rule,
  /*  921 */  _XorI_iRegI_immI_M1_rule,
  /*  922 */  iRegI_rule,
  /*  923 */  _XorL_iRegL_immL_M1_rule,
  /*  924 */  iRegL_rule,
  /*  925 */  0,
  /*  926 */  _Binary_iRegP_iRegP_rule,
  /*  927 */  _Binary_iRegN_iRegN_rule,
  /*  928 */  _Binary_iRegP_iRegP_rule,
  /*  929 */  _Binary_iRegN_iRegN_rule,
  /*  930 */  _Binary_iRegN_iRegN_rule,
  /*  931 */  _Binary_iRegP_iRegP_rule,
  /*  932 */  _Binary_iRegN_iRegN_rule,
  /*  933 */  _Binary_iRegN_iRegN_rule,
  /*  934 */  _Binary_iRegP_iRegP_rule,
  /*  935 */  _Binary_iRegP_iRegP_rule,
  /*  936 */  _Binary_iRegN_iRegN_rule,
  /*  937 */  _Binary_iRegP_iRegP_rule,
  /*  938 */  0,
  /*  939 */  _Binary_iRegP_iRegP_rule,
  /*  940 */  _Binary_iRegP_iRegP_rule,
  /*  941 */  _Binary_iRegP_iRegP_rule,
  /*  942 */  _Binary_iRegP_iRegP_rule,
  /*  943 */  _Binary_iRegP_iRegP_rule,
  /*  944 */  _Binary_iRegP_iRegP_rule,
  /*  945 */  iRegP_rule,
  /*  946 */  iRegP_rule,
  /*  947 */  0,
  /*  948 */  iRegP_rule,
  /*  949 */  _Binary_iRegP_iRegP_rule,
  /*  950 */  _Binary_iRegP_iRegP_rule,
  /*  951 */  _Binary_iRegP_iRegP_rule,
  /*  952 */  _Binary_iRegP_iRegP_rule,
  /*  953 */  _Binary_iRegP_iRegP_rule,
  /*  954 */  _Binary_iRegP_iRegP_rule,
  /*  955 */  iRegP_rule,
  /*  956 */  iRegP_rule,
  // last instruction
  0 // no trailing comma
};

const char        *ruleName[] = {
  /*    0 */  "UNIVERSE",
  /*    1 */  "LABEL",
  /*    2 */  "SREGI",
  /*    3 */  "SREGP",
  /*    4 */  "SREGF",
  /*    5 */  "SREGD",
  /*    6 */  "SREGL",
  /*    7 */  "METHOD",
  /*    8 */  "IMMI",
  /*    9 */  "IMMI0",
  /*   10 */  "IMMI_1",
  /*   11 */  "IMMI_M1",
  /*   12 */  "UIMMI6_GE32",
  /*   13 */  "IMMI_LE_4",
  /*   14 */  "IMMI_16",
  /*   15 */  "IMMI_24",
  /*   16 */  "IMMI_31",
  /*   17 */  "IMMI_63",
  /*   18 */  "IMMIADD",
  /*   19 */  "IMMISUB",
  /*   20 */  "IMMI5",
  /*   21 */  "IMML5",
  /*   22 */  "IMML",
  /*   23 */  "IMML0",
  /*   24 */  "IMMP",
  /*   25 */  "IMMP0",
  /*   26 */  "IMMP_1",
  /*   27 */  "IMMBYTEMAPBASE",
  /*   28 */  "IMMI_16BITS",
  /*   29 */  "IMMIPOWEROF2",
  /*   30 */  "IMML_32BITS",
  /*   31 */  "IMML_M1",
  /*   32 */  "IMML_PC_OFF",
  /*   33 */  "IMMLADD",
  /*   34 */  "IMMLSUB",
  /*   35 */  "IMMN",
  /*   36 */  "IMMN0",
  /*   37 */  "IMMNKLASS",
  /*   38 */  "IMMD",
  /*   39 */  "IMMD0",
  /*   40 */  "IMMF",
  /*   41 */  "IMMF0",
  /*   42 */  "IMMIOFFSET",
  /*   43 */  "IMMLOFFSET",
  /*   44 */  "IMMISCALE",
  /*   45 */  "IREGI",
  /*   46 */  "IREGINOSP",
  /*   47 */  "IREGI_R10",
  /*   48 */  "IREGI_R12",
  /*   49 */  "IREGI_R13",
  /*   50 */  "IREGI_R14",
  /*   51 */  "IREGL",
  /*   52 */  "IREGLNOSP",
  /*   53 */  "IREGL_R28",
  /*   54 */  "IREGL_R29",
  /*   55 */  "IREGL_R30",
  /*   56 */  "IREGP",
  /*   57 */  "IREGPNOSP",
  /*   58 */  "IREGP_R10",
  /*   59 */  "IREGP_R11",
  /*   60 */  "IREGP_R12",
  /*   61 */  "IREGP_R13",
  /*   62 */  "IREGP_R14",
  /*   63 */  "IREGP_R15",
  /*   64 */  "IREGP_R16",
  /*   65 */  "IREGP_R28",
  /*   66 */  "IREGP_R30",
  /*   67 */  "IREGP_R31",
  /*   68 */  "IREGN",
  /*   69 */  "IREGNNOSP",
  /*   70 */  "IREGL_R10",
  /*   71 */  "FREGF",
  /*   72 */  "FREGD",
  /*   73 */  "VREG",
  /*   74 */  "VREG_V1",
  /*   75 */  "VREG_V2",
  /*   76 */  "VREG_V3",
  /*   77 */  "VREG_V4",
  /*   78 */  "VREG_V5",
  /*   79 */  "VREG_V6",
  /*   80 */  "VREG_V7",
  /*   81 */  "VREG_V8",
  /*   82 */  "VREG_V9",
  /*   83 */  "VREG_V10",
  /*   84 */  "VREG_V11",
  /*   85 */  "VREG_V12",
  /*   86 */  "VREG_V13",
  /*   87 */  "VREG_V14",
  /*   88 */  "VREG_V15",
  /*   89 */  "VREGMASK",
  /*   90 */  "VREGMASK_V0",
  /*   91 */  "JAVATHREAD_REGP",
  /*   92 */  "INDIRECT",
  /*   93 */  "INDOFFI",
  /*   94 */  "INDOFFL",
  /*   95 */  "INDIRECTN",
  /*   96 */  "INDOFFIN",
  /*   97 */  "INDOFFLN",
  /*   98 */  "THREAD_ANCHOR_PC",
  /*   99 */  "STACKSLOTI",
  /*  100 */  "STACKSLOTF",
  /*  101 */  "STACKSLOTD",
  /*  102 */  "STACKSLOTL",
  /*  103 */  "IREGL2I",
  /*  104 */  "CMPOP",
  /*  105 */  "CMPOPU",
  /*  106 */  "CMPOPEQNE",
  /*  107 */  "CMPOPULTGE",
  /*  108 */  "CMPOPUEQNELEGT",
  /*  109 */  "RFLAGSREG",
  /*  110 */  "INLINE_CACHE_REGP",
  // last operand
  /*  111 */  "MEMORY",
  /*  112 */  "IREGIORL2I",
  /*  113 */  "IREGIORL",
  /*  114 */  "IREGNORP",
  /*  115 */  "IREGILNP",
  /*  116 */  "IREGILNPNOSP",
  /*  117 */  "IMMIORL",
  /*  118 */  "VMEMA",
  // last operand class
  /*  119 */  "_DecodeN_iRegN_",
  /*  120 */  "_LoadB_memory_",
  /*  121 */  "_LoadUB_memory_",
  /*  122 */  "_LoadS_memory_",
  /*  123 */  "_LoadUS_memory_",
  /*  124 */  "_LoadI_memory_",
  /*  125 */  "_ConvI2L__LoadI_memory__",
  /*  126 */  "_Binary_iRegI_R12_iRegI_R13",
  /*  127 */  "_Binary_iRegI_iRegI",
  /*  128 */  "_Binary_iRegL_iRegL",
  /*  129 */  "_Binary_iRegP_iRegP",
  /*  130 */  "_Binary_iRegN_iRegN",
  /*  131 */  "_ConvL2I_iRegL_",
  /*  132 */  "_ConvI2L_iRegI_",
  /*  133 */  "_RShiftI_iRegIorL2I_immI_31",
  /*  134 */  "_RShiftL_iRegL_immI_63",
  /*  135 */  "_CastP2X_iRegP_",
  /*  136 */  "_Binary_fRegF_fRegF",
  /*  137 */  "_Binary_fRegD_fRegD",
  /*  138 */  "_NegF_fRegF_",
  /*  139 */  "_NegD_fRegD_",
  /*  140 */  "_Binary_fRegF__NegF_fRegF_",
  /*  141 */  "_Binary_fRegD__NegD_fRegD_",
  /*  142 */  "_Binary_fRegD_immD",
  /*  143 */  "_Binary_immD_fRegD",
  /*  144 */  "_Binary_immF_fRegF",
  /*  145 */  "_ConvI2L_iRegIorL2I_",
  /*  146 */  "_CastP2X__DecodeN_iRegN__",
  /*  147 */  "_CmpI_iRegI_iRegI",
  /*  148 */  "_CmpU_iRegI_iRegI",
  /*  149 */  "_CmpL_iRegL_iRegL",
  /*  150 */  "_CmpUL_iRegL_iRegL",
  /*  151 */  "_CmpP_iRegP_iRegP",
  /*  152 */  "_CmpN_iRegN_iRegN",
  /*  153 */  "_CmpF_fRegF_fRegF",
  /*  154 */  "_CmpD_fRegD_fRegD",
  /*  155 */  "_CmpI_iRegI_immI0",
  /*  156 */  "_CmpU_iRegI_immI0",
  /*  157 */  "_CmpL_iRegL_immL0",
  /*  158 */  "_CmpUL_iRegL_immL0",
  /*  159 */  "_CmpP_iRegP_immP0",
  /*  160 */  "_CmpN_iRegN_immN0",
  /*  161 */  "_CmpP__DecodeN_iRegN__immP0",
  /*  162 */  "_Binary_cmpOp__CmpI_iRegI_iRegI",
  /*  163 */  "_Binary_iRegINoSp_iRegI",
  /*  164 */  "_Binary_cmpOpU__CmpU_iRegI_iRegI",
  /*  165 */  "_Binary_cmpOp__CmpL_iRegL_iRegL",
  /*  166 */  "_Binary_cmpOpU__CmpUL_iRegL_iRegL",
  /*  167 */  "_Binary_iRegLNoSp_iRegL",
  /*  168 */  "_PartialSubtypeCheck_iRegP_R14_iRegP_R10",
  /*  169 */  "_Binary_iRegP_R11_iRegI_R12",
  /*  170 */  "_Binary_iRegP_R13_iRegI_R14",
  /*  171 */  "_Binary_iRegP_R13_immI_le_4",
  /*  172 */  "_Binary_iRegP_R13_immI_1",
  /*  173 */  "_Binary_iRegP_R11_iRegP_R13",
  /*  174 */  "_Binary_vReg_vReg",
  /*  175 */  "_Binary_immI_vRegMask_V0",
  /*  176 */  "_Binary_vReg_vRegMask_V0",
  /*  177 */  "_NegVF_vReg_",
  /*  178 */  "_Binary_vReg__NegVF_vReg_",
  /*  179 */  "_NegVD_vReg_",
  /*  180 */  "_Binary_vReg__NegVD_vReg_",
  /*  181 */  "_Binary__NegVF_vReg__vRegMask_V0",
  /*  182 */  "_Binary__NegVD_vReg__vRegMask_V0",
  /*  183 */  "_MulVB_vReg_vReg",
  /*  184 */  "_MulVS_vReg_vReg",
  /*  185 */  "_MulVI_vReg_vReg",
  /*  186 */  "_MulVL_vReg_vReg",
  /*  187 */  "_Binary_vReg__MulVB_vReg_vReg",
  /*  188 */  "_Binary_vReg__MulVS_vReg_vReg",
  /*  189 */  "_Binary_vReg__MulVI_vReg_vReg",
  /*  190 */  "_Binary_vReg__MulVL_vReg_vReg",
  /*  191 */  "_Binary_iRegIorL2I_vReg",
  /*  192 */  "_Binary_iRegL_vReg",
  /*  193 */  "_Binary_fRegF_vReg",
  /*  194 */  "_Binary_fRegD_vReg",
  /*  195 */  "_RShiftCntV_immI_",
  /*  196 */  "_Binary_vReg__RShiftCntV_immI_",
  /*  197 */  "_LShiftCntV_immI_",
  /*  198 */  "_Binary_vReg__LShiftCntV_immI_",
  /*  199 */  "_Binary_iRegP_R11_iRegI_R13",
  /*  200 */  "_Binary_vReg__Binary_vReg_vRegMask_V0",
  /*  201 */  "_Binary_vReg_iRegIorL2I",
  /*  202 */  "_Binary_vReg_iRegL",
  /*  203 */  "_Binary_vReg_fRegF",
  /*  204 */  "_Binary_vReg_fRegD",
  /*  205 */  "_VectorTest_vRegMask_vRegMask",
  /*  206 */  "_Binary_cmpOp__VectorTest_vRegMask_vRegMask",
  /*  207 */  "_Binary_immI_1_immI0",
  /*  208 */  "_LShiftI_iRegIorL2I_immI_24",
  /*  209 */  "_LShiftI_iRegIorL2I_immI_16",
  /*  210 */  "_LShiftL_iRegL_immIScale",
  /*  211 */  "_LShiftL__ConvI2L_iRegI__immIScale",
  /*  212 */  "_XorI_iRegI_immI_M1",
  /*  213 */  "_XorL_iRegL_immL_M1",
  /*  214 */  "_AndI_iRegIorL2I_immIpowerOf2",
  // last internally defined operand
  /*  215 */  "loadConI",
  /*  216 */  "loadConL",
  /*  217 */  "loadConP",
  /*  218 */  "loadConP0",
  /*  219 */  "loadConP1",
  /*  220 */  "loadByteMapBase",
  /*  221 */  "loadConN",
  /*  222 */  "loadConN0",
  /*  223 */  "loadConNKlass",
  /*  224 */  "loadConF",
  /*  225 */  "loadConF0",
  /*  226 */  "loadConD",
  /*  227 */  "loadConD0",
  /*  228 */  "isInfiniteF_reg_reg",
  /*  229 */  "isInfiniteD_reg_reg",
  /*  230 */  "isFiniteF_reg_reg",
  /*  231 */  "isFiniteD_reg_reg",
  /*  232 */  "negF_reg_reg",
  /*  233 */  "negD_reg_reg",
  /*  234 */  "absI_reg",
  /*  235 */  "absL_reg",
  /*  236 */  "absF_reg",
  /*  237 */  "absD_reg",
  /*  238 */  "castX2P",
  /*  239 */  "castP2X",
  /*  240 */  "castPP",
  /*  241 */  "castLL",
  /*  242 */  "castII",
  /*  243 */  "checkCastPP",
  /*  244 */  "castFF",
  /*  245 */  "castDD",
  /*  246 */  "castVV",
  /*  247 */  "convI2Bool",
  /*  248 */  "convP2Bool",
  /*  249 */  "MoveF2I_stack_reg",
  /*  250 */  "MoveI2F_stack_reg",
  /*  251 */  "MoveD2L_stack_reg",
  /*  252 */  "MoveL2D_stack_reg",
  /*  253 */  "MoveF2I_reg_reg",
  /*  254 */  "MoveI2F_reg_reg",
  /*  255 */  "MoveD2L_reg_reg",
  /*  256 */  "MoveL2D_reg_reg",
  /*  257 */  "partialSubtypeCheckVsZero",
  /*  258 */  "tlsLoadP",
  /*  259 */  "cmpFastLock",
  /*  260 */  "cmpFastUnlock",
  /*  261 */  "vloadmask",
  /*  262 */  "vabs_fp",
  /*  263 */  "vabs_fp_0",
  /*  264 */  "vneg",
  /*  265 */  "vneg_0",
  /*  266 */  "vfneg",
  /*  267 */  "vfneg_0",
  /*  268 */  "replicate",
  /*  269 */  "replicateL",
  /*  270 */  "replicate_imm5",
  /*  271 */  "replicateL_imm5",
  /*  272 */  "replicateF",
  /*  273 */  "replicateD",
  /*  274 */  "vshiftcnt",
  /*  275 */  "vshiftcnt_0",
  /*  276 */  "vsqrt_fp",
  /*  277 */  "vsqrt_fp_0",
  /*  278 */  "vloadcon",
  /*  279 */  "vmask_gen_I",
  /*  280 */  "vmask_gen_L",
  /*  281 */  "vmask_gen_imm",
  /*  282 */  "vmaskcast",
  /*  283 */  "vcvtStoB",
  /*  284 */  "vcvtItoX_narrow",
  /*  285 */  "vcvtItoF",
  /*  286 */  "vcvtLtoI",
  /*  287 */  "vcvtLtoF",
  /*  288 */  "vcvtLtoD",
  /*  289 */  "vcvtDtoF",
  /*  290 */  "reinterpret",
  /*  291 */  "vmask_reinterpret_same_esize",
  /*  292 */  "vmask_truecount",
  /*  293 */  "vmask_lasttrue",
  /*  294 */  "vmask_tolong",
  /*  295 */  "vmask_fromlong",
  /*  296 */  "countLeadingZerosI_b",
  /*  297 */  "countLeadingZerosL_b",
  /*  298 */  "countTrailingZerosI_b",
  /*  299 */  "countTrailingZerosL_b",
  /*  300 */  "popCountI_b",
  /*  301 */  "popCountL_b",
  /*  302 */  "absI_reg_b",
  /*  303 */  "absL_reg_b",
  /*  304 */  "loadB",
  /*  305 */  "loadB2L",
  /*  306 */  "loadUB",
  /*  307 */  "loadUB2L",
  /*  308 */  "loadS",
  /*  309 */  "loadS2L",
  /*  310 */  "loadUS",
  /*  311 */  "loadUS2L",
  /*  312 */  "loadI",
  /*  313 */  "loadI2L",
  /*  314 */  "loadUI2L",
  /*  315 */  "loadL",
  /*  316 */  "loadRange",
  /*  317 */  "loadP",
  /*  318 */  "loadN",
  /*  319 */  "loadKlass",
  /*  320 */  "loadNKlass",
  /*  321 */  "loadF",
  /*  322 */  "loadD",
  /*  323 */  "storeimmCM0",
  /*  324 */  "storeimmCM0_ordered",
  /*  325 */  "storeB",
  /*  326 */  "storeimmB0",
  /*  327 */  "storeC",
  /*  328 */  "storeimmC0",
  /*  329 */  "storeI",
  /*  330 */  "storeimmI0",
  /*  331 */  "storeL",
  /*  332 */  "storeimmL0",
  /*  333 */  "storeP",
  /*  334 */  "storeimmP0",
  /*  335 */  "storeN",
  /*  336 */  "storeImmN0",
  /*  337 */  "storeF",
  /*  338 */  "storeD",
  /*  339 */  "storeNKlass",
  /*  340 */  "prefetchalloc",
  /*  341 */  "compareAndSwapB",
  /*  342 */  "compareAndSwapS",
  /*  343 */  "compareAndSwapI",
  /*  344 */  "compareAndSwapL",
  /*  345 */  "compareAndSwapP",
  /*  346 */  "compareAndSwapN",
  /*  347 */  "compareAndSwapBAcq",
  /*  348 */  "compareAndSwapSAcq",
  /*  349 */  "compareAndSwapIAcq",
  /*  350 */  "compareAndSwapLAcq",
  /*  351 */  "compareAndSwapPAcq",
  /*  352 */  "compareAndSwapNAcq",
  /*  353 */  "compareAndExchangeB",
  /*  354 */  "compareAndExchangeS",
  /*  355 */  "compareAndExchangeI",
  /*  356 */  "compareAndExchangeL",
  /*  357 */  "compareAndExchangeN",
  /*  358 */  "compareAndExchangeP",
  /*  359 */  "compareAndExchangeBAcq",
  /*  360 */  "compareAndExchangeSAcq",
  /*  361 */  "compareAndExchangeIAcq",
  /*  362 */  "compareAndExchangeLAcq",
  /*  363 */  "compareAndExchangeNAcq",
  /*  364 */  "compareAndExchangePAcq",
  /*  365 */  "weakCompareAndSwapB",
  /*  366 */  "weakCompareAndSwapS",
  /*  367 */  "weakCompareAndSwapI",
  /*  368 */  "weakCompareAndSwapL",
  /*  369 */  "weakCompareAndSwapN",
  /*  370 */  "weakCompareAndSwapP",
  /*  371 */  "weakCompareAndSwapBAcq",
  /*  372 */  "weakCompareAndSwapSAcq",
  /*  373 */  "weakCompareAndSwapIAcq",
  /*  374 */  "weakCompareAndSwapLAcq",
  /*  375 */  "weakCompareAndSwapNAcq",
  /*  376 */  "weakCompareAndSwapPAcq",
  /*  377 */  "get_and_setI",
  /*  378 */  "get_and_setL",
  /*  379 */  "get_and_setN",
  /*  380 */  "get_and_setP",
  /*  381 */  "get_and_setIAcq",
  /*  382 */  "get_and_setLAcq",
  /*  383 */  "get_and_setNAcq",
  /*  384 */  "get_and_setPAcq",
  /*  385 */  "get_and_addL",
  /*  386 */  "get_and_addL_no_res",
  /*  387 */  "get_and_addLi",
  /*  388 */  "get_and_addLi_no_res",
  /*  389 */  "get_and_addI",
  /*  390 */  "get_and_addI_no_res",
  /*  391 */  "get_and_addIi",
  /*  392 */  "get_and_addIi_no_res",
  /*  393 */  "get_and_addLAcq",
  /*  394 */  "get_and_addL_no_resAcq",
  /*  395 */  "get_and_addLiAcq",
  /*  396 */  "get_and_addLi_no_resAcq",
  /*  397 */  "get_and_addIAcq",
  /*  398 */  "get_and_addI_no_resAcq",
  /*  399 */  "get_and_addIiAcq",
  /*  400 */  "get_and_addIi_no_resAcq",
  /*  401 */  "addI_reg_reg",
  /*  402 */  "addI_reg_imm",
  /*  403 */  "addI_reg_imm_l2i",
  /*  404 */  "addP_reg_reg",
  /*  405 */  "lShiftL_regI_immGE32",
  /*  406 */  "addP_reg_imm",
  /*  407 */  "addL_reg_reg",
  /*  408 */  "addL_reg_imm",
  /*  409 */  "subI_reg_reg",
  /*  410 */  "subI_reg_imm",
  /*  411 */  "subL_reg_reg",
  /*  412 */  "subL_reg_imm",
  /*  413 */  "negI_reg",
  /*  414 */  "negL_reg",
  /*  415 */  "mulI",
  /*  416 */  "mulL",
  /*  417 */  "mulHiL_rReg",
  /*  418 */  "umulHiL_rReg",
  /*  419 */  "divI",
  /*  420 */  "UdivI",
  /*  421 */  "signExtract",
  /*  422 */  "divL",
  /*  423 */  "UdivL",
  /*  424 */  "signExtractL",
  /*  425 */  "modI",
  /*  426 */  "UmodI",
  /*  427 */  "modL",
  /*  428 */  "UmodL",
  /*  429 */  "lShiftI_reg_reg",
  /*  430 */  "lShiftI_reg_imm",
  /*  431 */  "urShiftI_reg_reg",
  /*  432 */  "urShiftI_reg_imm",
  /*  433 */  "rShiftI_reg_reg",
  /*  434 */  "rShiftI_reg_imm",
  /*  435 */  "lShiftL_reg_reg",
  /*  436 */  "lShiftL_reg_imm",
  /*  437 */  "urShiftL_reg_reg",
  /*  438 */  "urShiftL_reg_imm",
  /*  439 */  "urShiftP_reg_imm",
  /*  440 */  "rShiftL_reg_reg",
  /*  441 */  "rShiftL_reg_imm",
  /*  442 */  "regI_not_reg",
  /*  443 */  "regL_not_reg",
  /*  444 */  "addF_reg_reg",
  /*  445 */  "addD_reg_reg",
  /*  446 */  "subF_reg_reg",
  /*  447 */  "subD_reg_reg",
  /*  448 */  "mulF_reg_reg",
  /*  449 */  "mulD_reg_reg",
  /*  450 */  "maddF_reg_reg",
  /*  451 */  "maddD_reg_reg",
  /*  452 */  "msubF_reg_reg",
  /*  453 */  "msubD_reg_reg",
  /*  454 */  "nmsubF_reg_reg",
  /*  455 */  "nmsubD_reg_reg",
  /*  456 */  "nmaddF_reg_reg",
  /*  457 */  "nmaddD_reg_reg",
  /*  458 */  "maxF_reg_reg",
  /*  459 */  "minF_reg_reg",
  /*  460 */  "maxD_reg_reg",
  /*  461 */  "minD_reg_reg",
  /*  462 */  "divF_reg_reg",
  /*  463 */  "divD_reg_reg",
  /*  464 */  "sqrtF_reg",
  /*  465 */  "sqrtD_reg",
  /*  466 */  "roundD_reg",
  /*  467 */  "copySignD_reg",
  /*  468 */  "copySignF_reg",
  /*  469 */  "signumD_reg",
  /*  470 */  "signumF_reg",
  /*  471 */  "andI_reg_reg",
  /*  472 */  "andI_reg_imm",
  /*  473 */  "orI_reg_reg",
  /*  474 */  "orI_reg_imm",
  /*  475 */  "xorI_reg_reg",
  /*  476 */  "xorI_reg_imm",
  /*  477 */  "andL_reg_reg",
  /*  478 */  "andL_reg_imm",
  /*  479 */  "orL_reg_reg",
  /*  480 */  "orL_reg_imm",
  /*  481 */  "xorL_reg_reg",
  /*  482 */  "xorL_reg_imm",
  /*  483 */  "bytes_reverse_int",
  /*  484 */  "bytes_reverse_long",
  /*  485 */  "bytes_reverse_unsigned_short",
  /*  486 */  "bytes_reverse_short",
  /*  487 */  "load_fence",
  /*  488 */  "membar_acquire",
  /*  489 */  "membar_acquire_lock",
  /*  490 */  "store_fence",
  /*  491 */  "membar_release",
  /*  492 */  "membar_storestore",
  /*  493 */  "membar_storestore_0",
  /*  494 */  "membar_release_lock",
  /*  495 */  "membar_volatile",
  /*  496 */  "spin_wait",
  /*  497 */  "convI2L_reg_reg",
  /*  498 */  "convL2I_reg",
  /*  499 */  "convI2UL_reg_reg",
  /*  500 */  "convF2D_reg",
  /*  501 */  "convD2F_reg",
  /*  502 */  "convF2I_reg_reg",
  /*  503 */  "convI2F_reg_reg",
  /*  504 */  "convF2L_reg_reg",
  /*  505 */  "convL2F_reg_reg",
  /*  506 */  "convD2I_reg_reg",
  /*  507 */  "convI2D_reg_reg",
  /*  508 */  "convD2L_reg_reg",
  /*  509 */  "convL2D_reg_reg",
  /*  510 */  "convP2I",
  /*  511 */  "convN2I",
  /*  512 */  "encodeHeapOop",
  /*  513 */  "decodeHeapOop",
  /*  514 */  "decodeHeapOop_not_null",
  /*  515 */  "encodeKlass_not_null",
  /*  516 */  "decodeKlass_not_null",
  /*  517 */  "MoveF2I_reg_stack",
  /*  518 */  "MoveI2F_reg_stack",
  /*  519 */  "MoveD2L_reg_stack",
  /*  520 */  "MoveL2D_reg_stack",
  /*  521 */  "cmpF3_reg_reg",
  /*  522 */  "cmpD3_reg_reg",
  /*  523 */  "cmpL3_reg_reg",
  /*  524 */  "cmpUL3_reg_reg",
  /*  525 */  "cmpU3_reg_reg",
  /*  526 */  "cmpLTMask_reg_reg",
  /*  527 */  "cmpLTMask_reg_zero",
  /*  528 */  "minI_reg_reg",
  /*  529 */  "maxI_reg_reg",
  /*  530 */  "minI_reg_zero",
  /*  531 */  "minI_reg_zero_0",
  /*  532 */  "maxI_reg_zero",
  /*  533 */  "maxI_reg_zero_0",
  /*  534 */  "minI_rReg",
  /*  535 */  "maxI_rReg",
  /*  536 */  "branch",
  /*  537 */  "cmpFlag_branch",
  /*  538 */  "cmpI_branch",
  /*  539 */  "cmpI_loop",
  /*  540 */  "cmpU_branch",
  /*  541 */  "cmpL_branch",
  /*  542 */  "cmpL_loop",
  /*  543 */  "cmpUL_branch",
  /*  544 */  "cmpP_branch",
  /*  545 */  "cmpN_branch",
  /*  546 */  "cmpF_branch",
  /*  547 */  "cmpD_branch",
  /*  548 */  "cmpI_reg_imm0_branch",
  /*  549 */  "cmpI_reg_imm0_loop",
  /*  550 */  "cmpUEqNeLeGt_reg_imm0_branch",
  /*  551 */  "cmpL_reg_imm0_branch",
  /*  552 */  "cmpL_reg_imm0_loop",
  /*  553 */  "cmpULEqNeLeGt_reg_imm0_branch",
  /*  554 */  "cmpP_imm0_branch",
  /*  555 */  "cmpN_imm0_branch",
  /*  556 */  "cmpP_narrowOop_imm0_branch",
  /*  557 */  "far_cmpFlag_branch",
  /*  558 */  "far_cmpI_branch",
  /*  559 */  "far_cmpI_loop",
  /*  560 */  "far_cmpU_branch",
  /*  561 */  "far_cmpL_branch",
  /*  562 */  "far_cmpLloop",
  /*  563 */  "far_cmpUL_branch",
  /*  564 */  "far_cmpP_branch",
  /*  565 */  "far_cmpN_branch",
  /*  566 */  "far_cmpF_branch",
  /*  567 */  "far_cmpD_branch",
  /*  568 */  "far_cmpI_reg_imm0_branch",
  /*  569 */  "far_cmpI_reg_imm0_loop",
  /*  570 */  "far_cmpUEqNeLeGt_imm0_branch",
  /*  571 */  "far_cmpULtGe_reg_imm0_branch",
  /*  572 */  "far_cmpL_reg_imm0_branch",
  /*  573 */  "far_cmpL_reg_imm0_loop",
  /*  574 */  "far_cmpULEqNeLeGt_reg_imm0_branch",
  /*  575 */  "far_cmpULLtGe_reg_imm0_branch",
  /*  576 */  "far_cmpP_imm0_branch",
  /*  577 */  "far_cmpN_imm0_branch",
  /*  578 */  "far_cmpP_narrowOop_imm0_branch",
  /*  579 */  "cmovI_cmpI",
  /*  580 */  "cmovI_cmpU",
  /*  581 */  "cmovI_cmpL",
  /*  582 */  "cmovI_cmpUL",
  /*  583 */  "cmovL_cmpL",
  /*  584 */  "cmovL_cmpUL",
  /*  585 */  "cmovL_cmpI",
  /*  586 */  "cmovL_cmpU",
  /*  587 */  "CallStaticJavaDirect",
  /*  588 */  "CallDynamicJavaDirect",
  /*  589 */  "CallRuntimeDirect",
  /*  590 */  "CallLeafDirect",
  /*  591 */  "CallLeafNoFPDirect",
  /*  592 */  "partialSubtypeCheck",
  /*  593 */  "string_compareU",
  /*  594 */  "string_compareL",
  /*  595 */  "string_compareUL",
  /*  596 */  "string_compareLU",
  /*  597 */  "string_indexofUU",
  /*  598 */  "string_indexofLL",
  /*  599 */  "string_indexofUL",
  /*  600 */  "string_indexof_conUU",
  /*  601 */  "string_indexof_conLL",
  /*  602 */  "string_indexof_conUL",
  /*  603 */  "stringU_indexof_char",
  /*  604 */  "stringL_indexof_char",
  /*  605 */  "clearArray_reg_reg",
  /*  606 */  "clearArray_imm_reg",
  /*  607 */  "string_equalsL",
  /*  608 */  "string_equalsU",
  /*  609 */  "array_equalsB",
  /*  610 */  "array_equalsC",
  /*  611 */  "safePoint",
  /*  612 */  "TailCalljmpInd",
  /*  613 */  "TailjmpInd",
  /*  614 */  "CreateException",
  /*  615 */  "RethrowException",
  /*  616 */  "Ret",
  /*  617 */  "ShouldNotReachHere",
  /*  618 */  "loadV",
  /*  619 */  "storeV",
  /*  620 */  "vloadmask_masked",
  /*  621 */  "vstoremask",
  /*  622 */  "vmaskcmp",
  /*  623 */  "vmaskcmp_masked",
  /*  624 */  "vmaskcmp_fp",
  /*  625 */  "vmaskcmp_fp_masked",
  /*  626 */  "vabs",
  /*  627 */  "vabs_0",
  /*  628 */  "vabs_1",
  /*  629 */  "vabs_2",
  /*  630 */  "vabs_masked",
  /*  631 */  "vabs_masked_0",
  /*  632 */  "vabs_masked_1",
  /*  633 */  "vabs_masked_2",
  /*  634 */  "vabs_fp_masked",
  /*  635 */  "vabs_fp_masked_0",
  /*  636 */  "vadd",
  /*  637 */  "vadd_0",
  /*  638 */  "vadd_1",
  /*  639 */  "vadd_2",
  /*  640 */  "vadd_fp",
  /*  641 */  "vadd_fp_0",
  /*  642 */  "vadd_masked",
  /*  643 */  "vadd_masked_0",
  /*  644 */  "vadd_masked_1",
  /*  645 */  "vadd_masked_2",
  /*  646 */  "vadd_fp_masked",
  /*  647 */  "vadd_fp_masked_0",
  /*  648 */  "vsub",
  /*  649 */  "vsub_0",
  /*  650 */  "vsub_1",
  /*  651 */  "vsub_2",
  /*  652 */  "vsub_fp",
  /*  653 */  "vsub_fp_0",
  /*  654 */  "vsub_masked",
  /*  655 */  "vsub_masked_0",
  /*  656 */  "vsub_masked_1",
  /*  657 */  "vsub_masked_2",
  /*  658 */  "vsub_fp_masked",
  /*  659 */  "vsub_fp_masked_0",
  /*  660 */  "vand",
  /*  661 */  "vand_masked",
  /*  662 */  "vor",
  /*  663 */  "vor_masked",
  /*  664 */  "vxor",
  /*  665 */  "vxor_masked",
  /*  666 */  "vdiv_fp",
  /*  667 */  "vdiv_fp_0",
  /*  668 */  "vdiv_fp_masked",
  /*  669 */  "vdiv_fp_masked_0",
  /*  670 */  "vmax",
  /*  671 */  "vmin",
  /*  672 */  "vmax_masked",
  /*  673 */  "vmin_masked",
  /*  674 */  "vmax_fp",
  /*  675 */  "vmin_fp",
  /*  676 */  "vmax_fp_masked",
  /*  677 */  "vmin_fp_masked",
  /*  678 */  "vfmla",
  /*  679 */  "vfmla_0",
  /*  680 */  "vfmadd_masked",
  /*  681 */  "vfmadd_masked_0",
  /*  682 */  "vfmlsF",
  /*  683 */  "vfmlsD",
  /*  684 */  "vfnmsub_masked",
  /*  685 */  "vfnmsub_masked_0",
  /*  686 */  "vfnmlaF",
  /*  687 */  "vfnmlaD",
  /*  688 */  "vfnmadd_masked",
  /*  689 */  "vfnmadd_masked_0",
  /*  690 */  "vfnmlsF",
  /*  691 */  "vfnmlsD",
  /*  692 */  "vfmsub_masked",
  /*  693 */  "vfmsub_masked_0",
  /*  694 */  "vmla",
  /*  695 */  "vmla_0",
  /*  696 */  "vmla_1",
  /*  697 */  "vmla_2",
  /*  698 */  "vmla_3",
  /*  699 */  "vmla_4",
  /*  700 */  "vmla_5",
  /*  701 */  "vmla_6",
  /*  702 */  "vmla_masked",
  /*  703 */  "vmla_masked_0",
  /*  704 */  "vmla_masked_1",
  /*  705 */  "vmla_masked_2",
  /*  706 */  "vmls",
  /*  707 */  "vmls_0",
  /*  708 */  "vmls_1",
  /*  709 */  "vmls_2",
  /*  710 */  "vmls_masked",
  /*  711 */  "vmls_masked_0",
  /*  712 */  "vmls_masked_1",
  /*  713 */  "vmls_masked_2",
  /*  714 */  "vmul",
  /*  715 */  "vmul_0",
  /*  716 */  "vmul_1",
  /*  717 */  "vmul_2",
  /*  718 */  "vmul_fp",
  /*  719 */  "vmul_fp_0",
  /*  720 */  "vmul_masked",
  /*  721 */  "vmul_masked_0",
  /*  722 */  "vmul_masked_1",
  /*  723 */  "vmul_masked_2",
  /*  724 */  "vmul_fp_masked",
  /*  725 */  "vmul_fp_masked_0",
  /*  726 */  "vneg_masked",
  /*  727 */  "vneg_masked_0",
  /*  728 */  "vfneg_masked",
  /*  729 */  "vfneg_masked_0",
  /*  730 */  "reduce_andI",
  /*  731 */  "reduce_andL",
  /*  732 */  "reduce_andI_masked",
  /*  733 */  "reduce_andL_masked",
  /*  734 */  "reduce_orI",
  /*  735 */  "reduce_orL",
  /*  736 */  "reduce_orI_masked",
  /*  737 */  "reduce_orL_masked",
  /*  738 */  "reduce_xorI",
  /*  739 */  "reduce_xorL",
  /*  740 */  "reduce_xorI_masked",
  /*  741 */  "reduce_xorL_masked",
  /*  742 */  "reduce_addI",
  /*  743 */  "reduce_addL",
  /*  744 */  "reduce_addF",
  /*  745 */  "reduce_addD",
  /*  746 */  "reduce_addI_masked",
  /*  747 */  "reduce_addL_masked",
  /*  748 */  "reduce_addF_masked",
  /*  749 */  "reduce_addD_masked",
  /*  750 */  "vreduce_maxI",
  /*  751 */  "vreduce_maxL",
  /*  752 */  "vreduce_maxI_masked",
  /*  753 */  "vreduce_maxL_masked",
  /*  754 */  "vreduce_minI",
  /*  755 */  "vreduce_minL",
  /*  756 */  "vreduce_minI_masked",
  /*  757 */  "vreduce_minL_masked",
  /*  758 */  "vreduce_maxF",
  /*  759 */  "vreduce_maxD",
  /*  760 */  "vreduce_maxF_masked",
  /*  761 */  "vreduce_maxD_masked",
  /*  762 */  "vreduce_minF",
  /*  763 */  "vreduce_minD",
  /*  764 */  "vreduce_minF_masked",
  /*  765 */  "vreduce_minD_masked",
  /*  766 */  "vasrB",
  /*  767 */  "vasrS",
  /*  768 */  "vasrI",
  /*  769 */  "vasrL",
  /*  770 */  "vasrB_masked",
  /*  771 */  "vasrS_masked",
  /*  772 */  "vasrI_masked",
  /*  773 */  "vasrL_masked",
  /*  774 */  "vlslB",
  /*  775 */  "vlslS",
  /*  776 */  "vlslI",
  /*  777 */  "vlslL",
  /*  778 */  "vlslB_masked",
  /*  779 */  "vlslS_masked",
  /*  780 */  "vlslI_masked",
  /*  781 */  "vlslL_masked",
  /*  782 */  "vlsrB",
  /*  783 */  "vlsrS",
  /*  784 */  "vlsrI",
  /*  785 */  "vlsrL",
  /*  786 */  "vlsrB_masked",
  /*  787 */  "vlsrS_masked",
  /*  788 */  "vlsrI_masked",
  /*  789 */  "vlsrL_masked",
  /*  790 */  "vasrB_imm",
  /*  791 */  "vasrS_imm",
  /*  792 */  "vasrI_imm",
  /*  793 */  "vasrL_imm",
  /*  794 */  "vasrB_imm_masked",
  /*  795 */  "vasrS_imm_masked",
  /*  796 */  "vasrI_imm_masked",
  /*  797 */  "vasrL_imm_masked",
  /*  798 */  "vlsrB_imm",
  /*  799 */  "vlsrS_imm",
  /*  800 */  "vlsrI_imm",
  /*  801 */  "vlsrL_imm",
  /*  802 */  "vlsrB_imm_masked",
  /*  803 */  "vlsrS_imm_masked",
  /*  804 */  "vlsrI_imm_masked",
  /*  805 */  "vlsrL_imm_masked",
  /*  806 */  "vlslB_imm",
  /*  807 */  "vlslS_imm",
  /*  808 */  "vlslI_imm",
  /*  809 */  "vlslL_imm",
  /*  810 */  "vlslB_imm_masked",
  /*  811 */  "vlslS_imm_masked",
  /*  812 */  "vlslI_imm_masked",
  /*  813 */  "vlslL_imm_masked",
  /*  814 */  "vsqrt_fp_masked",
  /*  815 */  "vsqrt_fp_masked_0",
  /*  816 */  "vstring_equalsL",
  /*  817 */  "vstring_equalsU",
  /*  818 */  "varray_equalsB",
  /*  819 */  "varray_equalsC",
  /*  820 */  "vstring_compareU",
  /*  821 */  "vstring_compareL",
  /*  822 */  "vstring_compareUL",
  /*  823 */  "vstring_compareLU",
  /*  824 */  "vstring_inflate",
  /*  825 */  "vencode_iso_array",
  /*  826 */  "vencode_ascii_array",
  /*  827 */  "vstring_compress",
  /*  828 */  "vcount_positives",
  /*  829 */  "vstringU_indexof_char",
  /*  830 */  "vstringL_indexof_char",
  /*  831 */  "vclearArray_reg_reg",
  /*  832 */  "compressBitsI",
  /*  833 */  "compressBitsL",
  /*  834 */  "expandBitsI",
  /*  835 */  "expandBitsL",
  /*  836 */  "vmaskAll_immI",
  /*  837 */  "vmaskAllI",
  /*  838 */  "vmaskAll_immL",
  /*  839 */  "vmaskAllL",
  /*  840 */  "vmask_and",
  /*  841 */  "vmask_or",
  /*  842 */  "vmask_xor",
  /*  843 */  "loadV_masked",
  /*  844 */  "storeV_masked",
  /*  845 */  "vblend",
  /*  846 */  "vcvtBtoX",
  /*  847 */  "vcvtStoX_extend",
  /*  848 */  "vcvtStoX_fp_extend",
  /*  849 */  "vcvtItoL",
  /*  850 */  "vcvtItoD",
  /*  851 */  "vcvtFtoX_narrow",
  /*  852 */  "vcvtFtoI",
  /*  853 */  "vcvtFtoL",
  /*  854 */  "vcvtFtoD",
  /*  855 */  "vcvtDtoX_narrow",
  /*  856 */  "vcvtDtoL",
  /*  857 */  "reinterpretResize",
  /*  858 */  "vmask_reinterpret_diff_esize",
  /*  859 */  "rearrange",
  /*  860 */  "rearrange_masked",
  /*  861 */  "extract",
  /*  862 */  "extract_0",
  /*  863 */  "extract_1",
  /*  864 */  "extractL",
  /*  865 */  "extractF",
  /*  866 */  "extractD",
  /*  867 */  "mcompress",
  /*  868 */  "vcompress",
  /*  869 */  "vexpand",
  /*  870 */  "vsignum_reg",
  /*  871 */  "vsignum_reg_0",
  /*  872 */  "gather_load",
  /*  873 */  "gather_load_masked",
  /*  874 */  "scatter_store",
  /*  875 */  "scatter_store_masked",
  /*  876 */  "populateindex",
  /*  877 */  "insertI_index_lt32",
  /*  878 */  "insertI_index",
  /*  879 */  "insertL_index_lt32",
  /*  880 */  "insertL_index",
  /*  881 */  "insertF_index_lt32",
  /*  882 */  "insertF_index",
  /*  883 */  "insertD_index_lt32",
  /*  884 */  "insertD_index",
  /*  885 */  "vmask_firsttrue",
  /*  886 */  "cmovI_vtest_anytrue_negate",
  /*  887 */  "cmovI_vtest_alltrue_negate",
  /*  888 */  "vtest_anytrue_branch",
  /*  889 */  "vtest_alltrue_branch",
  /*  890 */  "rorI_imm_b",
  /*  891 */  "rorL_imm_b",
  /*  892 */  "rorI_reg_b",
  /*  893 */  "rorL_reg_b",
  /*  894 */  "rolI_reg_b",
  /*  895 */  "rolL_reg_b",
  /*  896 */  "convP2I_b",
  /*  897 */  "convB2I_reg_reg_b",
  /*  898 */  "convI2S_reg_reg_b",
  /*  899 */  "convS2UI_reg_reg_b",
  /*  900 */  "convI2UL_reg_reg_b",
  /*  901 */  "bytes_reverse_int_b",
  /*  902 */  "bytes_reverse_long_b",
  /*  903 */  "bytes_reverse_unsigned_short_b",
  /*  904 */  "bytes_reverse_short_b",
  /*  905 */  "shaddP_reg_reg_b",
  /*  906 */  "shaddP_reg_reg_ext_b",
  /*  907 */  "shaddL_reg_reg_b",
  /*  908 */  "shaddL_reg_reg_b_0",
  /*  909 */  "shaddL_reg_reg_ext_b",
  /*  910 */  "shaddL_reg_reg_ext_b_0",
  /*  911 */  "minI_reg_reg_b",
  /*  912 */  "maxI_reg_reg_b",
  /*  913 */  "minI_reg_zero_b",
  /*  914 */  "minI_reg_zero_b_0",
  /*  915 */  "maxI_reg_zero_b",
  /*  916 */  "maxI_reg_zero_b_0",
  /*  917 */  "andnI_reg_reg_b",
  /*  918 */  "andnI_reg_reg_b_0",
  /*  919 */  "andnL_reg_reg_b",
  /*  920 */  "andnL_reg_reg_b_0",
  /*  921 */  "ornI_reg_reg_b",
  /*  922 */  "ornI_reg_reg_b_0",
  /*  923 */  "ornL_reg_reg_b",
  /*  924 */  "ornL_reg_reg_b_0",
  /*  925 */  "convI2Bool_andI_reg_immIpowerOf2",
  /*  926 */  "compareAndSwapP_shenandoah",
  /*  927 */  "compareAndSwapN_shenandoah",
  /*  928 */  "compareAndSwapPAcq_shenandoah",
  /*  929 */  "compareAndSwapNAcq_shenandoah",
  /*  930 */  "compareAndExchangeN_shenandoah",
  /*  931 */  "compareAndExchangeP_shenandoah",
  /*  932 */  "weakCompareAndSwapN_shenandoah",
  /*  933 */  "compareAndExchangeNAcq_shenandoah",
  /*  934 */  "compareAndExchangePAcq_shenandoah",
  /*  935 */  "weakCompareAndSwapP_shenandoah",
  /*  936 */  "weakCompareAndSwapNAcq_shenandoah",
  /*  937 */  "weakCompareAndSwapPAcq_shenandoah",
  /*  938 */  "xLoadP",
  /*  939 */  "xCompareAndSwapP",
  /*  940 */  "xCompareAndSwapP_0",
  /*  941 */  "xCompareAndSwapPAcq",
  /*  942 */  "xCompareAndSwapPAcq_0",
  /*  943 */  "xCompareAndExchangeP",
  /*  944 */  "xCompareAndExchangePAcq",
  /*  945 */  "xGetAndSetP",
  /*  946 */  "xGetAndSetPAcq",
  /*  947 */  "zLoadP",
  /*  948 */  "zStoreP",
  /*  949 */  "zCompareAndSwapP",
  /*  950 */  "zCompareAndSwapP_0",
  /*  951 */  "zCompareAndSwapPAcq",
  /*  952 */  "zCompareAndSwapPAcq_0",
  /*  953 */  "zCompareAndExchangeP",
  /*  954 */  "zCompareAndExchangePAcq",
  /*  955 */  "zGetAndSetP",
  /*  956 */  "zGetAndSetPAcq",
  // last instruction
  "invalid rule name" // no trailing comma
};

const        bool  swallowed[] = {
  /*    0 */  false,
  /*    1 */  false,
  /*    2 */  false,
  /*    3 */  false,
  /*    4 */  false,
  /*    5 */  false,
  /*    6 */  false,
  /*    7 */  false,
  /*    8 */  true,
  /*    9 */  true,
  /*   10 */  true,
  /*   11 */  true,
  /*   12 */  true,
  /*   13 */  true,
  /*   14 */  true,
  /*   15 */  true,
  /*   16 */  true,
  /*   17 */  true,
  /*   18 */  true,
  /*   19 */  true,
  /*   20 */  true,
  /*   21 */  true,
  /*   22 */  true,
  /*   23 */  true,
  /*   24 */  true,
  /*   25 */  true,
  /*   26 */  true,
  /*   27 */  true,
  /*   28 */  true,
  /*   29 */  true,
  /*   30 */  true,
  /*   31 */  true,
  /*   32 */  true,
  /*   33 */  true,
  /*   34 */  true,
  /*   35 */  true,
  /*   36 */  true,
  /*   37 */  true,
  /*   38 */  true,
  /*   39 */  true,
  /*   40 */  true,
  /*   41 */  true,
  /*   42 */  true,
  /*   43 */  true,
  /*   44 */  true,
  /*   45 */  false,
  /*   46 */  false,
  /*   47 */  false,
  /*   48 */  false,
  /*   49 */  false,
  /*   50 */  false,
  /*   51 */  false,
  /*   52 */  false,
  /*   53 */  false,
  /*   54 */  false,
  /*   55 */  false,
  /*   56 */  false,
  /*   57 */  false,
  /*   58 */  false,
  /*   59 */  false,
  /*   60 */  false,
  /*   61 */  false,
  /*   62 */  false,
  /*   63 */  false,
  /*   64 */  false,
  /*   65 */  false,
  /*   66 */  false,
  /*   67 */  false,
  /*   68 */  false,
  /*   69 */  false,
  /*   70 */  false,
  /*   71 */  false,
  /*   72 */  false,
  /*   73 */  false,
  /*   74 */  false,
  /*   75 */  false,
  /*   76 */  false,
  /*   77 */  false,
  /*   78 */  false,
  /*   79 */  false,
  /*   80 */  false,
  /*   81 */  false,
  /*   82 */  false,
  /*   83 */  false,
  /*   84 */  false,
  /*   85 */  false,
  /*   86 */  false,
  /*   87 */  false,
  /*   88 */  false,
  /*   89 */  false,
  /*   90 */  false,
  /*   91 */  false,
  /*   92 */  false,
  /*   93 */  false,
  /*   94 */  false,
  /*   95 */  false,
  /*   96 */  false,
  /*   97 */  false,
  /*   98 */  false,
  /*   99 */  false,
  /*  100 */  false,
  /*  101 */  false,
  /*  102 */  false,
  /*  103 */  false,
  /*  104 */  true,
  /*  105 */  true,
  /*  106 */  true,
  /*  107 */  true,
  /*  108 */  true,
  /*  109 */  false,
  /*  110 */  false,
  // last operand
  /*  111 */  false,
  /*  112 */  false,
  /*  113 */  false,
  /*  114 */  false,
  /*  115 */  false,
  /*  116 */  false,
  /*  117 */  false,
  /*  118 */  false,
  // last operand class
  /*  119 */  false,
  /*  120 */  false,
  /*  121 */  false,
  /*  122 */  false,
  /*  123 */  false,
  /*  124 */  false,
  /*  125 */  false,
  /*  126 */  false,
  /*  127 */  false,
  /*  128 */  false,
  /*  129 */  false,
  /*  130 */  false,
  /*  131 */  false,
  /*  132 */  false,
  /*  133 */  false,
  /*  134 */  false,
  /*  135 */  false,
  /*  136 */  false,
  /*  137 */  false,
  /*  138 */  false,
  /*  139 */  false,
  /*  140 */  false,
  /*  141 */  false,
  /*  142 */  false,
  /*  143 */  false,
  /*  144 */  false,
  /*  145 */  false,
  /*  146 */  false,
  /*  147 */  false,
  /*  148 */  false,
  /*  149 */  false,
  /*  150 */  false,
  /*  151 */  false,
  /*  152 */  false,
  /*  153 */  false,
  /*  154 */  false,
  /*  155 */  false,
  /*  156 */  false,
  /*  157 */  false,
  /*  158 */  false,
  /*  159 */  false,
  /*  160 */  false,
  /*  161 */  false,
  /*  162 */  false,
  /*  163 */  false,
  /*  164 */  false,
  /*  165 */  false,
  /*  166 */  false,
  /*  167 */  false,
  /*  168 */  false,
  /*  169 */  false,
  /*  170 */  false,
  /*  171 */  false,
  /*  172 */  false,
  /*  173 */  false,
  /*  174 */  false,
  /*  175 */  false,
  /*  176 */  false,
  /*  177 */  false,
  /*  178 */  false,
  /*  179 */  false,
  /*  180 */  false,
  /*  181 */  false,
  /*  182 */  false,
  /*  183 */  false,
  /*  184 */  false,
  /*  185 */  false,
  /*  186 */  false,
  /*  187 */  false,
  /*  188 */  false,
  /*  189 */  false,
  /*  190 */  false,
  /*  191 */  false,
  /*  192 */  false,
  /*  193 */  false,
  /*  194 */  false,
  /*  195 */  false,
  /*  196 */  false,
  /*  197 */  false,
  /*  198 */  false,
  /*  199 */  false,
  /*  200 */  false,
  /*  201 */  false,
  /*  202 */  false,
  /*  203 */  false,
  /*  204 */  false,
  /*  205 */  false,
  /*  206 */  false,
  /*  207 */  false,
  /*  208 */  false,
  /*  209 */  false,
  /*  210 */  false,
  /*  211 */  false,
  /*  212 */  false,
  /*  213 */  false,
  /*  214 */  false,
  // last internally defined operand
  /*  215 */  false,
  /*  216 */  false,
  /*  217 */  false,
  /*  218 */  false,
  /*  219 */  false,
  /*  220 */  false,
  /*  221 */  false,
  /*  222 */  false,
  /*  223 */  false,
  /*  224 */  false,
  /*  225 */  false,
  /*  226 */  false,
  /*  227 */  false,
  /*  228 */  false,
  /*  229 */  false,
  /*  230 */  false,
  /*  231 */  false,
  /*  232 */  false,
  /*  233 */  false,
  /*  234 */  false,
  /*  235 */  false,
  /*  236 */  false,
  /*  237 */  false,
  /*  238 */  false,
  /*  239 */  false,
  /*  240 */  false,
  /*  241 */  false,
  /*  242 */  false,
  /*  243 */  false,
  /*  244 */  false,
  /*  245 */  false,
  /*  246 */  false,
  /*  247 */  false,
  /*  248 */  false,
  /*  249 */  false,
  /*  250 */  false,
  /*  251 */  false,
  /*  252 */  false,
  /*  253 */  false,
  /*  254 */  false,
  /*  255 */  false,
  /*  256 */  false,
  /*  257 */  false,
  /*  258 */  false,
  /*  259 */  false,
  /*  260 */  false,
  /*  261 */  false,
  /*  262 */  false,
  /*  263 */  false,
  /*  264 */  false,
  /*  265 */  false,
  /*  266 */  false,
  /*  267 */  false,
  /*  268 */  false,
  /*  269 */  false,
  /*  270 */  false,
  /*  271 */  false,
  /*  272 */  false,
  /*  273 */  false,
  /*  274 */  false,
  /*  275 */  false,
  /*  276 */  false,
  /*  277 */  false,
  /*  278 */  false,
  /*  279 */  false,
  /*  280 */  false,
  /*  281 */  false,
  /*  282 */  false,
  /*  283 */  false,
  /*  284 */  false,
  /*  285 */  false,
  /*  286 */  false,
  /*  287 */  false,
  /*  288 */  false,
  /*  289 */  false,
  /*  290 */  false,
  /*  291 */  false,
  /*  292 */  false,
  /*  293 */  false,
  /*  294 */  false,
  /*  295 */  false,
  /*  296 */  false,
  /*  297 */  false,
  /*  298 */  false,
  /*  299 */  false,
  /*  300 */  false,
  /*  301 */  false,
  /*  302 */  false,
  /*  303 */  false,
  /*  304 */  false,
  /*  305 */  false,
  /*  306 */  false,
  /*  307 */  false,
  /*  308 */  false,
  /*  309 */  false,
  /*  310 */  false,
  /*  311 */  false,
  /*  312 */  false,
  /*  313 */  false,
  /*  314 */  false,
  /*  315 */  false,
  /*  316 */  false,
  /*  317 */  false,
  /*  318 */  false,
  /*  319 */  false,
  /*  320 */  false,
  /*  321 */  false,
  /*  322 */  false,
  /*  323 */  false,
  /*  324 */  false,
  /*  325 */  false,
  /*  326 */  false,
  /*  327 */  false,
  /*  328 */  false,
  /*  329 */  false,
  /*  330 */  false,
  /*  331 */  false,
  /*  332 */  false,
  /*  333 */  false,
  /*  334 */  false,
  /*  335 */  false,
  /*  336 */  false,
  /*  337 */  false,
  /*  338 */  false,
  /*  339 */  false,
  /*  340 */  false,
  /*  341 */  false,
  /*  342 */  false,
  /*  343 */  false,
  /*  344 */  false,
  /*  345 */  false,
  /*  346 */  false,
  /*  347 */  false,
  /*  348 */  false,
  /*  349 */  false,
  /*  350 */  false,
  /*  351 */  false,
  /*  352 */  false,
  /*  353 */  false,
  /*  354 */  false,
  /*  355 */  false,
  /*  356 */  false,
  /*  357 */  false,
  /*  358 */  false,
  /*  359 */  false,
  /*  360 */  false,
  /*  361 */  false,
  /*  362 */  false,
  /*  363 */  false,
  /*  364 */  false,
  /*  365 */  false,
  /*  366 */  false,
  /*  367 */  false,
  /*  368 */  false,
  /*  369 */  false,
  /*  370 */  false,
  /*  371 */  false,
  /*  372 */  false,
  /*  373 */  false,
  /*  374 */  false,
  /*  375 */  false,
  /*  376 */  false,
  /*  377 */  false,
  /*  378 */  false,
  /*  379 */  false,
  /*  380 */  false,
  /*  381 */  false,
  /*  382 */  false,
  /*  383 */  false,
  /*  384 */  false,
  /*  385 */  false,
  /*  386 */  false,
  /*  387 */  false,
  /*  388 */  false,
  /*  389 */  false,
  /*  390 */  false,
  /*  391 */  false,
  /*  392 */  false,
  /*  393 */  false,
  /*  394 */  false,
  /*  395 */  false,
  /*  396 */  false,
  /*  397 */  false,
  /*  398 */  false,
  /*  399 */  false,
  /*  400 */  false,
  /*  401 */  false,
  /*  402 */  false,
  /*  403 */  false,
  /*  404 */  false,
  /*  405 */  false,
  /*  406 */  false,
  /*  407 */  false,
  /*  408 */  false,
  /*  409 */  false,
  /*  410 */  false,
  /*  411 */  false,
  /*  412 */  false,
  /*  413 */  false,
  /*  414 */  false,
  /*  415 */  false,
  /*  416 */  false,
  /*  417 */  false,
  /*  418 */  false,
  /*  419 */  false,
  /*  420 */  false,
  /*  421 */  false,
  /*  422 */  false,
  /*  423 */  false,
  /*  424 */  false,
  /*  425 */  false,
  /*  426 */  false,
  /*  427 */  false,
  /*  428 */  false,
  /*  429 */  false,
  /*  430 */  false,
  /*  431 */  false,
  /*  432 */  false,
  /*  433 */  false,
  /*  434 */  false,
  /*  435 */  false,
  /*  436 */  false,
  /*  437 */  false,
  /*  438 */  false,
  /*  439 */  false,
  /*  440 */  false,
  /*  441 */  false,
  /*  442 */  false,
  /*  443 */  false,
  /*  444 */  false,
  /*  445 */  false,
  /*  446 */  false,
  /*  447 */  false,
  /*  448 */  false,
  /*  449 */  false,
  /*  450 */  false,
  /*  451 */  false,
  /*  452 */  false,
  /*  453 */  false,
  /*  454 */  false,
  /*  455 */  false,
  /*  456 */  false,
  /*  457 */  false,
  /*  458 */  false,
  /*  459 */  false,
  /*  460 */  false,
  /*  461 */  false,
  /*  462 */  false,
  /*  463 */  false,
  /*  464 */  false,
  /*  465 */  false,
  /*  466 */  false,
  /*  467 */  false,
  /*  468 */  false,
  /*  469 */  false,
  /*  470 */  false,
  /*  471 */  false,
  /*  472 */  false,
  /*  473 */  false,
  /*  474 */  false,
  /*  475 */  false,
  /*  476 */  false,
  /*  477 */  false,
  /*  478 */  false,
  /*  479 */  false,
  /*  480 */  false,
  /*  481 */  false,
  /*  482 */  false,
  /*  483 */  false,
  /*  484 */  false,
  /*  485 */  false,
  /*  486 */  false,
  /*  487 */  false,
  /*  488 */  false,
  /*  489 */  false,
  /*  490 */  false,
  /*  491 */  false,
  /*  492 */  false,
  /*  493 */  false,
  /*  494 */  false,
  /*  495 */  false,
  /*  496 */  false,
  /*  497 */  false,
  /*  498 */  false,
  /*  499 */  false,
  /*  500 */  false,
  /*  501 */  false,
  /*  502 */  false,
  /*  503 */  false,
  /*  504 */  false,
  /*  505 */  false,
  /*  506 */  false,
  /*  507 */  false,
  /*  508 */  false,
  /*  509 */  false,
  /*  510 */  false,
  /*  511 */  false,
  /*  512 */  false,
  /*  513 */  false,
  /*  514 */  false,
  /*  515 */  false,
  /*  516 */  false,
  /*  517 */  false,
  /*  518 */  false,
  /*  519 */  false,
  /*  520 */  false,
  /*  521 */  false,
  /*  522 */  false,
  /*  523 */  false,
  /*  524 */  false,
  /*  525 */  false,
  /*  526 */  false,
  /*  527 */  false,
  /*  528 */  false,
  /*  529 */  false,
  /*  530 */  false,
  /*  531 */  false,
  /*  532 */  false,
  /*  533 */  false,
  /*  534 */  false,
  /*  535 */  false,
  /*  536 */  false,
  /*  537 */  false,
  /*  538 */  false,
  /*  539 */  false,
  /*  540 */  false,
  /*  541 */  false,
  /*  542 */  false,
  /*  543 */  false,
  /*  544 */  false,
  /*  545 */  false,
  /*  546 */  false,
  /*  547 */  false,
  /*  548 */  false,
  /*  549 */  false,
  /*  550 */  false,
  /*  551 */  false,
  /*  552 */  false,
  /*  553 */  false,
  /*  554 */  false,
  /*  555 */  false,
  /*  556 */  false,
  /*  557 */  false,
  /*  558 */  false,
  /*  559 */  false,
  /*  560 */  false,
  /*  561 */  false,
  /*  562 */  false,
  /*  563 */  false,
  /*  564 */  false,
  /*  565 */  false,
  /*  566 */  false,
  /*  567 */  false,
  /*  568 */  false,
  /*  569 */  false,
  /*  570 */  false,
  /*  571 */  false,
  /*  572 */  false,
  /*  573 */  false,
  /*  574 */  false,
  /*  575 */  false,
  /*  576 */  false,
  /*  577 */  false,
  /*  578 */  false,
  /*  579 */  false,
  /*  580 */  false,
  /*  581 */  false,
  /*  582 */  false,
  /*  583 */  false,
  /*  584 */  false,
  /*  585 */  false,
  /*  586 */  false,
  /*  587 */  false,
  /*  588 */  false,
  /*  589 */  false,
  /*  590 */  false,
  /*  591 */  false,
  /*  592 */  false,
  /*  593 */  false,
  /*  594 */  false,
  /*  595 */  false,
  /*  596 */  false,
  /*  597 */  false,
  /*  598 */  false,
  /*  599 */  false,
  /*  600 */  false,
  /*  601 */  false,
  /*  602 */  false,
  /*  603 */  false,
  /*  604 */  false,
  /*  605 */  false,
  /*  606 */  false,
  /*  607 */  false,
  /*  608 */  false,
  /*  609 */  false,
  /*  610 */  false,
  /*  611 */  false,
  /*  612 */  false,
  /*  613 */  false,
  /*  614 */  false,
  /*  615 */  false,
  /*  616 */  false,
  /*  617 */  false,
  /*  618 */  false,
  /*  619 */  false,
  /*  620 */  false,
  /*  621 */  false,
  /*  622 */  false,
  /*  623 */  false,
  /*  624 */  false,
  /*  625 */  false,
  /*  626 */  false,
  /*  627 */  false,
  /*  628 */  false,
  /*  629 */  false,
  /*  630 */  false,
  /*  631 */  false,
  /*  632 */  false,
  /*  633 */  false,
  /*  634 */  false,
  /*  635 */  false,
  /*  636 */  false,
  /*  637 */  false,
  /*  638 */  false,
  /*  639 */  false,
  /*  640 */  false,
  /*  641 */  false,
  /*  642 */  false,
  /*  643 */  false,
  /*  644 */  false,
  /*  645 */  false,
  /*  646 */  false,
  /*  647 */  false,
  /*  648 */  false,
  /*  649 */  false,
  /*  650 */  false,
  /*  651 */  false,
  /*  652 */  false,
  /*  653 */  false,
  /*  654 */  false,
  /*  655 */  false,
  /*  656 */  false,
  /*  657 */  false,
  /*  658 */  false,
  /*  659 */  false,
  /*  660 */  false,
  /*  661 */  false,
  /*  662 */  false,
  /*  663 */  false,
  /*  664 */  false,
  /*  665 */  false,
  /*  666 */  false,
  /*  667 */  false,
  /*  668 */  false,
  /*  669 */  false,
  /*  670 */  false,
  /*  671 */  false,
  /*  672 */  false,
  /*  673 */  false,
  /*  674 */  false,
  /*  675 */  false,
  /*  676 */  false,
  /*  677 */  false,
  /*  678 */  false,
  /*  679 */  false,
  /*  680 */  false,
  /*  681 */  false,
  /*  682 */  false,
  /*  683 */  false,
  /*  684 */  false,
  /*  685 */  false,
  /*  686 */  false,
  /*  687 */  false,
  /*  688 */  false,
  /*  689 */  false,
  /*  690 */  false,
  /*  691 */  false,
  /*  692 */  false,
  /*  693 */  false,
  /*  694 */  false,
  /*  695 */  false,
  /*  696 */  false,
  /*  697 */  false,
  /*  698 */  false,
  /*  699 */  false,
  /*  700 */  false,
  /*  701 */  false,
  /*  702 */  false,
  /*  703 */  false,
  /*  704 */  false,
  /*  705 */  false,
  /*  706 */  false,
  /*  707 */  false,
  /*  708 */  false,
  /*  709 */  false,
  /*  710 */  false,
  /*  711 */  false,
  /*  712 */  false,
  /*  713 */  false,
  /*  714 */  false,
  /*  715 */  false,
  /*  716 */  false,
  /*  717 */  false,
  /*  718 */  false,
  /*  719 */  false,
  /*  720 */  false,
  /*  721 */  false,
  /*  722 */  false,
  /*  723 */  false,
  /*  724 */  false,
  /*  725 */  false,
  /*  726 */  false,
  /*  727 */  false,
  /*  728 */  false,
  /*  729 */  false,
  /*  730 */  false,
  /*  731 */  false,
  /*  732 */  false,
  /*  733 */  false,
  /*  734 */  false,
  /*  735 */  false,
  /*  736 */  false,
  /*  737 */  false,
  /*  738 */  false,
  /*  739 */  false,
  /*  740 */  false,
  /*  741 */  false,
  /*  742 */  false,
  /*  743 */  false,
  /*  744 */  false,
  /*  745 */  false,
  /*  746 */  false,
  /*  747 */  false,
  /*  748 */  false,
  /*  749 */  false,
  /*  750 */  false,
  /*  751 */  false,
  /*  752 */  false,
  /*  753 */  false,
  /*  754 */  false,
  /*  755 */  false,
  /*  756 */  false,
  /*  757 */  false,
  /*  758 */  false,
  /*  759 */  false,
  /*  760 */  false,
  /*  761 */  false,
  /*  762 */  false,
  /*  763 */  false,
  /*  764 */  false,
  /*  765 */  false,
  /*  766 */  false,
  /*  767 */  false,
  /*  768 */  false,
  /*  769 */  false,
  /*  770 */  false,
  /*  771 */  false,
  /*  772 */  false,
  /*  773 */  false,
  /*  774 */  false,
  /*  775 */  false,
  /*  776 */  false,
  /*  777 */  false,
  /*  778 */  false,
  /*  779 */  false,
  /*  780 */  false,
  /*  781 */  false,
  /*  782 */  false,
  /*  783 */  false,
  /*  784 */  false,
  /*  785 */  false,
  /*  786 */  false,
  /*  787 */  false,
  /*  788 */  false,
  /*  789 */  false,
  /*  790 */  false,
  /*  791 */  false,
  /*  792 */  false,
  /*  793 */  false,
  /*  794 */  false,
  /*  795 */  false,
  /*  796 */  false,
  /*  797 */  false,
  /*  798 */  false,
  /*  799 */  false,
  /*  800 */  false,
  /*  801 */  false,
  /*  802 */  false,
  /*  803 */  false,
  /*  804 */  false,
  /*  805 */  false,
  /*  806 */  false,
  /*  807 */  false,
  /*  808 */  false,
  /*  809 */  false,
  /*  810 */  false,
  /*  811 */  false,
  /*  812 */  false,
  /*  813 */  false,
  /*  814 */  false,
  /*  815 */  false,
  /*  816 */  false,
  /*  817 */  false,
  /*  818 */  false,
  /*  819 */  false,
  /*  820 */  false,
  /*  821 */  false,
  /*  822 */  false,
  /*  823 */  false,
  /*  824 */  false,
  /*  825 */  false,
  /*  826 */  false,
  /*  827 */  false,
  /*  828 */  false,
  /*  829 */  false,
  /*  830 */  false,
  /*  831 */  false,
  /*  832 */  false,
  /*  833 */  false,
  /*  834 */  false,
  /*  835 */  false,
  /*  836 */  false,
  /*  837 */  false,
  /*  838 */  false,
  /*  839 */  false,
  /*  840 */  false,
  /*  841 */  false,
  /*  842 */  false,
  /*  843 */  false,
  /*  844 */  false,
  /*  845 */  false,
  /*  846 */  false,
  /*  847 */  false,
  /*  848 */  false,
  /*  849 */  false,
  /*  850 */  false,
  /*  851 */  false,
  /*  852 */  false,
  /*  853 */  false,
  /*  854 */  false,
  /*  855 */  false,
  /*  856 */  false,
  /*  857 */  false,
  /*  858 */  false,
  /*  859 */  false,
  /*  860 */  false,
  /*  861 */  false,
  /*  862 */  false,
  /*  863 */  false,
  /*  864 */  false,
  /*  865 */  false,
  /*  866 */  false,
  /*  867 */  false,
  /*  868 */  false,
  /*  869 */  false,
  /*  870 */  false,
  /*  871 */  false,
  /*  872 */  false,
  /*  873 */  false,
  /*  874 */  false,
  /*  875 */  false,
  /*  876 */  false,
  /*  877 */  false,
  /*  878 */  false,
  /*  879 */  false,
  /*  880 */  false,
  /*  881 */  false,
  /*  882 */  false,
  /*  883 */  false,
  /*  884 */  false,
  /*  885 */  false,
  /*  886 */  false,
  /*  887 */  false,
  /*  888 */  false,
  /*  889 */  false,
  /*  890 */  false,
  /*  891 */  false,
  /*  892 */  false,
  /*  893 */  false,
  /*  894 */  false,
  /*  895 */  false,
  /*  896 */  false,
  /*  897 */  false,
  /*  898 */  false,
  /*  899 */  false,
  /*  900 */  false,
  /*  901 */  false,
  /*  902 */  false,
  /*  903 */  false,
  /*  904 */  false,
  /*  905 */  false,
  /*  906 */  false,
  /*  907 */  false,
  /*  908 */  false,
  /*  909 */  false,
  /*  910 */  false,
  /*  911 */  false,
  /*  912 */  false,
  /*  913 */  false,
  /*  914 */  false,
  /*  915 */  false,
  /*  916 */  false,
  /*  917 */  false,
  /*  918 */  false,
  /*  919 */  false,
  /*  920 */  false,
  /*  921 */  false,
  /*  922 */  false,
  /*  923 */  false,
  /*  924 */  false,
  /*  925 */  false,
  /*  926 */  false,
  /*  927 */  false,
  /*  928 */  false,
  /*  929 */  false,
  /*  930 */  false,
  /*  931 */  false,
  /*  932 */  false,
  /*  933 */  false,
  /*  934 */  false,
  /*  935 */  false,
  /*  936 */  false,
  /*  937 */  false,
  /*  938 */  false,
  /*  939 */  false,
  /*  940 */  false,
  /*  941 */  false,
  /*  942 */  false,
  /*  943 */  false,
  /*  944 */  false,
  /*  945 */  false,
  /*  946 */  false,
  /*  947 */  false,
  /*  948 */  false,
  /*  949 */  false,
  /*  950 */  false,
  /*  951 */  false,
  /*  952 */  false,
  /*  953 */  false,
  /*  954 */  false,
  /*  955 */  false,
  /*  956 */  false,
  // last instruction
  false // no trailing comma
};

// Mapping from machine-independent opcode to boolean
const        char must_clone[] = {
  0, // Node: 0
  0, // Set: 1
  0, // RegN: 2
  0, // RegI: 3
  0, // RegP: 4
  0, // RegF: 5
  0, // RegD: 6
  0, // RegL: 7
  0, // VecA: 8
  0, // VecS: 9
  0, // VecD: 10
  0, // VecX: 11
  0, // VecY: 12
  0, // VecZ: 13
  0, // RegVectMask: 14
  0, // RegFlags: 15
  0, // _last_machine_leaf: 16
  0, // AbsD: 17
  0, // AbsF: 18
  0, // AbsI: 19
  0, // AbsL: 20
  0, // AddD: 21
  0, // AddF: 22
  0, // AddI: 23
  0, // AddL: 24
  0, // AddP: 25
  0, // Allocate: 26
  0, // AllocateArray: 27
  0, // AndI: 28
  0, // AndL: 29
  0, // ArrayCopy: 30
  0, // AryEq: 31
  0, // AtanD: 32
  1, // Binary: 33
  0, // Blackhole: 34
  1, // Bool: 35
  0, // BoxLock: 36
  0, // ReverseBytesI: 37
  0, // ReverseBytesL: 38
  0, // ReverseBytesUS: 39
  0, // ReverseBytesS: 40
  0, // ReverseBytesV: 41
  0, // CProj: 42
  0, // CacheWB: 43
  0, // CacheWBPreSync: 44
  0, // CacheWBPostSync: 45
  0, // CallDynamicJava: 46
  0, // CallJava: 47
  0, // CallLeaf: 48
  0, // CallLeafNoFP: 49
  0, // CallLeafVector: 50
  0, // CallRuntime: 51
  0, // CallStaticJava: 52
  0, // CastDD: 53
  0, // CastFF: 54
  0, // CastII: 55
  0, // CastLL: 56
  0, // CastVV: 57
  0, // CastX2P: 58
  0, // CastP2X: 59
  0, // CastPP: 60
  0, // Catch: 61
  0, // CatchProj: 62
  0, // CheckCastPP: 63
  0, // ClearArray: 64
  0, // CompressBits: 65
  0, // ExpandBits: 66
  0, // CompressBitsV: 67
  0, // ExpandBitsV: 68
  0, // ConstraintCast: 69
  0, // CMoveD: 70
  0, // CMoveF: 71
  0, // CMoveI: 72
  0, // CMoveL: 73
  0, // CMoveP: 74
  0, // CMoveN: 75
  1, // CmpN: 76
  1, // CmpD: 77
  0, // CmpD3: 78
  1, // CmpF: 79
  0, // CmpF3: 80
  1, // CmpI: 81
  1, // CmpL: 82
  0, // CmpL3: 83
  0, // CmpLTMask: 84
  1, // CmpP: 85
  1, // CmpU: 86
  0, // CmpU3: 87
  1, // CmpUL: 88
  0, // CmpUL3: 89
  0, // CompareAndSwapB: 90
  0, // CompareAndSwapS: 91
  0, // CompareAndSwapI: 92
  0, // CompareAndSwapL: 93
  0, // CompareAndSwapP: 94
  0, // CompareAndSwapN: 95
  0, // WeakCompareAndSwapB: 96
  0, // WeakCompareAndSwapS: 97
  0, // WeakCompareAndSwapI: 98
  0, // WeakCompareAndSwapL: 99
  0, // WeakCompareAndSwapP: 100
  0, // WeakCompareAndSwapN: 101
  0, // CompareAndExchangeB: 102
  0, // CompareAndExchangeS: 103
  0, // CompareAndExchangeI: 104
  0, // CompareAndExchangeL: 105
  0, // CompareAndExchangeP: 106
  0, // CompareAndExchangeN: 107
  0, // GetAndAddB: 108
  0, // GetAndAddS: 109
  0, // GetAndAddI: 110
  0, // GetAndAddL: 111
  0, // GetAndSetB: 112
  0, // GetAndSetS: 113
  0, // GetAndSetI: 114
  0, // GetAndSetL: 115
  0, // GetAndSetP: 116
  0, // GetAndSetN: 117
  0, // Con: 118
  0, // ConN: 119
  0, // ConNKlass: 120
  0, // ConD: 121
  0, // ConF: 122
  0, // ConI: 123
  0, // ConL: 124
  0, // ConP: 125
  0, // Conv2B: 126
  0, // ConvD2F: 127
  0, // ConvD2I: 128
  0, // ConvD2L: 129
  0, // ConvF2D: 130
  0, // ConvF2I: 131
  0, // ConvF2L: 132
  0, // ConvI2D: 133
  0, // ConvI2F: 134
  0, // ConvI2L: 135
  0, // ConvL2D: 136
  0, // ConvL2F: 137
  0, // ConvL2I: 138
  0, // ConvF2HF: 139
  0, // ConvHF2F: 140
  0, // CountedLoop: 141
  0, // CountedLoopEnd: 142
  0, // OuterStripMinedLoop: 143
  0, // OuterStripMinedLoopEnd: 144
  0, // LongCountedLoop: 145
  0, // LongCountedLoopEnd: 146
  0, // CountLeadingZerosI: 147
  0, // CountLeadingZerosL: 148
  0, // CountLeadingZerosV: 149
  0, // CountTrailingZerosI: 150
  0, // CountTrailingZerosL: 151
  0, // CountTrailingZerosV: 152
  0, // CreateEx: 153
  0, // DecodeN: 154
  0, // DecodeNKlass: 155
  0, // DivD: 156
  0, // DivF: 157
  0, // DivI: 158
  0, // DivL: 159
  0, // UDivI: 160
  0, // UDivL: 161
  0, // DivMod: 162
  0, // DivModI: 163
  0, // DivModL: 164
  0, // UDivModI: 165
  0, // UDivModL: 166
  0, // EncodeISOArray: 167
  0, // EncodeP: 168
  0, // EncodePKlass: 169
  1, // FastLock: 170
  1, // FastUnlock: 171
  0, // FmaD: 172
  0, // FmaF: 173
  0, // Goto: 174
  0, // Halt: 175
  0, // CountPositives: 176
  0, // If: 177
  0, // RangeCheck: 178
  0, // IfFalse: 179
  0, // IfTrue: 180
  0, // Initialize: 181
  0, // JProj: 182
  0, // Jump: 183
  0, // JumpProj: 184
  0, // LShiftI: 185
  0, // LShiftL: 186
  0, // LoadB: 187
  0, // LoadUB: 188
  0, // LoadUS: 189
  0, // LoadD: 190
  0, // LoadD_unaligned: 191
  0, // LoadF: 192
  0, // LoadI: 193
  0, // LoadKlass: 194
  0, // LoadNKlass: 195
  0, // LoadL: 196
  0, // LoadL_unaligned: 197
  0, // LoadP: 198
  0, // LoadN: 199
  0, // LoadRange: 200
  0, // LoadS: 201
  0, // Lock: 202
  0, // Loop: 203
  0, // LoopLimit: 204
  0, // Mach: 205
  0, // MachNullCheck: 206
  0, // MachProj: 207
  0, // MulAddS2I: 208
  0, // MaxI: 209
  0, // MaxL: 210
  0, // MaxD: 211
  0, // MaxF: 212
  0, // MemBarAcquire: 213
  0, // LoadFence: 214
  0, // MemBarAcquireLock: 215
  0, // MemBarCPUOrder: 216
  0, // MemBarRelease: 217
  0, // StoreFence: 218
  0, // StoreStoreFence: 219
  0, // MemBarReleaseLock: 220
  0, // MemBarVolatile: 221
  0, // MemBarStoreStore: 222
  0, // MergeMem: 223
  0, // MinI: 224
  0, // MinL: 225
  0, // MinF: 226
  0, // MinD: 227
  0, // ModD: 228
  0, // ModF: 229
  0, // ModI: 230
  0, // ModL: 231
  0, // UModI: 232
  0, // UModL: 233
  0, // MoveI2F: 234
  0, // MoveF2I: 235
  0, // MoveL2D: 236
  0, // MoveD2L: 237
  0, // IsInfiniteF: 238
  0, // IsFiniteF: 239
  0, // IsInfiniteD: 240
  0, // IsFiniteD: 241
  0, // MulD: 242
  0, // MulF: 243
  0, // MulHiL: 244
  0, // UMulHiL: 245
  0, // MulI: 246
  0, // MulL: 247
  0, // Multi: 248
  0, // NegI: 249
  0, // NegL: 250
  0, // NegD: 251
  0, // NegF: 252
  0, // NeverBranch: 253
  0, // OnSpinWait: 254
  0, // Opaque1: 255
  0, // OpaqueLoopInit: 256
  0, // OpaqueLoopStride: 257
  0, // OpaqueZeroTripGuard: 258
  0, // Opaque3: 259
  0, // Opaque4: 260
  0, // ProfileBoolean: 261
  0, // OrI: 262
  0, // OrL: 263
  1, // OverflowAddI: 264
  1, // OverflowSubI: 265
  1, // OverflowMulI: 266
  1, // OverflowAddL: 267
  1, // OverflowSubL: 268
  1, // OverflowMulL: 269
  0, // PCTable: 270
  0, // Parm: 271
  0, // ParsePredicate: 272
  0, // PartialSubtypeCheck: 273
  0, // SubTypeCheck: 274
  0, // Phi: 275
  0, // PopCountI: 276
  0, // PopCountL: 277
  0, // PopCountVI: 278
  0, // PopCountVL: 279
  0, // PopulateIndex: 280
  0, // PrefetchAllocation: 281
  0, // Proj: 282
  0, // RShiftI: 283
  0, // RShiftL: 284
  0, // Region: 285
  0, // Rethrow: 286
  0, // Return: 287
  0, // ReverseI: 288
  0, // ReverseL: 289
  0, // ReverseV: 290
  0, // Root: 291
  0, // RoundDouble: 292
  0, // RoundDoubleMode: 293
  0, // RoundDoubleModeV: 294
  0, // RoundFloat: 295
  0, // RotateLeft: 296
  0, // RotateLeftV: 297
  0, // RotateRight: 298
  0, // RotateRightV: 299
  0, // SafePoint: 300
  0, // SafePointScalarObject: 301
  0, // SafePointScalarMerge: 302
  0, // ShenandoahCompareAndExchangeP: 303
  0, // ShenandoahCompareAndExchangeN: 304
  0, // ShenandoahCompareAndSwapN: 305
  0, // ShenandoahCompareAndSwapP: 306
  0, // ShenandoahWeakCompareAndSwapN: 307
  0, // ShenandoahWeakCompareAndSwapP: 308
  0, // ShenandoahIUBarrier: 309
  0, // ShenandoahLoadReferenceBarrier: 310
  0, // SCMemProj: 311
  0, // CopySignD: 312
  0, // CopySignF: 313
  0, // SignumD: 314
  0, // SignumF: 315
  0, // SignumVF: 316
  0, // SignumVD: 317
  0, // SqrtD: 318
  0, // SqrtF: 319
  0, // RoundF: 320
  0, // RoundD: 321
  0, // Start: 322
  0, // StartOSR: 323
  0, // StoreB: 324
  0, // StoreC: 325
  0, // StoreCM: 326
  0, // StoreD: 327
  0, // StoreF: 328
  0, // StoreI: 329
  0, // StoreL: 330
  0, // StoreP: 331
  0, // StoreN: 332
  0, // StoreNKlass: 333
  0, // StrComp: 334
  0, // StrCompressedCopy: 335
  0, // StrEquals: 336
  0, // StrIndexOf: 337
  0, // StrIndexOfChar: 338
  0, // StrInflatedCopy: 339
  0, // SubD: 340
  0, // SubF: 341
  0, // SubI: 342
  0, // SubL: 343
  0, // TailCall: 344
  0, // TailJump: 345
  0, // MacroLogicV: 346
  0, // ThreadLocal: 347
  0, // Unlock: 348
  0, // URShiftB: 349
  0, // URShiftS: 350
  0, // URShiftI: 351
  0, // URShiftL: 352
  0, // XorI: 353
  0, // XorL: 354
  0, // Vector: 355
  0, // AddVB: 356
  0, // AddVS: 357
  0, // AddVI: 358
  0, // AddReductionVI: 359
  0, // AddVL: 360
  0, // AddReductionVL: 361
  0, // AddVF: 362
  0, // AddReductionVF: 363
  0, // AddVD: 364
  0, // AddReductionVD: 365
  0, // SubVB: 366
  0, // SubVS: 367
  0, // SubVI: 368
  0, // SubVL: 369
  0, // SubVF: 370
  0, // SubVD: 371
  0, // MulVB: 372
  0, // MulVS: 373
  0, // MulVI: 374
  0, // MulReductionVI: 375
  0, // MulVL: 376
  0, // MulReductionVL: 377
  0, // MulVF: 378
  0, // MulReductionVF: 379
  0, // MulVD: 380
  0, // MulReductionVD: 381
  0, // MulAddVS2VI: 382
  0, // FmaVD: 383
  0, // FmaVF: 384
  0, // DivVF: 385
  0, // DivVD: 386
  0, // AbsVB: 387
  0, // AbsVS: 388
  0, // AbsVI: 389
  0, // AbsVL: 390
  0, // AbsVF: 391
  0, // AbsVD: 392
  0, // NegVI: 393
  0, // NegVL: 394
  0, // NegVF: 395
  0, // NegVD: 396
  0, // SqrtVD: 397
  0, // SqrtVF: 398
  0, // LShiftCntV: 399
  0, // RShiftCntV: 400
  0, // LShiftVB: 401
  0, // LShiftVS: 402
  0, // LShiftVI: 403
  0, // LShiftVL: 404
  0, // RShiftVB: 405
  0, // RShiftVS: 406
  0, // RShiftVI: 407
  0, // RShiftVL: 408
  0, // URShiftVB: 409
  0, // URShiftVS: 410
  0, // URShiftVI: 411
  0, // URShiftVL: 412
  0, // AndV: 413
  0, // AndReductionV: 414
  0, // OrV: 415
  0, // OrReductionV: 416
  0, // XorV: 417
  0, // XorReductionV: 418
  0, // MinV: 419
  0, // MaxV: 420
  0, // MinReductionV: 421
  0, // MaxReductionV: 422
  0, // CompressV: 423
  0, // CompressM: 424
  0, // ExpandV: 425
  0, // LoadVector: 426
  0, // LoadVectorGather: 427
  0, // LoadVectorGatherMasked: 428
  0, // StoreVector: 429
  0, // StoreVectorScatter: 430
  0, // StoreVectorScatterMasked: 431
  0, // LoadVectorMasked: 432
  0, // StoreVectorMasked: 433
  0, // VectorCmpMasked: 434
  0, // VectorMaskGen: 435
  0, // VectorMaskOp: 436
  0, // VectorMaskTrueCount: 437
  0, // VectorMaskFirstTrue: 438
  0, // VectorMaskLastTrue: 439
  0, // VectorMaskToLong: 440
  0, // VectorLongToMask: 441
  0, // Pack: 442
  0, // PackB: 443
  0, // PackS: 444
  0, // PackI: 445
  0, // PackL: 446
  0, // PackF: 447
  0, // PackD: 448
  0, // Pack2L: 449
  0, // Pack2D: 450
  0, // Replicate: 451
  0, // RoundVF: 452
  0, // RoundVD: 453
  0, // Extract: 454
  0, // ExtractB: 455
  0, // ExtractUB: 456
  0, // ExtractC: 457
  0, // ExtractS: 458
  0, // ExtractI: 459
  0, // ExtractL: 460
  0, // ExtractF: 461
  0, // ExtractD: 462
  0, // Digit: 463
  0, // LowerCase: 464
  0, // UpperCase: 465
  0, // Whitespace: 466
  0, // VectorBox: 467
  0, // VectorBoxAllocate: 468
  0, // VectorUnbox: 469
  0, // VectorMaskWrapper: 470
  0, // VectorMaskCmp: 471
  0, // VectorMaskCast: 472
  1, // VectorTest: 473
  0, // VectorBlend: 474
  0, // VectorRearrange: 475
  0, // VectorLoadMask: 476
  0, // VectorLoadShuffle: 477
  0, // VectorLoadConst: 478
  0, // VectorStoreMask: 479
  0, // VectorReinterpret: 480
  0, // VectorCast: 481
  0, // VectorCastB2X: 482
  0, // VectorCastS2X: 483
  0, // VectorCastI2X: 484
  0, // VectorCastL2X: 485
  0, // VectorCastF2X: 486
  0, // VectorCastD2X: 487
  0, // VectorCastF2HF: 488
  0, // VectorCastHF2F: 489
  0, // VectorUCastB2X: 490
  0, // VectorUCastS2X: 491
  0, // VectorUCastI2X: 492
  0, // VectorizedHashCode: 493
  0, // VectorInsert: 494
  0, // MaskAll: 495
  0, // AndVMask: 496
  0, // OrVMask: 497
  0 // no trailing comma // XorVMask: 498
};
//  The following instructions can cisc-spill



// An array of character pointers to machine register names.
const char *Matcher::regName[REG_COUNT] = {
  "R7",
  "R7_H",
  "R28",
  "R28_H",
  "R29",
  "R29_H",
  "R30",
  "R30_H",
  "R31",
  "R31_H",
  "R10",
  "R10_H",
  "R11",
  "R11_H",
  "R12",
  "R12_H",
  "R13",
  "R13_H",
  "R14",
  "R14_H",
  "R15",
  "R15_H",
  "R16",
  "R16_H",
  "R17",
  "R17_H",
  "R9",
  "R9_H",
  "R18",
  "R18_H",
  "R19",
  "R19_H",
  "R20",
  "R20_H",
  "R21",
  "R21_H",
  "R22",
  "R22_H",
  "R24",
  "R24_H",
  "R25",
  "R25_H",
  "R26",
  "R26_H",
  "R23",
  "R23_H",
  "R27",
  "R27_H",
  "R4",
  "R4_H",
  "R8",
  "R8_H",
  "R0",
  "R0_H",
  "R1",
  "R1_H",
  "R2",
  "R2_H",
  "R3",
  "R3_H",
  "F0",
  "F0_H",
  "F1",
  "F1_H",
  "F2",
  "F2_H",
  "F3",
  "F3_H",
  "F4",
  "F4_H",
  "F5",
  "F5_H",
  "F6",
  "F6_H",
  "F7",
  "F7_H",
  "F28",
  "F28_H",
  "F29",
  "F29_H",
  "F30",
  "F30_H",
  "F31",
  "F31_H",
  "F10",
  "F10_H",
  "F11",
  "F11_H",
  "F12",
  "F12_H",
  "F13",
  "F13_H",
  "F14",
  "F14_H",
  "F15",
  "F15_H",
  "F16",
  "F16_H",
  "F17",
  "F17_H",
  "F8",
  "F8_H",
  "F9",
  "F9_H",
  "F18",
  "F18_H",
  "F19",
  "F19_H",
  "F20",
  "F20_H",
  "F21",
  "F21_H",
  "F22",
  "F22_H",
  "F23",
  "F23_H",
  "F24",
  "F24_H",
  "F25",
  "F25_H",
  "F26",
  "F26_H",
  "F27",
  "F27_H",
  "V0",
  "V0_H",
  "V0_J",
  "V0_K",
  "V1",
  "V1_H",
  "V1_J",
  "V1_K",
  "V2",
  "V2_H",
  "V2_J",
  "V2_K",
  "V3",
  "V3_H",
  "V3_J",
  "V3_K",
  "V4",
  "V4_H",
  "V4_J",
  "V4_K",
  "V5",
  "V5_H",
  "V5_J",
  "V5_K",
  "V6",
  "V6_H",
  "V6_J",
  "V6_K",
  "V7",
  "V7_H",
  "V7_J",
  "V7_K",
  "V8",
  "V8_H",
  "V8_J",
  "V8_K",
  "V9",
  "V9_H",
  "V9_J",
  "V9_K",
  "V10",
  "V10_H",
  "V10_J",
  "V10_K",
  "V11",
  "V11_H",
  "V11_J",
  "V11_K",
  "V12",
  "V12_H",
  "V12_J",
  "V12_K",
  "V13",
  "V13_H",
  "V13_J",
  "V13_K",
  "V14",
  "V14_H",
  "V14_J",
  "V14_K",
  "V15",
  "V15_H",
  "V15_J",
  "V15_K",
  "V16",
  "V16_H",
  "V16_J",
  "V16_K",
  "V17",
  "V17_H",
  "V17_J",
  "V17_K",
  "V18",
  "V18_H",
  "V18_J",
  "V18_K",
  "V19",
  "V19_H",
  "V19_J",
  "V19_K",
  "V20",
  "V20_H",
  "V20_J",
  "V20_K",
  "V21",
  "V21_H",
  "V21_J",
  "V21_K",
  "V22",
  "V22_H",
  "V22_J",
  "V22_K",
  "V23",
  "V23_H",
  "V23_J",
  "V23_K",
  "V24",
  "V24_H",
  "V24_J",
  "V24_K",
  "V25",
  "V25_H",
  "V25_J",
  "V25_K",
  "V26",
  "V26_H",
  "V26_J",
  "V26_K",
  "V27",
  "V27_H",
  "V27_J",
  "V27_K",
  "V28",
  "V28_H",
  "V28_J",
  "V28_K",
  "V29",
  "V29_H",
  "V29_J",
  "V29_K",
  "V30",
  "V30_H",
  "V30_J",
  "V30_K",
  "V31",
  "V31_H",
  "V31_J",
  "V31_K",
  "RFLAGS" // no trailing comma
};

// An array of character pointers to machine register names.
const VMReg OptoReg::opto2vm[REG_COUNT] = {
	x7->as_VMReg()         ,
	x7->as_VMReg()->next() ,
	x28->as_VMReg()        ,
	x28->as_VMReg()->next(),
	x29->as_VMReg()        ,
	x29->as_VMReg()->next(),
	x30->as_VMReg()        ,
	x30->as_VMReg()->next(),
	x31->as_VMReg()        ,
	x31->as_VMReg()->next(),
	x10->as_VMReg()        ,
	x10->as_VMReg()->next(),
	x11->as_VMReg()        ,
	x11->as_VMReg()->next(),
	x12->as_VMReg()        ,
	x12->as_VMReg()->next(),
	x13->as_VMReg()        ,
	x13->as_VMReg()->next(),
	x14->as_VMReg()        ,
	x14->as_VMReg()->next(),
	x15->as_VMReg()        ,
	x15->as_VMReg()->next(),
	x16->as_VMReg()        ,
	x16->as_VMReg()->next(),
	x17->as_VMReg()        ,
	x17->as_VMReg()->next(),
	x9->as_VMReg()         ,
	x9->as_VMReg()->next() ,
	x18->as_VMReg()        ,
	x18->as_VMReg()->next(),
	x19->as_VMReg()        ,
	x19->as_VMReg()->next(),
	x20->as_VMReg()        ,
	x20->as_VMReg()->next(),
	x21->as_VMReg()        ,
	x21->as_VMReg()->next(),
	x22->as_VMReg()        ,
	x22->as_VMReg()->next(),
	x24->as_VMReg()        ,
	x24->as_VMReg()->next(),
	x25->as_VMReg()        ,
	x25->as_VMReg()->next(),
	x26->as_VMReg()        ,
	x26->as_VMReg()->next(),
	x23->as_VMReg()        ,
	x23->as_VMReg()->next(),
	x27->as_VMReg()        ,
	x27->as_VMReg()->next(),
	x4->as_VMReg()         ,
	x4->as_VMReg()->next() ,
	x8->as_VMReg()         ,
	x8->as_VMReg()->next() ,
	x0->as_VMReg()         ,
	x0->as_VMReg()->next() ,
	x1->as_VMReg()         ,
	x1->as_VMReg()->next() ,
	x2->as_VMReg()         ,
	x2->as_VMReg()->next() ,
	x3->as_VMReg()         ,
	x3->as_VMReg()->next() ,
	f0->as_VMReg()          ,
	f0->as_VMReg()->next()  ,
	f1->as_VMReg()          ,
	f1->as_VMReg()->next()  ,
	f2->as_VMReg()          ,
	f2->as_VMReg()->next()  ,
	f3->as_VMReg()          ,
	f3->as_VMReg()->next()  ,
	f4->as_VMReg()          ,
	f4->as_VMReg()->next()  ,
	f5->as_VMReg()          ,
	f5->as_VMReg()->next()  ,
	f6->as_VMReg()          ,
	f6->as_VMReg()->next()  ,
	f7->as_VMReg()          ,
	f7->as_VMReg()->next()  ,
	f28->as_VMReg()         ,
	f28->as_VMReg()->next() ,
	f29->as_VMReg()         ,
	f29->as_VMReg()->next() ,
	f30->as_VMReg()         ,
	f30->as_VMReg()->next() ,
	f31->as_VMReg()         ,
	f31->as_VMReg()->next() ,
	f10->as_VMReg()         ,
	f10->as_VMReg()->next() ,
	f11->as_VMReg()         ,
	f11->as_VMReg()->next() ,
	f12->as_VMReg()         ,
	f12->as_VMReg()->next() ,
	f13->as_VMReg()         ,
	f13->as_VMReg()->next() ,
	f14->as_VMReg()         ,
	f14->as_VMReg()->next() ,
	f15->as_VMReg()         ,
	f15->as_VMReg()->next() ,
	f16->as_VMReg()         ,
	f16->as_VMReg()->next() ,
	f17->as_VMReg()         ,
	f17->as_VMReg()->next() ,
	f8->as_VMReg()          ,
	f8->as_VMReg()->next()  ,
	f9->as_VMReg()          ,
	f9->as_VMReg()->next()  ,
	f18->as_VMReg()         ,
	f18->as_VMReg()->next() ,
	f19->as_VMReg()         ,
	f19->as_VMReg()->next() ,
	f20->as_VMReg()         ,
	f20->as_VMReg()->next() ,
	f21->as_VMReg()         ,
	f21->as_VMReg()->next() ,
	f22->as_VMReg()         ,
	f22->as_VMReg()->next() ,
	f23->as_VMReg()         ,
	f23->as_VMReg()->next() ,
	f24->as_VMReg()         ,
	f24->as_VMReg()->next() ,
	f25->as_VMReg()         ,
	f25->as_VMReg()->next() ,
	f26->as_VMReg()         ,
	f26->as_VMReg()->next() ,
	f27->as_VMReg()         ,
	f27->as_VMReg()->next() ,
	v0->as_VMReg()           ,
	v0->as_VMReg()->next()   ,
	v0->as_VMReg()->next(2)  ,
	v0->as_VMReg()->next(3)  ,
	v1->as_VMReg() 	        ,
	v1->as_VMReg()->next()   ,
	v1->as_VMReg()->next(2)  ,
	v1->as_VMReg()->next(3)  ,
	v2->as_VMReg()           ,
	v2->as_VMReg()->next()   ,
	v2->as_VMReg()->next(2)  ,
	v2->as_VMReg()->next(3)  ,
	v3->as_VMReg()           ,
	v3->as_VMReg()->next()   ,
	v3->as_VMReg()->next(2)  ,
	v3->as_VMReg()->next(3)  ,
	v4->as_VMReg()           ,
	v4->as_VMReg()->next()   ,
	v4->as_VMReg()->next(2)  ,
	v4->as_VMReg()->next(3)  ,
	v5->as_VMReg() 	        ,
	v5->as_VMReg()->next()   ,
	v5->as_VMReg()->next(2)  ,
	v5->as_VMReg()->next(3)  ,
	v6->as_VMReg()           ,
	v6->as_VMReg()->next()   ,
	v6->as_VMReg()->next(2)  ,
	v6->as_VMReg()->next(3)  ,
	v7->as_VMReg() 	        ,
	v7->as_VMReg()->next()   ,
	v7->as_VMReg()->next(2)  ,
	v7->as_VMReg()->next(3)  ,
	v8->as_VMReg()           ,
	v8->as_VMReg()->next()   ,
	v8->as_VMReg()->next(2)  ,
	v8->as_VMReg()->next(3)  ,
	v9->as_VMReg()           ,
	v9->as_VMReg()->next()   ,
	v9->as_VMReg()->next(2)  ,
	v9->as_VMReg()->next(3)  ,
	v10->as_VMReg()          ,
	v10->as_VMReg()->next()  ,
	v10->as_VMReg()->next(2) ,
	v10->as_VMReg()->next(3) ,
	v11->as_VMReg()          ,
	v11->as_VMReg()->next()  ,
	v11->as_VMReg()->next(2) ,
	v11->as_VMReg()->next(3) ,
	v12->as_VMReg()          ,
	v12->as_VMReg()->next()  ,
	v12->as_VMReg()->next(2) ,
	v12->as_VMReg()->next(3) ,
	v13->as_VMReg()          ,
	v13->as_VMReg()->next()  ,
	v13->as_VMReg()->next(2) ,
	v13->as_VMReg()->next(3) ,
	v14->as_VMReg()          ,
	v14->as_VMReg()->next()  ,
	v14->as_VMReg()->next(2) ,
	v14->as_VMReg()->next(3) ,
	v15->as_VMReg()          ,
	v15->as_VMReg()->next()  ,
	v15->as_VMReg()->next(2) ,
	v15->as_VMReg()->next(3) ,
	v16->as_VMReg()          ,
	v16->as_VMReg()->next()  ,
	v16->as_VMReg()->next(2) ,
	v16->as_VMReg()->next(3) ,
	v17->as_VMReg()          ,
	v17->as_VMReg()->next()  ,
	v17->as_VMReg()->next(2) ,
	v17->as_VMReg()->next(3) ,
	v18->as_VMReg()          ,
	v18->as_VMReg()->next()  ,
	v18->as_VMReg()->next(2) ,
	v18->as_VMReg()->next(3) ,
	v19->as_VMReg()          ,
	v19->as_VMReg()->next()  ,
	v19->as_VMReg()->next(2) ,
	v19->as_VMReg()->next(3) ,
	v20->as_VMReg()          ,
	v20->as_VMReg()->next()  ,
	v20->as_VMReg()->next(2) ,
	v20->as_VMReg()->next(3) ,
	v21->as_VMReg()          ,
	v21->as_VMReg()->next()  ,
	v21->as_VMReg()->next(2) ,
	v21->as_VMReg()->next(3) ,
	v22->as_VMReg()          ,
	v22->as_VMReg()->next()  ,
	v22->as_VMReg()->next(2) ,
	v22->as_VMReg()->next(3) ,
	v23->as_VMReg()          ,
	v23->as_VMReg()->next()  ,
	v23->as_VMReg()->next(2) ,
	v23->as_VMReg()->next(3) ,
	v24->as_VMReg()          ,
	v24->as_VMReg()->next()  ,
	v24->as_VMReg()->next(2) ,
	v24->as_VMReg()->next(3) ,
	v25->as_VMReg()          ,
	v25->as_VMReg()->next()  ,
	v25->as_VMReg()->next(2) ,
	v25->as_VMReg()->next(3) ,
	v26->as_VMReg()          ,
	v26->as_VMReg()->next()  ,
	v26->as_VMReg()->next(2) ,
	v26->as_VMReg()->next(3) ,
	v27->as_VMReg()          ,
	v27->as_VMReg()->next()  ,
	v27->as_VMReg()->next(2) ,
	v27->as_VMReg()->next(3) ,
	v28->as_VMReg()          ,
	v28->as_VMReg()->next()  ,
	v28->as_VMReg()->next(2) ,
	v28->as_VMReg()->next(3) ,
	v29->as_VMReg()          ,
	v29->as_VMReg()->next()  ,
	v29->as_VMReg()->next(2) ,
	v29->as_VMReg()->next(3) ,
	v30->as_VMReg()          ,
	v30->as_VMReg()->next()  ,
	v30->as_VMReg()->next(2) ,
	v30->as_VMReg()->next(3) ,
	v31->as_VMReg()          ,
	v31->as_VMReg()->next()  ,
	v31->as_VMReg()->next(2) ,
	v31->as_VMReg()->next(3) ,
	x6->as_VMReg()         // no trailing comma
	};

 OptoReg::Name OptoReg::vm2opto[ConcreteRegisterImpl::number_of_registers];

// An array of the machine register encode values
const unsigned char Matcher::_regEncode[REG_COUNT] = {
  (unsigned char)'\x7',  // R7
  (unsigned char)'\x7',  // R7_H
  (unsigned char)'\x1C',  // R28
  (unsigned char)'\x1C',  // R28_H
  (unsigned char)'\x1D',  // R29
  (unsigned char)'\x1D',  // R29_H
  (unsigned char)'\x1E',  // R30
  (unsigned char)'\x1E',  // R30_H
  (unsigned char)'\x1F',  // R31
  (unsigned char)'\x1F',  // R31_H
  (unsigned char)'\xA',  // R10
  (unsigned char)'\xA',  // R10_H
  (unsigned char)'\xB',  // R11
  (unsigned char)'\xB',  // R11_H
  (unsigned char)'\xC',  // R12
  (unsigned char)'\xC',  // R12_H
  (unsigned char)'\xD',  // R13
  (unsigned char)'\xD',  // R13_H
  (unsigned char)'\xE',  // R14
  (unsigned char)'\xE',  // R14_H
  (unsigned char)'\xF',  // R15
  (unsigned char)'\xF',  // R15_H
  (unsigned char)'\x10',  // R16
  (unsigned char)'\x10',  // R16_H
  (unsigned char)'\x11',  // R17
  (unsigned char)'\x11',  // R17_H
  (unsigned char)'\x9',  // R9
  (unsigned char)'\x9',  // R9_H
  (unsigned char)'\x12',  // R18
  (unsigned char)'\x12',  // R18_H
  (unsigned char)'\x13',  // R19
  (unsigned char)'\x13',  // R19_H
  (unsigned char)'\x14',  // R20
  (unsigned char)'\x14',  // R20_H
  (unsigned char)'\x15',  // R21
  (unsigned char)'\x15',  // R21_H
  (unsigned char)'\x16',  // R22
  (unsigned char)'\x16',  // R22_H
  (unsigned char)'\x18',  // R24
  (unsigned char)'\x18',  // R24_H
  (unsigned char)'\x19',  // R25
  (unsigned char)'\x19',  // R25_H
  (unsigned char)'\x1A',  // R26
  (unsigned char)'\x1A',  // R26_H
  (unsigned char)'\x17',  // R23
  (unsigned char)'\x17',  // R23_H
  (unsigned char)'\x1B',  // R27
  (unsigned char)'\x1B',  // R27_H
  (unsigned char)'\x4',  // R4
  (unsigned char)'\x4',  // R4_H
  (unsigned char)'\x8',  // R8
  (unsigned char)'\x8',  // R8_H
  (unsigned char)'\x0',  // R0
  (unsigned char)'\x0',  // R0_H
  (unsigned char)'\x1',  // R1
  (unsigned char)'\x1',  // R1_H
  (unsigned char)'\x2',  // R2
  (unsigned char)'\x2',  // R2_H
  (unsigned char)'\x3',  // R3
  (unsigned char)'\x3',  // R3_H
  (unsigned char)'\x0',  // F0
  (unsigned char)'\x0',  // F0_H
  (unsigned char)'\x1',  // F1
  (unsigned char)'\x1',  // F1_H
  (unsigned char)'\x2',  // F2
  (unsigned char)'\x2',  // F2_H
  (unsigned char)'\x3',  // F3
  (unsigned char)'\x3',  // F3_H
  (unsigned char)'\x4',  // F4
  (unsigned char)'\x4',  // F4_H
  (unsigned char)'\x5',  // F5
  (unsigned char)'\x5',  // F5_H
  (unsigned char)'\x6',  // F6
  (unsigned char)'\x6',  // F6_H
  (unsigned char)'\x7',  // F7
  (unsigned char)'\x7',  // F7_H
  (unsigned char)'\x1C',  // F28
  (unsigned char)'\x1C',  // F28_H
  (unsigned char)'\x1D',  // F29
  (unsigned char)'\x1D',  // F29_H
  (unsigned char)'\x1E',  // F30
  (unsigned char)'\x1E',  // F30_H
  (unsigned char)'\x1F',  // F31
  (unsigned char)'\x1F',  // F31_H
  (unsigned char)'\xA',  // F10
  (unsigned char)'\xA',  // F10_H
  (unsigned char)'\xB',  // F11
  (unsigned char)'\xB',  // F11_H
  (unsigned char)'\xC',  // F12
  (unsigned char)'\xC',  // F12_H
  (unsigned char)'\xD',  // F13
  (unsigned char)'\xD',  // F13_H
  (unsigned char)'\xE',  // F14
  (unsigned char)'\xE',  // F14_H
  (unsigned char)'\xF',  // F15
  (unsigned char)'\xF',  // F15_H
  (unsigned char)'\x10',  // F16
  (unsigned char)'\x10',  // F16_H
  (unsigned char)'\x11',  // F17
  (unsigned char)'\x11',  // F17_H
  (unsigned char)'\x8',  // F8
  (unsigned char)'\x8',  // F8_H
  (unsigned char)'\x9',  // F9
  (unsigned char)'\x9',  // F9_H
  (unsigned char)'\x12',  // F18
  (unsigned char)'\x12',  // F18_H
  (unsigned char)'\x13',  // F19
  (unsigned char)'\x13',  // F19_H
  (unsigned char)'\x14',  // F20
  (unsigned char)'\x14',  // F20_H
  (unsigned char)'\x15',  // F21
  (unsigned char)'\x15',  // F21_H
  (unsigned char)'\x16',  // F22
  (unsigned char)'\x16',  // F22_H
  (unsigned char)'\x17',  // F23
  (unsigned char)'\x17',  // F23_H
  (unsigned char)'\x18',  // F24
  (unsigned char)'\x18',  // F24_H
  (unsigned char)'\x19',  // F25
  (unsigned char)'\x19',  // F25_H
  (unsigned char)'\x1A',  // F26
  (unsigned char)'\x1A',  // F26_H
  (unsigned char)'\x1B',  // F27
  (unsigned char)'\x1B',  // F27_H
  (unsigned char)'\x0',  // V0
  (unsigned char)'\x0',  // V0_H
  (unsigned char)'\x0',  // V0_J
  (unsigned char)'\x0',  // V0_K
  (unsigned char)'\x1',  // V1
  (unsigned char)'\x1',  // V1_H
  (unsigned char)'\x1',  // V1_J
  (unsigned char)'\x1',  // V1_K
  (unsigned char)'\x2',  // V2
  (unsigned char)'\x2',  // V2_H
  (unsigned char)'\x2',  // V2_J
  (unsigned char)'\x2',  // V2_K
  (unsigned char)'\x3',  // V3
  (unsigned char)'\x3',  // V3_H
  (unsigned char)'\x3',  // V3_J
  (unsigned char)'\x3',  // V3_K
  (unsigned char)'\x4',  // V4
  (unsigned char)'\x4',  // V4_H
  (unsigned char)'\x4',  // V4_J
  (unsigned char)'\x4',  // V4_K
  (unsigned char)'\x5',  // V5
  (unsigned char)'\x5',  // V5_H
  (unsigned char)'\x5',  // V5_J
  (unsigned char)'\x5',  // V5_K
  (unsigned char)'\x6',  // V6
  (unsigned char)'\x6',  // V6_H
  (unsigned char)'\x6',  // V6_J
  (unsigned char)'\x6',  // V6_K
  (unsigned char)'\x7',  // V7
  (unsigned char)'\x7',  // V7_H
  (unsigned char)'\x7',  // V7_J
  (unsigned char)'\x7',  // V7_K
  (unsigned char)'\x8',  // V8
  (unsigned char)'\x8',  // V8_H
  (unsigned char)'\x8',  // V8_J
  (unsigned char)'\x8',  // V8_K
  (unsigned char)'\x9',  // V9
  (unsigned char)'\x9',  // V9_H
  (unsigned char)'\x9',  // V9_J
  (unsigned char)'\x9',  // V9_K
  (unsigned char)'\xA',  // V10
  (unsigned char)'\xA',  // V10_H
  (unsigned char)'\xA',  // V10_J
  (unsigned char)'\xA',  // V10_K
  (unsigned char)'\xB',  // V11
  (unsigned char)'\xB',  // V11_H
  (unsigned char)'\xB',  // V11_J
  (unsigned char)'\xB',  // V11_K
  (unsigned char)'\xC',  // V12
  (unsigned char)'\xC',  // V12_H
  (unsigned char)'\xC',  // V12_J
  (unsigned char)'\xC',  // V12_K
  (unsigned char)'\xD',  // V13
  (unsigned char)'\xD',  // V13_H
  (unsigned char)'\xD',  // V13_J
  (unsigned char)'\xD',  // V13_K
  (unsigned char)'\xE',  // V14
  (unsigned char)'\xE',  // V14_H
  (unsigned char)'\xE',  // V14_J
  (unsigned char)'\xE',  // V14_K
  (unsigned char)'\xF',  // V15
  (unsigned char)'\xF',  // V15_H
  (unsigned char)'\xF',  // V15_J
  (unsigned char)'\xF',  // V15_K
  (unsigned char)'\x10',  // V16
  (unsigned char)'\x10',  // V16_H
  (unsigned char)'\x10',  // V16_J
  (unsigned char)'\x10',  // V16_K
  (unsigned char)'\x11',  // V17
  (unsigned char)'\x11',  // V17_H
  (unsigned char)'\x11',  // V17_J
  (unsigned char)'\x11',  // V17_K
  (unsigned char)'\x12',  // V18
  (unsigned char)'\x12',  // V18_H
  (unsigned char)'\x12',  // V18_J
  (unsigned char)'\x12',  // V18_K
  (unsigned char)'\x13',  // V19
  (unsigned char)'\x13',  // V19_H
  (unsigned char)'\x13',  // V19_J
  (unsigned char)'\x13',  // V19_K
  (unsigned char)'\x14',  // V20
  (unsigned char)'\x14',  // V20_H
  (unsigned char)'\x14',  // V20_J
  (unsigned char)'\x14',  // V20_K
  (unsigned char)'\x15',  // V21
  (unsigned char)'\x15',  // V21_H
  (unsigned char)'\x15',  // V21_J
  (unsigned char)'\x15',  // V21_K
  (unsigned char)'\x16',  // V22
  (unsigned char)'\x16',  // V22_H
  (unsigned char)'\x16',  // V22_J
  (unsigned char)'\x16',  // V22_K
  (unsigned char)'\x17',  // V23
  (unsigned char)'\x17',  // V23_H
  (unsigned char)'\x17',  // V23_J
  (unsigned char)'\x17',  // V23_K
  (unsigned char)'\x18',  // V24
  (unsigned char)'\x18',  // V24_H
  (unsigned char)'\x18',  // V24_J
  (unsigned char)'\x18',  // V24_K
  (unsigned char)'\x19',  // V25
  (unsigned char)'\x19',  // V25_H
  (unsigned char)'\x19',  // V25_J
  (unsigned char)'\x19',  // V25_K
  (unsigned char)'\x1A',  // V26
  (unsigned char)'\x1A',  // V26_H
  (unsigned char)'\x1A',  // V26_J
  (unsigned char)'\x1A',  // V26_K
  (unsigned char)'\x1B',  // V27
  (unsigned char)'\x1B',  // V27_H
  (unsigned char)'\x1B',  // V27_J
  (unsigned char)'\x1B',  // V27_K
  (unsigned char)'\x1C',  // V28
  (unsigned char)'\x1C',  // V28_H
  (unsigned char)'\x1C',  // V28_J
  (unsigned char)'\x1C',  // V28_K
  (unsigned char)'\x1D',  // V29
  (unsigned char)'\x1D',  // V29_H
  (unsigned char)'\x1D',  // V29_J
  (unsigned char)'\x1D',  // V29_K
  (unsigned char)'\x1E',  // V30
  (unsigned char)'\x1E',  // V30_H
  (unsigned char)'\x1E',  // V30_J
  (unsigned char)'\x1E',  // V30_K
  (unsigned char)'\x1F',  // V31
  (unsigned char)'\x1F',  // V31_H
  (unsigned char)'\x1F',  // V31_J
  (unsigned char)'\x1F',  // V31_K
  (unsigned char)'\x6' // no trailing comma  // RFLAGS
};


//------------------Define classes derived from MachOper---------------------
MachOper  *labelOper::clone() const {
  return  new labelOper(_label, _block_num);
}
uint labelOper::opcode() const { return LABEL; }

const RegMask *sRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

MachOper  *methodOper::clone() const {
  return  new methodOper(_method);
}
uint methodOper::opcode() const { return METHOD; }

const RegMask *iRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *iRegINoSpOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_SPECIAL_REG32_mask();
}

const RegMask *iRegI_R10Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_R10_REG_mask();
}

const RegMask *iRegI_R12Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_R12_REG_mask();
}

const RegMask *iRegI_R13Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_R13_REG_mask();
}

const RegMask *iRegI_R14Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_R14_REG_mask();
}

const RegMask *iRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG_mask();
}

const RegMask *iRegLNoSpOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_SPECIAL_REG_mask();
}

const RegMask *iRegL_R28Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R28_REG_mask();
}

const RegMask *iRegL_R29Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R29_REG_mask();
}

const RegMask *iRegL_R30Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R30_REG_mask();
}

const RegMask *iRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *iRegPNoSpOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_SPECIAL_PTR_REG_mask();
}

const RegMask *iRegP_R10Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R10_REG_mask();
}

const RegMask *iRegP_R11Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R11_REG_mask();
}

const RegMask *iRegP_R12Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R12_REG_mask();
}

const RegMask *iRegP_R13Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R13_REG_mask();
}

const RegMask *iRegP_R14Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R14_REG_mask();
}

const RegMask *iRegP_R15Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R15_REG_mask();
}

const RegMask *iRegP_R16Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R16_REG_mask();
}

const RegMask *iRegP_R28Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R28_REG_mask();
}

const RegMask *iRegP_R30Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R30_REG_mask();
}

const RegMask *iRegP_R31Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R31_REG_mask();
}

const RegMask *iRegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *iRegNNoSpOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_SPECIAL_REG32_mask();
}

const RegMask *iRegL_R10Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R10_REG_mask();
}

const RegMask *fRegFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &FLOAT_REG_mask();
}

const RegMask *fRegDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &DOUBLE_REG_mask();
}

const RegMask *vRegOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VECTORA_REG_mask();
}

const RegMask *vReg_V1Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V1_REG_mask();
}

const RegMask *vReg_V2Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V2_REG_mask();
}

const RegMask *vReg_V3Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V3_REG_mask();
}

const RegMask *vReg_V4Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V4_REG_mask();
}

const RegMask *vReg_V5Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V5_REG_mask();
}

const RegMask *vReg_V6Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V6_REG_mask();
}

const RegMask *vReg_V7Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V7_REG_mask();
}

const RegMask *vReg_V8Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V8_REG_mask();
}

const RegMask *vReg_V9Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V9_REG_mask();
}

const RegMask *vReg_V10Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V10_REG_mask();
}

const RegMask *vReg_V11Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V11_REG_mask();
}

const RegMask *vReg_V12Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V12_REG_mask();
}

const RegMask *vReg_V13Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V13_REG_mask();
}

const RegMask *vReg_V14Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V14_REG_mask();
}

const RegMask *vReg_V15Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V15_REG_mask();
}

const RegMask *vRegMaskOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VMASK_REG_mask();
}

const RegMask *vRegMask_V0Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VMASK_REG_V0_mask();
}

const RegMask *javaThread_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &JAVA_THREAD_REG_mask();
}

const RegMask *indirectOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indirectNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *indOffINOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *indOffLNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *thread_anchor_pcOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *stackSlotIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *iRegL2IOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG_mask();
}

const RegMask *rFlagsRegOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &REG_FLAGS_mask();
}

const RegMask *inline_cache_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &METHOD_REG_mask();
}

//------------------Define members for classes derived from MachNode----------
// Build short branch version of this instruction
MachNode *far_cmpI_branchNode::short_branch_version() {
  cmpI_branchNode *node = new cmpI_branchNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *far_cmpI_loopNode::short_branch_version() {
  cmpI_loopNode *node = new cmpI_loopNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *far_cmpU_branchNode::short_branch_version() {
  cmpU_branchNode *node = new cmpU_branchNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *far_cmpL_branchNode::short_branch_version() {
  cmpL_branchNode *node = new cmpL_branchNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *far_cmpLloopNode::short_branch_version() {
  cmpL_loopNode *node = new cmpL_loopNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *far_cmpUL_branchNode::short_branch_version() {
  cmpUL_branchNode *node = new cmpUL_branchNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *far_cmpP_branchNode::short_branch_version() {
  cmpP_branchNode *node = new cmpP_branchNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *far_cmpN_branchNode::short_branch_version() {
  cmpN_branchNode *node = new cmpN_branchNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *far_cmpF_branchNode::short_branch_version() {
  cmpF_branchNode *node = new cmpF_branchNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *far_cmpD_branchNode::short_branch_version() {
  cmpD_branchNode *node = new cmpD_branchNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *far_cmpI_reg_imm0_branchNode::short_branch_version() {
  cmpI_reg_imm0_branchNode *node = new cmpI_reg_imm0_branchNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *far_cmpI_reg_imm0_loopNode::short_branch_version() {
  cmpI_reg_imm0_loopNode *node = new cmpI_reg_imm0_loopNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *far_cmpUEqNeLeGt_imm0_branchNode::short_branch_version() {
  cmpUEqNeLeGt_reg_imm0_branchNode *node = new cmpUEqNeLeGt_reg_imm0_branchNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *far_cmpL_reg_imm0_branchNode::short_branch_version() {
  cmpL_reg_imm0_branchNode *node = new cmpL_reg_imm0_branchNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *far_cmpL_reg_imm0_loopNode::short_branch_version() {
  cmpL_reg_imm0_loopNode *node = new cmpL_reg_imm0_loopNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *far_cmpULEqNeLeGt_reg_imm0_branchNode::short_branch_version() {
  cmpULEqNeLeGt_reg_imm0_branchNode *node = new cmpULEqNeLeGt_reg_imm0_branchNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *far_cmpP_imm0_branchNode::short_branch_version() {
  cmpP_imm0_branchNode *node = new cmpP_imm0_branchNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *far_cmpN_imm0_branchNode::short_branch_version() {
  cmpN_imm0_branchNode *node = new cmpN_imm0_branchNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *far_cmpP_narrowOop_imm0_branchNode::short_branch_version() {
  cmpP_narrowOop_imm0_branchNode *node = new cmpP_narrowOop_imm0_branchNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

void branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpFlag_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpFlag_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpI_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpI_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpI_loopNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpI_loopNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpU_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpU_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpL_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpL_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpL_loopNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpL_loopNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpUL_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpUL_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpP_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpP_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpN_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpN_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpF_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpF_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpD_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpD_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpI_reg_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpI_reg_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpI_reg_imm0_loopNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpI_reg_imm0_loopNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpUEqNeLeGt_reg_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpUEqNeLeGt_reg_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpL_reg_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpL_reg_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpL_reg_imm0_loopNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpL_reg_imm0_loopNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpULEqNeLeGt_reg_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpULEqNeLeGt_reg_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpP_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpP_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpN_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpN_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpP_narrowOop_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpP_narrowOop_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpFlag_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpFlag_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpI_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpI_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpI_loopNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpI_loopNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpU_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpU_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpL_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpL_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpLloopNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpLloopNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpUL_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpUL_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpP_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpP_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpN_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpN_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpF_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpF_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpD_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpD_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpI_reg_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpI_reg_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpI_reg_imm0_loopNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpI_reg_imm0_loopNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpUEqNeLeGt_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpUEqNeLeGt_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpULtGe_reg_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpULtGe_reg_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpL_reg_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpL_reg_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpL_reg_imm0_loopNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpL_reg_imm0_loopNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpULEqNeLeGt_reg_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpULEqNeLeGt_reg_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpULLtGe_reg_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpULLtGe_reg_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpP_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpP_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpN_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpN_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void far_cmpP_narrowOop_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void far_cmpP_narrowOop_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void vtest_anytrue_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void vtest_anytrue_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void vtest_alltrue_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void vtest_alltrue_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void CallStaticJavaDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallDynamicJavaDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallRuntimeDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallLeafDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallLeafNoFPDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

int loadBNode::reloc() const {
  return 1;
}

int loadB2LNode::reloc() const {
  return 1;
}

int loadUBNode::reloc() const {
  return 1;
}

int loadUB2LNode::reloc() const {
  return 1;
}

int loadSNode::reloc() const {
  return 1;
}

int loadS2LNode::reloc() const {
  return 1;
}

int loadUSNode::reloc() const {
  return 1;
}

int loadUS2LNode::reloc() const {
  return 1;
}

int loadINode::reloc() const {
  return 1;
}

int loadI2LNode::reloc() const {
  return 1;
}

int loadUI2LNode::reloc() const {
  return 1;
}

int loadLNode::reloc() const {
  return 1;
}

int loadRangeNode::reloc() const {
  return 1;
}

int loadPNode::reloc() const {
  return 1;
}

int loadNNode::reloc() const {
  return 1;
}

int loadKlassNode::reloc() const {
  return 1;
}

int loadNKlassNode::reloc() const {
  return 1;
}

int loadFNode::reloc() const {
  return 1;
}

int loadDNode::reloc() const {
  return 1;
}

int loadConPNode::reloc() const {
  return 1;
}

int loadConP0Node::reloc() const {
  return 1;
}

int loadConP1Node::reloc() const {
  return 1;
}

int loadByteMapBaseNode::reloc() const {
  return 1;
}

int loadConFNode::reloc() const {
  return 2;
}

int loadConF0Node::reloc() const {
  return 2;
}

int loadConDNode::reloc() const {
  return 2;
}

int loadConD0Node::reloc() const {
  return 2;
}

int storeimmCM0Node::reloc() const {
  return 2;
}

int storeimmCM0_orderedNode::reloc() const {
  return 2;
}

int storeBNode::reloc() const {
  return 3;
}

int storeimmB0Node::reloc() const {
  return 2;
}

int storeCNode::reloc() const {
  return 3;
}

int storeimmC0Node::reloc() const {
  return 2;
}

int storeINode::reloc() const {
  return 3;
}

int storeimmI0Node::reloc() const {
  return 2;
}

int storeLNode::reloc() const {
  return 2;
}

int storeimmL0Node::reloc() const {
  return 2;
}

int storePNode::reloc() const {
  return 2;
}

int storeimmP0Node::reloc() const {
  return 3;
}

int storeNNode::reloc() const {
  return 2;
}

int storeImmN0Node::reloc() const {
  return 2;
}

int storeFNode::reloc() const {
  return 2;
}

int storeDNode::reloc() const {
  return 2;
}

int storeNKlassNode::reloc() const {
  return 2;
}

int prefetchallocNode::reloc() const {
  return 1;
}

int get_and_addINode::reloc() const {
  return 1;
}

int get_and_addI_no_resNode::reloc() const {
  return 1;
}

int get_and_addIAcqNode::reloc() const {
  return 1;
}

int get_and_addI_no_resAcqNode::reloc() const {
  return 1;
}

int addI_reg_regNode::reloc() const {
  return 2;
}

int addI_reg_immNode::reloc() const {
  return 1;
}

int subI_reg_regNode::reloc() const {
  return 2;
}

int subI_reg_immNode::reloc() const {
  return 1;
}

int negI_regNode::reloc() const {
  return 1;
}

int mulINode::reloc() const {
  return 2;
}

int divINode::reloc() const {
  return 2;
}

int UdivINode::reloc() const {
  return 2;
}

int signExtractNode::reloc() const {
  return 1;
}

int modINode::reloc() const {
  return 2;
}

int UmodINode::reloc() const {
  return 2;
}

int lShiftI_reg_regNode::reloc() const {
  return 2;
}

int lShiftI_reg_immNode::reloc() const {
  return 1;
}

int urShiftI_reg_regNode::reloc() const {
  return 2;
}

int urShiftI_reg_immNode::reloc() const {
  return 1;
}

int rShiftI_reg_regNode::reloc() const {
  return 2;
}

int rShiftI_reg_immNode::reloc() const {
  return 1;
}

int lShiftL_reg_regNode::reloc() const {
  return 1;
}

int urShiftL_reg_regNode::reloc() const {
  return 1;
}

int rShiftL_reg_regNode::reloc() const {
  return 1;
}

int absI_regNode::reloc() const {
  return 1;
}

int copySignD_regNode::reloc() const {
  return 1;
}

int signumD_regNode::reloc() const {
  return 1;
}

int signumF_regNode::reloc() const {
  return 1;
}

int bytes_reverse_intNode::reloc() const {
  return 1;
}

int bytes_reverse_unsigned_shortNode::reloc() const {
  return 1;
}

int bytes_reverse_shortNode::reloc() const {
  return 1;
}

int convI2L_reg_regNode::reloc() const {
  return 1;
}

int convI2UL_reg_regNode::reloc() const {
  return 1;
}

int convI2F_reg_regNode::reloc() const {
  return 1;
}

int convI2D_reg_regNode::reloc() const {
  return 1;
}

int cmpLTMask_reg_zeroNode::reloc() const {
  return 1;
}

int cmpP_imm0_branchNode::reloc() const {
  return 1;
}

int cmpP_narrowOop_imm0_branchNode::reloc() const {
  return 1;
}

int far_cmpP_imm0_branchNode::reloc() const {
  return 1;
}

int far_cmpP_narrowOop_imm0_branchNode::reloc() const {
  return 1;
}

int CallStaticJavaDirectNode::reloc() const {
  return 1;
}

int CallDynamicJavaDirectNode::reloc() const {
  return 1;
}

int CallRuntimeDirectNode::reloc() const {
  return 1;
}

int CallLeafDirectNode::reloc() const {
  return 1;
}

int CallLeafNoFPDirectNode::reloc() const {
  return 1;
}

int partialSubtypeCheckVsZeroNode::reloc() const {
  return 1;
}

int safePointNode::reloc() const {
  return 1;
}

int TailCalljmpIndNode::reloc() const {
  return 1;
}

int TailjmpIndNode::reloc() const {
  return 1;
}

int RethrowExceptionNode::reloc() const {
  return 1;
}

int RetNode::reloc() const {
  return 1;
}

int loadVNode::reloc() const {
  return 1;
}

int storeVNode::reloc() const {
  return 2;
}

int reduce_andINode::reloc() const {
  return 1;
}

int reduce_andI_maskedNode::reloc() const {
  return 1;
}

int reduce_orINode::reloc() const {
  return 1;
}

int reduce_orI_maskedNode::reloc() const {
  return 1;
}

int reduce_xorINode::reloc() const {
  return 1;
}

int reduce_xorI_maskedNode::reloc() const {
  return 1;
}

int reduce_addINode::reloc() const {
  return 1;
}

int reduce_addI_maskedNode::reloc() const {
  return 1;
}

int vreduce_maxINode::reloc() const {
  return 1;
}

int vreduce_maxI_maskedNode::reloc() const {
  return 1;
}

int vreduce_minINode::reloc() const {
  return 1;
}

int vreduce_minI_maskedNode::reloc() const {
  return 1;
}

int replicateNode::reloc() const {
  return 1;
}

int vshiftcntNode::reloc() const {
  return 1;
}

int vshiftcnt_0Node::reloc() const {
  return 1;
}

int compressBitsINode::reloc() const {
  return 2;
}

int expandBitsINode::reloc() const {
  return 2;
}

int vmaskAllINode::reloc() const {
  return 1;
}

int loadV_maskedNode::reloc() const {
  return 1;
}

int storeV_maskedNode::reloc() const {
  return 2;
}

int populateindexNode::reloc() const {
  return 2;
}

int insertI_index_lt32Node::reloc() const {
  return 1;
}

int insertI_indexNode::reloc() const {
  return 2;
}

int insertL_indexNode::reloc() const {
  return 1;
}

int insertF_indexNode::reloc() const {
  return 1;
}

int insertD_indexNode::reloc() const {
  return 1;
}

int convB2I_reg_reg_bNode::reloc() const {
  return 1;
}

int convI2S_reg_reg_bNode::reloc() const {
  return 1;
}

int convS2UI_reg_reg_bNode::reloc() const {
  return 1;
}

int convI2UL_reg_reg_bNode::reloc() const {
  return 1;
}

int bytes_reverse_int_bNode::reloc() const {
  return 1;
}

int bytes_reverse_unsigned_short_bNode::reloc() const {
  return 1;
}

int bytes_reverse_short_bNode::reloc() const {
  return 1;
}

int countLeadingZerosI_bNode::reloc() const {
  return 1;
}

int countTrailingZerosI_bNode::reloc() const {
  return 1;
}

int popCountI_bNode::reloc() const {
  return 1;
}

int convI2Bool_andI_reg_immIpowerOf2Node::reloc() const {
  return 1;
}

int xLoadPNode::reloc() const {
  return 1;
}

int zLoadPNode::reloc() const {
  return 1;
}

int zStorePNode::reloc() const {
  return 2;
}


void loadBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4568 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ lb(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 9789 "ad_riscv.cpp"
  }
}

void loadB2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4583 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ lb(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 9805 "ad_riscv.cpp"
  }
}

void loadUBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4598 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ lbu(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 9821 "ad_riscv.cpp"
  }
}

void loadUB2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4613 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ lbu(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 9837 "ad_riscv.cpp"
  }
}

void loadSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4628 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ lh(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 9853 "ad_riscv.cpp"
  }
}

void loadS2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4643 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ lh(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 9869 "ad_riscv.cpp"
  }
}

void loadUSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4658 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ lhu(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 9885 "ad_riscv.cpp"
  }
}

void loadUS2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4673 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ lhu(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 9901 "ad_riscv.cpp"
  }
}

void loadINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4688 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ lw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 9917 "ad_riscv.cpp"
  }
}

void loadI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4703 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ lw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 9933 "ad_riscv.cpp"
  }
}

void loadUI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4718 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ lwu(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 9950 "ad_riscv.cpp"
  }
}

void loadLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4733 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ ld(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 9966 "ad_riscv.cpp"
  }
}

void loadRangeNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4748 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ lwu(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 9982 "ad_riscv.cpp"
  }
}

void loadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4764 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ ld(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 9998 "ad_riscv.cpp"
  }
}

void loadNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4779 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ lwu(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 10014 "ad_riscv.cpp"
  }
}

void loadKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4794 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ ld(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 10030 "ad_riscv.cpp"
  }
}

void loadNKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4809 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ lwu(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 10046 "ad_riscv.cpp"
  }
}

void loadFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4824 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ flw(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 10062 "ad_riscv.cpp"
  }
}

void loadDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4839 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fld(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 10078 "ad_riscv.cpp"
  }
}

void loadConINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2203 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    int64_t con = (int64_t)opnd_array(1)->constant();
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ mv(dst_reg, con);
  
#line 10096 "ad_riscv.cpp"
  }
}

void loadConLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2203 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    int64_t con = (int64_t)opnd_array(1)->constantL();
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ mv(dst_reg, con);
  
#line 10114 "ad_riscv.cpp"
  }
}

void loadConPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2210 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    address con = (address)opnd_array(1)->constant();
    if (con == NULL || con == (address)1) {
      ShouldNotReachHere();
    } else {
      relocInfo::relocType rtype = opnd_array(1)->constant_reloc();
      if (rtype == relocInfo::oop_type) {
        __ movoop(dst_reg, (jobject)con);
      } else if (rtype == relocInfo::metadata_type) {
        __ mov_metadata(dst_reg, (Metadata*)con);
      } else {
        assert(rtype == relocInfo::none, "unexpected reloc type");
        __ mv(dst_reg, opnd_array(1)->constant());
      }
    }
  
#line 10144 "ad_riscv.cpp"
  }
}

void loadConP0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2253 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ mv(dst_reg, zr);
  
#line 10161 "ad_riscv.cpp"
  }
}

void loadConP1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2229 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ mv(dst_reg, 1);
  
#line 10178 "ad_riscv.cpp"
  }
}

void loadByteMapBaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2235 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    __ load_byte_map_base(opnd_array(0)->as_Register(ra_,this)/* dst */);
  
#line 10194 "ad_riscv.cpp"
  }
}

void loadConNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2240 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    address con = (address)opnd_array(1)->constant();
    if (con == NULL) {
      ShouldNotReachHere();
    } else {
      relocInfo::relocType rtype = opnd_array(1)->constant_reloc();
      assert(rtype == relocInfo::oop_type, "unexpected reloc type");
      __ set_narrow_oop(dst_reg, (jobject)con);
    }
  
#line 10218 "ad_riscv.cpp"
  }
}

void loadConN0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2253 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ mv(dst_reg, zr);
  
#line 10235 "ad_riscv.cpp"
  }
}

void loadConNKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2259 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    address con = (address)opnd_array(1)->constant();
    if (con == NULL) {
      ShouldNotReachHere();
    } else {
      relocInfo::relocType rtype = opnd_array(1)->constant_reloc();
      assert(rtype == relocInfo::metadata_type, "unexpected reloc type");
      __ set_narrow_klass(dst_reg, (Klass *)con);
    }
  
#line 10259 "ad_riscv.cpp"
  }
}

void loadConFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4971 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ flw(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 10275 "ad_riscv.cpp"
  }
}

void loadConFNode::eval_constant(Compile* C) {
  {

#line 4972 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(1));
#line 10284 "ad_riscv.cpp"
  }
}
void loadConF0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4985 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fmv_w_x(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), zr);
  
#line 10299 "ad_riscv.cpp"
  }
}

void loadConDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5001 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fld(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 10315 "ad_riscv.cpp"
  }
}

void loadConDNode::eval_constant(Compile* C) {
  {

#line 5002 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(1));
#line 10324 "ad_riscv.cpp"
  }
}
void loadConD0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5015 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fmv_d_x(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), zr);
  
#line 10339 "ad_riscv.cpp"
  }
}

void storeimmCM0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5032 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ sb(zr, Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 10356 "ad_riscv.cpp"
  }
}

void storeimmCM0_orderedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5049 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ membar(MacroAssembler::LoadStore | MacroAssembler::StoreStore);
    __ sb(zr, Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 10374 "ad_riscv.cpp"
  }
}

void storeBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5065 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ sb(as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 10391 "ad_riscv.cpp"
  }
}

void storeimmB0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5079 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ sb(zr, Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 10408 "ad_riscv.cpp"
  }
}

void storeCNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5094 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ sh(as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 10425 "ad_riscv.cpp"
  }
}

void storeimmC0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5108 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ sh(zr, Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 10442 "ad_riscv.cpp"
  }
}

void storeINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5123 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ sw(as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 10459 "ad_riscv.cpp"
  }
}

void storeimmI0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5137 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ sw(zr, Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 10476 "ad_riscv.cpp"
  }
}

void storeLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5152 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ sd(as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 10493 "ad_riscv.cpp"
  }
}

void storeimmL0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5167 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ sd(zr, Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 10510 "ad_riscv.cpp"
  }
}

void storePNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5183 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ sd(as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 10527 "ad_riscv.cpp"
  }
}

void storeimmP0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5199 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ sd(zr, Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 10544 "ad_riscv.cpp"
  }
}

void storeNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5214 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ sw(as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 10561 "ad_riscv.cpp"
  }
}

void storeImmN0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5228 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ sw(zr, Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 10578 "ad_riscv.cpp"
  }
}

void storeFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5243 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fsw(as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 10595 "ad_riscv.cpp"
  }
}

void storeDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5258 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fsd(as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 10612 "ad_riscv.cpp"
  }
}

void storeNKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5273 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ sw(as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */), Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1)));
  
#line 10629 "ad_riscv.cpp"
  }
}

void prefetchallocNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5291 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    if (Assembler::is_simm12(opnd_array(1)->disp(ra_,this,idx1))) {
      if ((opnd_array(1)->disp(ra_,this,idx1)& 0x1f) == 0) {
        __ prefetch_w(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1));
      } else {
        __ addi(t0, as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1));
        __ prefetch_w(t0, 0);
      }
    } else {
      __ mv(t0, opnd_array(1)->disp(ra_,this,idx1));
      __ add(t0, as_Register(opnd_array(1)->base(ra_,this,idx1)), t0);
      __ prefetch_w(t0, 0);
    }
  
#line 10656 "ad_riscv.cpp"
  }
}

void compareAndSwapBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5329 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmpxchg_narrow_value(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int8,
                            Assembler::relaxed /* acquire */, Assembler::rl /* release */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */,
                            true /* result as bool */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */, opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */);
  
#line 10680 "ad_riscv.cpp"
  }
}

void compareAndSwapSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5352 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmpxchg_narrow_value(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int16,
                            Assembler::relaxed /* acquire */, Assembler::rl /* release */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */,
                            true /* result as bool */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */, opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */);
  
#line 10704 "ad_riscv.cpp"
  }
}

void compareAndSwapINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2272 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int32,
               /*acquire*/ Assembler::relaxed, /*release*/ Assembler::rl, opnd_array(0)->as_Register(ra_,this)/* res */,
               /*result as bool*/ true);
  
#line 10724 "ad_riscv.cpp"
  }
}

void compareAndSwapLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2286 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int64,
               /*acquire*/ Assembler::relaxed, /*release*/ Assembler::rl, opnd_array(0)->as_Register(ra_,this)/* res */,
               /*result as bool*/ true);
  
#line 10744 "ad_riscv.cpp"
  }
}

void compareAndSwapPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2286 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int64,
               /*acquire*/ Assembler::relaxed, /*release*/ Assembler::rl, opnd_array(0)->as_Register(ra_,this)/* res */,
               /*result as bool*/ true);
  
#line 10764 "ad_riscv.cpp"
  }
}

void compareAndSwapNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2279 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::uint32,
               /*acquire*/ Assembler::relaxed, /*release*/ Assembler::rl, opnd_array(0)->as_Register(ra_,this)/* res */,
               /*result as bool*/ true);
  
#line 10784 "ad_riscv.cpp"
  }
}

void compareAndSwapBAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5444 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmpxchg_narrow_value(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int8,
                            Assembler::aq /* acquire */, Assembler::rl /* release */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */,
                            true /* result as bool */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */, opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */);
  
#line 10808 "ad_riscv.cpp"
  }
}

void compareAndSwapSAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5469 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmpxchg_narrow_value(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int16,
                            Assembler::aq /* acquire */, Assembler::rl /* release */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */,
                            true /* result as bool */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */, opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */);
  
#line 10832 "ad_riscv.cpp"
  }
}

void compareAndSwapIAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2293 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int32,
               /*acquire*/ Assembler::aq, /*release*/ Assembler::rl, opnd_array(0)->as_Register(ra_,this)/* res */,
               /*result as bool*/ true);
  
#line 10852 "ad_riscv.cpp"
  }
}

void compareAndSwapLAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2307 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int64,
               /*acquire*/ Assembler::aq, /*release*/ Assembler::rl, opnd_array(0)->as_Register(ra_,this)/* res */,
               /*result as bool*/ true);
  
#line 10872 "ad_riscv.cpp"
  }
}

void compareAndSwapPAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2307 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int64,
               /*acquire*/ Assembler::aq, /*release*/ Assembler::rl, opnd_array(0)->as_Register(ra_,this)/* res */,
               /*result as bool*/ true);
  
#line 10892 "ad_riscv.cpp"
  }
}

void compareAndSwapNAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2300 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::uint32,
               /*acquire*/ Assembler::aq, /*release*/ Assembler::rl, opnd_array(0)->as_Register(ra_,this)/* res */,
               /*result as bool*/ true);
  
#line 10912 "ad_riscv.cpp"
  }
}

void compareAndExchangeBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5569 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmpxchg_narrow_value(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int8,
                            /*acquire*/ Assembler::relaxed, /*release*/ Assembler::rl, opnd_array(4)->as_Register(ra_,this,idx4)/* res */,
                            /*result_as_bool*/ false, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */, opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */);
  
#line 10936 "ad_riscv.cpp"
  }
}

void compareAndExchangeSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5591 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmpxchg_narrow_value(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int16,
                            /*acquire*/ Assembler::relaxed, /*release*/ Assembler::rl, opnd_array(4)->as_Register(ra_,this,idx4)/* res */,
                            /*result_as_bool*/ false, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */, opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */);
  
#line 10960 "ad_riscv.cpp"
  }
}

void compareAndExchangeINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5612 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int32,
               /*acquire*/ Assembler::relaxed, /*release*/ Assembler::rl, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 10980 "ad_riscv.cpp"
  }
}

void compareAndExchangeLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5632 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int64,
               /*acquire*/ Assembler::relaxed, /*release*/ Assembler::rl, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 11000 "ad_riscv.cpp"
  }
}

void compareAndExchangeNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5652 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::uint32,
               /*acquire*/ Assembler::relaxed, /*release*/ Assembler::rl, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 11020 "ad_riscv.cpp"
  }
}

void compareAndExchangePNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5673 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int64,
               /*acquire*/ Assembler::relaxed, /*release*/ Assembler::rl, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 11040 "ad_riscv.cpp"
  }
}

void compareAndExchangeBAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5696 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmpxchg_narrow_value(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int8,
                            /*acquire*/ Assembler::aq, /*release*/ Assembler::rl, opnd_array(4)->as_Register(ra_,this,idx4)/* res */,
                            /*result_as_bool*/ false, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */, opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */);
  
#line 11064 "ad_riscv.cpp"
  }
}

void compareAndExchangeSAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5720 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmpxchg_narrow_value(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int16,
                            /*acquire*/ Assembler::aq, /*release*/ Assembler::rl, opnd_array(4)->as_Register(ra_,this,idx4)/* res */,
                            /*result_as_bool*/ false, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */, opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */);
  
#line 11088 "ad_riscv.cpp"
  }
}

void compareAndExchangeIAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5743 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int32,
               /*acquire*/ Assembler::aq, /*release*/ Assembler::rl, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 11108 "ad_riscv.cpp"
  }
}

void compareAndExchangeLAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5765 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int64,
               /*acquire*/ Assembler::aq, /*release*/ Assembler::rl, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 11128 "ad_riscv.cpp"
  }
}

void compareAndExchangeNAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5787 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::uint32,
               /*acquire*/ Assembler::aq, /*release*/ Assembler::rl, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 11148 "ad_riscv.cpp"
  }
}

void compareAndExchangePAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5809 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmpxchg(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int64,
               /*acquire*/ Assembler::aq, /*release*/ Assembler::rl, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 11168 "ad_riscv.cpp"
  }
}

void weakCompareAndSwapBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5831 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ weak_cmpxchg_narrow_value(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int8,
                                 /*acquire*/ Assembler::relaxed, /*release*/ Assembler::rl, opnd_array(4)->as_Register(ra_,this,idx4)/* res */,
                                 opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */, opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */);
  
#line 11192 "ad_riscv.cpp"
  }
}

void weakCompareAndSwapSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5854 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ weak_cmpxchg_narrow_value(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int16,
                                 /*acquire*/ Assembler::relaxed, /*release*/ Assembler::rl, opnd_array(4)->as_Register(ra_,this,idx4)/* res */,
                                 opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */, opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */);
  
#line 11216 "ad_riscv.cpp"
  }
}

void weakCompareAndSwapINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5874 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmpxchg_weak(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int32,
                    /*acquire*/ Assembler::relaxed, /*release*/ Assembler::rl, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 11235 "ad_riscv.cpp"
  }
}

void weakCompareAndSwapLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5893 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmpxchg_weak(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int64,
                    /*acquire*/ Assembler::relaxed, /*release*/ Assembler::rl, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 11254 "ad_riscv.cpp"
  }
}

void weakCompareAndSwapNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5912 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmpxchg_weak(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::uint32,
                    /*acquire*/ Assembler::relaxed, /*release*/ Assembler::rl, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 11273 "ad_riscv.cpp"
  }
}

void weakCompareAndSwapPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5932 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmpxchg_weak(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int64,
                    /*acquire*/ Assembler::relaxed, /*release*/ Assembler::rl, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 11292 "ad_riscv.cpp"
  }
}

void weakCompareAndSwapBAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5956 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ weak_cmpxchg_narrow_value(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int8,
                                 /*acquire*/ Assembler::aq, /*release*/ Assembler::rl, opnd_array(4)->as_Register(ra_,this,idx4)/* res */,
                                 opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */, opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */);
  
#line 11316 "ad_riscv.cpp"
  }
}

void weakCompareAndSwapSAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 5981 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ weak_cmpxchg_narrow_value(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int16,
                                 /*acquire*/ Assembler::aq, /*release*/ Assembler::rl, opnd_array(4)->as_Register(ra_,this,idx4)/* res */,
                                 opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */, opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */);
  
#line 11340 "ad_riscv.cpp"
  }
}

void weakCompareAndSwapIAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6003 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmpxchg_weak(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int32,
                    /*acquire*/ Assembler::aq, /*release*/ Assembler::rl, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 11359 "ad_riscv.cpp"
  }
}

void weakCompareAndSwapLAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6024 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmpxchg_weak(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int64,
                    /*acquire*/ Assembler::aq, /*release*/ Assembler::rl, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 11378 "ad_riscv.cpp"
  }
}

void weakCompareAndSwapNAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6045 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmpxchg_weak(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::uint32,
                    /*acquire*/ Assembler::aq, /*release*/ Assembler::rl, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 11397 "ad_riscv.cpp"
  }
}

void weakCompareAndSwapPAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6066 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmpxchg_weak(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int64,
                    /*acquire*/ Assembler::aq, /*release*/ Assembler::rl, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 11416 "ad_riscv.cpp"
  }
}

void get_and_setINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6082 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ atomic_xchgw(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 11433 "ad_riscv.cpp"
  }
}

void get_and_setLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6097 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ atomic_xchg(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 11450 "ad_riscv.cpp"
  }
}

void get_and_setNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6112 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ atomic_xchgwu(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 11467 "ad_riscv.cpp"
  }
}

void get_and_setPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6128 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ atomic_xchg(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 11484 "ad_riscv.cpp"
  }
}

void get_and_setIAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6145 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ atomic_xchgalw(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 11501 "ad_riscv.cpp"
  }
}

void get_and_setLAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6162 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ atomic_xchgal(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 11518 "ad_riscv.cpp"
  }
}

void get_and_setNAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6179 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ atomic_xchgalwu(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 11535 "ad_riscv.cpp"
  }
}

void get_and_setPAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6196 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ atomic_xchgal(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 11552 "ad_riscv.cpp"
  }
}

void get_and_addLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6211 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ atomic_add(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 11569 "ad_riscv.cpp"
  }
}

void get_and_addL_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6228 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ atomic_add(noreg, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 11586 "ad_riscv.cpp"
  }
}

void get_and_addLiNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6243 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ atomic_add(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->constantL(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 11603 "ad_riscv.cpp"
  }
}

void get_and_addLi_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6260 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ atomic_add(noreg, opnd_array(2)->constantL(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 11620 "ad_riscv.cpp"
  }
}

void get_and_addINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6275 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ atomic_addw(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 11637 "ad_riscv.cpp"
  }
}

void get_and_addI_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6292 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ atomic_addw(noreg, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 11654 "ad_riscv.cpp"
  }
}

void get_and_addIiNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6307 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ atomic_addw(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->constant(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 11671 "ad_riscv.cpp"
  }
}

void get_and_addIi_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6324 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ atomic_addw(noreg, opnd_array(2)->constant(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 11688 "ad_riscv.cpp"
  }
}

void get_and_addLAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6341 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ atomic_addal(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 11705 "ad_riscv.cpp"
  }
}

void get_and_addL_no_resAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6357 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ atomic_addal(noreg, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 11722 "ad_riscv.cpp"
  }
}

void get_and_addLiAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6374 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ atomic_addal(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->constantL(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 11739 "ad_riscv.cpp"
  }
}

void get_and_addLi_no_resAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6391 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ atomic_addal(noreg, opnd_array(2)->constantL(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 11756 "ad_riscv.cpp"
  }
}

void get_and_addIAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6408 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ atomic_addalw(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 11773 "ad_riscv.cpp"
  }
}

void get_and_addI_no_resAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6425 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ atomic_addalw(noreg, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 11790 "ad_riscv.cpp"
  }
}

void get_and_addIiAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6442 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ atomic_addalw(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->constant(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 11807 "ad_riscv.cpp"
  }
}

void get_and_addIi_no_resAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6459 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ atomic_addalw(noreg, opnd_array(2)->constant(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 11824 "ad_riscv.cpp"
  }
}

void addI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6483 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 11843 "ad_riscv.cpp"
  }
}

void addI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6498 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    int32_t con = (int32_t)opnd_array(2)->constant();
    __ addiw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             opnd_array(2)->constant());
  
#line 11863 "ad_riscv.cpp"
  }
}

void addI_reg_imm_l2iNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6514 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ addiw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             opnd_array(2)->constant());
  
#line 11882 "ad_riscv.cpp"
  }
}

void addP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6530 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 11901 "ad_riscv.cpp"
  }
}

void lShiftL_regI_immGE32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// scale
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6545 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ slli(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), opnd_array(2)->constant()& 63);
  
#line 11918 "ad_riscv.cpp"
  }
}

void addP_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6560 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    // src2 is imm, so actually call the addi
    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           opnd_array(2)->constantL());
  
#line 11938 "ad_riscv.cpp"
  }
}

void addL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6576 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 11957 "ad_riscv.cpp"
  }
}

void addL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6591 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    // src2 is imm, so actually call the addi
    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           opnd_array(2)->constantL());
  
#line 11977 "ad_riscv.cpp"
  }
}

void subI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6608 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 11996 "ad_riscv.cpp"
  }
}

void subI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6624 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    // src2 is imm, so actually call the addiw
    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            opnd_array(2)->constant());
  
#line 12016 "ad_riscv.cpp"
  }
}

void subL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6640 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 12035 "ad_riscv.cpp"
  }
}

void subL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6655 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    // src2 is imm, so actually call the addi
    __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           opnd_array(2)->constantL());
  
#line 12055 "ad_riscv.cpp"
  }
}

void negI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6672 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    // actually call the subw
    __ negw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */));
  
#line 12074 "ad_riscv.cpp"
  }
}

void negL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6688 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    // actually call the sub
    __ neg(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */));
  
#line 12093 "ad_riscv.cpp"
  }
}

void mulINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6705 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    // riscv64 mulw will sign-extension to high 32 bits in dst reg
    __ mulw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 12113 "ad_riscv.cpp"
  }
}

void mulLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6722 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ mul(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 12132 "ad_riscv.cpp"
  }
}

void mulHiL_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6737 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ mulh(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 12151 "ad_riscv.cpp"
  }
}

void umulHiL_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6752 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ mulhu(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 12170 "ad_riscv.cpp"
  }
}

void divINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2465 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivl(dst_reg, src1_reg, src2_reg, /* want_remainder */ false, /* is_signed */ true);
  
#line 12190 "ad_riscv.cpp"
  }
}

void UdivINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2473 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivl(dst_reg, src1_reg, src2_reg, /* want_remainder */ false, /* is_signed */ false);
  
#line 12210 "ad_riscv.cpp"
  }
}

void signExtractNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// div2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6786 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ srliw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), 31);
  
#line 12228 "ad_riscv.cpp"
  }
}

void divLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2481 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivq(dst_reg, src1_reg, src2_reg, /* want_remainder */ false, /* is_signed */ true);
  
#line 12248 "ad_riscv.cpp"
  }
}

void UdivLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2489 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivq(dst_reg, src1_reg, src2_reg, /* want_remainder */ false, /* is_signed */ false);
  
#line 12268 "ad_riscv.cpp"
  }
}

void signExtractLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// div2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6818 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ srli(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), 63);
  
#line 12286 "ad_riscv.cpp"
  }
}

void modINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2497 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivl(dst_reg, src1_reg, src2_reg, /* want_remainder */ true, /* is_signed */ true);
  
#line 12306 "ad_riscv.cpp"
  }
}

void UmodINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2505 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivl(dst_reg, src1_reg, src2_reg, /* want_remainder */ true, /* is_signed */ false);
  
#line 12326 "ad_riscv.cpp"
  }
}

void modLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2513 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivq(dst_reg, src1_reg, src2_reg, /* want_remainder */ true, /* is_signed */ true);
  
#line 12346 "ad_riscv.cpp"
  }
}

void UmodLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2521 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivq(dst_reg, src1_reg, src2_reg, /* want_remainder */ true, /* is_signed */ false);
  
#line 12366 "ad_riscv.cpp"
  }
}

void lShiftI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6873 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ sllw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 12385 "ad_riscv.cpp"
  }
}

void lShiftI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6888 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    // the shift amount is encoded in the lower
    // 5 bits of the I-immediate field for RV32I
    __ slliw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             (unsigned) opnd_array(2)->constant()& 0x1f);
  
#line 12406 "ad_riscv.cpp"
  }
}

void urShiftI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6906 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ srlw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 12425 "ad_riscv.cpp"
  }
}

void urShiftI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6921 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    // the shift amount is encoded in the lower
    // 6 bits of the I-immediate field for RV64I
    __ srliw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             (unsigned) opnd_array(2)->constant()& 0x1f);
  
#line 12446 "ad_riscv.cpp"
  }
}

void rShiftI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6939 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    // riscv will sign-ext dst high 32 bits
    __ sraw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 12466 "ad_riscv.cpp"
  }
}

void rShiftI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6955 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    // riscv will sign-ext dst high 32 bits
    __ sraiw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             (unsigned) opnd_array(2)->constant()& 0x1f);
  
#line 12486 "ad_riscv.cpp"
  }
}

void lShiftL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6975 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ sll(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 12505 "ad_riscv.cpp"
  }
}

void lShiftL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 6991 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    // the shift amount is encoded in the lower
    // 6 bits of the I-immediate field for RV64I
    __ slli(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            (unsigned) opnd_array(2)->constant()& 0x3f);
  
#line 12526 "ad_riscv.cpp"
  }
}

void urShiftL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7010 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ srl(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 12545 "ad_riscv.cpp"
  }
}

void urShiftL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7026 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    // the shift amount is encoded in the lower
    // 6 bits of the I-immediate field for RV64I
    __ srli(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            (unsigned) opnd_array(2)->constant()& 0x3f);
  
#line 12566 "ad_riscv.cpp"
  }
}

void urShiftP_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7044 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    // the shift amount is encoded in the lower
    // 6 bits of the I-immediate field for RV64I
    __ srli(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            (unsigned) opnd_array(2)->constant()& 0x3f);
  
#line 12587 "ad_riscv.cpp"
  }
}

void rShiftL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7063 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ sra(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 12606 "ad_riscv.cpp"
  }
}

void rShiftL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7079 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    // the shift amount is encoded in the lower
    // 6 bits of the I-immediate field for RV64I
    __ srai(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            (unsigned) opnd_array(2)->constant()& 0x3f);
  
#line 12627 "ad_riscv.cpp"
  }
}

void regI_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7095 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ xori(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), -1);
  
#line 12644 "ad_riscv.cpp"
  }
}

void regL_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7107 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ xori(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), -1);
  
#line 12661 "ad_riscv.cpp"
  }
}

void addF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7124 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fadd_s(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 12680 "ad_riscv.cpp"
  }
}

void addD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7139 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fadd_d(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 12699 "ad_riscv.cpp"
  }
}

void subF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7154 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fsub_s(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 12718 "ad_riscv.cpp"
  }
}

void subD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7169 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fsub_d(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 12737 "ad_riscv.cpp"
  }
}

void mulF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7184 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fmul_s(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 12756 "ad_riscv.cpp"
  }
}

void mulD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7199 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fmul_d(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 12775 "ad_riscv.cpp"
  }
}

void maddF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7215 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ fmadd_s(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
               as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
               as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
               as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 12797 "ad_riscv.cpp"
  }
}

void maddD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7233 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ fmadd_d(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
               as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
               as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
               as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 12819 "ad_riscv.cpp"
  }
}

void msubF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7251 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ fmsub_s(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
               as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
               as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
               as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 12841 "ad_riscv.cpp"
  }
}

void msubD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7269 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ fmsub_d(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
               as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
               as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
               as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 12863 "ad_riscv.cpp"
  }
}

void nmsubF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7288 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ fnmsub_s(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
                as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
                as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
                as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 12885 "ad_riscv.cpp"
  }
}

void nmsubD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7307 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ fnmsub_d(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
                as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
                as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
                as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 12907 "ad_riscv.cpp"
  }
}

void nmaddF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7326 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ fnmadd_s(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
                as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
                as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
                as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 12929 "ad_riscv.cpp"
  }
}

void nmaddD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7345 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ fnmadd_d(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
                as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
                as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
                as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 12951 "ad_riscv.cpp"
  }
}

void maxF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7363 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ minmax_fp(as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */),
                 as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                 false /* is_double */, false /* is_min */);
  
#line 12971 "ad_riscv.cpp"
  }
}

void minF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7379 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ minmax_fp(as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */),
                 as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                 false /* is_double */, true /* is_min */);
  
#line 12991 "ad_riscv.cpp"
  }
}

void maxD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7395 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ minmax_fp(as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */),
                 as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                 true /* is_double */, false /* is_min */);
  
#line 13011 "ad_riscv.cpp"
  }
}

void minD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7411 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ minmax_fp(as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */),
                 as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                 true /* is_double */, true /* is_min */);
  
#line 13031 "ad_riscv.cpp"
  }
}

void isInfiniteF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7426 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fclass_s(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ andi(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Assembler::fclass_mask::inf);
    __ slt(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), zr, as_Register(opnd_array(0)->reg(ra_,this)/* dst */));
  
#line 13049 "ad_riscv.cpp"
  }
}

void isInfiniteD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7441 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fclass_d(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ andi(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Assembler::fclass_mask::inf);
    __ slt(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), zr, as_Register(opnd_array(0)->reg(ra_,this)/* dst */));
  
#line 13067 "ad_riscv.cpp"
  }
}

void isFiniteF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7456 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fclass_s(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ andi(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Assembler::fclass_mask::finite);
    __ slt(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), zr, as_Register(opnd_array(0)->reg(ra_,this)/* dst */));
  
#line 13085 "ad_riscv.cpp"
  }
}

void isFiniteD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7471 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fclass_d(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ andi(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Assembler::fclass_mask::finite);
    __ slt(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), zr, as_Register(opnd_array(0)->reg(ra_,this)/* dst */));
  
#line 13103 "ad_riscv.cpp"
  }
}

void divF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7486 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fdiv_s(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 13122 "ad_riscv.cpp"
  }
}

void divD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7501 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fdiv_d(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 13141 "ad_riscv.cpp"
  }
}

void negF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7516 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fneg_s(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 13158 "ad_riscv.cpp"
  }
}

void negD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7530 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fneg_d(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 13175 "ad_riscv.cpp"
  }
}

void absI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7548 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ sraiw(t0, as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), 0x1f);
    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), t0);
    __ xorr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(0)->reg(ra_,this)/* dst */), t0);
  
#line 13193 "ad_riscv.cpp"
  }
}

void absL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7567 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ srai(t0, as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), 0x3f);
    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), t0);
    __ xorr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(0)->reg(ra_,this)/* dst */), t0);
  
#line 13211 "ad_riscv.cpp"
  }
}

void absF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7581 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fabs_s(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 13228 "ad_riscv.cpp"
  }
}

void absD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7594 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fabs_d(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 13245 "ad_riscv.cpp"
  }
}

void sqrtF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7607 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fsqrt_s(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
               as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 13262 "ad_riscv.cpp"
  }
}

void sqrtD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7620 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fsqrt_d(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
               as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 13279 "ad_riscv.cpp"
  }
}

void roundD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rmode
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7635 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ round_double_mode(as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */),
               as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), opnd_array(2)->constant(), opnd_array(4)->as_Register(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp2 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp3 */);
  
#line 13301 "ad_riscv.cpp"
  }
}

void copySignD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7647 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    FloatRegister dst = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
                  src1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
                  src2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ fsgnj_d(dst, src1, src2);
  
#line 13322 "ad_riscv.cpp"
  }
}

void copySignF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7659 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    FloatRegister dst = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
                  src1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
                  src2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ fsgnj_s(dst, src1, src2);
  
#line 13342 "ad_riscv.cpp"
  }
}

void signumD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7671 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ signum_fp(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst */), as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* one */), true /* is_double */);
  
#line 13360 "ad_riscv.cpp"
  }
}

void signumF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7680 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ signum_fp(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst */), as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* one */), false /* is_double */);
  
#line 13378 "ad_riscv.cpp"
  }
}

void andI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7698 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 13397 "ad_riscv.cpp"
  }
}

void andI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7714 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ andi(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            (int32_t)(opnd_array(2)->constant()));
  
#line 13416 "ad_riscv.cpp"
  }
}

void orI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7730 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 13435 "ad_riscv.cpp"
  }
}

void orI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7746 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ ori(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           (int32_t)(opnd_array(2)->constant()));
  
#line 13454 "ad_riscv.cpp"
  }
}

void xorI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7762 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ xorr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 13473 "ad_riscv.cpp"
  }
}

void xorI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7778 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ xori(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            (int32_t)(opnd_array(2)->constant()));
  
#line 13492 "ad_riscv.cpp"
  }
}

void andL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7794 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 13511 "ad_riscv.cpp"
  }
}

void andL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7810 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ andi(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            (int32_t)(opnd_array(2)->constantL()));
  
#line 13530 "ad_riscv.cpp"
  }
}

void orL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7826 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 13549 "ad_riscv.cpp"
  }
}

void orL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7842 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ ori(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           (int32_t)(opnd_array(2)->constantL()));
  
#line 13568 "ad_riscv.cpp"
  }
}

void xorL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7858 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ xorr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 13587 "ad_riscv.cpp"
  }
}

void xorL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7874 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ xori(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            (int32_t)(opnd_array(2)->constantL()));
  
#line 13606 "ad_riscv.cpp"
  }
}

void bytes_reverse_intNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7893 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ revb_w_w(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 13622 "ad_riscv.cpp"
  }
}

void bytes_reverse_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7907 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ revb(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 13638 "ad_riscv.cpp"
  }
}

void bytes_reverse_unsigned_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7920 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ revb_h_h_u(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 13654 "ad_riscv.cpp"
  }
}

void bytes_reverse_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7933 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ revb_h_h(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 13670 "ad_riscv.cpp"
  }
}

void load_fenceNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7949 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ membar(MacroAssembler::LoadLoad | MacroAssembler::LoadStore);
  
#line 13686 "ad_riscv.cpp"
  }
}

void membar_acquireNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7962 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ block_comment("membar_acquire");
    __ membar(MacroAssembler::LoadLoad | MacroAssembler::LoadStore);
  
#line 13703 "ad_riscv.cpp"
  }
}

void membar_acquire_lockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7976 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ block_comment("membar_acquire_lock (elided)");
  
#line 13719 "ad_riscv.cpp"
  }
}

void store_fenceNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 7989 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ membar(MacroAssembler::LoadStore | MacroAssembler::StoreStore);
  
#line 13735 "ad_riscv.cpp"
  }
}

void membar_releaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8002 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ block_comment("membar_release");
    __ membar(MacroAssembler::LoadStore | MacroAssembler::StoreStore);
  
#line 13752 "ad_riscv.cpp"
  }
}

void membar_storestoreNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8016 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ membar(MacroAssembler::StoreStore);
  
#line 13768 "ad_riscv.cpp"
  }
}

void membar_storestore_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8016 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ membar(MacroAssembler::StoreStore);
  
#line 13784 "ad_riscv.cpp"
  }
}

void membar_release_lockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8028 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ block_comment("membar_release_lock (elided)");
  
#line 13800 "ad_riscv.cpp"
  }
}

void membar_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8042 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ block_comment("membar_volatile");
    __ membar(MacroAssembler::StoreLoad);
  
#line 13817 "ad_riscv.cpp"
  }
}

void spin_waitNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8057 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ pause();
  
#line 13833 "ad_riscv.cpp"
  }
}

void castX2PNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8073 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    if (opnd_array(0)->reg(ra_,this)/* dst */!= opnd_array(1)->reg(ra_,this,idx1)/* src */) {
      __ mv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    }
  
#line 13851 "ad_riscv.cpp"
  }
}

void castP2XNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8088 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    if (opnd_array(0)->reg(ra_,this)/* dst */!= opnd_array(1)->reg(ra_,this,idx1)/* src */) {
      __ mv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    }
  
#line 13869 "ad_riscv.cpp"
  }
}

void castPPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castPPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castLLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castLLNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castIINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castIINode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void checkCastPPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint checkCastPPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castFFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castFFNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castDDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castDDNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castVVNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castVVNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void convI2BoolNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8185 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ snez(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 13976 "ad_riscv.cpp"
  }
}

void convP2BoolNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8200 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ snez(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 13992 "ad_riscv.cpp"
  }
}

void convI2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8215 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ sign_extend(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), 32);
  
#line 14008 "ad_riscv.cpp"
  }
}

void convL2I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8227 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ sign_extend(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), 32);
  
#line 14024 "ad_riscv.cpp"
  }
}

void convI2UL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8242 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ zero_extend(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), 32);
  
#line 14041 "ad_riscv.cpp"
  }
}

void convF2D_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8257 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fcvt_d_s(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 14057 "ad_riscv.cpp"
  }
}

void convD2F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8270 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fcvt_s_d(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 14073 "ad_riscv.cpp"
  }
}

void convF2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8285 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fcvt_w_s_safe(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 14089 "ad_riscv.cpp"
  }
}

void convI2F_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8298 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fcvt_s_w(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 14105 "ad_riscv.cpp"
  }
}

void convF2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8313 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fcvt_l_s_safe(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 14121 "ad_riscv.cpp"
  }
}

void convL2F_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8326 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fcvt_s_l(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 14137 "ad_riscv.cpp"
  }
}

void convD2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8341 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fcvt_w_d_safe(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 14153 "ad_riscv.cpp"
  }
}

void convI2D_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8354 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fcvt_d_w(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 14169 "ad_riscv.cpp"
  }
}

void convD2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8369 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fcvt_l_d_safe(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 14185 "ad_riscv.cpp"
  }
}

void convL2D_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8382 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fcvt_d_l(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 14201 "ad_riscv.cpp"
  }
}

void convP2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8396 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ zero_extend(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, 32);
  
#line 14217 "ad_riscv.cpp"
  }
}

void convN2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8413 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ mv(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 14233 "ad_riscv.cpp"
  }
}

void encodeHeapOopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8425 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ encode_heap_oop(d, s);
  
#line 14251 "ad_riscv.cpp"
  }
}

void decodeHeapOopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8440 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ decode_heap_oop(d, s);
  
#line 14269 "ad_riscv.cpp"
  }
}

void decodeHeapOop_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8455 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ decode_heap_oop_not_null(d, s);
  
#line 14287 "ad_riscv.cpp"
  }
}

void encodeKlass_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8470 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ encode_klass_not_null(dst_reg, src_reg, t0);
  
#line 14305 "ad_riscv.cpp"
  }
}

void decodeKlass_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8487 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register tmp_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* tmp */);
    __ decode_klass_not_null(dst_reg, src_reg, tmp_reg);
  
#line 14325 "ad_riscv.cpp"
  }
}

void MoveF2I_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8509 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ lw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Address(sp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 14341 "ad_riscv.cpp"
  }
}

void MoveI2F_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8527 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ flw(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), Address(sp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 14357 "ad_riscv.cpp"
  }
}

void MoveD2L_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8545 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ ld(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Address(sp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 14373 "ad_riscv.cpp"
  }
}

void MoveL2D_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8563 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fld(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), Address(sp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 14389 "ad_riscv.cpp"
  }
}

void MoveF2I_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8581 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fsw(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), Address(sp, opnd_array(0)->disp(ra_,this,0)));
  
#line 14405 "ad_riscv.cpp"
  }
}

void MoveI2F_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8599 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ sw(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), Address(sp, opnd_array(0)->disp(ra_,this,0)));
  
#line 14421 "ad_riscv.cpp"
  }
}

void MoveD2L_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8617 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fsd(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), Address(sp, opnd_array(0)->disp(ra_,this,0)));
  
#line 14437 "ad_riscv.cpp"
  }
}

void MoveL2D_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8635 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ sd(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), Address(sp, opnd_array(0)->disp(ra_,this,0)));
  
#line 14453 "ad_riscv.cpp"
  }
}

void MoveF2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8653 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fmv_x_w(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 14469 "ad_riscv.cpp"
  }
}

void MoveI2F_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8671 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fmv_w_x(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 14485 "ad_riscv.cpp"
  }
}

void MoveD2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8689 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fmv_x_d(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 14501 "ad_riscv.cpp"
  }
}

void MoveL2D_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8707 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fmv_d_x(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 14517 "ad_riscv.cpp"
  }
}

void cmpF3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8730 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    // we want -1 for unordered or less than, 0 for equal and 1 for greater than.
    __ float_compare(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* op1 */),
                     as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* op2 */), -1 /*unordered_result < 0*/);
  
#line 14536 "ad_riscv.cpp"
  }
}

void cmpD3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8751 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    // we want -1 for unordered or less than, 0 for equal and 1 for greater than.
    __ double_compare(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* op1 */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* op2 */), -1 /*unordered_result < 0*/);
  
#line 14554 "ad_riscv.cpp"
  }
}

void cmpL3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8770 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_l2i(t0, as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */));
    __ mv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), t0);
  
#line 14572 "ad_riscv.cpp"
  }
}

void cmpUL3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8789 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_ul2i(t0, as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */));
    __ mv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), t0);
  
#line 14590 "ad_riscv.cpp"
  }
}

void cmpU3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8808 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_uw2i(t0, as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */));
    __ mv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), t0);
  
#line 14608 "ad_riscv.cpp"
  }
}

void cmpLTMask_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// p
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// q
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8826 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ slt(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* p */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* q */));
    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), zr, as_Register(opnd_array(0)->reg(ra_,this)/* dst */));
  
#line 14626 "ad_riscv.cpp"
  }
}

void cmpLTMask_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8842 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ sraiw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op */), 31);
  
#line 14643 "ad_riscv.cpp"
  }
}

void minI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8864 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    Label Lskip;
    __ ble(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* dst */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */), Lskip);
    __ mv(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* dst */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */));
    __ bind(Lskip);
  
#line 14663 "ad_riscv.cpp"
  }
}

void maxI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8885 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    Label Lskip;
    __ bge(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* dst */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */), Lskip);
    __ mv(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* dst */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */));
    __ bind(Lskip);
  
#line 14683 "ad_riscv.cpp"
  }
}

void minI_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8911 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    Label Lskip;
    __ blez(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* dst */), Lskip);
    __ mv(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* dst */), zr);
    __ bind(Lskip);
  
#line 14703 "ad_riscv.cpp"
  }
}

void minI_reg_zero_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8911 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    Label Lskip;
    __ blez(as_Register(opnd_array(2)->reg(ra_,this,idx2)/* dst */), Lskip);
    __ mv(as_Register(opnd_array(2)->reg(ra_,this,idx2)/* dst */), zr);
    __ bind(Lskip);
  
#line 14723 "ad_riscv.cpp"
  }
}

void maxI_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8933 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    Label Lskip;
    __ bgez(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* dst */), Lskip);
    __ mv(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* dst */), zr);
    __ bind(Lskip);
  
#line 14743 "ad_riscv.cpp"
  }
}

void maxI_reg_zero_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8933 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    Label Lskip;
    __ bgez(as_Register(opnd_array(2)->reg(ra_,this,idx2)/* dst */), Lskip);
    __ mv(as_Register(opnd_array(2)->reg(ra_,this,idx2)/* dst */), zr);
    __ bind(Lskip);
  
#line 14763 "ad_riscv.cpp"
  }
}

void minI_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8959 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    Label Lsrc1, Ldone;
    __ ble(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Lsrc1);
    __ mv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
    __ j(Ldone);
    __ bind(Lsrc1);
    __ mv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */));
    __ bind(Ldone);
  
#line 14786 "ad_riscv.cpp"
  }
}

void maxI_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 8988 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    Label Lsrc1, Ldone;
    __ bge(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Lsrc1);
    __ mv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
    __ j(Ldone);
    __ bind(Lsrc1);
    __ mv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */));
    __ bind(Ldone);

  
#line 14810 "ad_riscv.cpp"
  }
}

void branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2316 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    Label* L = opnd_array(1)->label();
    __ j(*L);
  
#line 14827 "ad_riscv.cpp"
  }
}

void cmpFlag_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lbl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9032 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ enc_cmpEqNe_imm0_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* cr */), *(opnd_array(3)->label()));
  
#line 14845 "ad_riscv.cpp"
  }
}

void cmpI_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9051 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* op2 */), *(opnd_array(4)->label()));
  
#line 14864 "ad_riscv.cpp"
  }
}

void cmpI_loopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9070 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* op2 */), *(opnd_array(4)->label()));
  
#line 14883 "ad_riscv.cpp"
  }
}

void cmpU_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9090 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_branch(opnd_array(1)->ccode()| C2_MacroAssembler::unsigned_branch_mask, as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */),
                  as_Register(opnd_array(3)->reg(ra_,this,idx3)/* op2 */), *(opnd_array(4)->label()));
  
#line 14903 "ad_riscv.cpp"
  }
}

void cmpL_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9111 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* op2 */), *(opnd_array(4)->label()));
  
#line 14922 "ad_riscv.cpp"
  }
}

void cmpL_loopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9130 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* op2 */), *(opnd_array(4)->label()));
  
#line 14941 "ad_riscv.cpp"
  }
}

void cmpUL_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9149 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_branch(opnd_array(1)->ccode()| C2_MacroAssembler::unsigned_branch_mask, as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */),
                  as_Register(opnd_array(3)->reg(ra_,this,idx3)/* op2 */), *(opnd_array(4)->label()));
  
#line 14961 "ad_riscv.cpp"
  }
}

void cmpP_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9170 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_branch(opnd_array(1)->ccode()| C2_MacroAssembler::unsigned_branch_mask, as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */),
                  as_Register(opnd_array(3)->reg(ra_,this,idx3)/* op2 */), *(opnd_array(4)->label()));
  
#line 14981 "ad_riscv.cpp"
  }
}

void cmpN_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9191 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_branch(opnd_array(1)->ccode()| C2_MacroAssembler::unsigned_branch_mask, as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */),
                  as_Register(opnd_array(3)->reg(ra_,this,idx3)/* op2 */), *(opnd_array(4)->label()));
  
#line 15001 "ad_riscv.cpp"
  }
}

void cmpF_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9211 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ float_cmp_branch(opnd_array(1)->ccode(), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* op2 */), *(opnd_array(4)->label()));
  
#line 15020 "ad_riscv.cpp"
  }
}

void cmpD_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9229 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ float_cmp_branch(opnd_array(1)->ccode()| C2_MacroAssembler::double_branch_mask, as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* op1 */),
                        as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* op2 */), *(opnd_array(4)->label()));
  
#line 15040 "ad_riscv.cpp"
  }
}

void cmpI_reg_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9249 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), zr, *(opnd_array(4)->label()));
  
#line 15059 "ad_riscv.cpp"
  }
}

void cmpI_reg_imm0_loopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9268 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), zr, *(opnd_array(4)->label()));
  
#line 15078 "ad_riscv.cpp"
  }
}

void cmpUEqNeLeGt_reg_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9288 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ enc_cmpUEqNeLeGt_imm0_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), *(opnd_array(4)->label()));
  
#line 15097 "ad_riscv.cpp"
  }
}

void cmpL_reg_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9308 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), zr, *(opnd_array(4)->label()));
  
#line 15116 "ad_riscv.cpp"
  }
}

void cmpL_reg_imm0_loopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9327 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), zr, *(opnd_array(4)->label()));
  
#line 15135 "ad_riscv.cpp"
  }
}

void cmpULEqNeLeGt_reg_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9347 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ enc_cmpUEqNeLeGt_imm0_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), *(opnd_array(4)->label()));
  
#line 15154 "ad_riscv.cpp"
  }
}

void cmpP_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9364 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ enc_cmpEqNe_imm0_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), *(opnd_array(4)->label()));
  
#line 15173 "ad_riscv.cpp"
  }
}

void cmpN_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9382 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ enc_cmpEqNe_imm0_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), *(opnd_array(4)->label()));
  
#line 15192 "ad_riscv.cpp"
  }
}

void cmpP_narrowOop_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9399 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ enc_cmpEqNe_imm0_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), *(opnd_array(4)->label()));
  
#line 15211 "ad_riscv.cpp"
  }
}

void far_cmpFlag_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lbl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9416 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ enc_cmpEqNe_imm0_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* cr */), *(opnd_array(3)->label()), /* is_far */ true);
  
#line 15229 "ad_riscv.cpp"
  }
}

void far_cmpI_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9434 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* op2 */), *(opnd_array(4)->label()), /* is_far */ true);
  
#line 15248 "ad_riscv.cpp"
  }
}

void far_cmpI_loopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9448 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* op2 */), *(opnd_array(4)->label()), /* is_far */ true);
  
#line 15267 "ad_riscv.cpp"
  }
}

void far_cmpU_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9462 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_branch(opnd_array(1)->ccode()| C2_MacroAssembler::unsigned_branch_mask, as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */),
                       as_Register(opnd_array(3)->reg(ra_,this,idx3)/* op2 */), *(opnd_array(4)->label()), /* is_far */ true);
  
#line 15287 "ad_riscv.cpp"
  }
}

void far_cmpL_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9477 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* op2 */), *(opnd_array(4)->label()), /* is_far */ true);
  
#line 15306 "ad_riscv.cpp"
  }
}

void far_cmpLloopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9491 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* op2 */), *(opnd_array(4)->label()), /* is_far */ true);
  
#line 15325 "ad_riscv.cpp"
  }
}

void far_cmpUL_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9505 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_branch(opnd_array(1)->ccode()| C2_MacroAssembler::unsigned_branch_mask, as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */),
                       as_Register(opnd_array(3)->reg(ra_,this,idx3)/* op2 */), *(opnd_array(4)->label()), /* is_far */ true);
  
#line 15345 "ad_riscv.cpp"
  }
}

void far_cmpP_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9523 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_branch(opnd_array(1)->ccode()| C2_MacroAssembler::unsigned_branch_mask, as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */),
                       as_Register(opnd_array(3)->reg(ra_,this,idx3)/* op2 */), *(opnd_array(4)->label()), /* is_far */ true);
  
#line 15365 "ad_riscv.cpp"
  }
}

void far_cmpN_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9541 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_branch(opnd_array(1)->ccode()| C2_MacroAssembler::unsigned_branch_mask, as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */),
                       as_Register(opnd_array(3)->reg(ra_,this,idx3)/* op2 */), *(opnd_array(4)->label()), /* is_far */ true);
  
#line 15385 "ad_riscv.cpp"
  }
}

void far_cmpF_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9559 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ float_cmp_branch(opnd_array(1)->ccode(), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* op2 */),
                        *(opnd_array(4)->label()), /* is_far */ true);
  
#line 15405 "ad_riscv.cpp"
  }
}

void far_cmpD_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9576 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ float_cmp_branch(opnd_array(1)->ccode()| C2_MacroAssembler::double_branch_mask, as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* op1 */),
                        as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* op2 */), *(opnd_array(4)->label()), /* is_far */ true);
  
#line 15425 "ad_riscv.cpp"
  }
}

void far_cmpI_reg_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9594 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), zr, *(opnd_array(4)->label()), /* is_far */ true);
  
#line 15444 "ad_riscv.cpp"
  }
}

void far_cmpI_reg_imm0_loopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9611 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), zr, *(opnd_array(4)->label()), /* is_far */ true);
  
#line 15463 "ad_riscv.cpp"
  }
}

void far_cmpUEqNeLeGt_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9628 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ enc_cmpUEqNeLeGt_imm0_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), *(opnd_array(4)->label()), /* is_far */ true);
  
#line 15482 "ad_riscv.cpp"
  }
}

void far_cmpULtGe_reg_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {

#line 2322 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    Label* L = opnd_array(4)->label();
    switch (opnd_array(1)->ccode()) {
      case(BoolTest::ge):
        __ j(*L);
        break;
      case(BoolTest::lt):
        break;
      default:
        Unimplemented();
    }
  
#line 15510 "ad_riscv.cpp"
  }
}

void far_cmpL_reg_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9661 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), zr, *(opnd_array(4)->label()), /* is_far */ true);
  
#line 15529 "ad_riscv.cpp"
  }
}

void far_cmpL_reg_imm0_loopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9678 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ cmp_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), zr, *(opnd_array(4)->label()), /* is_far */ true);
  
#line 15548 "ad_riscv.cpp"
  }
}

void far_cmpULEqNeLeGt_reg_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9695 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ enc_cmpUEqNeLeGt_imm0_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), *(opnd_array(4)->label()), /* is_far */ true);
  
#line 15567 "ad_riscv.cpp"
  }
}

void far_cmpULLtGe_reg_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {

#line 2322 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    Label* L = opnd_array(4)->label();
    switch (opnd_array(1)->ccode()) {
      case(BoolTest::ge):
        __ j(*L);
        break;
      case(BoolTest::lt):
        break;
      default:
        Unimplemented();
    }
  
#line 15595 "ad_riscv.cpp"
  }
}

void far_cmpP_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9725 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ enc_cmpEqNe_imm0_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), *(opnd_array(4)->label()), /* is_far */ true);
  
#line 15614 "ad_riscv.cpp"
  }
}

void far_cmpN_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9740 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ enc_cmpEqNe_imm0_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), *(opnd_array(4)->label()), /* is_far */ true);
  
#line 15633 "ad_riscv.cpp"
  }
}

void far_cmpP_narrowOop_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9754 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ enc_cmpEqNe_imm0_branch(opnd_array(1)->ccode(), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), *(opnd_array(4)->label()), /* is_far */ true);
  
#line 15652 "ad_riscv.cpp"
  }
}

void cmovI_cmpINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// op2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9771 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ enc_cmove(opnd_array(1)->ccode(),
                 as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* op2 */),
                 as_Register(opnd_array(4)->reg(ra_,this,idx4)/* dst */), as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src */));
  
#line 15674 "ad_riscv.cpp"
  }
}

void cmovI_cmpUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// op2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9788 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ enc_cmove(opnd_array(1)->ccode()| C2_MacroAssembler::unsigned_branch_mask,
                 as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* op2 */),
                 as_Register(opnd_array(4)->reg(ra_,this,idx4)/* dst */), as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src */));
  
#line 15696 "ad_riscv.cpp"
  }
}

void cmovI_cmpLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// op2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9805 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ enc_cmove(opnd_array(1)->ccode(),
                 as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* op2 */),
                 as_Register(opnd_array(4)->reg(ra_,this,idx4)/* dst */), as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src */));
  
#line 15718 "ad_riscv.cpp"
  }
}

void cmovI_cmpULNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// op2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9822 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ enc_cmove(opnd_array(1)->ccode()| C2_MacroAssembler::unsigned_branch_mask,
                 as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* op2 */),
                 as_Register(opnd_array(4)->reg(ra_,this,idx4)/* dst */), as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src */));
  
#line 15740 "ad_riscv.cpp"
  }
}

void cmovL_cmpLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// op2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9839 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ enc_cmove(opnd_array(1)->ccode(),
                 as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* op2 */),
                 as_Register(opnd_array(4)->reg(ra_,this,idx4)/* dst */), as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src */));
  
#line 15762 "ad_riscv.cpp"
  }
}

void cmovL_cmpULNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// op2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9856 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ enc_cmove(opnd_array(1)->ccode()| C2_MacroAssembler::unsigned_branch_mask,
                 as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* op2 */),
                 as_Register(opnd_array(4)->reg(ra_,this,idx4)/* dst */), as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src */));
  
#line 15784 "ad_riscv.cpp"
  }
}

void cmovL_cmpINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// op2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9873 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ enc_cmove(opnd_array(1)->ccode(),
                 as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* op2 */),
                 as_Register(opnd_array(4)->reg(ra_,this,idx4)/* dst */), as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src */));
  
#line 15806 "ad_riscv.cpp"
  }
}

void cmovL_cmpUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// op2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 9890 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ enc_cmove(opnd_array(1)->ccode()| C2_MacroAssembler::unsigned_branch_mask,
                 as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* op2 */),
                 as_Register(opnd_array(4)->reg(ra_,this,idx4)/* dst */), as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src */));
  
#line 15828 "ad_riscv.cpp"
  }
}

void CallStaticJavaDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2365 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    Assembler::IncompressibleRegion ir(&_masm);  // Fixed length: see ret_addr_offset

    address addr = (address)opnd_array(1)->method();
    address call = NULL;
    assert_cond(addr != NULL);
    if (!_method) {
      // A call to a runtime wrapper, e.g. new, new_typeArray_Java, uncommon_trap.
      call = __ trampoline_call(Address(addr, relocInfo::runtime_call_type));
      if (call == NULL) {
        ciEnv::current()->record_failure("CodeCache is full");
        return;
      }
    } else if (_method->intrinsic_id() == vmIntrinsicID::_ensureMaterializedForStackWalk) {
      // The NOP here is purely to ensure that eliding a call to
      // JVM_EnsureMaterializedForStackWalk doesn't change the code size.
      __ nop();
      __ block_comment("call JVM_EnsureMaterializedForStackWalk (elided)");
    } else {
      int method_index = resolved_method_index(cbuf);
      RelocationHolder rspec = _optimized_virtual ? opt_virtual_call_Relocation::spec(method_index)
                                                  : static_call_Relocation::spec(method_index);
      call = __ trampoline_call(Address(addr, rspec));
      if (call == NULL) {
        ciEnv::current()->record_failure("CodeCache is full");
        return;
      }

      if (CodeBuffer::supports_shared_stubs() && _method->can_be_statically_bound()) {
        // Calls of the same statically bound method can share
        // a stub to the interpreter.
        cbuf.shared_stub_to_interp_for(_method, call - cbuf.insts_begin());
      } else {
        // Emit stub for static call
        address stub = CompiledStaticCall::emit_to_interp_stub(cbuf, call);
        if (stub == NULL) {
          ciEnv::current()->record_failure("CodeCache is full");
          return;
        }
      }
    }

    __ post_call_nop();
  
#line 15885 "ad_riscv.cpp"
  }
  {

#line 2424 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    if (VerifyStackAtCalls) {
      // Check that stack depth is unchanged: find majik cookie on stack
      __ call_Unimplemented();
    }
  
#line 15897 "ad_riscv.cpp"
  }
}

void CallDynamicJavaDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  {

#line 2411 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    Assembler::IncompressibleRegion ir(&_masm);  // Fixed length: see ret_addr_offset
    int method_index = resolved_method_index(cbuf);
    address call = __ ic_call((address)opnd_array(1)->method(), method_index);
    if (call == NULL) {
      ciEnv::current()->record_failure("CodeCache is full");
      return;
    }

    __ post_call_nop();
  
#line 15921 "ad_riscv.cpp"
  }
  {

#line 2424 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    if (VerifyStackAtCalls) {
      // Check that stack depth is unchanged: find majik cookie on stack
      __ call_Unimplemented();
    }
  
#line 15933 "ad_riscv.cpp"
  }
}

void CallRuntimeDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  {

#line 2432 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    Assembler::IncompressibleRegion ir(&_masm);  // Fixed length: see ret_addr_offset

    // some calls to generated routines (arraycopy code) are scheduled
    // by C2 as runtime calls. if so we can call them using a jr (they
    // will be in a reachable segment) otherwise we have to use a jalr
    // which loads the absolute address into a register.
    address entry = (address)opnd_array(1)->method();
    CodeBlob *cb = CodeCache::find_blob(entry);
    if (cb != NULL) {
      address call = __ trampoline_call(Address(entry, relocInfo::runtime_call_type));
      if (call == NULL) {
        ciEnv::current()->record_failure("CodeCache is full");
        return;
      }
      __ post_call_nop();
    } else {
      Label retaddr;
      __ la(t1, retaddr);
      __ la(t0, RuntimeAddress(entry));
      // Leave a breadcrumb for JavaFrameAnchor::capture_last_Java_pc()
      __ addi(sp, sp, -2 * wordSize);
      __ sd(t1, Address(sp, wordSize));
      __ jalr(t0);
      __ bind(retaddr);
      __ post_call_nop();
      __ addi(sp, sp, 2 * wordSize);
    }
  
#line 15975 "ad_riscv.cpp"
  }
}

void CallLeafDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  {

#line 2432 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    Assembler::IncompressibleRegion ir(&_masm);  // Fixed length: see ret_addr_offset

    // some calls to generated routines (arraycopy code) are scheduled
    // by C2 as runtime calls. if so we can call them using a jr (they
    // will be in a reachable segment) otherwise we have to use a jalr
    // which loads the absolute address into a register.
    address entry = (address)opnd_array(1)->method();
    CodeBlob *cb = CodeCache::find_blob(entry);
    if (cb != NULL) {
      address call = __ trampoline_call(Address(entry, relocInfo::runtime_call_type));
      if (call == NULL) {
        ciEnv::current()->record_failure("CodeCache is full");
        return;
      }
      __ post_call_nop();
    } else {
      Label retaddr;
      __ la(t1, retaddr);
      __ la(t0, RuntimeAddress(entry));
      // Leave a breadcrumb for JavaFrameAnchor::capture_last_Java_pc()
      __ addi(sp, sp, -2 * wordSize);
      __ sd(t1, Address(sp, wordSize));
      __ jalr(t0);
      __ bind(retaddr);
      __ post_call_nop();
      __ addi(sp, sp, 2 * wordSize);
    }
  
#line 16017 "ad_riscv.cpp"
  }
}

void CallLeafNoFPDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  {

#line 2432 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    Assembler::IncompressibleRegion ir(&_masm);  // Fixed length: see ret_addr_offset

    // some calls to generated routines (arraycopy code) are scheduled
    // by C2 as runtime calls. if so we can call them using a jr (they
    // will be in a reachable segment) otherwise we have to use a jalr
    // which loads the absolute address into a register.
    address entry = (address)opnd_array(1)->method();
    CodeBlob *cb = CodeCache::find_blob(entry);
    if (cb != NULL) {
      address call = __ trampoline_call(Address(entry, relocInfo::runtime_call_type));
      if (call == NULL) {
        ciEnv::current()->record_failure("CodeCache is full");
        return;
      }
      __ post_call_nop();
    } else {
      Label retaddr;
      __ la(t1, retaddr);
      __ la(t0, RuntimeAddress(entry));
      // Leave a breadcrumb for JavaFrameAnchor::capture_last_Java_pc()
      __ addi(sp, sp, -2 * wordSize);
      __ sd(t1, Address(sp, wordSize));
      __ jalr(t0);
      __ bind(retaddr);
      __ post_call_nop();
      __ addi(sp, sp, 2 * wordSize);
    }
  
#line 16059 "ad_riscv.cpp"
  }
}

void partialSubtypeCheckNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// sub
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// super
  {

#line 2338 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    Register sub_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* sub */);
    Register super_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* super */);
    Register temp_reg = as_Register(R12_enc);
    Register result_reg = as_Register(opnd_array(0)->reg(ra_,this)/* result */);
    Register cr_reg = t1;

    Label miss;
    Label done;
    C2_MacroAssembler _masm(&cbuf);
    __ check_klass_subtype_slow_path(sub_reg, super_reg, temp_reg, result_reg,
                                     NULL, &miss);
    if ((0x1 /*primary()*/)) {
      __ mv(result_reg, zr);
    } else {
      __ mv(cr_reg, zr);
      __ j(done);
    }

    __ bind(miss);
    if (!(0x1 /*primary()*/)) {
      __ mv(cr_reg, 1);
    }

    __ bind(done);
  
#line 16098 "ad_riscv.cpp"
  }
}

void partialSubtypeCheckVsZeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// sub
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// super
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  {

#line 2338 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    Register sub_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* sub */);
    Register super_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* super */);
    Register temp_reg = as_Register(R12_enc);
    Register result_reg = as_Register(R15_enc);
    Register cr_reg = t1;

    Label miss;
    Label done;
    C2_MacroAssembler _masm(&cbuf);
    __ check_klass_subtype_slow_path(sub_reg, super_reg, temp_reg, result_reg,
                                     NULL, &miss);
    if ((0x0 /*primary()*/)) {
      __ mv(result_reg, zr);
    } else {
      __ mv(cr_reg, zr);
      __ j(done);
    }

    __ bind(miss);
    if (!(0x0 /*primary()*/)) {
      __ mv(cr_reg, 1);
    }

    __ bind(done);
  
#line 16138 "ad_riscv.cpp"
  }
}

void string_compareUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10042 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    // Count is in 8-bit bytes; non-Compact chars are 16 bits.
    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      as_Register(R28_enc), as_Register(R29_enc), as_Register(R30_enc),
                      StrIntrinsicNode::UU);
  
#line 16161 "ad_riscv.cpp"
  }
}

void string_compareLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10060 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      as_Register(R28_enc), as_Register(R29_enc), as_Register(R30_enc),
                      StrIntrinsicNode::LL);
  
#line 16183 "ad_riscv.cpp"
  }
}

void string_compareULNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10077 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      as_Register(R28_enc), as_Register(R29_enc), as_Register(R30_enc),
                      StrIntrinsicNode::UL);
  
#line 16205 "ad_riscv.cpp"
  }
}

void string_compareLUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10095 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      as_Register(R28_enc), as_Register(R29_enc), as_Register(R30_enc),
                      StrIntrinsicNode::LU);
  
#line 16227 "ad_riscv.cpp"
  }
}

void string_indexofUUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// result
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp1
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp2
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp3
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// tmp4
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// tmp5
  unsigned idx11 = idx10 + opnd_array(10)->num_edges(); 	// tmp6
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10114 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */,
                      opnd_array(6)->as_Register(ra_,this,idx6)/* tmp1 */, opnd_array(7)->as_Register(ra_,this,idx7)/* tmp2 */,
                      opnd_array(8)->as_Register(ra_,this,idx8)/* tmp3 */, opnd_array(9)->as_Register(ra_,this,idx9)/* tmp4 */,
                      opnd_array(10)->as_Register(ra_,this,idx10)/* tmp5 */, opnd_array(11)->as_Register(ra_,this,idx11)/* tmp6 */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* result */, StrIntrinsicNode::UU);
  
#line 16258 "ad_riscv.cpp"
  }
}

void string_indexofLLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// result
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp1
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp2
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp3
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// tmp4
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// tmp5
  unsigned idx11 = idx10 + opnd_array(10)->num_edges(); 	// tmp6
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10135 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */,
                      opnd_array(6)->as_Register(ra_,this,idx6)/* tmp1 */, opnd_array(7)->as_Register(ra_,this,idx7)/* tmp2 */,
                      opnd_array(8)->as_Register(ra_,this,idx8)/* tmp3 */, opnd_array(9)->as_Register(ra_,this,idx9)/* tmp4 */,
                      opnd_array(10)->as_Register(ra_,this,idx10)/* tmp5 */, opnd_array(11)->as_Register(ra_,this,idx11)/* tmp6 */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* result */, StrIntrinsicNode::LL);
  
#line 16289 "ad_riscv.cpp"
  }
}

void string_indexofULNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// result
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp1
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp2
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp3
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// tmp4
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// tmp5
  unsigned idx11 = idx10 + opnd_array(10)->num_edges(); 	// tmp6
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10156 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */,
                      opnd_array(6)->as_Register(ra_,this,idx6)/* tmp1 */, opnd_array(7)->as_Register(ra_,this,idx7)/* tmp2 */,
                      opnd_array(8)->as_Register(ra_,this,idx8)/* tmp3 */, opnd_array(9)->as_Register(ra_,this,idx9)/* tmp4 */,
                      opnd_array(10)->as_Register(ra_,this,idx10)/* tmp5 */, opnd_array(11)->as_Register(ra_,this,idx11)/* tmp6 */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* result */, StrIntrinsicNode::UL);
  
#line 16320 "ad_riscv.cpp"
  }
}

void string_indexof_conUUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// int_cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// result
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp1
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp2
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp3
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// tmp4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10178 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    int icnt2 = (int)opnd_array(4)->constant();
    __ string_indexof_linearscan(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                                 opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, zr,
                                 opnd_array(6)->as_Register(ra_,this,idx6)/* tmp1 */, opnd_array(7)->as_Register(ra_,this,idx7)/* tmp2 */,
                                 opnd_array(8)->as_Register(ra_,this,idx8)/* tmp3 */, opnd_array(9)->as_Register(ra_,this,idx9)/* tmp4 */,
                                 icnt2, opnd_array(5)->as_Register(ra_,this,idx5)/* result */, StrIntrinsicNode::UU);
  
#line 16349 "ad_riscv.cpp"
  }
}

void string_indexof_conLLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// int_cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// result
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp1
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp2
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp3
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// tmp4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10199 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    int icnt2 = (int)opnd_array(4)->constant();
    __ string_indexof_linearscan(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                                 opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, zr,
                                 opnd_array(6)->as_Register(ra_,this,idx6)/* tmp1 */, opnd_array(7)->as_Register(ra_,this,idx7)/* tmp2 */,
                                 opnd_array(8)->as_Register(ra_,this,idx8)/* tmp3 */, opnd_array(9)->as_Register(ra_,this,idx9)/* tmp4 */,
                                 icnt2, opnd_array(5)->as_Register(ra_,this,idx5)/* result */, StrIntrinsicNode::LL);
  
#line 16378 "ad_riscv.cpp"
  }
}

void string_indexof_conULNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// int_cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// result
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp1
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp2
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp3
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// tmp4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10220 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    int icnt2 = (int)opnd_array(4)->constant();
    __ string_indexof_linearscan(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                                 opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, zr,
                                 opnd_array(6)->as_Register(ra_,this,idx6)/* tmp1 */, opnd_array(7)->as_Register(ra_,this,idx7)/* tmp2 */,
                                 opnd_array(8)->as_Register(ra_,this,idx8)/* tmp3 */, opnd_array(9)->as_Register(ra_,this,idx9)/* tmp4 */,
                                 icnt2, opnd_array(5)->as_Register(ra_,this,idx5)/* result */, StrIntrinsicNode::UL);
  
#line 16407 "ad_riscv.cpp"
  }
}

void stringU_indexof_charNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ch
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// result
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10241 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ string_indexof_char(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* ch */,
                           opnd_array(4)->as_Register(ra_,this,idx4)/* result */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                           opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */, opnd_array(8)->as_Register(ra_,this,idx8)/* tmp4 */, false /* isU */);
  
#line 16432 "ad_riscv.cpp"
  }
}

void stringL_indexof_charNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ch
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// result
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10260 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ string_indexof_char(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* ch */,
                           opnd_array(4)->as_Register(ra_,this,idx4)/* result */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                           opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */, opnd_array(8)->as_Register(ra_,this,idx8)/* tmp4 */, true /* isL */);
  
#line 16457 "ad_riscv.cpp"
  }
}

void clearArray_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cnt
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10280 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    address tpc = __ zero_words(opnd_array(2)->as_Register(ra_,this,idx2)/* base */, opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */);
    if (tpc == NULL) {
      ciEnv::current()->record_failure("CodeCache is full");
      return;
    }
  
#line 16480 "ad_riscv.cpp"
  }
}

void clearArray_imm_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cnt
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10301 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ zero_words(opnd_array(2)->as_Register(ra_,this,idx2)/* base */, (uint64_t)opnd_array(1)->constantL());
  
#line 16497 "ad_riscv.cpp"
  }
}

void string_equalsLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// str2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cnt
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10316 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    // Count is in 8-bit bytes; non-Compact chars are 16 bits.
    __ string_equals(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* str2 */,
                     opnd_array(0)->as_Register(ra_,this)/* result */, opnd_array(3)->as_Register(ra_,this,idx3)/* cnt */, 1);
  
#line 16517 "ad_riscv.cpp"
  }
}

void string_equalsUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// str2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cnt
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10332 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    // Count is in 8-bit bytes; non-Compact chars are 16 bits.
    __ string_equals(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* str2 */,
                     opnd_array(0)->as_Register(ra_,this)/* result */, opnd_array(3)->as_Register(ra_,this,idx3)/* cnt */, 2);
  
#line 16537 "ad_riscv.cpp"
  }
}

void array_equalsBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// ary1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// ary2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp3
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10349 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ arrays_equals(opnd_array(1)->as_Register(ra_,this,idx1)/* ary1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* ary2 */,
                     opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp3 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp4 */,
                     opnd_array(0)->as_Register(ra_,this)/* result */, as_Register(R28_enc), 1);
  
#line 16560 "ad_riscv.cpp"
  }
}

void array_equalsCNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// ary1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// ary2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp3
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp4
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10366 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ arrays_equals(opnd_array(1)->as_Register(ra_,this,idx1)/* ary1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* ary2 */,
                     opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp3 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp4 */,
                     opnd_array(0)->as_Register(ra_,this)/* result */, as_Register(R28_enc), 2);
  
#line 16583 "ad_riscv.cpp"
  }
}

void safePointNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10385 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ read_polling_page(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* poll */), 0, relocInfo::poll_type);
  
#line 16599 "ad_riscv.cpp"
  }
}

void tlsLoadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint tlsLoadPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void cmpFastLockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// object
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// box
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10420 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fast_lock(opnd_array(1)->as_Register(ra_,this,idx1)/* object */, opnd_array(2)->as_Register(ra_,this,idx2)/* box */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp3 */);
  
#line 16632 "ad_riscv.cpp"
  }
}

void cmpFastUnlockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// object
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// box
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10436 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    __ fast_unlock(opnd_array(1)->as_Register(ra_,this,idx1)/* object */, opnd_array(2)->as_Register(ra_,this,idx2)/* box */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */);
  
#line 16651 "ad_riscv.cpp"
  }
}

void TailCalljmpIndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// method_oop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// 
  {

#line 2529 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register target_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* jump_target */);
    __ jr(target_reg);
  
#line 16669 "ad_riscv.cpp"
  }
}

void TailjmpIndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// ex_oop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// 
  {

#line 2535 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    Register target_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* jump_target */);
    // exception oop should be in x10
    // ret addr has been popped into ra
    // callee expects it in x13
    __ mv(x13, ra);
    __ jr(target_reg);
  
#line 16691 "ad_riscv.cpp"
  }
}

void CreateExceptionNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint CreateExceptionNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void RethrowExceptionNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {

#line 2545 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    __ far_jump(RuntimeAddress(OptoRuntime::rethrow_stub()));
  
#line 16720 "ad_riscv.cpp"
  }
}

void RetNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {

#line 2550 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    C2_MacroAssembler _masm(&cbuf);
    __ ret();
  
#line 16736 "ad_riscv.cpp"
  }
}

void ShouldNotReachHereNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 10527 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    if (is_reachable()) {
      __ stop(_halt_reason);
    }
  
#line 16754 "ad_riscv.cpp"
  }
}

void loadVNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    C2_MacroAssembler _masm(&cbuf);

#line 106 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    VectorRegister dst_reg = as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), false, dst_reg,
              Matcher::vector_element_basic_type(this), as_Register(opnd_array(1)->base(ra_,this,idx1)), Matcher::vector_length(this));
  
#line 16772 "ad_riscv.cpp"
  }
}

void storeVNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 118 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    VectorRegister src_reg = as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(C2_MacroAssembler(&cbuf), true, src_reg,
              Matcher::vector_element_basic_type(this, opnd_array(2)), as_Register(opnd_array(1)->base(ra_,this,idx1)), Matcher::vector_length(this, opnd_array(2)));
  
#line 16791 "ad_riscv.cpp"
  }
}

void vloadmaskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 131 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_BOOLEAN, Matcher::vector_length(this));
    __ vmsne_vx(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), zr);
  
#line 16808 "ad_riscv.cpp"
  }
}

void vloadmask_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 141 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_BOOLEAN, Matcher::vector_length(this));
    __ vmsne_vx(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), zr, Assembler::v0_t);
  
#line 16826 "ad_riscv.cpp"
  }
}

void vstoremaskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// v0
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  {
    C2_MacroAssembler _masm(&cbuf);

#line 153 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_BOOLEAN, Matcher::vector_length(this));
    __ vxor_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */));
    __ vmerge_vim(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), 1);
  
#line 16845 "ad_riscv.cpp"
  }
}

void vmaskcmpNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {
    C2_MacroAssembler _masm(&cbuf);

#line 170 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint vector_length = Matcher::vector_length(this);
    __ compare_integral_v(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */),
                          as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                          (int)(opnd_array(3)->constant()), bt, vector_length);
  
#line 16867 "ad_riscv.cpp"
  }
}

void vmaskcmp_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 188 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint vector_length = Matcher::vector_length(this);
    __ compare_integral_v(as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* dst */),
                          as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                          (int)(opnd_array(3)->constant()), bt, vector_length, Assembler::v0_t);
  
#line 16891 "ad_riscv.cpp"
  }
}

void vmaskcmp_fpNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 206 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint vector_length = Matcher::vector_length(this);
    __ compare_fp_v(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* dst */),
                    as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                    (int)(opnd_array(3)->constant()), bt, vector_length);
  
#line 16914 "ad_riscv.cpp"
  }
}

void vmaskcmp_fp_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 222 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    uint vector_length = Matcher::vector_length(this);
    __ compare_fp_v(as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* dst */),
                    as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                    (int)(opnd_array(3)->constant()), bt, vector_length, Assembler::v0_t);
  
#line 16938 "ad_riscv.cpp"
  }
}

void vabsNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 242 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vrsub_vi(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), 0);
    __ vmax_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16958 "ad_riscv.cpp"
  }
}

void vabs_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 242 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vrsub_vi(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), 0);
    __ vmax_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16978 "ad_riscv.cpp"
  }
}

void vabs_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 242 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vrsub_vi(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), 0);
    __ vmax_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 16998 "ad_riscv.cpp"
  }
}

void vabs_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 242 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vrsub_vi(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), 0);
    __ vmax_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 17018 "ad_riscv.cpp"
  }
}

void vabs_fpNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 256 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfabs_v(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 17036 "ad_riscv.cpp"
  }
}

void vabs_fp_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 256 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfabs_v(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 17054 "ad_riscv.cpp"
  }
}

void vabs_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// v0
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 274 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vrsub_vi(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), 0,
                Assembler::v0_t);
    __ vmax_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), Assembler::v0_t);
  
#line 17077 "ad_riscv.cpp"
  }
}

void vabs_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// v0
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 274 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vrsub_vi(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), 0,
                Assembler::v0_t);
    __ vmax_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), Assembler::v0_t);
  
#line 17100 "ad_riscv.cpp"
  }
}

void vabs_masked_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// v0
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 274 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vrsub_vi(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), 0,
                Assembler::v0_t);
    __ vmax_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), Assembler::v0_t);
  
#line 17123 "ad_riscv.cpp"
  }
}

void vabs_masked_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// v0
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 274 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vrsub_vi(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), 0,
                Assembler::v0_t);
    __ vmax_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), Assembler::v0_t);
  
#line 17146 "ad_riscv.cpp"
  }
}

void vabs_fp_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 290 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfabs_v(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), Assembler::v0_t);
  
#line 17165 "ad_riscv.cpp"
  }
}

void vabs_fp_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 290 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfabs_v(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), Assembler::v0_t);
  
#line 17184 "ad_riscv.cpp"
  }
}

void vaddNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 307 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vadd_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 17205 "ad_riscv.cpp"
  }
}

void vadd_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 307 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vadd_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 17226 "ad_riscv.cpp"
  }
}

void vadd_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 307 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vadd_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 17247 "ad_riscv.cpp"
  }
}

void vadd_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 307 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vadd_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 17268 "ad_riscv.cpp"
  }
}

void vadd_fpNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 322 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfadd_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */),
                as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
                as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 17289 "ad_riscv.cpp"
  }
}

void vadd_fp_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 322 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfadd_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */),
                as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
                as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 17310 "ad_riscv.cpp"
  }
}

void vadd_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 341 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vadd_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Assembler::v0_t);
  
#line 17332 "ad_riscv.cpp"
  }
}

void vadd_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 341 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vadd_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Assembler::v0_t);
  
#line 17354 "ad_riscv.cpp"
  }
}

void vadd_masked_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 341 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vadd_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Assembler::v0_t);
  
#line 17376 "ad_riscv.cpp"
  }
}

void vadd_masked_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 341 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vadd_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Assembler::v0_t);
  
#line 17398 "ad_riscv.cpp"
  }
}

void vadd_fp_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 356 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfadd_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Assembler::v0_t);
  
#line 17420 "ad_riscv.cpp"
  }
}

void vadd_fp_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 356 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfadd_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Assembler::v0_t);
  
#line 17442 "ad_riscv.cpp"
  }
}

void vsubNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 375 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vsub_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 17462 "ad_riscv.cpp"
  }
}

void vsub_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 375 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vsub_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 17482 "ad_riscv.cpp"
  }
}

void vsub_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 375 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vsub_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 17502 "ad_riscv.cpp"
  }
}

void vsub_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 375 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vsub_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 17522 "ad_riscv.cpp"
  }
}

void vsub_fpNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 389 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfsub_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
                as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 17542 "ad_riscv.cpp"
  }
}

void vsub_fp_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 389 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfsub_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
                as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 17562 "ad_riscv.cpp"
  }
}

void vsub_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 407 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vsub_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Assembler::v0_t);
  
#line 17583 "ad_riscv.cpp"
  }
}

void vsub_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 407 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vsub_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Assembler::v0_t);
  
#line 17604 "ad_riscv.cpp"
  }
}

void vsub_masked_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 407 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vsub_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Assembler::v0_t);
  
#line 17625 "ad_riscv.cpp"
  }
}

void vsub_masked_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 407 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vsub_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Assembler::v0_t);
  
#line 17646 "ad_riscv.cpp"
  }
}

void vsub_fp_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 421 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfsub_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Assembler::v0_t);
  
#line 17667 "ad_riscv.cpp"
  }
}

void vsub_fp_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 421 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfsub_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Assembler::v0_t);
  
#line 17688 "ad_riscv.cpp"
  }
}

void vandNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 436 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vand_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 17709 "ad_riscv.cpp"
  }
}

void vand_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 452 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vand_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Assembler::v0_t);
  
#line 17731 "ad_riscv.cpp"
  }
}

void vorNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 468 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vor_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 17752 "ad_riscv.cpp"
  }
}

void vor_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 484 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vor_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
              as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
              as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Assembler::v0_t);
  
#line 17774 "ad_riscv.cpp"
  }
}

void vxorNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 500 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vxor_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 17795 "ad_riscv.cpp"
  }
}

void vxor_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 516 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vxor_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Assembler::v0_t);
  
#line 17817 "ad_riscv.cpp"
  }
}

void vdiv_fpNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 533 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfdiv_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */),
                as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
                as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 17838 "ad_riscv.cpp"
  }
}

void vdiv_fp_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 533 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfdiv_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */),
                as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
                as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 17859 "ad_riscv.cpp"
  }
}

void vdiv_fp_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 550 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfdiv_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Assembler::v0_t);
  
#line 17881 "ad_riscv.cpp"
  }
}

void vdiv_fp_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 550 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfdiv_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Assembler::v0_t);
  
#line 17903 "ad_riscv.cpp"
  }
}

void vmaxNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 568 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmax_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 17923 "ad_riscv.cpp"
  }
}

void vminNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 583 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmin_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 17943 "ad_riscv.cpp"
  }
}

void vmax_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 600 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmax_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Assembler::v0_t);
  
#line 17964 "ad_riscv.cpp"
  }
}

void vmin_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 615 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmin_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Assembler::v0_t);
  
#line 17985 "ad_riscv.cpp"
  }
}

void vmax_fpNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 633 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ minmax_fp_v(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */),
                   as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                   bt, false /* is_min */, Matcher::vector_length(this));
  
#line 18007 "ad_riscv.cpp"
  }
}

void vmin_fpNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 649 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ minmax_fp_v(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */),
                   as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                   bt, true /* is_min */, Matcher::vector_length(this));
  
#line 18029 "ad_riscv.cpp"
  }
}

void vmax_fp_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vmask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 667 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ minmax_fp_masked_v(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                          as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* vmask */),
                          as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp1 */), as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* tmp2 */),
                          bt, false /* is_min */, Matcher::vector_length(this));
  
#line 18054 "ad_riscv.cpp"
  }
}

void vmin_fp_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vmask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 684 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ minmax_fp_masked_v(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                          as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* vmask */),
                          as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp1 */), as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* tmp2 */),
                          bt, true /* is_min */, Matcher::vector_length(this));
  
#line 18079 "ad_riscv.cpp"
  }
}

void vfmlaNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 702 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfmacc_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                 as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 18101 "ad_riscv.cpp"
  }
}

void vfmla_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 702 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfmacc_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                 as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 18123 "ad_riscv.cpp"
  }
}

void vfmadd_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 719 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfmadd_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                 as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */), Assembler::v0_t);
  
#line 18146 "ad_riscv.cpp"
  }
}

void vfmadd_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 719 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfmadd_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                 as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */), Assembler::v0_t);
  
#line 18169 "ad_riscv.cpp"
  }
}

void vfmlsFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 737 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ vsetvli_helper(T_FLOAT, Matcher::vector_length(this));
    __ vfnmsac_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                  as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 18190 "ad_riscv.cpp"
  }
}

void vfmlsDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 752 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ vsetvli_helper(T_DOUBLE, Matcher::vector_length(this));
    __ vfnmsac_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                  as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 18211 "ad_riscv.cpp"
  }
}

void vfnmsub_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 768 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfnmsub_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                  as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */), Assembler::v0_t);
  
#line 18234 "ad_riscv.cpp"
  }
}

void vfnmsub_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 768 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfnmsub_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                  as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */), Assembler::v0_t);
  
#line 18257 "ad_riscv.cpp"
  }
}

void vfnmlaFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 786 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ vsetvli_helper(T_FLOAT, Matcher::vector_length(this));
    __ vfnmacc_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                  as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 18278 "ad_riscv.cpp"
  }
}

void vfnmlaDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 801 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ vsetvli_helper(T_DOUBLE, Matcher::vector_length(this));
    __ vfnmacc_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                  as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 18299 "ad_riscv.cpp"
  }
}

void vfnmadd_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 817 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfnmadd_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                  as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */), Assembler::v0_t);
  
#line 18322 "ad_riscv.cpp"
  }
}

void vfnmadd_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 817 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfnmadd_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                  as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */), Assembler::v0_t);
  
#line 18345 "ad_riscv.cpp"
  }
}

void vfnmlsFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 834 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ vsetvli_helper(T_FLOAT, Matcher::vector_length(this));
    __ vfmsac_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                 as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 18366 "ad_riscv.cpp"
  }
}

void vfnmlsDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 848 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ vsetvli_helper(T_DOUBLE, Matcher::vector_length(this));
    __ vfmsac_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                 as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 18387 "ad_riscv.cpp"
  }
}

void vfmsub_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 864 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfmsub_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                 as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */), Assembler::v0_t);
  
#line 18410 "ad_riscv.cpp"
  }
}

void vfmsub_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 864 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfmsub_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                 as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */), Assembler::v0_t);
  
#line 18433 "ad_riscv.cpp"
  }
}

void vmlaNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 884 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmacc_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 18454 "ad_riscv.cpp"
  }
}

void vmla_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst_src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 884 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmacc_vv(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst_src1 */),
                as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src3 */));
  
#line 18475 "ad_riscv.cpp"
  }
}

void vmla_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 884 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmacc_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 18496 "ad_riscv.cpp"
  }
}

void vmla_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst_src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 884 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmacc_vv(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst_src1 */),
                as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src3 */));
  
#line 18517 "ad_riscv.cpp"
  }
}

void vmla_3Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 884 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmacc_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 18538 "ad_riscv.cpp"
  }
}

void vmla_4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst_src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 884 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmacc_vv(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst_src1 */),
                as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src3 */));
  
#line 18559 "ad_riscv.cpp"
  }
}

void vmla_5Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 884 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmacc_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 18580 "ad_riscv.cpp"
  }
}

void vmla_6Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst_src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 884 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmacc_vv(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst_src1 */),
                as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src3 */));
  
#line 18601 "ad_riscv.cpp"
  }
}

void vmla_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 901 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmacc_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */), Assembler::v0_t);
  
#line 18623 "ad_riscv.cpp"
  }
}

void vmla_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 901 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmacc_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */), Assembler::v0_t);
  
#line 18645 "ad_riscv.cpp"
  }
}

void vmla_masked_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 901 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmacc_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */), Assembler::v0_t);
  
#line 18667 "ad_riscv.cpp"
  }
}

void vmla_masked_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 901 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmacc_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */), Assembler::v0_t);
  
#line 18689 "ad_riscv.cpp"
  }
}

void vmlsNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 920 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vnmsac_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                 as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 18710 "ad_riscv.cpp"
  }
}

void vmls_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 920 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vnmsac_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                 as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 18731 "ad_riscv.cpp"
  }
}

void vmls_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 920 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vnmsac_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                 as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 18752 "ad_riscv.cpp"
  }
}

void vmls_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    C2_MacroAssembler _masm(&cbuf);

#line 920 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vnmsac_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                 as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 18773 "ad_riscv.cpp"
  }
}

void vmls_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 937 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vnmsac_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                 as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */), Assembler::v0_t);
  
#line 18795 "ad_riscv.cpp"
  }
}

void vmls_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 937 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vnmsac_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                 as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */), Assembler::v0_t);
  
#line 18817 "ad_riscv.cpp"
  }
}

void vmls_masked_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 937 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vnmsac_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                 as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */), Assembler::v0_t);
  
#line 18839 "ad_riscv.cpp"
  }
}

void vmls_masked_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 937 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vnmsac_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                 as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* src3 */), Assembler::v0_t);
  
#line 18861 "ad_riscv.cpp"
  }
}

void vmulNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 955 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmul_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 18881 "ad_riscv.cpp"
  }
}

void vmul_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 955 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmul_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 18901 "ad_riscv.cpp"
  }
}

void vmul_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 955 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmul_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 18921 "ad_riscv.cpp"
  }
}

void vmul_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 955 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmul_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 18941 "ad_riscv.cpp"
  }
}

void vmul_fpNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 969 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfmul_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
                as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 18961 "ad_riscv.cpp"
  }
}

void vmul_fp_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 969 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfmul_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
                as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 18981 "ad_riscv.cpp"
  }
}

void vmul_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 987 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmul_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Assembler::v0_t);
  
#line 19002 "ad_riscv.cpp"
  }
}

void vmul_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 987 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmul_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Assembler::v0_t);
  
#line 19023 "ad_riscv.cpp"
  }
}

void vmul_masked_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 987 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmul_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Assembler::v0_t);
  
#line 19044 "ad_riscv.cpp"
  }
}

void vmul_masked_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 987 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmul_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Assembler::v0_t);
  
#line 19065 "ad_riscv.cpp"
  }
}

void vmul_fp_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1001 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfmul_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Assembler::v0_t);
  
#line 19086 "ad_riscv.cpp"
  }
}

void vmul_fp_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1001 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfmul_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src1 */),
                as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), Assembler::v0_t);
  
#line 19107 "ad_riscv.cpp"
  }
}

void vnegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1017 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vneg_v(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 19125 "ad_riscv.cpp"
  }
}

void vneg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1017 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vneg_v(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 19143 "ad_riscv.cpp"
  }
}

void vneg_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1032 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vneg_v(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */),
              Assembler::v0_t);
  
#line 19163 "ad_riscv.cpp"
  }
}

void vneg_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1032 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vneg_v(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */),
              Assembler::v0_t);
  
#line 19183 "ad_riscv.cpp"
  }
}

void vfnegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1048 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfneg_v(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 19201 "ad_riscv.cpp"
  }
}

void vfneg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1048 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfneg_v(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 19219 "ad_riscv.cpp"
  }
}

void vfneg_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1063 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfneg_v(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */),
               Assembler::v0_t);
  
#line 19239 "ad_riscv.cpp"
  }
}

void vfneg_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1063 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfneg_v(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */),
               Assembler::v0_t);
  
#line 19259 "ad_riscv.cpp"
  }
}

void reduce_andINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1082 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ reduce_integral_v(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
                         as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */),
                         this->ideal_Opcode(), bt, Matcher::vector_length(this, opnd_array(2)));
  
#line 19280 "ad_riscv.cpp"
  }
}

void reduce_andLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1097 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ reduce_integral_v(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
                         as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */),
                         this->ideal_Opcode(), bt, Matcher::vector_length(this, opnd_array(2)));
  
#line 19301 "ad_riscv.cpp"
  }
}

void reduce_andI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1116 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ reduce_integral_v(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
                         as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */),
                         this->ideal_Opcode(), bt, Matcher::vector_length(this, opnd_array(2)),
                         Assembler::v0_t);
  
#line 19324 "ad_riscv.cpp"
  }
}

void reduce_andL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1132 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ reduce_integral_v(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
                         as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */),
                         this->ideal_Opcode(), bt, Matcher::vector_length(this, opnd_array(2)),
                         Assembler::v0_t);
  
#line 19347 "ad_riscv.cpp"
  }
}

void reduce_orINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1152 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ reduce_integral_v(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
                         as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */),
                         this->ideal_Opcode(), bt, Matcher::vector_length(this, opnd_array(2)));
  
#line 19368 "ad_riscv.cpp"
  }
}

void reduce_orLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1167 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ reduce_integral_v(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
                         as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */),
                         this->ideal_Opcode(), bt, Matcher::vector_length(this, opnd_array(2)));
  
#line 19389 "ad_riscv.cpp"
  }
}

void reduce_orI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1186 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ reduce_integral_v(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
                         as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */),
                         this->ideal_Opcode(), bt, Matcher::vector_length(this, opnd_array(2)),
                         Assembler::v0_t);
  
#line 19412 "ad_riscv.cpp"
  }
}

void reduce_orL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1202 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ reduce_integral_v(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
                         as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */),
                         this->ideal_Opcode(), bt, Matcher::vector_length(this, opnd_array(2)),
                         Assembler::v0_t);
  
#line 19435 "ad_riscv.cpp"
  }
}

void reduce_xorINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1222 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ reduce_integral_v(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
                         as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */),
                         this->ideal_Opcode(), bt, Matcher::vector_length(this, opnd_array(2)));
  
#line 19456 "ad_riscv.cpp"
  }
}

void reduce_xorLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1237 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ reduce_integral_v(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
                         as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */),
                         this->ideal_Opcode(), bt, Matcher::vector_length(this, opnd_array(2)));
  
#line 19477 "ad_riscv.cpp"
  }
}

void reduce_xorI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1256 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ reduce_integral_v(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
                         as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */),
                         this->ideal_Opcode(), bt, Matcher::vector_length(this, opnd_array(2)),
                         Assembler::v0_t);
  
#line 19500 "ad_riscv.cpp"
  }
}

void reduce_xorL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1272 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ reduce_integral_v(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
                         as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */),
                         this->ideal_Opcode(), bt, Matcher::vector_length(this, opnd_array(2)),
                         Assembler::v0_t);
  
#line 19523 "ad_riscv.cpp"
  }
}

void reduce_addINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1292 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ reduce_integral_v(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
                         as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */),
                         this->ideal_Opcode(), bt, Matcher::vector_length(this, opnd_array(2)));
  
#line 19544 "ad_riscv.cpp"
  }
}

void reduce_addLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1307 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ reduce_integral_v(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
                         as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */),
                         this->ideal_Opcode(), bt, Matcher::vector_length(this, opnd_array(2)));
  
#line 19565 "ad_riscv.cpp"
  }
}

void reduce_addFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1321 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_FLOAT, Matcher::vector_length(this, opnd_array(2)));
    __ vfmv_s_f(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */);
    __ vfredosum_vs(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                    as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */));
    __ vfmv_f_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */));
  
#line 19587 "ad_riscv.cpp"
  }
}

void reduce_addDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1336 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_DOUBLE, Matcher::vector_length(this, opnd_array(2)));
    __ vfmv_s_f(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */);
    __ vfredosum_vs(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                    as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */));
    __ vfmv_f_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */));
  
#line 19609 "ad_riscv.cpp"
  }
}

void reduce_addI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1356 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ reduce_integral_v(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
                         as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */),
                         this->ideal_Opcode(), bt, Matcher::vector_length(this, opnd_array(2)),
                         Assembler::v0_t);
  
#line 19632 "ad_riscv.cpp"
  }
}

void reduce_addL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1372 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ reduce_integral_v(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
                         as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */),
                         this->ideal_Opcode(), bt, Matcher::vector_length(this, opnd_array(2)),
                         Assembler::v0_t);
  
#line 19655 "ad_riscv.cpp"
  }
}

void reduce_addF_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1387 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_FLOAT, Matcher::vector_length(this, opnd_array(2)));
    __ vfmv_s_f(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */);
    __ vfredosum_vs(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                    as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */), Assembler::v0_t);
    __ vfmv_f_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */));
  
#line 19678 "ad_riscv.cpp"
  }
}

void reduce_addD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1402 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_DOUBLE, Matcher::vector_length(this, opnd_array(2)));
    __ vfmv_s_f(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */);
    __ vfredosum_vs(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                    as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */), Assembler::v0_t);
    __ vfmv_f_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */));
  
#line 19701 "ad_riscv.cpp"
  }
}

void vreduce_maxINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1422 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ reduce_integral_v(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
                         as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */),
                         this->ideal_Opcode(), bt, Matcher::vector_length(this, opnd_array(2)));
  
#line 19722 "ad_riscv.cpp"
  }
}

void vreduce_maxLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1437 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ reduce_integral_v(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
                         as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */),
                         this->ideal_Opcode(), bt, Matcher::vector_length(this, opnd_array(2)));
  
#line 19743 "ad_riscv.cpp"
  }
}

void vreduce_maxI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1456 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ reduce_integral_v(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
                         as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */),
                         this->ideal_Opcode(), bt, Matcher::vector_length(this, opnd_array(2)),
                         Assembler::v0_t);
  
#line 19766 "ad_riscv.cpp"
  }
}

void vreduce_maxL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1472 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ reduce_integral_v(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
                         as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */),
                         this->ideal_Opcode(), bt, Matcher::vector_length(this, opnd_array(2)),
                         Assembler::v0_t);
  
#line 19789 "ad_riscv.cpp"
  }
}

void vreduce_minINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1492 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ reduce_integral_v(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
                         as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */),
                         this->ideal_Opcode(), bt, Matcher::vector_length(this, opnd_array(2)));
  
#line 19810 "ad_riscv.cpp"
  }
}

void vreduce_minLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1507 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ reduce_integral_v(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
                         as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */),
                         this->ideal_Opcode(), bt, Matcher::vector_length(this, opnd_array(2)));
  
#line 19831 "ad_riscv.cpp"
  }
}

void vreduce_minI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1526 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ reduce_integral_v(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
                         as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */),
                         this->ideal_Opcode(), bt, Matcher::vector_length(this, opnd_array(2)),
                         Assembler::v0_t);
  
#line 19854 "ad_riscv.cpp"
  }
}

void vreduce_minL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1542 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ reduce_integral_v(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */,
                         as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */),
                         this->ideal_Opcode(), bt, Matcher::vector_length(this, opnd_array(2)),
                         Assembler::v0_t);
  
#line 19877 "ad_riscv.cpp"
  }
}

void vreduce_maxFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1560 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ reduce_minmax_fp_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */,
                          opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                          as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp1 */), as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* tmp2 */),
                          false /* is_double */, false /* is_min */, Matcher::vector_length(this, opnd_array(2)));
  
#line 19900 "ad_riscv.cpp"
  }
}

void vreduce_maxDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1575 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ reduce_minmax_fp_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */,
                          opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                          as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp1 */), as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* tmp2 */),
                          true /* is_double */, false /* is_min */, Matcher::vector_length(this, opnd_array(2)));
  
#line 19923 "ad_riscv.cpp"
  }
}

void vreduce_maxF_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1592 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ reduce_minmax_fp_v(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */,
                          opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                          as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* tmp1 */), as_VectorRegister(opnd_array(6)->reg(ra_,this,idx6)/* tmp2 */),
                          false /* is_double */, false /* is_min */,
                          Matcher::vector_length(this, opnd_array(2)), Assembler::v0_t);
  
#line 19948 "ad_riscv.cpp"
  }
}

void vreduce_maxD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1608 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ reduce_minmax_fp_v(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */,
                          opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                          as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* tmp1 */), as_VectorRegister(opnd_array(6)->reg(ra_,this,idx6)/* tmp2 */),
                          true /* is_double */, false /* is_min */,
                          Matcher::vector_length(this, opnd_array(2)), Assembler::v0_t);
  
#line 19973 "ad_riscv.cpp"
  }
}

void vreduce_minFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1626 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ reduce_minmax_fp_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */,
                          opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                          as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp1 */), as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* tmp2 */),
                          false /* is_double */, true /* is_min */, Matcher::vector_length(this, opnd_array(2)));
  
#line 19996 "ad_riscv.cpp"
  }
}

void vreduce_minDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1641 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ reduce_minmax_fp_v(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */,
                          opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                          as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp1 */), as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* tmp2 */),
                          true /* is_double */, true /* is_min */, Matcher::vector_length(this, opnd_array(2)));
  
#line 20019 "ad_riscv.cpp"
  }
}

void vreduce_minF_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1658 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ reduce_minmax_fp_v(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */,
                          opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                          as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* tmp1 */), as_VectorRegister(opnd_array(6)->reg(ra_,this,idx6)/* tmp2 */),
                          false /* is_double */, true /* is_min */,
                          Matcher::vector_length(this, opnd_array(2)), Assembler::v0_t);
  
#line 20044 "ad_riscv.cpp"
  }
}

void vreduce_minD_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1674 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ reduce_minmax_fp_v(opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */,
                          opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
                          as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* tmp1 */), as_VectorRegister(opnd_array(6)->reg(ra_,this,idx6)/* tmp2 */),
                          true /* is_double */, true /* is_min */,
                          Matcher::vector_length(this, opnd_array(2)), Assembler::v0_t);
  
#line 20069 "ad_riscv.cpp"
  }
}

void replicateNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1691 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmv_v_x(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 20087 "ad_riscv.cpp"
  }
}

void replicateLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1704 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_LONG, Matcher::vector_length(this));
    __ vmv_v_x(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 20104 "ad_riscv.cpp"
  }
}

void replicate_imm5Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1716 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length_in_bytes(this));
    __ vmv_v_i(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->constant());
  
#line 20122 "ad_riscv.cpp"
  }
}

void replicateL_imm5Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1729 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_LONG, Matcher::vector_length(this));
    __ vmv_v_i(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->constantL());
  
#line 20139 "ad_riscv.cpp"
  }
}

void replicateFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1741 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_FLOAT, Matcher::vector_length(this));
    __ vfmv_v_f(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 20156 "ad_riscv.cpp"
  }
}

void replicateDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1753 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_DOUBLE, Matcher::vector_length(this));
    __ vfmv_v_f(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);
  
#line 20173 "ad_riscv.cpp"
  }
}

void vasrBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1767 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_BYTE, Matcher::vector_length(this));
    // if shift > BitsPerByte - 1, clear the low BitsPerByte - 1 bits
    __ vmsgtu_vi(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), BitsPerByte - 1);
    __ vsra_vi(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
               BitsPerByte - 1, Assembler::v0_t);
    // otherwise, shift
    __ vmnot_m(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */));
    __ vsra_vv(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), Assembler::v0_t);
  
#line 20200 "ad_riscv.cpp"
  }
}

void vasrSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1786 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_SHORT, Matcher::vector_length(this));
    // if shift > BitsPerShort - 1, clear the low BitsPerShort - 1 bits
    __ vmsgtu_vi(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), BitsPerShort - 1);
    __ vsra_vi(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
               BitsPerShort - 1, Assembler::v0_t);
    // otherwise, shift
    __ vmnot_m(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */));
    __ vsra_vv(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), Assembler::v0_t);
  
#line 20227 "ad_riscv.cpp"
  }
}

void vasrINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1804 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_INT, Matcher::vector_length(this));
    __ vsra_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 20246 "ad_riscv.cpp"
  }
}

void vasrLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1816 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_LONG, Matcher::vector_length(this));
    __ vsra_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 20265 "ad_riscv.cpp"
  }
}

void vasrB_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vmask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1829 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_BYTE, Matcher::vector_length(this));
    __ vmsgtu_vi(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), BitsPerByte - 1);
    // if shift > BitsPerByte - 1, clear the low BitsPerByte - 1 bits
    __ vmerge_vim(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), BitsPerByte - 1);
    // otherwise, shift
    __ vmv1r_v(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* vmask */));
    __ vsra_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), Assembler::v0_t);
  
#line 20291 "ad_riscv.cpp"
  }
}

void vasrS_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vmask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1847 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_SHORT, Matcher::vector_length(this));
    __ vmsgtu_vi(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), BitsPerShort - 1);
    // if shift > BitsPerShort - 1, clear the low BitsPerShort - 1 bits
    __ vmerge_vim(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), BitsPerShort - 1);
    // otherwise, shift
    __ vmv1r_v(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* vmask */));
    __ vsra_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), Assembler::v0_t);
  
#line 20317 "ad_riscv.cpp"
  }
}

void vasrI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1865 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_INT, Matcher::vector_length(this));
    __ vsra_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), Assembler::v0_t);
  
#line 20337 "ad_riscv.cpp"
  }
}

void vasrL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1878 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_LONG, Matcher::vector_length(this));
    __ vsra_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), Assembler::v0_t);
  
#line 20357 "ad_riscv.cpp"
  }
}

void vlslBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1891 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_BYTE, Matcher::vector_length(this));
    // if shift > BitsPerByte - 1, clear the element
    __ vmsgtu_vi(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), BitsPerByte - 1);
    __ vxor_vv(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), Assembler::v0_t);
    // otherwise, shift
    __ vmnot_m(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */));
    __ vsll_vv(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), Assembler::v0_t);
  
#line 20384 "ad_riscv.cpp"
  }
}

void vlslSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1910 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_SHORT, Matcher::vector_length(this));
    // if shift > BitsPerShort - 1, clear the element
    __ vmsgtu_vi(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), BitsPerShort - 1);
    __ vxor_vv(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), Assembler::v0_t);
    // otherwise, shift
    __ vmnot_m(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */));
    __ vsll_vv(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), Assembler::v0_t);
  
#line 20411 "ad_riscv.cpp"
  }
}

void vlslINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1928 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_INT, Matcher::vector_length(this));
    __ vsll_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 20430 "ad_riscv.cpp"
  }
}

void vlslLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1940 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_LONG, Matcher::vector_length(this));
    __ vsll_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 20449 "ad_riscv.cpp"
  }
}

void vlslB_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vmask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1953 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_BYTE, Matcher::vector_length(this));
    // if shift > BitsPerByte - 1, clear the element
    __ vmsgtu_vi(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), BitsPerByte - 1);
    __ vmand_mm(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */),
                as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* vmask */));
    __ vxor_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), Assembler::v0_t);
    // otherwise, shift
    __ vmv1r_v(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* vmask */));
    __ vsll_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), Assembler::v0_t);
  
#line 20478 "ad_riscv.cpp"
  }
}

void vlslS_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vmask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1974 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_SHORT, Matcher::vector_length(this));
    // if shift > BitsPerShort - 1, clear the element
    __ vmsgtu_vi(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), BitsPerShort - 1);
    __ vmand_mm(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */),
                as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* vmask */));
    __ vxor_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), Assembler::v0_t);
    // otherwise, shift
    __ vmv1r_v(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* vmask */));
    __ vsll_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), Assembler::v0_t);
  
#line 20507 "ad_riscv.cpp"
  }
}

void vlslI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 1995 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_INT, Matcher::vector_length(this));
    __ vsll_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), Assembler::v0_t);
  
#line 20527 "ad_riscv.cpp"
  }
}

void vlslL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2008 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_LONG, Matcher::vector_length(this));
    __ vsll_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), Assembler::v0_t);
  
#line 20547 "ad_riscv.cpp"
  }
}

void vlsrBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2021 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_BYTE, Matcher::vector_length(this));
    // if shift > BitsPerByte - 1, clear the element
    __ vmsgtu_vi(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), BitsPerByte - 1);
    __ vxor_vv(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), Assembler::v0_t);
    // otherwise, shift
    __ vmnot_m(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */));
    __ vsrl_vv(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), Assembler::v0_t);
  
#line 20574 "ad_riscv.cpp"
  }
}

void vlsrSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2040 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_SHORT, Matcher::vector_length(this));
    // if shift > BitsPerShort - 1, clear the element
    __ vmsgtu_vi(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), BitsPerShort - 1);
    __ vxor_vv(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), Assembler::v0_t);
    // otherwise, shift
    __ vmnot_m(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */));
    __ vsrl_vv(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), Assembler::v0_t);
  
#line 20601 "ad_riscv.cpp"
  }
}

void vlsrINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2058 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_INT, Matcher::vector_length(this));
    __ vsrl_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 20620 "ad_riscv.cpp"
  }
}

void vlsrLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2070 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_LONG, Matcher::vector_length(this));
    __ vsrl_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 20639 "ad_riscv.cpp"
  }
}

void vlsrB_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vmask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2083 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_BYTE, Matcher::vector_length(this));
    // if shift > BitsPerByte - 1, clear the element
    __ vmsgtu_vi(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), BitsPerByte - 1);
    __ vmand_mm(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */),
                as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* vmask */));
    __ vxor_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), Assembler::v0_t);
    // otherwise, shift
    __ vmv1r_v(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* vmask */));
    __ vsrl_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), Assembler::v0_t);
  
#line 20668 "ad_riscv.cpp"
  }
}

void vlsrS_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vmask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2104 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_SHORT, Matcher::vector_length(this));
    // if shift > BitsPerShort - 1, clear the element
    __ vmsgtu_vi(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), BitsPerShort - 1);
    __ vmand_mm(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */),
                as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* vmask */));
    __ vxor_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), Assembler::v0_t);
    // otherwise, shift
    __ vmv1r_v(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* vmask */));
    __ vsrl_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), Assembler::v0_t);
  
#line 20697 "ad_riscv.cpp"
  }
}

void vlsrI_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2125 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_INT, Matcher::vector_length(this));
    __ vsrl_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), Assembler::v0_t);
  
#line 20717 "ad_riscv.cpp"
  }
}

void vlsrL_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2138 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_LONG, Matcher::vector_length(this));
    __ vsrl_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shift */), Assembler::v0_t);
  
#line 20737 "ad_riscv.cpp"
  }
}

void vasrB_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2150 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint32_t con = (unsigned)opnd_array(2)->constant()& 0x1f;
    __ vsetvli_helper(T_BYTE, Matcher::vector_length(this));
    if (con == 0) {
      __ vor_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
      return;
    }
    if (con >= BitsPerByte) con = BitsPerByte - 1;
    __ vsra_vi(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), con);
  
#line 20762 "ad_riscv.cpp"
  }
}

void vasrS_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2168 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint32_t con = (unsigned)opnd_array(2)->constant()& 0x1f;
    __ vsetvli_helper(T_SHORT, Matcher::vector_length(this));
    if (con == 0) {
      __ vor_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
      return;
    }
    if (con >= BitsPerShort) con = BitsPerShort - 1;
    __ vsra_vi(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), con);
  
#line 20787 "ad_riscv.cpp"
  }
}

void vasrI_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2186 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint32_t con = (unsigned)opnd_array(2)->constant()& 0x1f;
    __ vsetvli_helper(T_INT, Matcher::vector_length(this));
    if (con == 0) {
      __ vor_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
      return;
    }
    __ vsra_vi(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), con);
  
#line 20811 "ad_riscv.cpp"
  }
}

void vasrL_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2204 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint32_t con = (unsigned)opnd_array(2)->constant()& 0x1f;
    __ vsetvli_helper(T_LONG, Matcher::vector_length(this));
    if (con == 0) {
      __ vor_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
      return;
    }
    __ vsra_vi(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), con);
  
#line 20835 "ad_riscv.cpp"
  }
}

void vasrB_imm_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2221 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint32_t con = (unsigned)opnd_array(2)->constant()& 0x1f;
    if (con == 0) {
      return;
    }
    if (con >= BitsPerByte) con = BitsPerByte - 1;
    __ vsetvli_helper(T_BYTE, Matcher::vector_length(this));
    __ vsra_vi(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), con,
               Assembler::v0_t);
  
#line 20860 "ad_riscv.cpp"
  }
}

void vasrS_imm_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2238 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint32_t con = (unsigned)opnd_array(2)->constant()& 0x1f;
    if (con == 0) {
      return;
    }
    if (con >= BitsPerShort) con = BitsPerShort - 1;
    __ vsetvli_helper(T_SHORT, Matcher::vector_length(this));
    __ vsra_vi(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), con,
               Assembler::v0_t);
  
#line 20885 "ad_riscv.cpp"
  }
}

void vasrI_imm_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2255 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint32_t con = (unsigned)opnd_array(2)->constant()& 0x1f;
    if (con == 0) {
      return;
    }
    __ vsetvli_helper(T_INT, Matcher::vector_length(this));
    __ vsra_vi(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), con,
               Assembler::v0_t);
  
#line 20909 "ad_riscv.cpp"
  }
}

void vasrL_imm_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2272 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint32_t con = (unsigned)opnd_array(2)->constant()& 0x1f;
    if (con == 0) {
      return;
    }
    __ vsetvli_helper(T_LONG, Matcher::vector_length(this));
    __ vsra_vi(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), con,
               Assembler::v0_t);
  
#line 20933 "ad_riscv.cpp"
  }
}

void vlsrB_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2288 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint32_t con = (unsigned)opnd_array(2)->constant()& 0x1f;
    __ vsetvli_helper(T_BYTE, Matcher::vector_length(this));
    if (con == 0) {
      __ vor_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
      return;
    }
    if (con >= BitsPerByte) {
      __ vxor_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                 as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
      return;
    }
    __ vsrl_vi(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), con);
  
#line 20962 "ad_riscv.cpp"
  }
}

void vlsrS_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2310 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint32_t con = (unsigned)opnd_array(2)->constant()& 0x1f;
    __ vsetvli_helper(T_SHORT, Matcher::vector_length(this));
    if (con == 0) {
      __ vor_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
      return;
    }
    if (con >= BitsPerShort) {
      __ vxor_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                 as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
      return;
    }
    __ vsrl_vi(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), con);
  
#line 20991 "ad_riscv.cpp"
  }
}

void vlsrI_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2332 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint32_t con = (unsigned)opnd_array(2)->constant()& 0x1f;
    __ vsetvli_helper(T_INT, Matcher::vector_length(this));
    if (con == 0) {
      __ vor_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
      return;
    }
    __ vsrl_vi(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), con);
  
#line 21015 "ad_riscv.cpp"
  }
}

void vlsrL_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2350 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint32_t con = (unsigned)opnd_array(2)->constant()& 0x1f;
    __ vsetvli_helper(T_LONG, Matcher::vector_length(this));
    if (con == 0) {
      __ vor_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
      return;
    }
    __ vsrl_vi(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), con);
  
#line 21039 "ad_riscv.cpp"
  }
}

void vlsrB_imm_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2367 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint32_t con = (unsigned)opnd_array(2)->constant()& 0x1f;
    if (con == 0) {
      return;
    }
    __ vsetvli_helper(T_BYTE, Matcher::vector_length(this));
    if (con >= BitsPerByte) {
      __ vxor_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */),
                 as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), Assembler::v0_t);
      return;
    }
    __ vsrl_vi(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), con,
               Assembler::v0_t);
  
#line 21068 "ad_riscv.cpp"
  }
}

void vlsrS_imm_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2388 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint32_t con = (unsigned)opnd_array(2)->constant()& 0x1f;
    if (con == 0) {
      return;
    }
    __ vsetvli_helper(T_SHORT, Matcher::vector_length(this));
    if (con >= BitsPerShort) {
      __ vxor_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */),
                 as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), Assembler::v0_t);
      return;
    }
    __ vsrl_vi(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), con,
               Assembler::v0_t);
  
#line 21097 "ad_riscv.cpp"
  }
}

void vlsrI_imm_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2409 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint32_t con = (unsigned)opnd_array(2)->constant()& 0x1f;
    if (con == 0) {
      return;
    }
    __ vsetvli_helper(T_INT, Matcher::vector_length(this));
    __ vsrl_vi(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), con,
               Assembler::v0_t);
  
#line 21121 "ad_riscv.cpp"
  }
}

void vlsrL_imm_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2426 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint32_t con = (unsigned)opnd_array(2)->constant()& 0x1f;
    if (con == 0) {
      return;
    }
    __ vsetvli_helper(T_LONG, Matcher::vector_length(this));
    __ vsrl_vi(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), con,
               Assembler::v0_t);
  
#line 21145 "ad_riscv.cpp"
  }
}

void vlslB_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2442 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint32_t con = (unsigned)opnd_array(2)->constant()& 0x1f;
    __ vsetvli_helper(T_BYTE, Matcher::vector_length(this));
    if (con >= BitsPerByte) {
      __ vxor_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                 as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
      return;
    }
    __ vsll_vi(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), con);
  
#line 21169 "ad_riscv.cpp"
  }
}

void vlslS_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2459 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint32_t con = (unsigned)opnd_array(2)->constant()& 0x1f;
    __ vsetvli_helper(T_SHORT, Matcher::vector_length(this));
    if (con >= BitsPerShort) {
      __ vxor_vv(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                 as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
      return;
    }
    __ vsll_vi(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), con);
  
#line 21193 "ad_riscv.cpp"
  }
}

void vlslI_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2476 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint32_t con = (unsigned)opnd_array(2)->constant()& 0x1f;
    __ vsetvli_helper(T_INT, Matcher::vector_length(this));
    __ vsll_vi(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), con);
  
#line 21212 "ad_riscv.cpp"
  }
}

void vlslL_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2489 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint32_t con = (unsigned)opnd_array(2)->constant()& 0x1f;
    __ vsetvli_helper(T_LONG, Matcher::vector_length(this));
    __ vsll_vi(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), con);
  
#line 21231 "ad_riscv.cpp"
  }
}

void vlslB_imm_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2501 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint32_t con = (unsigned)opnd_array(2)->constant()& 0x1f;
    __ vsetvli_helper(T_BYTE, Matcher::vector_length(this));
    if (con >= BitsPerByte) {
      __ vxor_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */),
                 as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), Assembler::v0_t);
      return;
    }
    __ vsll_vi(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), con,
               Assembler::v0_t);
  
#line 21257 "ad_riscv.cpp"
  }
}

void vlslS_imm_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2519 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint32_t con = (unsigned)opnd_array(2)->constant()& 0x1f;
    __ vsetvli_helper(T_SHORT, Matcher::vector_length(this));
    if (con >= BitsPerShort) {
      __ vxor_vv(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */),
                 as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), Assembler::v0_t);
      return;
    }
    __ vsll_vi(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), con,
               Assembler::v0_t);
  
#line 21283 "ad_riscv.cpp"
  }
}

void vlslI_imm_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2537 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint32_t con = (unsigned)opnd_array(2)->constant()& 0x1f;
    __ vsetvli_helper(T_INT, Matcher::vector_length(this));
    __ vsll_vi(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), con,
               Assembler::v0_t);
  
#line 21304 "ad_riscv.cpp"
  }
}

void vlslL_imm_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2551 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint32_t con = (unsigned)opnd_array(2)->constant()& 0x1f;
    __ vsetvli_helper(T_LONG, Matcher::vector_length(this));
    __ vsll_vi(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), con,
               Assembler::v0_t);
  
#line 21325 "ad_riscv.cpp"
  }
}

void vshiftcntNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cnt
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2566 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmv_v_x(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* cnt */));
  
#line 21343 "ad_riscv.cpp"
  }
}

void vshiftcnt_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cnt
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2566 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmv_v_x(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* cnt */));
  
#line 21361 "ad_riscv.cpp"
  }
}

void vsqrt_fpNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2581 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfsqrt_v(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 21379 "ad_riscv.cpp"
  }
}

void vsqrt_fp_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2581 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfsqrt_v(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 21397 "ad_riscv.cpp"
  }
}

void vsqrt_fp_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2596 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfsqrt_v(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */),
                Assembler::v0_t);
  
#line 21417 "ad_riscv.cpp"
  }
}

void vsqrt_fp_masked_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2596 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vfsqrt_v(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst_src */),
                Assembler::v0_t);
  
#line 21437 "ad_riscv.cpp"
  }
}

void vstring_equalsLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// str2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cnt
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// v3
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// v4
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// v5
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2614 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    // Count is in 8-bit bytes; non-Compact chars are 16 bits.
    __ string_equals_v(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* str2 */,
                       opnd_array(0)->as_Register(ra_,this)/* result */, opnd_array(3)->as_Register(ra_,this,idx3)/* cnt */, 1);
  
#line 21461 "ad_riscv.cpp"
  }
}

void vstring_equalsUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// str2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cnt
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// v3
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// v4
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// v5
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2631 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    // Count is in 8-bit bytes; non-Compact chars are 16 bits.
    __ string_equals_v(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* str2 */,
                       opnd_array(0)->as_Register(ra_,this)/* result */, opnd_array(3)->as_Register(ra_,this,idx3)/* cnt */, 2);
  
#line 21485 "ad_riscv.cpp"
  }
}

void varray_equalsBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// ary1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// ary2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v3
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// v4
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// v5
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2647 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ arrays_equals_v(opnd_array(1)->as_Register(ra_,this,idx1)/* ary1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* ary2 */,
                       opnd_array(0)->as_Register(ra_,this)/* result */, as_Register(R28_enc), 1);
    
#line 21507 "ad_riscv.cpp"
  }
}

void varray_equalsCNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// ary1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// ary2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v3
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// v4
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// v5
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2662 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ arrays_equals_v(opnd_array(1)->as_Register(ra_,this,idx1)/* ary1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* ary2 */,
                       opnd_array(0)->as_Register(ra_,this)/* result */, as_Register(R28_enc), 2);
  
#line 21529 "ad_riscv.cpp"
  }
}

void vstring_compareUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// v2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// v3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// v4
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// v5
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2679 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    // Count is in 8-bit bytes; non-Compact chars are 16 bits.
    __ string_compare_v(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                        opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                        as_Register(R28_enc), as_Register(R29_enc),
                        StrIntrinsicNode::UU);
  
#line 21556 "ad_riscv.cpp"
  }
}

void vstring_compareLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// v2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// v3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// v4
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// v5
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2698 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ string_compare_v(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                        opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                        as_Register(R28_enc), as_Register(R29_enc),
                        StrIntrinsicNode::LL);
  
#line 21582 "ad_riscv.cpp"
  }
}

void vstring_compareULNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// v4
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// v5
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// v6
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// v7
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// v8
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// v9
  unsigned idx11 = idx10 + opnd_array(10)->num_edges(); 	// v10
  unsigned idx12 = idx11 + opnd_array(11)->num_edges(); 	// v11
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2718 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ string_compare_v(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                        opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                        as_Register(R28_enc), as_Register(R29_enc),
                        StrIntrinsicNode::UL);
  
#line 21612 "ad_riscv.cpp"
  }
}

void vstring_compareLUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// v4
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// v5
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// v6
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// v7
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// v8
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// v9
  unsigned idx11 = idx10 + opnd_array(10)->num_edges(); 	// v10
  unsigned idx12 = idx11 + opnd_array(11)->num_edges(); 	// v11
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2737 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ string_compare_v(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                        opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                        as_Register(R28_enc), as_Register(R29_enc),
                        StrIntrinsicNode::LU);
  
#line 21642 "ad_riscv.cpp"
  }
}

void vstring_inflateNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v4
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// v5
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// v6
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// v7
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2755 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ byte_array_inflate_v(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */, opnd_array(8)->as_Register(ra_,this,idx8)/* tmp */);
  
#line 21665 "ad_riscv.cpp"
  }
}

void vencode_iso_arrayNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// result
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// v1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// v2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// v3
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// v0
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2771 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ encode_iso_array_v(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
                          opnd_array(4)->as_Register(ra_,this,idx4)/* result */, opnd_array(9)->as_Register(ra_,this,idx9)/* tmp */, false /* ascii */);
  
#line 21690 "ad_riscv.cpp"
  }
}

void vencode_ascii_arrayNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// result
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// v1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// v2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// v3
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// v0
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2787 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ encode_iso_array_v(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
                          opnd_array(4)->as_Register(ra_,this,idx4)/* result */, opnd_array(9)->as_Register(ra_,this,idx9)/* tmp */, true /* ascii */);
  
#line 21715 "ad_riscv.cpp"
  }
}

void vstring_compressNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// result
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// v1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// v2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// v3
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// v0
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2804 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ char_array_compress_v(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
                             opnd_array(4)->as_Register(ra_,this,idx4)/* result */, opnd_array(9)->as_Register(ra_,this,idx9)/* tmp */);
  
#line 21740 "ad_riscv.cpp"
  }
}

void vcount_positivesNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// ary
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// len
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// result
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v4
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// v5
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// v6
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// v7
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2819 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ count_positives_v(opnd_array(1)->as_Register(ra_,this,idx1)/* ary */, opnd_array(2)->as_Register(ra_,this,idx2)/* len */, opnd_array(3)->as_Register(ra_,this,idx3)/* result */, opnd_array(8)->as_Register(ra_,this,idx8)/* tmp */);
  
#line 21763 "ad_riscv.cpp"
  }
}

void vstringU_indexof_charNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ch
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// result
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// v4
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// v5
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// v6
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// v7
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2837 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ string_indexof_char_v(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* ch */,
                             opnd_array(4)->as_Register(ra_,this,idx4)/* result */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                             false /* isL */);
  
#line 21790 "ad_riscv.cpp"
  }
}

void vstringL_indexof_charNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ch
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// result
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// v4
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// v5
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// v6
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// v7
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2857 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ string_indexof_char_v(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* ch */,
                             opnd_array(4)->as_Register(ra_,this,idx4)/* result */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                             true /* isL */);
  
#line 21817 "ad_riscv.cpp"
  }
}

void vclearArray_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cnt
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v5
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// v6
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// v7
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2876 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ clear_array_v(opnd_array(2)->as_Register(ra_,this,idx2)/* base */, opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */);
  
#line 21838 "ad_riscv.cpp"
  }
}

void compressBitsINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v4
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// v5
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// v8
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// v9
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2904 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ compress_bits_i_v(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* mask */));
  
#line 21860 "ad_riscv.cpp"
  }
}

void compressBitsLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v4
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// v5
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// v6
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// v7
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// v8
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// v9
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// v10
  unsigned idx11 = idx10 + opnd_array(10)->num_edges(); 	// v11
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2930 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ compress_bits_l_v(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* mask */));
  
#line 21886 "ad_riscv.cpp"
  }
}

void expandBitsINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v4
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// v5
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// v8
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// v9
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// v12
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// v13
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2958 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ expand_bits_i_v(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* mask */));
  
#line 21910 "ad_riscv.cpp"
  }
}

void expandBitsLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v4
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// v5
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// v6
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// v7
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// v8
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// v9
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// v10
  unsigned idx11 = idx10 + opnd_array(10)->num_edges(); 	// v11
  unsigned idx12 = idx11 + opnd_array(11)->num_edges(); 	// v12
  unsigned idx13 = idx12 + opnd_array(12)->num_edges(); 	// v13
  unsigned idx14 = idx13 + opnd_array(13)->num_edges(); 	// v14
  unsigned idx15 = idx14 + opnd_array(14)->num_edges(); 	// v15
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2987 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ expand_bits_l_v(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* mask */));
  
#line 21940 "ad_riscv.cpp"
  }
}

void vloadconNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 2998 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vid_v(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */));
    if (is_floating_point_type(bt)) {
      __ csrwi(CSR_FRM, C2_MacroAssembler::rne);
      __ vfcvt_f_x_v(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */));
    }
  
#line 21962 "ad_riscv.cpp"
  }
}

void vmask_gen_INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3013 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vid_v(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */));
    __ vmsltu_vx(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 21981 "ad_riscv.cpp"
  }
}

void vmask_gen_LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3025 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vid_v(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */));
    __ vmsltu_vx(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 22000 "ad_riscv.cpp"
  }
}

void vmask_gen_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3039 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    if ((uint)(opnd_array(1)->constantL()) == 0) {
      __ vmclr_m(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */));
    } else if ((uint)(opnd_array(1)->constantL()) == Matcher::vector_length(this)) {
      __ vmset_m(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */));
    } else {
      assert((uint)(opnd_array(1)->constantL()) < Matcher::vector_length(this), "unsupported input lane_cnt");
      __ vid_v(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */));
      __ vmsleu_vi(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), (uint)(opnd_array(1)->constantL()) - 1);
    }
  
#line 22026 "ad_riscv.cpp"
  }
}

void vmaskAll_immINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3058 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    int con = (int)opnd_array(1)->constant();
    if (con == 0) {
      __ vmclr_m(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */));
    } else {
      assert(con == -1, "invalid constant value for mask");
      __ vmset_m(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */));
    }
  
#line 22050 "ad_riscv.cpp"
  }
}

void vmaskAllINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3075 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmv_v_x(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ vmsne_vx(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), zr);
  
#line 22069 "ad_riscv.cpp"
  }
}

void vmaskAll_immLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3087 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    long con = (long)opnd_array(1)->constantL();
    if (con == 0) {
      __ vmclr_m(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */));
    } else {
      assert(con == -1, "invalid constant value for mask");
      __ vmset_m(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */));
    }
  
#line 22093 "ad_riscv.cpp"
  }
}

void vmaskAllLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3104 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmv_v_x(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ vmsne_vx(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), zr);
  
#line 22112 "ad_riscv.cpp"
  }
}

void vmask_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3120 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmand_mm(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */),
                as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
                as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 22133 "ad_riscv.cpp"
  }
}

void vmask_orNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3133 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmor_mm(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */),
               as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
               as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 22154 "ad_riscv.cpp"
  }
}

void vmask_xorNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3146 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmxor_mm(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */),
                as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
                as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 22175 "ad_riscv.cpp"
  }
}

void vmaskcastNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  // User did not define which encode class to use.
}

void loadV_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3169 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    VectorRegister dst_reg = as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(C2_MacroAssembler(&cbuf), false, dst_reg,
              Matcher::vector_element_basic_type(this), as_Register(opnd_array(1)->base(ra_,this,idx1)),
              Matcher::vector_length(this), Assembler::v0_t);
  
#line 22203 "ad_riscv.cpp"
  }
}

void storeV_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3181 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    VectorRegister src_reg = as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(C2_MacroAssembler(&cbuf), true, src_reg,
              Matcher::vector_element_basic_type(this, opnd_array(2)), as_Register(opnd_array(1)->base(ra_,this,idx1)),
              Matcher::vector_length(this, opnd_array(2)), Assembler::v0_t);
  
#line 22224 "ad_riscv.cpp"
  }
}

void vblendNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3195 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmerge_vvm(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
                  as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 22245 "ad_riscv.cpp"
  }
}

void vcvtBtoXNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3212 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    if (is_floating_point_type(bt)) {
      __ integer_extend_v(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */), bt == T_FLOAT ? T_INT : T_LONG,
                          Matcher::vector_length(this), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), T_BYTE);
      __ csrwi(CSR_FRM, C2_MacroAssembler::rne);
      __ vfcvt_f_x_v(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */));
    } else {
      __ integer_extend_v(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */), bt, 
                          Matcher::vector_length(this), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), T_BYTE);
    }
  
#line 22271 "ad_riscv.cpp"
  }
}

void vcvtStoBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3233 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ integer_narrow_v(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), T_BYTE, Matcher::vector_length(this),
                        as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), T_SHORT);
  
#line 22288 "ad_riscv.cpp"
  }
}

void vcvtStoX_extendNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3246 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ integer_extend_v(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */), Matcher::vector_element_basic_type(this),
                        Matcher::vector_length(this), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), T_SHORT);
  
#line 22306 "ad_riscv.cpp"
  }
}

void vcvtStoX_fp_extendNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3259 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ integer_extend_v(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */), (bt == T_FLOAT ? T_INT : T_LONG),
                        Matcher::vector_length(this), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), T_SHORT);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ csrwi(CSR_FRM, C2_MacroAssembler::rne);
    __ vfcvt_f_x_v(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */));
  
#line 22328 "ad_riscv.cpp"
  }
}

void vcvtItoX_narrowNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3277 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ integer_narrow_v(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), bt, Matcher::vector_length(this),
                        as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), T_INT);
  
#line 22346 "ad_riscv.cpp"
  }
}

void vcvtItoLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3290 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ integer_extend_v(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */), T_LONG,
                        Matcher::vector_length(this), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), T_INT);
  
#line 22364 "ad_riscv.cpp"
  }
}

void vcvtItoFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3301 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_FLOAT, Matcher::vector_length(this));
    __ csrwi(CSR_FRM, C2_MacroAssembler::rne);
    __ vfcvt_f_x_v(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 22382 "ad_riscv.cpp"
  }
}

void vcvtItoDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3314 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_INT, Matcher::vector_length(this), Assembler::mf2);
    __ csrwi(CSR_FRM, C2_MacroAssembler::rne);
    __ vfwcvt_f_x_v(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 22401 "ad_riscv.cpp"
  }
}

void vcvtLtoINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3330 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ integer_narrow_v(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), bt, Matcher::vector_length(this),
                        as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), T_LONG);
  
#line 22419 "ad_riscv.cpp"
  }
}

void vcvtLtoFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3342 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_FLOAT, Matcher::vector_length(this), Assembler::mf2);
    __ csrwi(CSR_FRM, C2_MacroAssembler::rne);
    __ vfncvt_f_x_w(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 22437 "ad_riscv.cpp"
  }
}

void vcvtLtoDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3354 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_DOUBLE, Matcher::vector_length(this));
    __ csrwi(CSR_FRM, C2_MacroAssembler::rne);
    __ vfcvt_f_x_v(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 22455 "ad_riscv.cpp"
  }
}

void vcvtFtoX_narrowNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3370 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_FLOAT, Matcher::vector_length(this));
    __ vfcvt_rtz_x_f_v_safe(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ integer_narrow_v(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */), bt, Matcher::vector_length(this),
                        as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */), T_INT);
  
#line 22477 "ad_riscv.cpp"
  }
}

void vcvtFtoINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3385 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_FLOAT, Matcher::vector_length(this));
    __ vfcvt_rtz_x_f_v_safe(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 22496 "ad_riscv.cpp"
  }
}

void vcvtFtoLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3397 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_LONG, Matcher::vector_length(this));
    __ vxor_vv(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */));
    __ vsetvli_helper(T_FLOAT, Matcher::vector_length(this), Assembler::mf2);
    __ vmfeq_vv(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* v0 */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ vfwcvt_rtz_x_f_v(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), Assembler::v0_t);
  
#line 22518 "ad_riscv.cpp"
  }
}

void vcvtFtoDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3412 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_FLOAT, Matcher::vector_length(this), Assembler::mf2);
    __ csrwi(CSR_FRM, C2_MacroAssembler::rne);
    __ vfwcvt_f_f_v(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 22537 "ad_riscv.cpp"
  }
}

void vcvtDtoX_narrowNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3429 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_DOUBLE, Matcher::vector_length(this));
    __ vmfeq_vv(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* v0 */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ vsetvli_helper(T_INT, Matcher::vector_length(this), Assembler::mf2);
    __ vxor_vv(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */));
    __ vfncvt_rtz_x_f_w(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), Assembler::v0_t);
    BasicType bt = Matcher::vector_element_basic_type(this);
    if (bt == T_BYTE || bt == T_SHORT) {
      __ integer_narrow_v(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */), bt, Matcher::vector_length(this),
                          as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */), T_INT);
    }
  
#line 22564 "ad_riscv.cpp"
  }
}

void vcvtDtoLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3449 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_LONG, Matcher::vector_length(this));
    __ vfcvt_rtz_x_f_v_safe(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 22583 "ad_riscv.cpp"
  }
}

void vcvtDtoFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3460 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_FLOAT, Matcher::vector_length(this), Assembler::mf2);
    __ csrwi(CSR_FRM, C2_MacroAssembler::rne);
    __ vfncvt_f_f_w(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 22601 "ad_riscv.cpp"
  }
}

void reinterpretNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3475 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    // empty
  
#line 22617 "ad_riscv.cpp"
  }
}

void reinterpretResizeNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3486 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint length_in_bytes_src = Matcher::vector_length_in_bytes(this, opnd_array(1));
    uint length_in_bytes_dst = Matcher::vector_length_in_bytes(this);
    uint length_in_bytes_resize = length_in_bytes_src < length_in_bytes_dst ?
                                  length_in_bytes_src : length_in_bytes_dst;
    assert(length_in_bytes_src <= MaxVectorSize && length_in_bytes_dst <= MaxVectorSize,
           "invalid vector length");
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vxor_vv(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */));
    __ vsetvli_helper(T_BYTE, length_in_bytes_resize);
    __ vmv_v_v(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 22644 "ad_riscv.cpp"
  }
}

void vmask_reinterpret_same_esizeNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst_src
  // User did not define which encode class to use.
}

void vmask_reinterpret_diff_esizeNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3520 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType from_bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ vsetvli_helper(from_bt, Matcher::vector_length(this, opnd_array(1)));
    __ vxor_vv(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp */));
    __ vmerge_vim(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp */), -1);
    BasicType to_bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(to_bt, Matcher::vector_length(this));
    __ vmseq_vi(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp */), -1);
  
#line 22675 "ad_riscv.cpp"
  }
}

void rearrangeNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shuffle
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3538 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vrgather_vv(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                   as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shuffle */));
  
#line 22696 "ad_riscv.cpp"
  }
}

void rearrange_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shuffle
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3551 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vxor_vv(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* dst */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* dst */),
               as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* dst */));
    __ vrgather_vv(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                   as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* shuffle */), Assembler::v0_t);
  
#line 22720 "ad_riscv.cpp"
  }
}

void extractNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3571 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ extract_v(opnd_array(0)->as_Register(ra_,this)/* dst */, as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                 Matcher::vector_element_basic_type(this, opnd_array(1)), (int)(opnd_array(2)->constant()),
                 as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */));
  
#line 22740 "ad_riscv.cpp"
  }
}

void extract_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3571 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ extract_v(opnd_array(0)->as_Register(ra_,this)/* dst */, as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                 Matcher::vector_element_basic_type(this, opnd_array(1)), (int)(opnd_array(2)->constant()),
                 as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */));
  
#line 22760 "ad_riscv.cpp"
  }
}

void extract_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3571 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ extract_v(opnd_array(0)->as_Register(ra_,this)/* dst */, as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                 Matcher::vector_element_basic_type(this, opnd_array(1)), (int)(opnd_array(2)->constant()),
                 as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */));
  
#line 22780 "ad_riscv.cpp"
  }
}

void extractLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3584 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ extract_v(opnd_array(0)->as_Register(ra_,this)/* dst */, as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), T_LONG,
                 (int)(opnd_array(2)->constant()), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */));
  
#line 22799 "ad_riscv.cpp"
  }
}

void extractFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3597 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ extract_fp_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), T_FLOAT,
                    (int)(opnd_array(2)->constant()), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */));
  
#line 22818 "ad_riscv.cpp"
  }
}

void extractDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3609 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ extract_fp_v(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), T_DOUBLE,
                    (int)(opnd_array(2)->constant()), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp */));
  
#line 22837 "ad_riscv.cpp"
  }
}

void mcompressNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3622 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vid_v(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp */));
    __ vcpop_m(t0, as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ vmsltu_vx(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp */), t0);
  
#line 22858 "ad_riscv.cpp"
  }
}

void vcompressNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// v0
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3636 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vxor_vv(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */),
               as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */));
    __ vcompress_vm(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                    as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* v0 */));
  
#line 22881 "ad_riscv.cpp"
  }
}

void vexpandNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// v0
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3651 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ viota_m(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* v0 */));
    __ vxor_vv(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */),
               as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */));
    __ vrgather_vv(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */),
                   as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */), Assembler::v0_t);
  
#line 22906 "ad_riscv.cpp"
  }
}

void vsignum_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3672 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ signum_fp_v(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* one */),
                   bt, Matcher::vector_length(this));
  
#line 22927 "ad_riscv.cpp"
  }
}

void vsignum_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3672 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ signum_fp_v(as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* dst */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* one */),
                   bt, Matcher::vector_length(this));
  
#line 22948 "ad_riscv.cpp"
  }
}

void gather_loadNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3688 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vmv1r_v(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* idx */));
    BasicType bt = Matcher::vector_element_basic_type(this);
    Assembler::SEW sew = Assembler::elemtype_to_sew(bt);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vsll_vi(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */), (int)sew);
    __ vluxei32_v(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */), as_Register(opnd_array(1)->base(ra_,this,idx1)),
                  as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */));
 
#line 22972 "ad_riscv.cpp"
  }
}

void gather_load_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// v0
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3706 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vmv1r_v(as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* tmp */), as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* idx */));
    BasicType bt = Matcher::vector_element_basic_type(this);
    Assembler::SEW sew = Assembler::elemtype_to_sew(bt);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vsll_vi(as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* tmp */), as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* tmp */), (int)sew);
    __ vxor_vv(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* dst */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* dst */),
               as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* dst */));
    __ vluxei32_v(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* dst */), as_Register(opnd_array(1)->base(ra_,this,idx1)),
                  as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* tmp */), Assembler::v0_t);
 
#line 23000 "ad_riscv.cpp"
  }
}

void scatter_storeNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3728 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vmv1r_v(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* idx */));
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    Assembler::SEW sew = Assembler::elemtype_to_sew(bt);
    __ vsetvli_helper(bt, Matcher::vector_length(this, opnd_array(2)));
    __ vsll_vi(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */), (int)sew);
    __ vsuxei32_v(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */), as_Register(opnd_array(1)->base(ra_,this,idx1)),
                  as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */));
  
#line 23025 "ad_riscv.cpp"
  }
}

void scatter_store_maskedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3746 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vmv1r_v(as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* tmp */), as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* idx */));
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    Assembler::SEW sew = Assembler::elemtype_to_sew(bt);
    __ vsetvli_helper(bt, Matcher::vector_length(this, opnd_array(2)));
    __ vsll_vi(as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* tmp */), as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* tmp */), (int)sew);
    __ vsuxei32_v(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */), as_Register(opnd_array(1)->base(ra_,this,idx1)),
                  as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* tmp */), Assembler::v0_t);
  
#line 23051 "ad_riscv.cpp"
  }
}

void populateindexNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3764 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    Assembler::SEW sew = Assembler::elemtype_to_sew(bt);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vmv_v_x(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */));
    __ vid_v(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */));
    __ vmacc_vx(as_VectorRegister(opnd_array(3)->reg(ra_,this,idx3)/* dst */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */));
  
#line 23075 "ad_riscv.cpp"
  }
}

void insertI_index_lt32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3787 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vid_v(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */));
    __ vadd_vi(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), -16);
    __ vmseq_vi(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), (int)(opnd_array(3)->constant()) - 16);
    __ vmerge_vxm(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), opnd_array(2)->as_Register(ra_,this,idx2)/* val */);
  
#line 23099 "ad_riscv.cpp"
  }
}

void insertI_indexNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3806 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vid_v(as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* v0 */));
    __ vmv_v_x(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */), opnd_array(3)->as_Register(ra_,this,idx3)/* idx */);
    __ vmseq_vv(as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* v0 */), as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* v0 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */));
    __ vmerge_vxm(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), opnd_array(2)->as_Register(ra_,this,idx2)/* val */);
  
#line 23124 "ad_riscv.cpp"
  }
}

void insertL_index_lt32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3825 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vid_v(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */));
    __ vadd_vi(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), -16);
    __ vmseq_vi(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), (int)(opnd_array(3)->constant()) - 16);
    __ vmerge_vxm(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), opnd_array(2)->as_Register(ra_,this,idx2)/* val */);
  
#line 23148 "ad_riscv.cpp"
  }
}

void insertL_indexNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3842 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vsetvli_helper(bt, Matcher::vector_length(this));
    __ vid_v(as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* v0 */));
    __ vmv_v_x(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */), opnd_array(3)->as_Register(ra_,this,idx3)/* idx */);
    __ vmseq_vv(as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* v0 */), as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* v0 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */));
    __ vmerge_vxm(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), opnd_array(2)->as_Register(ra_,this,idx2)/* val */);
  
#line 23173 "ad_riscv.cpp"
  }
}

void insertF_index_lt32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3861 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_FLOAT, Matcher::vector_length(this));
    __ vid_v(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */));
    __ vadd_vi(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), -16);
    __ vmseq_vi(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), (int)(opnd_array(3)->constant()) - 16);
    __ vfmerge_vfm(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* val */);
  
#line 23196 "ad_riscv.cpp"
  }
}

void insertF_indexNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3877 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_FLOAT, Matcher::vector_length(this));
    __ vid_v(as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* v0 */));
    __ vmv_v_x(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */), opnd_array(3)->as_Register(ra_,this,idx3)/* idx */);
    __ vmseq_vv(as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* v0 */), as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* v0 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */));
    __ vfmerge_vfm(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* val */);
  
#line 23220 "ad_riscv.cpp"
  }
}

void insertD_index_lt32Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3895 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_DOUBLE, Matcher::vector_length(this));
    __ vid_v(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */));
    __ vadd_vi(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), -16);
    __ vmseq_vi(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* v0 */), (int)(opnd_array(3)->constant()) - 16);
    __ vfmerge_vfm(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* val */);
  
#line 23243 "ad_riscv.cpp"
  }
}

void insertD_indexNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// v0
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3911 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    __ vsetvli_helper(T_DOUBLE, Matcher::vector_length(this));
    __ vid_v(as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* v0 */));
    __ vmv_v_x(as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */), opnd_array(3)->as_Register(ra_,this,idx3)/* idx */);
    __ vmseq_vv(as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* v0 */), as_VectorRegister(opnd_array(5)->reg(ra_,this,idx5)/* v0 */), as_VectorRegister(opnd_array(4)->reg(ra_,this,idx4)/* tmp */));
    __ vfmerge_vfm(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* val */);
  
#line 23267 "ad_riscv.cpp"
  }
}

void vmask_truecountNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3928 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ vsetvli_helper(bt, Matcher::vector_length(this, opnd_array(1)));
    __ vcpop_m(opnd_array(0)->as_Register(ra_,this)/* dst */, as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 23285 "ad_riscv.cpp"
  }
}

void vmask_firsttrueNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3945 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ vsetvli_helper(bt, Matcher::vector_length(this, opnd_array(1)));
    __ vmsbf_m(as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp */), as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ vcpop_m(opnd_array(0)->as_Register(ra_,this)/* dst */, as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp */));
  
#line 23305 "ad_riscv.cpp"
  }
}

void vmask_lasttrueNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3962 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint vector_length = Matcher::vector_length(this, opnd_array(1));
    assert(UseZbb && vector_length <= XLEN, "precondition");
    __ vsetvli_helper(T_LONG, 1);
    __ vmv_x_s(opnd_array(0)->as_Register(ra_,this)/* dst */, as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    if (XLEN != vector_length) {
      __ slli(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, XLEN - vector_length);
      __ srli(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, XLEN - vector_length);
    }
    __ clz(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */);
    __ mv(t0, XLEN - 1);
    __ sub(opnd_array(0)->as_Register(ra_,this)/* dst */, t0, opnd_array(0)->as_Register(ra_,this)/* dst */);
  
#line 23331 "ad_riscv.cpp"
  }
}

void vmask_tolongNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 3983 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint vector_length = Matcher::vector_length(this, opnd_array(1));
    assert(vector_length <= XLEN, "precondition");
    __ vsetvli_helper(T_LONG, 1);
    __ vmv_x_s(opnd_array(0)->as_Register(ra_,this)/* dst */, as_VectorRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    if (XLEN != vector_length) {
      __ slli(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, XLEN - vector_length);
      __ srli(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, XLEN - vector_length);
    }
  
#line 23354 "ad_riscv.cpp"
  }
}

void vmask_fromlongNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4001 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    assert(Matcher::vector_length(this) <= XLEN, "precondition");
    __ vsetvli_helper(T_LONG, 1);
    __ vmv_s_x(as_VectorRegister(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 23372 "ad_riscv.cpp"
  }
}

void cmovI_vtest_anytrue_negateNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// op2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// one
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4035 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint vector_length = Matcher::vector_length(this, opnd_array(2));
    __ vsetvli_helper(bt, vector_length);
    __ vcpop_m(opnd_array(0)->as_Register(ra_,this)/* dst */, as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* op1 */));
    __ snez(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */);
  
#line 23396 "ad_riscv.cpp"
  }
}

void cmovI_vtest_alltrue_negateNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// op2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// one
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4070 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    uint vector_length = Matcher::vector_length(this, opnd_array(2));
    __ vsetvli_helper(bt, vector_length);
    __ vcpop_m(opnd_array(0)->as_Register(ra_,this)/* dst */, as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* op1 */));
    __ sub(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, vector_length);
    __ seqz(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */);
  
#line 23421 "ad_riscv.cpp"
  }
}

void vtest_anytrue_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4088 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint vector_length = Matcher::vector_length(this, opnd_array(2));
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ vsetvli_helper(bt, vector_length);
    __ vcpop_m(t0, as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* op1 */));
    __ enc_cmpEqNe_imm0_branch(opnd_array(1)->ccode(), t0, *(opnd_array(4)->label()), /* is_far */ true);
  
#line 23444 "ad_riscv.cpp"
  }
}

void vtest_alltrue_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lbl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    C2_MacroAssembler _masm(&cbuf);

#line 4105 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_v.ad"

    uint vector_length = Matcher::vector_length(this, opnd_array(2));
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    __ vsetvli_helper(bt, vector_length);
    __ vcpop_m(t0, as_VectorRegister(opnd_array(2)->reg(ra_,this,idx2)/* op1 */));
    __ sub(t0, t0, vector_length);
    __ enc_cmpEqNe_imm0_branch(opnd_array(1)->ccode(), t0, *(opnd_array(4)->label()), /* is_far */ true);
  
#line 23468 "ad_riscv.cpp"
  }
}

void rorI_imm_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 35 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ roriw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), opnd_array(2)->constant()& 0x1f);
  
#line 23485 "ad_riscv.cpp"
  }
}

void rorL_imm_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 49 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ rori(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), opnd_array(2)->constant()& 0x3f);
  
#line 23502 "ad_riscv.cpp"
  }
}

void rorI_reg_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 62 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ rorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 23519 "ad_riscv.cpp"
  }
}

void rorL_reg_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 74 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ ror(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 23536 "ad_riscv.cpp"
  }
}

void rolI_reg_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 86 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ rolw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 23553 "ad_riscv.cpp"
  }
}

void rolL_reg_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 98 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ rol(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
  
#line 23570 "ad_riscv.cpp"
  }
}

void convP2I_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 112 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ zext_w(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 23586 "ad_riscv.cpp"
  }
}

void convB2I_reg_reg_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 127 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ sext_b(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 23604 "ad_riscv.cpp"
  }
}

void convI2S_reg_reg_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  {
    C2_MacroAssembler _masm(&cbuf);

#line 142 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ sext_h(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 23622 "ad_riscv.cpp"
  }
}

void convS2UI_reg_reg_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 157 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ zext_h(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 23639 "ad_riscv.cpp"
  }
}

void convI2UL_reg_reg_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 172 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ zext_w(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 23656 "ad_riscv.cpp"
  }
}

void bytes_reverse_int_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 187 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ revb_w_w(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 23672 "ad_riscv.cpp"
  }
}

void bytes_reverse_long_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 201 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ rev8(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 23688 "ad_riscv.cpp"
  }
}

void bytes_reverse_unsigned_short_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 215 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ revb_h_h_u(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 23704 "ad_riscv.cpp"
  }
}

void bytes_reverse_short_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 229 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ revb_h_h(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 23720 "ad_riscv.cpp"
  }
}

void shaddP_reg_reg_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 244 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ shadd(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             t0,
             opnd_array(3)->constant());
  
#line 23742 "ad_riscv.cpp"
  }
}

void shaddP_reg_reg_ext_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 262 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ shadd(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             t0,
             opnd_array(3)->constant());
  
#line 23764 "ad_riscv.cpp"
  }
}

void shaddL_reg_reg_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 281 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ shadd(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             t0,
             opnd_array(3)->constant());
  
#line 23786 "ad_riscv.cpp"
  }
}

void shaddL_reg_reg_b_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 281 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ shadd(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             t0,
             opnd_array(2)->constant());
  
#line 23808 "ad_riscv.cpp"
  }
}

void shaddL_reg_reg_ext_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// imm
  {
    C2_MacroAssembler _masm(&cbuf);

#line 299 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ shadd(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             t0,
             opnd_array(3)->constant());
  
#line 23830 "ad_riscv.cpp"
  }
}

void shaddL_reg_reg_ext_b_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 299 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ shadd(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             t0,
             opnd_array(2)->constant());
  
#line 23852 "ad_riscv.cpp"
  }
}

void countLeadingZerosI_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 318 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ clzw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 23868 "ad_riscv.cpp"
  }
}

void countLeadingZerosL_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 332 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ clz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 23884 "ad_riscv.cpp"
  }
}

void countTrailingZerosI_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 346 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ ctzw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 23900 "ad_riscv.cpp"
  }
}

void countTrailingZerosL_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 360 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ ctz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 23916 "ad_riscv.cpp"
  }
}

void popCountI_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 375 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ cpopw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 23932 "ad_riscv.cpp"
  }
}

void popCountL_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 390 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ cpop(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 23948 "ad_riscv.cpp"
  }
}

void minI_reg_reg_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 405 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ min(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 23965 "ad_riscv.cpp"
  }
}

void maxI_reg_reg_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    C2_MacroAssembler _masm(&cbuf);

#line 419 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ max(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 23982 "ad_riscv.cpp"
  }
}

void minI_reg_zero_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 438 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ min(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), zr);
  
#line 23999 "ad_riscv.cpp"
  }
}

void minI_reg_zero_b_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 438 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ min(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */), zr);
  
#line 24016 "ad_riscv.cpp"
  }
}

void maxI_reg_zero_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    C2_MacroAssembler _masm(&cbuf);

#line 453 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ max(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), zr);
  
#line 24033 "ad_riscv.cpp"
  }
}

void maxI_reg_zero_b_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 453 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ max(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */), zr);
  
#line 24050 "ad_riscv.cpp"
  }
}

void absI_reg_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 471 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ negw(t0, as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ max(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), t0);
  
#line 24067 "ad_riscv.cpp"
  }
}

void absL_reg_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    C2_MacroAssembler _masm(&cbuf);

#line 489 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ neg(t0, as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ max(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), t0);
  
#line 24084 "ad_riscv.cpp"
  }
}

void andnI_reg_reg_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 505 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ andn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 24104 "ad_riscv.cpp"
  }
}

void andnI_reg_reg_b_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 505 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ andn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */));
  
#line 24124 "ad_riscv.cpp"
  }
}

void andnL_reg_reg_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 521 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ andn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 24144 "ad_riscv.cpp"
  }
}

void andnL_reg_reg_b_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 521 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ andn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */));
  
#line 24164 "ad_riscv.cpp"
  }
}

void ornI_reg_reg_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 538 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 24184 "ad_riscv.cpp"
  }
}

void ornI_reg_reg_b_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 538 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */));
  
#line 24204 "ad_riscv.cpp"
  }
}

void ornL_reg_reg_bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 554 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 24224 "ad_riscv.cpp"
  }
}

void ornL_reg_reg_b_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    C2_MacroAssembler _masm(&cbuf);

#line 554 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */));
  
#line 24244 "ad_riscv.cpp"
  }
}

void convI2Bool_andI_reg_immIpowerOf2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    C2_MacroAssembler _masm(&cbuf);

#line 570 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv_b.ad"

    __ bexti(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, exact_log2((juint)(opnd_array(2)->constant())));
  
#line 24261 "ad_riscv.cpp"
  }
}

void compareAndSwapP_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 41 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/shenandoah/shenandoah_riscv.ad"

    Register tmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    __ mv(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   Assembler::relaxed /* acquire */, Assembler::rl /* release */,
                                                   false /* is_cae */, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 24284 "ad_riscv.cpp"
  }
}

void compareAndSwapN_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 62 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/shenandoah/shenandoah_riscv.ad"

    Register tmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    __ mv(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   Assembler::relaxed /* acquire */, Assembler::rl /* release */,
                                                   false /* is_cae */, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 24307 "ad_riscv.cpp"
  }
}

void compareAndSwapPAcq_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 84 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/shenandoah/shenandoah_riscv.ad"

    Register tmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    __ mv(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   Assembler::aq /* acquire */, Assembler::rl /* release */,
                                                   false /* is_cae */, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 24330 "ad_riscv.cpp"
  }
}

void compareAndSwapNAcq_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 106 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/shenandoah/shenandoah_riscv.ad"

    Register tmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    __ mv(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   Assembler::aq /* acquire */, Assembler::rl /* release */,
                                                   false /* is_cae */, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 24353 "ad_riscv.cpp"
  }
}

void compareAndExchangeN_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 126 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/shenandoah/shenandoah_riscv.ad"

    Register tmp = opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */;
    __ mv(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   Assembler::relaxed /* acquire */, Assembler::rl /* release */,
                                                   true /* is_cae */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 24377 "ad_riscv.cpp"
  }
}

void compareAndExchangeP_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 146 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/shenandoah/shenandoah_riscv.ad"

    Register tmp = opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */;
    __ mv(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   Assembler::relaxed /* acquire */, Assembler::rl /* release */,
                                                   true /* is_cae */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 24401 "ad_riscv.cpp"
  }
}

void weakCompareAndSwapN_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 167 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/shenandoah/shenandoah_riscv.ad"

    Register tmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    __ mv(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    // Weak is not current supported by ShenandoahBarrierSet::cmpxchg_oop
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   Assembler::relaxed /* acquire */, Assembler::rl /* release */,
                                                   false /* is_cae */, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 24425 "ad_riscv.cpp"
  }
}

void compareAndExchangeNAcq_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 189 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/shenandoah/shenandoah_riscv.ad"

    Register tmp = opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */;
    __ mv(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */);
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   Assembler::aq /* acquire */, Assembler::rl /* release */,
                                                   true /* is_cae */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 24449 "ad_riscv.cpp"
  }
}

void compareAndExchangePAcq_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 210 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/shenandoah/shenandoah_riscv.ad"

    Register tmp = opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */;
    __ mv(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */);
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   Assembler::aq /* acquire */, Assembler::rl /* release */,
                                                   true /* is_cae */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 24473 "ad_riscv.cpp"
  }
}

void weakCompareAndSwapP_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 230 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/shenandoah/shenandoah_riscv.ad"

    Register tmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    __ mv(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   Assembler::relaxed /* acquire */, Assembler::rl /* release */,
                                                   false /* is_cae */, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 24496 "ad_riscv.cpp"
  }
}

void weakCompareAndSwapNAcq_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 252 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/shenandoah/shenandoah_riscv.ad"

    Register tmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    __ mv(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    // Weak is not current supported by ShenandoahBarrierSet::cmpxchg_oop
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   Assembler::aq /* acquire */, Assembler::rl /* release */,
                                                   false /* is_cae */, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 24520 "ad_riscv.cpp"
  }
}

void weakCompareAndSwapPAcq_shenandoahNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 275 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/shenandoah/shenandoah_riscv.ad"

    Register tmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    __ mv(tmp, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */); // Must not clobber oldval.
    // Weak is not current supported by ShenandoahBarrierSet::cmpxchg_oop
    ShenandoahBarrierSet::assembler()->cmpxchg_oop(&_masm, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, tmp, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   Assembler::aq /* acquire */, Assembler::rl /* release */,
                                                   false /* is_cae */, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 24544 "ad_riscv.cpp"
  }
}

void xLoadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 65 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/x/x_riscv.ad"

    const Address ref_addr (as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1));
    __ ld(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, ref_addr);
    x_load_barrier(_masm, this, ref_addr, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, t0 /* tmp */, barrier_data());
  
#line 24563 "ad_riscv.cpp"
  }
}

void xCompareAndSwapPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 85 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/x/x_riscv.ad"

    Label failed;
    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int64,
               Assembler::relaxed /* acquire */, Assembler::rl /* release */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */,
               true /* result_as_bool */);
    __ beqz(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, failed);
    __ mv(t0, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */);
    __ bind(failed);
    if (barrier_data() != XLoadBarrierElided) {
      Label good;
      __ ld(t1, Address(xthread, XThreadLocalData::address_bad_mask_offset()), t1 /* tmp */);
      __ andr(t1, t1, t0);
      __ beqz(t1, good);
      x_load_barrier_slow_path(_masm, this, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */), t0 /* ref */, t1 /* tmp */);
      __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int64,
                 Assembler::relaxed /* acquire */, Assembler::rl /* release */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */,
                 true /* result_as_bool */);
      __ bind(good);
    }
  
#line 24600 "ad_riscv.cpp"
  }
}

void xCompareAndSwapP_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 85 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/x/x_riscv.ad"

    Label failed;
    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int64,
               Assembler::relaxed /* acquire */, Assembler::rl /* release */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */,
               true /* result_as_bool */);
    __ beqz(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, failed);
    __ mv(t0, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */);
    __ bind(failed);
    if (barrier_data() != XLoadBarrierElided) {
      Label good;
      __ ld(t1, Address(xthread, XThreadLocalData::address_bad_mask_offset()), t1 /* tmp */);
      __ andr(t1, t1, t0);
      __ beqz(t1, good);
      x_load_barrier_slow_path(_masm, this, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */), t0 /* ref */, t1 /* tmp */);
      __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int64,
                 Assembler::relaxed /* acquire */, Assembler::rl /* release */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */,
                 true /* result_as_bool */);
      __ bind(good);
    }
  
#line 24637 "ad_riscv.cpp"
  }
}

void xCompareAndSwapPAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 121 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/x/x_riscv.ad"

    Label failed;
    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int64,
               Assembler::aq /* acquire */, Assembler::rl /* release */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */,
               true /* result_as_bool */);
    __ beqz(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, failed);
    __ mv(t0, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */);
    __ bind(failed);
    if (barrier_data() != XLoadBarrierElided) {
      Label good;
      __ ld(t1, Address(xthread, XThreadLocalData::address_bad_mask_offset()), t1 /* tmp */);
      __ andr(t1, t1, t0);
      __ beqz(t1, good);
      x_load_barrier_slow_path(_masm, this, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */), t0 /* ref */, t1 /* tmp */);
      __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int64,
                 Assembler::aq /* acquire */, Assembler::rl /* release */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */,
                 true /* result_as_bool */);
      __ bind(good);
    }
  
#line 24674 "ad_riscv.cpp"
  }
}

void xCompareAndSwapPAcq_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 121 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/x/x_riscv.ad"

    Label failed;
    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int64,
               Assembler::aq /* acquire */, Assembler::rl /* release */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */,
               true /* result_as_bool */);
    __ beqz(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, failed);
    __ mv(t0, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */);
    __ bind(failed);
    if (barrier_data() != XLoadBarrierElided) {
      Label good;
      __ ld(t1, Address(xthread, XThreadLocalData::address_bad_mask_offset()), t1 /* tmp */);
      __ andr(t1, t1, t0);
      __ beqz(t1, good);
      x_load_barrier_slow_path(_masm, this, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */), t0 /* ref */, t1 /* tmp */);
      __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int64,
                 Assembler::aq /* acquire */, Assembler::rl /* release */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */,
                 true /* result_as_bool */);
      __ bind(good);
    }
  
#line 24711 "ad_riscv.cpp"
  }
}

void xCompareAndExchangePNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 155 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/x/x_riscv.ad"

    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int64,
               Assembler::relaxed /* acquire */, Assembler::rl /* release */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    if (barrier_data() != XLoadBarrierElided) {
      Label good;
      __ ld(t0, Address(xthread, XThreadLocalData::address_bad_mask_offset()));
      __ andr(t0, t0, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
      __ beqz(t0, good);
      x_load_barrier_slow_path(_masm, this, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */), opnd_array(4)->as_Register(ra_,this,idx4)/* res */, t0 /* tmp */);
      __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int64,
                 Assembler::relaxed /* acquire */, Assembler::rl /* release */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
      __ bind(good);
    }
  
#line 24742 "ad_riscv.cpp"
  }
}

void xCompareAndExchangePAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  {
    C2_MacroAssembler _masm(&cbuf);

#line 183 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/x/x_riscv.ad"

    guarantee(opnd_array(1)->index(ra_,this,idx1)== -1 && opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int64,
               Assembler::aq /* acquire */, Assembler::rl /* release */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    if (barrier_data() != XLoadBarrierElided) {
      Label good;
      __ ld(t0, Address(xthread, XThreadLocalData::address_bad_mask_offset()));
      __ andr(t0, t0, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
      __ beqz(t0, good);
      x_load_barrier_slow_path(_masm, this, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */), opnd_array(4)->as_Register(ra_,this,idx4)/* res */, t0 /* tmp */);
      __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Assembler::int64,
                 Assembler::aq /* acquire */, Assembler::rl /* release */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
      __ bind(good);
    }
  
#line 24773 "ad_riscv.cpp"
  }
}

void xGetAndSetPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// prev
  {
    C2_MacroAssembler _masm(&cbuf);

#line 211 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/x/x_riscv.ad"

    __ atomic_xchg(opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
    x_load_barrier(_masm, this, Address(noreg, 0), opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, t0 /* tmp */, barrier_data());
  
#line 24792 "ad_riscv.cpp"
  }
}

void xGetAndSetPAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// prev
  {
    C2_MacroAssembler _masm(&cbuf);

#line 228 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/x/x_riscv.ad"

    __ atomic_xchgal(opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
    x_load_barrier(_masm, this, Address(noreg, 0), opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, t0 /* tmp */, barrier_data());
  
#line 24811 "ad_riscv.cpp"
  }
}

void zLoadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {
    C2_MacroAssembler _masm(&cbuf);

#line 103 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/z/z_riscv.ad"

    const Address ref_addr(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1));
    __ ld(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, ref_addr);
    z_load_barrier(_masm, this, ref_addr, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, t0);
  
#line 24830 "ad_riscv.cpp"
  }
}

void zStorePNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 121 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/z/z_riscv.ad"

    const Address ref_addr(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1));
    z_store_barrier(_masm, this, ref_addr, opnd_array(2)->as_Register(ra_,this,idx2)/* src */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, t1, false /* is_atomic */);
    __ sd(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, ref_addr);
  
#line 24850 "ad_riscv.cpp"
  }
}

void zCompareAndSwapPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// oldval_tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// newval_tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 140 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/z/z_riscv.ad"

    guarantee(opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    Address ref_addr(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_color(_masm, this, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, t0);
    z_store_barrier(_masm, this, ref_addr, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, t1, true /* is_atomic */);
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, Assembler::int64, Assembler::relaxed /* acquire */, Assembler::rl /* release */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */, true /* result_as_bool */);
  
#line 24875 "ad_riscv.cpp"
  }
}

void zCompareAndSwapP_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// oldval_tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// newval_tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 140 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/z/z_riscv.ad"

    guarantee(opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    Address ref_addr(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_color(_masm, this, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, t0);
    z_store_barrier(_masm, this, ref_addr, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, t1, true /* is_atomic */);
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, Assembler::int64, Assembler::relaxed /* acquire */, Assembler::rl /* release */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */, true /* result_as_bool */);
  
#line 24900 "ad_riscv.cpp"
  }
}

void zCompareAndSwapPAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// oldval_tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// newval_tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 162 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/z/z_riscv.ad"

    guarantee(opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    Address ref_addr(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_color(_masm, this, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, t0);
    z_store_barrier(_masm, this, ref_addr, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, t1, true /* is_atomic */);
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, Assembler::int64, Assembler::aq /* acquire */, Assembler::rl /* release */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */, true /* result_as_bool */);
  
#line 24925 "ad_riscv.cpp"
  }
}

void zCompareAndSwapPAcq_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// oldval_tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// newval_tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 162 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/z/z_riscv.ad"

    guarantee(opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    Address ref_addr(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_color(_masm, this, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, t0);
    z_store_barrier(_masm, this, ref_addr, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, t1, true /* is_atomic */);
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, Assembler::int64, Assembler::aq /* acquire */, Assembler::rl /* release */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */, true /* result_as_bool */);
  
#line 24950 "ad_riscv.cpp"
  }
}

void zCompareAndExchangePNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// oldval_tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// newval_tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 182 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/z/z_riscv.ad"

    guarantee(opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    Address ref_addr(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_color(_masm, this, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, t0);
    z_store_barrier(_masm, this, ref_addr, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, t1, true /* is_atomic */);
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, Assembler::int64, Assembler::relaxed /* acquire */, Assembler::rl /* release */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    z_uncolor(_masm, this, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 24976 "ad_riscv.cpp"
  }
}

void zCompareAndExchangePAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// oldval_tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// newval_tmp
  {
    C2_MacroAssembler _masm(&cbuf);

#line 203 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/z/z_riscv.ad"

    guarantee(opnd_array(1)->disp(ra_,this,idx1)== 0, "impossible encoding");
    Address ref_addr(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_color(_masm, this, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, t0);
    z_store_barrier(_masm, this, ref_addr, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, t1, true /* is_atomic */);
    __ cmpxchg(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(5)->as_Register(ra_,this,idx5)/* oldval_tmp */, opnd_array(6)->as_Register(ra_,this,idx6)/* newval_tmp */, Assembler::int64, Assembler::aq /* acquire */, Assembler::rl /* release */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    z_uncolor(_masm, this, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
  
#line 25002 "ad_riscv.cpp"
  }
}

void zGetAndSetPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// prev
  {
    C2_MacroAssembler _masm(&cbuf);

#line 224 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/z/z_riscv.ad"

    z_store_barrier(_masm, this, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */), opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, t1, true /* is_atomic */);
    __ atomic_xchg(opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_uncolor(_masm, this, opnd_array(3)->as_Register(ra_,this,idx3)/* prev */);
  
#line 25022 "ad_riscv.cpp"
  }
}

void zGetAndSetPAcqNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// prev
  {
    C2_MacroAssembler _masm(&cbuf);

#line 242 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/gc/z/z_riscv.ad"

    z_store_barrier(_masm, this, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */), opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, t1, true /* is_atomic */);
    __ atomic_xchgal(opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, opnd_array(3)->as_Register(ra_,this,idx3)/* prev */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    z_uncolor(_masm, this, opnd_array(3)->as_Register(ra_,this,idx3)/* prev */);
  
#line 25042 "ad_riscv.cpp"
  }
}

const MachOper* loadBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadB2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUB2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadSNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadS2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUSNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadINode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadLNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadRangeNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadPNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadNNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadNKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadFNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadDNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmCM0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmCM0_orderedNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeBNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmB0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeCNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmC0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeINode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmI0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeLNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmL0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storePNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmP0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeNNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmN0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeFNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeDNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeNKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchallocNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapBNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapSNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapINode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapLNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapPNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapNNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapBAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapSAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapIAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapLAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapPAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapNAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeBNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeSNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeINode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeLNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeNNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangePNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeBAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeSAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeIAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeLAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeNAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangePAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapBNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapSNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapINode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapLNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapNNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapPNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapBAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapSAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapIAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapLAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapNAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapPAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setINode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setLNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setNNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setPNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setIAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setLAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setNAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setPAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addL_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLiNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLi_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addINode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addI_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addIiNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addIi_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addL_no_resAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLiAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLi_no_resAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addIAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addI_no_resAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addIiAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addIi_no_resAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadVNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeVNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadV_maskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeV_maskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* gather_loadNode::memory_operand() const { return _opnds[1]; }
const MachOper* gather_load_maskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* scatter_storeNode::memory_operand() const { return _opnds[1]; }
const MachOper* scatter_store_maskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapP_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapN_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapPAcq_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapNAcq_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeN_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeP_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapN_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeNAcq_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangePAcq_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapP_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapNAcq_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* weakCompareAndSwapPAcq_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* xLoadPNode::memory_operand() const { return _opnds[1]; }
const MachOper* xCompareAndSwapPNode::memory_operand() const { return _opnds[1]; }
const MachOper* xCompareAndSwapP_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* xCompareAndSwapPAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* xCompareAndSwapPAcq_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* xCompareAndExchangePNode::memory_operand() const { return _opnds[1]; }
const MachOper* xCompareAndExchangePAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* xGetAndSetPNode::memory_operand() const { return _opnds[1]; }
const MachOper* xGetAndSetPAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* zLoadPNode::memory_operand() const { return _opnds[1]; }
const MachOper* zStorePNode::memory_operand() const { return _opnds[1]; }
const MachOper* zCompareAndSwapPNode::memory_operand() const { return _opnds[1]; }
const MachOper* zCompareAndSwapP_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* zCompareAndSwapPAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* zCompareAndSwapPAcq_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* zCompareAndExchangePNode::memory_operand() const { return _opnds[1]; }
const MachOper* zCompareAndExchangePAcqNode::memory_operand() const { return _opnds[1]; }
const MachOper* zGetAndSetPNode::memory_operand() const { return _opnds[1]; }
const MachOper* zGetAndSetPAcqNode::memory_operand() const { return _opnds[1]; }


bool Matcher::has_match_rule(int opcode) {
  assert(_last_machine_leaf < opcode && opcode < _last_opcode, "opcode in range");
  return _hasMatchRule[opcode];
}

const bool Matcher::_hasMatchRule[_last_opcode] = {
    false,  // Node
    false,  // Set
    false,  // RegN
    false,  // RegI
    false,  // RegP
    false,  // RegF
    false,  // RegD
    false,  // RegL
    false,  // VecA
    false,  // VecS
    false,  // VecD
    false,  // VecX
    false,  // VecY
    false,  // VecZ
    false,  // RegVectMask
    false,  // RegFlags
    false,  // _last_machine_leaf
    true ,  // AbsD
    true ,  // AbsF
    true ,  // AbsI
    true ,  // AbsL
    true ,  // AddD
    true ,  // AddF
    true ,  // AddI
    true ,  // AddL
    true ,  // AddP
    false,  // Allocate
    false,  // AllocateArray
    true ,  // AndI
    true ,  // AndL
    false,  // ArrayCopy
    true ,  // AryEq
    false,  // AtanD
    true ,  // Binary
    false,  // Blackhole
    true ,  // Bool
    false,  // BoxLock
    true ,  // ReverseBytesI
    true ,  // ReverseBytesL
    true ,  // ReverseBytesUS
    true ,  // ReverseBytesS
    false,  // ReverseBytesV
    false,  // CProj
    false,  // CacheWB
    false,  // CacheWBPreSync
    false,  // CacheWBPostSync
    true ,  // CallDynamicJava
    false,  // CallJava
    true ,  // CallLeaf
    true ,  // CallLeafNoFP
    false,  // CallLeafVector
    true ,  // CallRuntime
    true ,  // CallStaticJava
    true ,  // CastDD
    true ,  // CastFF
    true ,  // CastII
    true ,  // CastLL
    true ,  // CastVV
    true ,  // CastX2P
    true ,  // CastP2X
    true ,  // CastPP
    false,  // Catch
    false,  // CatchProj
    true ,  // CheckCastPP
    true ,  // ClearArray
    true ,  // CompressBits
    true ,  // ExpandBits
    false,  // CompressBitsV
    false,  // ExpandBitsV
    false,  // ConstraintCast
    false,  // CMoveD
    false,  // CMoveF
    true ,  // CMoveI
    true ,  // CMoveL
    false,  // CMoveP
    false,  // CMoveN
    true ,  // CmpN
    true ,  // CmpD
    true ,  // CmpD3
    true ,  // CmpF
    true ,  // CmpF3
    true ,  // CmpI
    true ,  // CmpL
    true ,  // CmpL3
    true ,  // CmpLTMask
    true ,  // CmpP
    true ,  // CmpU
    true ,  // CmpU3
    true ,  // CmpUL
    true ,  // CmpUL3
    true ,  // CompareAndSwapB
    true ,  // CompareAndSwapS
    true ,  // CompareAndSwapI
    true ,  // CompareAndSwapL
    true ,  // CompareAndSwapP
    true ,  // CompareAndSwapN
    true ,  // WeakCompareAndSwapB
    true ,  // WeakCompareAndSwapS
    true ,  // WeakCompareAndSwapI
    true ,  // WeakCompareAndSwapL
    true ,  // WeakCompareAndSwapP
    true ,  // WeakCompareAndSwapN
    true ,  // CompareAndExchangeB
    true ,  // CompareAndExchangeS
    true ,  // CompareAndExchangeI
    true ,  // CompareAndExchangeL
    true ,  // CompareAndExchangeP
    true ,  // CompareAndExchangeN
    false,  // GetAndAddB
    false,  // GetAndAddS
    true ,  // GetAndAddI
    true ,  // GetAndAddL
    false,  // GetAndSetB
    false,  // GetAndSetS
    true ,  // GetAndSetI
    true ,  // GetAndSetL
    true ,  // GetAndSetP
    true ,  // GetAndSetN
    false,  // Con
    true ,  // ConN
    true ,  // ConNKlass
    true ,  // ConD
    true ,  // ConF
    true ,  // ConI
    true ,  // ConL
    true ,  // ConP
    true ,  // Conv2B
    true ,  // ConvD2F
    true ,  // ConvD2I
    true ,  // ConvD2L
    true ,  // ConvF2D
    true ,  // ConvF2I
    true ,  // ConvF2L
    true ,  // ConvI2D
    true ,  // ConvI2F
    true ,  // ConvI2L
    true ,  // ConvL2D
    true ,  // ConvL2F
    true ,  // ConvL2I
    false,  // ConvF2HF
    false,  // ConvHF2F
    false,  // CountedLoop
    true ,  // CountedLoopEnd
    false,  // OuterStripMinedLoop
    false,  // OuterStripMinedLoopEnd
    false,  // LongCountedLoop
    false,  // LongCountedLoopEnd
    true ,  // CountLeadingZerosI
    true ,  // CountLeadingZerosL
    false,  // CountLeadingZerosV
    true ,  // CountTrailingZerosI
    true ,  // CountTrailingZerosL
    false,  // CountTrailingZerosV
    true ,  // CreateEx
    true ,  // DecodeN
    true ,  // DecodeNKlass
    true ,  // DivD
    true ,  // DivF
    true ,  // DivI
    true ,  // DivL
    true ,  // UDivI
    true ,  // UDivL
    false,  // DivMod
    false,  // DivModI
    false,  // DivModL
    false,  // UDivModI
    false,  // UDivModL
    true ,  // EncodeISOArray
    true ,  // EncodeP
    true ,  // EncodePKlass
    true ,  // FastLock
    true ,  // FastUnlock
    true ,  // FmaD
    true ,  // FmaF
    true ,  // Goto
    true ,  // Halt
    true ,  // CountPositives
    true ,  // If
    false,  // RangeCheck
    false,  // IfFalse
    false,  // IfTrue
    false,  // Initialize
    false,  // JProj
    false,  // Jump
    false,  // JumpProj
    true ,  // LShiftI
    true ,  // LShiftL
    true ,  // LoadB
    true ,  // LoadUB
    true ,  // LoadUS
    true ,  // LoadD
    false,  // LoadD_unaligned
    true ,  // LoadF
    true ,  // LoadI
    true ,  // LoadKlass
    true ,  // LoadNKlass
    true ,  // LoadL
    false,  // LoadL_unaligned
    true ,  // LoadP
    true ,  // LoadN
    true ,  // LoadRange
    true ,  // LoadS
    false,  // Lock
    false,  // Loop
    false,  // LoopLimit
    false,  // Mach
    false,  // MachNullCheck
    false,  // MachProj
    false,  // MulAddS2I
    true ,  // MaxI
    false,  // MaxL
    true ,  // MaxD
    true ,  // MaxF
    true ,  // MemBarAcquire
    true ,  // LoadFence
    true ,  // MemBarAcquireLock
    false,  // MemBarCPUOrder
    true ,  // MemBarRelease
    true ,  // StoreFence
    true ,  // StoreStoreFence
    true ,  // MemBarReleaseLock
    true ,  // MemBarVolatile
    true ,  // MemBarStoreStore
    false,  // MergeMem
    true ,  // MinI
    false,  // MinL
    true ,  // MinF
    true ,  // MinD
    false,  // ModD
    false,  // ModF
    true ,  // ModI
    true ,  // ModL
    true ,  // UModI
    true ,  // UModL
    true ,  // MoveI2F
    true ,  // MoveF2I
    true ,  // MoveL2D
    true ,  // MoveD2L
    true ,  // IsInfiniteF
    true ,  // IsFiniteF
    true ,  // IsInfiniteD
    true ,  // IsFiniteD
    true ,  // MulD
    true ,  // MulF
    true ,  // MulHiL
    true ,  // UMulHiL
    true ,  // MulI
    true ,  // MulL
    false,  // Multi
    false,  // NegI
    false,  // NegL
    true ,  // NegD
    true ,  // NegF
    false,  // NeverBranch
    true ,  // OnSpinWait
    false,  // Opaque1
    false,  // OpaqueLoopInit
    false,  // OpaqueLoopStride
    false,  // OpaqueZeroTripGuard
    false,  // Opaque3
    false,  // Opaque4
    false,  // ProfileBoolean
    true ,  // OrI
    true ,  // OrL
    false,  // OverflowAddI
    false,  // OverflowSubI
    false,  // OverflowMulI
    false,  // OverflowAddL
    false,  // OverflowSubL
    false,  // OverflowMulL
    false,  // PCTable
    false,  // Parm
    false,  // ParsePredicate
    true ,  // PartialSubtypeCheck
    false,  // SubTypeCheck
    false,  // Phi
    true ,  // PopCountI
    true ,  // PopCountL
    false,  // PopCountVI
    false,  // PopCountVL
    true ,  // PopulateIndex
    true ,  // PrefetchAllocation
    false,  // Proj
    true ,  // RShiftI
    true ,  // RShiftL
    false,  // Region
    true ,  // Rethrow
    true ,  // Return
    false,  // ReverseI
    false,  // ReverseL
    false,  // ReverseV
    false,  // Root
    false,  // RoundDouble
    true ,  // RoundDoubleMode
    false,  // RoundDoubleModeV
    false,  // RoundFloat
    true ,  // RotateLeft
    false,  // RotateLeftV
    true ,  // RotateRight
    false,  // RotateRightV
    true ,  // SafePoint
    false,  // SafePointScalarObject
    false,  // SafePointScalarMerge
    true ,  // ShenandoahCompareAndExchangeP
    true ,  // ShenandoahCompareAndExchangeN
    true ,  // ShenandoahCompareAndSwapN
    true ,  // ShenandoahCompareAndSwapP
    true ,  // ShenandoahWeakCompareAndSwapN
    true ,  // ShenandoahWeakCompareAndSwapP
    false,  // ShenandoahIUBarrier
    false,  // ShenandoahLoadReferenceBarrier
    false,  // SCMemProj
    true ,  // CopySignD
    true ,  // CopySignF
    true ,  // SignumD
    true ,  // SignumF
    true ,  // SignumVF
    true ,  // SignumVD
    true ,  // SqrtD
    true ,  // SqrtF
    false,  // RoundF
    false,  // RoundD
    false,  // Start
    false,  // StartOSR
    true ,  // StoreB
    true ,  // StoreC
    true ,  // StoreCM
    true ,  // StoreD
    true ,  // StoreF
    true ,  // StoreI
    true ,  // StoreL
    true ,  // StoreP
    true ,  // StoreN
    true ,  // StoreNKlass
    true ,  // StrComp
    true ,  // StrCompressedCopy
    true ,  // StrEquals
    true ,  // StrIndexOf
    true ,  // StrIndexOfChar
    true ,  // StrInflatedCopy
    true ,  // SubD
    true ,  // SubF
    true ,  // SubI
    true ,  // SubL
    true ,  // TailCall
    true ,  // TailJump
    false,  // MacroLogicV
    true ,  // ThreadLocal
    false,  // Unlock
    false,  // URShiftB
    false,  // URShiftS
    true ,  // URShiftI
    true ,  // URShiftL
    true ,  // XorI
    true ,  // XorL
    false,  // Vector
    true ,  // AddVB
    true ,  // AddVS
    true ,  // AddVI
    true ,  // AddReductionVI
    true ,  // AddVL
    true ,  // AddReductionVL
    true ,  // AddVF
    true ,  // AddReductionVF
    true ,  // AddVD
    true ,  // AddReductionVD
    true ,  // SubVB
    true ,  // SubVS
    true ,  // SubVI
    true ,  // SubVL
    true ,  // SubVF
    true ,  // SubVD
    true ,  // MulVB
    true ,  // MulVS
    true ,  // MulVI
    false,  // MulReductionVI
    true ,  // MulVL
    false,  // MulReductionVL
    true ,  // MulVF
    false,  // MulReductionVF
    true ,  // MulVD
    false,  // MulReductionVD
    false,  // MulAddVS2VI
    true ,  // FmaVD
    true ,  // FmaVF
    true ,  // DivVF
    true ,  // DivVD
    true ,  // AbsVB
    true ,  // AbsVS
    true ,  // AbsVI
    true ,  // AbsVL
    true ,  // AbsVF
    true ,  // AbsVD
    true ,  // NegVI
    true ,  // NegVL
    true ,  // NegVF
    true ,  // NegVD
    true ,  // SqrtVD
    true ,  // SqrtVF
    true ,  // LShiftCntV
    true ,  // RShiftCntV
    true ,  // LShiftVB
    true ,  // LShiftVS
    true ,  // LShiftVI
    true ,  // LShiftVL
    true ,  // RShiftVB
    true ,  // RShiftVS
    true ,  // RShiftVI
    true ,  // RShiftVL
    true ,  // URShiftVB
    true ,  // URShiftVS
    true ,  // URShiftVI
    true ,  // URShiftVL
    true ,  // AndV
    true ,  // AndReductionV
    true ,  // OrV
    true ,  // OrReductionV
    true ,  // XorV
    true ,  // XorReductionV
    true ,  // MinV
    true ,  // MaxV
    true ,  // MinReductionV
    true ,  // MaxReductionV
    true ,  // CompressV
    true ,  // CompressM
    true ,  // ExpandV
    true ,  // LoadVector
    true ,  // LoadVectorGather
    true ,  // LoadVectorGatherMasked
    true ,  // StoreVector
    true ,  // StoreVectorScatter
    true ,  // StoreVectorScatterMasked
    true ,  // LoadVectorMasked
    true ,  // StoreVectorMasked
    false,  // VectorCmpMasked
    true ,  // VectorMaskGen
    false,  // VectorMaskOp
    true ,  // VectorMaskTrueCount
    true ,  // VectorMaskFirstTrue
    true ,  // VectorMaskLastTrue
    true ,  // VectorMaskToLong
    true ,  // VectorLongToMask
    false,  // Pack
    false,  // PackB
    false,  // PackS
    false,  // PackI
    false,  // PackL
    false,  // PackF
    false,  // PackD
    false,  // Pack2L
    false,  // Pack2D
    true ,  // Replicate
    false,  // RoundVF
    false,  // RoundVD
    false,  // Extract
    true ,  // ExtractB
    false,  // ExtractUB
    false,  // ExtractC
    true ,  // ExtractS
    true ,  // ExtractI
    true ,  // ExtractL
    true ,  // ExtractF
    true ,  // ExtractD
    false,  // Digit
    false,  // LowerCase
    false,  // UpperCase
    false,  // Whitespace
    false,  // VectorBox
    false,  // VectorBoxAllocate
    false,  // VectorUnbox
    false,  // VectorMaskWrapper
    true ,  // VectorMaskCmp
    true ,  // VectorMaskCast
    true ,  // VectorTest
    true ,  // VectorBlend
    true ,  // VectorRearrange
    true ,  // VectorLoadMask
    false,  // VectorLoadShuffle
    true ,  // VectorLoadConst
    true ,  // VectorStoreMask
    true ,  // VectorReinterpret
    false,  // VectorCast
    true ,  // VectorCastB2X
    true ,  // VectorCastS2X
    true ,  // VectorCastI2X
    true ,  // VectorCastL2X
    true ,  // VectorCastF2X
    true ,  // VectorCastD2X
    false,  // VectorCastF2HF
    false,  // VectorCastHF2F
    false,  // VectorUCastB2X
    false,  // VectorUCastS2X
    false,  // VectorUCastI2X
    false,  // VectorizedHashCode
    true ,  // VectorInsert
    true ,  // MaskAll
    true ,  // AndVMask
    true ,  // OrVMask
    true    // XorVMask
};


int Compile::sync_stack_slots() const { return 1 * VMRegImpl::slots_per_word; }

uint Matcher::stack_alignment_in_bytes() { return StackAlignmentInBytes; }

OptoReg::Name Matcher::return_addr() const { return OptoReg::stack2reg(- 2 +
              align_up((Compile::current()->in_preserve_stack_slots() +
                        Compile::current()->fixed_slots()),
                       stack_alignment_in_slots())); }

uint Compile::varargs_C_out_slots_killed() const { return frame::arg_reg_save_area_bytes / BytesPerInt; }

OptoRegPair Matcher::return_value(uint ideal_reg) {

#line 2661 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    assert(ideal_reg >= Op_RegI && ideal_reg <= Op_RegL,
           "only return normal values");

    static const int lo[Op_RegL + 1] = { // enum name
      0,                                 // Op_Node
      0,                                 // Op_Set
      R10_num,                           // Op_RegN
      R10_num,                           // Op_RegI
      R10_num,                           // Op_RegP
      F10_num,                           // Op_RegF
      F10_num,                           // Op_RegD
      R10_num                            // Op_RegL
    };

    static const int hi[Op_RegL + 1] = { // enum name
      0,                                 // Op_Node
      0,                                 // Op_Set
      OptoReg::Bad,                      // Op_RegN
      OptoReg::Bad,                      // Op_RegI
      R10_H_num,                         // Op_RegP
      OptoReg::Bad,                      // Op_RegF
      F10_H_num,                         // Op_RegD
      R10_H_num                          // Op_RegL
    };

    return OptoRegPair(hi[ideal_reg], lo[ideal_reg]);
  
#line 25734 "ad_riscv.cpp"

}

OptoRegPair Matcher::c_return_value(uint ideal_reg) {

#line 2661 "/builddir/build/BUILD/java-22-openjdk-22.0.0.0.36-0.3.ea.rolling.fc41.riscv64/jdk-22+36/src/hotspot/cpu/riscv/riscv.ad"

    assert(ideal_reg >= Op_RegI && ideal_reg <= Op_RegL,
           "only return normal values");

    static const int lo[Op_RegL + 1] = { // enum name
      0,                                 // Op_Node
      0,                                 // Op_Set
      R10_num,                           // Op_RegN
      R10_num,                           // Op_RegI
      R10_num,                           // Op_RegP
      F10_num,                           // Op_RegF
      F10_num,                           // Op_RegD
      R10_num                            // Op_RegL
    };

    static const int hi[Op_RegL + 1] = { // enum name
      0,                                 // Op_Node
      0,                                 // Op_Set
      OptoReg::Bad,                      // Op_RegN
      OptoReg::Bad,                      // Op_RegI
      R10_H_num,                         // Op_RegP
      OptoReg::Bad,                      // Op_RegF
      F10_H_num,                         // Op_RegD
      R10_H_num                          // Op_RegL
    };

    return OptoRegPair(hi[ideal_reg], lo[ideal_reg]);
  
#line 25769 "ad_riscv.cpp"

}

OptoReg::Name Matcher::inline_cache_reg() { return OptoReg::Name(R31_num); }

int Matcher::inline_cache_reg_encode() { return _regEncode[inline_cache_reg()]; }

OptoReg::Name Matcher::interpreter_frame_pointer_reg() { return OptoReg::Name(R8_num); }

OptoReg::Name Matcher::c_frame_pointer() const { return OptoReg::Name(R2_num); }

// Number of callee-save + always-save registers
int  Matcher::number_of_saved_registers() {
  return 0;
};

bool Compile::needs_deep_clone_jvms() { return false; }

// Check consistency of C++ compilation with ADLC options:
// Check adlc -DLINUX=1
#ifndef LINUX
#  error "LINUX must be defined"
#endif // LINUX
// Check adlc -D_GNU_SOURCE=1
#ifndef _GNU_SOURCE
#  error "_GNU_SOURCE must be defined"
#endif // _GNU_SOURCE
// Check adlc -DRISCV64=1
#ifndef RISCV64
#  error "RISCV64 must be defined"
#endif // RISCV64
// Check adlc -D_LP64=1
#ifndef _LP64
#  error "_LP64 must be defined"
#endif // _LP64
// Check adlc -DNDEBUG=1
#ifndef NDEBUG
#  error "NDEBUG must be defined"
#endif // NDEBUG
// Check adlc -DPRODUCT=1
#ifndef PRODUCT
#  error "PRODUCT must be defined"
#endif // PRODUCT
